package pwc.taxtech.atms.common.util;

import org.apache.poi.ss.usermodel.*;
import org.apache.poi.xssf.usermodel.XSSFCellStyle;
import org.apache.poi.xssf.usermodel.XSSFColor;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

/**
 * author kevin
 * version 1.0
 */
public class POIStyleUtil {

    public static void setCellAlign(XSSFWorkbook xssfWorkbook, Cell cell) {
        CellStyle cellStyle = xssfWorkbook.createCellStyle();
        cellStyle.setAlignment(HorizontalAlignment.CENTER);// 设置居中
        cellStyle.setVerticalAlignment(VerticalAlignment.CENTER);
        cell.setCellStyle(cellStyle);
    }

    ///new XSSFColor(java.awt.Color.YELLOW)
    public static void setCellBackgroundColor(XSSFWorkbook xssfWorkbook, Cell cell,   XSSFColor xssfColor ,FillPatternType fillPatternType) {
        if(fillPatternType == null)
            fillPatternType = FillPatternType.SOLID_FOREGROUND;
        XSSFCellStyle cellStyle = xssfWorkbook.createCellStyle();
        cellStyle.setFillPattern(fillPatternType);
        cellStyle.setFillForegroundColor(xssfColor);
        cell.setCellStyle(cellStyle);
    }
    public static void setCellBackgroundColor(XSSFWorkbook xssfWorkbook, Cell cell,   XSSFColor xssfColor){
        setCellBackgroundColor(xssfWorkbook, cell, xssfColor, null);
    }
}
