package pwc.taxtech.atms.constant.enums;

public enum EnumAnalysisExpTempPath {
    EachTaxAmount(0, "/analysis_excel_template/tax_data.xlsx"),
    ActualReturnTax(1, "/analysis_excel_template/actual_tax_return.xlsx"),
    GMVSubsidy(2, "/analysis_excel_template/gmv_subsidy.xlsx"),
    EmployeeNum(3, "/analysis_excel_template/employ_num.xlsx"),
    DriverNum(4, "/analysis_excel_template/driver_num.xlsx"),
    BUData(100, "/analysis_excel_template/international_bu_data.xlsx"),
    TaxData(101, "/analysis_excel_template/international_tax_data.xlsx"),
    ;

    private Integer code;

    private String path;

    EnumAnalysisExpTempPath(Integer code, String path) {
        this.code = code;
        this.path = path;
    }

    public Integer getCode() {
        return code;
    }

    public String getPath() {
        return path;
    }

    public static EnumAnalysisExpTempPath fromCode(Integer code){
        for(EnumAnalysisExpTempPath enu: EnumAnalysisExpTempPath.values()){
            if(enu.getCode().intValue()==code.intValue())return enu;
        }
        return null;
    }

    public static String getPath(Integer code){
        for(EnumAnalysisExpTempPath eaetp: EnumAnalysisExpTempPath.values()){
            if(eaetp.getCode().intValue()==code.intValue())return eaetp.path;
        }
        return null;
    }
}
