package pwc.taxtech.atms.constant.enums;

public enum EnumImportType {
    Undefined(0),
    ProfitLoss(1),
    BalanceSheet(2),
    RedLetterInfoTable(3),
    AdjustmentTable(4),
    CashFlow(5),
    CoupaPurchasingReport(6),
    InvoiceData(7),
    CertifiedInvoicesList(8),
    InvoiceRecord(9),
    ExtractFinancialData(10),
    ExtractInvoiceData(11),
    RevenueMapping(12),
    RevenueConfig(13)
    ;

    private Integer code;

    EnumImportType(Integer code) {
        this.code = code;
    }

    public Integer getCode() {
        return code;
    }

    public static String getNameByCode(Integer code){
        for(EnumImportType enumImportType : EnumImportType.values()){
            if(Integer.compare(code, enumImportType.getCode())==0){
                return enumImportType.name();
            }
        }
        return null;
    }
}
