package pwc.taxtech.atms.constant.enums;

import java.util.HashMap;
import java.util.Map;

public class FileUploadEnum {

    /**
     * 业务来源
     */
    public enum BizSource {
        REPORT_UPLOAD("REPORT_UPLOAD", "历史报表归档上传"),
        RECORD_UPLOAD("RECORD_UPLOAD", "档案管理上传"),
        REPORT_TEMPLATE_UPLOAD("REPORT_TEMPLATE_UPLOAD", "报表模板上传"),
        PERIOD_REPORT_TEMPLATE_UPLOAD("PERIOD_REPORT_TEMPLATE_UPLOAD", "期间报表模板上传"),;
        private String code;
        private String name;
        public static final Map<String, String> MAPPING = new HashMap<>();

        BizSource(String code, String name) {
            this.code = code;
            this.name = name;
        }

        public String getCode() {
            return code;
        }

        public String getName() {
            return name;
        }

        static {
            for (FileUploadEnum.BizSource bizSource : FileUploadEnum.BizSource.values()) {
                MAPPING.put(bizSource.getCode(), bizSource.getName());
            }
        }
    }


}
