package pwc.taxtech.atms.constant.enums;

import java.util.HashMap;
import java.util.Map;

public class ReportFileUploadEnum {

    /**
     * 报表类型
     */
    public enum ReportType {
        NORMAL_DECLARATION("增值税纳税申报表", "增值税纳税申报表"),
        CORR_DECLARATION("增值税更正申报表", "增值税更正申报表"),
        NORMAL_TAX_RECEIPT("增值税纳税税票", "增值税纳税税票"),
        CORR_TAX_RECEIPT("增值税更正税票", "增值税更正税票"),

        CIT_FIRST_QUARTERLY("企业所得税第一季度预缴表", "企业所得税第一季度预缴表"),
        CIT_CORRECT_FIRST_QUARTERLY("企业所得税更正第一季度预缴表", "企业所得税更正第一季度预缴表"),
        CIT_SECOND_QUARTERLY("企业所得税第二季度预缴表", "企业所得税第二季度预缴表"),
        CIT_CORRECT_SECOND_QUARTERLY("企业所得税更正第二季度预缴表", "企业所得税更正第二季度预缴表"),
        CIT_THIRD_QUARTERLY("企业所得税第三季度预缴表", "企业所得税第三季度预缴表"),
        CIT_CORRECT_THIRD_QUARTERLY("企业所得税更正第三季度预缴表", "企业所得税更正第三季度预缴表"),
        CIT_FORTH_QUARTERLY("企业所得税第四季度预缴表", "企业所得税第四季度预缴表"),
        CIT_CORRECT_FORTH_QUARTERLY("企业所得税更正第四季度预缴表", "企业所得税更正第四季度预缴表"),

        CIT_FINAL_SETTLEMENT_DECLARATION_FORM("企业所得税汇算清缴纳税申报表", "企业所得税汇算清缴纳税申报表"),
        CIT_CORRECT_FINAL_SETTLEMENT_DECLARATION_FORM("企业所得税更正汇算清缴纳税申报表", "企业所得税更正汇算清缴纳税申报表"),

        CIT_FIRST_TAX_STAMP("企业所得税第一季度纳税税票", "企业所得税第一季度纳税税票"),
        CIT_CORRECT_FIRST_TAX_STAMP("企业所得税第一季度更正纳税税票", "企业所得税第一季度更正纳税税票"),
        CIT_SECOND_TAX_STAMP("企业所得税第二季度纳税税票", "企业所得税第二季度纳税税票"),
        CIT_CORRECT_SECOND_TAX_STAMP("企业所得税更正第二季度纳税税票", "企业所得税更正第二季度纳税税票"),
        CIT_THIRD_TAX_STAMP("企业所得税第三季度纳税税票", "企业所得税第三季度纳税税票"),
        CIT_CORRECT_THIRD_TAX_STAMP("企业所得税更正第三季度纳税税票", "企业所得税更正第三季度纳税税票"),
        CIT_FORTH_TAX_STAMP("企业所得税第四季度纳税税票", "企业所得税第四季度纳税税票"),
        CIT_CORRECT_FORTH_TAX_STAMP("企业所得税更正第四季度纳税税票", "企业所得税更正第四季度纳税税票"),

        CIT_FINAL_SETTLEMENT_TAX_STAMP("企业所得税汇算清缴纳税税票", "企业所得税汇算清缴纳税税票"),
        CIT_CORRECT_FINAL_SETTLEMENT_TAX_STAMP("企业所得税更正汇算清缴纳税税票", "企业所得税更正汇算清缴纳税税票");
        private String code;
        private String name;
        public static final Map<String, String> MAPPING = new HashMap<>();

        ReportType(String code, String name) {
            this.code = code;
            this.name = name;
        }

        public String getCode() {
            return code;
        }

        public String getName() {
            return name;
        }

        static {
            for (ReportFileUploadEnum.ReportType reportType : ReportFileUploadEnum.ReportType.values()) {
                MAPPING.put(reportType.getCode(), reportType.getName());
            }
        }
    }

    /**
     * 来源类型
     */
    public enum SuorceType {
        VAT("VAT", "VAT"),
        CIT("CIT", "CIT"),
        RECORD("RECORD", "档案");
        private String code;
        private String name;
        public static final Map<String, String> MAPPING = new HashMap<>();

        SuorceType(String code, String name) {
            this.code = code;
            this.name = name;
        }

        public String getCode() {
            return code;
        }

        public String getName() {
            return name;
        }

        static {
            for (ReportFileUploadEnum.SuorceType suorceType : ReportFileUploadEnum.SuorceType.values()) {
                MAPPING.put(suorceType.getCode(), suorceType.getName());
            }
        }
    }



}
