package pwc.taxtech.atms.dao;

import org.springframework.stereotype.Service;
import pwc.taxtech.atms.service.impl.BaseService;
import pwc.taxtech.atms.vat.dao.GlBalanceMapper;
import pwc.taxtech.atms.vat.entity.GlBalance;
import pwc.taxtech.atms.vat.entity.GlBalanceExample;

import javax.annotation.Resource;
import java.util.Optional;

@Service
public class GlBalanceDao extends BaseService {

    @Resource
    private GlBalanceMapper glBalanceMapper;

    /**
     * 查找科目
     *
     * @param code code
     * @return GlBalance
     */
    public Optional<GlBalance> get(String code, String orgId, String period) {
        GlBalanceExample example = new GlBalanceExample();
        example.createCriteria().andSegment3EqualTo(code).andSegment1EqualTo(orgId).andPeriodNameEqualTo(period);
        Optional<GlBalance> optional = glBalanceMapper.selectByExample(example).stream().findFirst();
        if (optional.isPresent()) {
            return optional;
        }
        GlBalanceExample example2 = new GlBalanceExample();
        example2.createCriteria().andSegment4EqualTo(code).andSegment1EqualTo(orgId).andPeriodNameEqualTo(period);
        return glBalanceMapper.selectByExample(example2).stream().findFirst();
    }
}
