package pwc.taxtech.atms.dto.equity;


import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import pwc.taxtech.atms.common.util.PwCIdSerialize;

import java.util.Date;

public class EquityInfoDto {
    /**
     * Database Column Remarks:
     *   唯一编号
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column equity_information.id
     *
     * @mbg.generated
     */
    @JsonSerialize(using = PwCIdSerialize.class)
    private Long id;

    /**
     * Database Column Remarks:
     *   股权信息序号。从1开始
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column equity_information.e_num
     *
     * @mbg.generated
     */
    private Integer eNum;

    /**
     * Database Column Remarks:
     *   对应机构编号
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column equity_information_history.organization_id
     *
     * @mbg.generated
     */
    private String organizationId;

    /**
     * Database Column Remarks:
     *   投资方名称。表格里的文本框
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column equity_information_history.investor_name
     *
     * @mbg.generated
     */
    private String investorName;

    /**
     * Database Column Remarks:
     *   投资方经济性质
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column equity_information_history.investor_economic_nature
     *
     * @mbg.generated
     */
    private String investorEconomicNature;

    /**
     * Database Column Remarks:
     *   证件类型
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column equity_information_history.certificate_type
     *
     * @mbg.generated
     */
    private String certificateType;

    /**
     * Database Column Remarks:
     *   证件号码.
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column equity_information_history.id_num
     *
     * @mbg.generated
     */
    private String idNum;

    /**
     * Database Column Remarks:
     *   投资金额.
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column equity_information_history.investment_amount
     *
     * @mbg.generated
     */
    private Long investmentAmount;

    /**
     * Database Column Remarks:
     *   投资金额币种.
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column equity_information_history.investment_currency
     *
     * @mbg.generated
     */
    private String investmentCurrency;

    /**
     * Database Column Remarks:
     *   投资比例
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column equity_information_history.investment_radio
     *
     * @mbg.generated
     */
    private Float investmentRadio;

    /**
     * Database Column Remarks:
     *   实缴股东名称.
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column equity_information_history.payable_shareholder_name
     *
     * @mbg.generated
     */
    private String payableShareholderName;

    /**
     * Database Column Remarks:
     *   实缴股东证件编号
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column equity_information_history.payable_shareholder_id_num
     *
     * @mbg.generated
     */
    private String payableShareholderIdNum;

    /**
     * Database Column Remarks:
     *   实缴出资金额
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column equity_information_history.payable_capital_contribution_amount
     *
     * @mbg.generated
     */
    private Long payableCapitalContributionAmount;

    /**
     * Database Column Remarks:
     *   实缴出资币种
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column equity_information_history.payable_capital_contribution_currency
     *
     * @mbg.generated
     */
    private String payableCapitalContributionCurrency;

    /**
     * Database Column Remarks:
     *   实缴出资比例。百分比，多个股东合计为100%
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column equity_information_history.payable_contribution_proportion
     *
     * @mbg.generated
     */
    private Float payableContributionProportion;

    /**
     * Database Column Remarks:
     *   创建时间
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column equity_information_history.create_time
     *
     * @mbg.generated
     */
    private Date createTime;

    /**
     * Database Column Remarks:
     *   更新时间
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column equity_information_history.update_time
     *
     * @mbg.generated
     */
    private Date updateTime;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Integer geteNum() {
        return eNum;
    }

    public void seteNum(Integer eNum) {
        this.eNum = eNum;
    }

    public String getOrganizationId() {
        return organizationId;
    }

    public void setOrganizationId(String organizationId) {
        this.organizationId = organizationId;
    }

    public String getInvestorName() {
        return investorName;
    }

    public void setInvestorName(String investorName) {
        this.investorName = investorName;
    }

    public String getInvestorEconomicNature() {
        return investorEconomicNature;
    }

    public void setInvestorEconomicNature(String investorEconomicNature) {
        this.investorEconomicNature = investorEconomicNature;
    }

    public String getCertificateType() {
        return certificateType;
    }

    public void setCertificateType(String certificateType) {
        this.certificateType = certificateType;
    }

    public String getIdNum() {
        return idNum;
    }

    public void setIdNum(String idNum) {
        this.idNum = idNum;
    }

    public Long getInvestmentAmount() {
        return investmentAmount;
    }

    public void setInvestmentAmount(Long investmentAmount) {
        this.investmentAmount = investmentAmount;
    }

    public String getInvestmentCurrency() {
        return investmentCurrency;
    }

    public void setInvestmentCurrency(String investmentCurrency) {
        this.investmentCurrency = investmentCurrency;
    }

    public Float getInvestmentRadio() {
        return investmentRadio;
    }

    public void setInvestmentRadio(Float investmentRadio) {
        this.investmentRadio = investmentRadio;
    }

    public String getPayableShareholderName() {
        return payableShareholderName;
    }

    public void setPayableShareholderName(String payableShareholderName) {
        this.payableShareholderName = payableShareholderName;
    }

    public String getPayableShareholderIdNum() {
        return payableShareholderIdNum;
    }

    public void setPayableShareholderIdNum(String payableShareholderIdNum) {
        this.payableShareholderIdNum = payableShareholderIdNum;
    }

    public Long getPayableCapitalContributionAmount() {
        return payableCapitalContributionAmount;
    }

    public void setPayableCapitalContributionAmount(Long payableCapitalContributionAmount) {
        this.payableCapitalContributionAmount = payableCapitalContributionAmount;
    }

    public String getPayableCapitalContributionCurrency() {
        return payableCapitalContributionCurrency;
    }

    public void setPayableCapitalContributionCurrency(String payableCapitalContributionCurrency) {
        this.payableCapitalContributionCurrency = payableCapitalContributionCurrency;
    }

    public Float getPayableContributionProportion() {
        return payableContributionProportion;
    }

    public void setPayableContributionProportion(Float payableContributionProportion) {
        this.payableContributionProportion = payableContributionProportion;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }
}
