package pwc.taxtech.atms.dto.organization;

import com.fasterxml.jackson.annotation.JsonProperty;
import pwc.taxtech.atms.anno.ExcelCell;

import java.util.Date;

public class OrgInfoDto {
    //@JsonProperty("ID")
    private String id;
    @ExcelCell(index=1)
    private String name;
    @ExcelCell(index=2)
    private String code;
    @ExcelCell(index=3)
    private String taxPayerNumber;
    @ExcelCell(index=4)
    private String structureName;
    @ExcelCell(index=5)
    private String regionName;
    @ExcelCell(index=6)
    private String businessUnitName;
    private String areaId;
    @ExcelCell(index=7)
    private String areaName;
    @ExcelCell(index=8)
    private String industryName;
    @ExcelCell(index=9)
    private Boolean isActive;

    @JsonProperty("parentID")
    private String parentId;
    @JsonProperty("regionID")
    private String regionId; //City
    @JsonProperty("structureID")
    private String structureId;
    @JsonProperty("industryID")
    private String industryId;
    @JsonProperty("businessUnitID")
    private String businessUnitId;
    @ExcelCell(index=10)
    private String englishName;

    @ExcelCell(index=11)
    private String abbreviation;
    @ExcelCell(index=12)
    private Date foundationDate;
    @ExcelCell(index=13)
    private String registrationLocation;
    @ExcelCell(index=14)
    private String registrationLocationEn;
    @ExcelCell(index=15)
    private String legalPersonName;
    @ExcelCell(index=16)
    private String businessScope;
    @ExcelCell(index=17)
    private String regStatus;
    @ExcelCell(index=18)
    private String architectureType;
    @ExcelCell(index=19)
    private String nationalEconomicIndustry;
    @ExcelCell(index=20)
    private Boolean engageNationalProhibitIndustry;

    @ExcelCell(index=21)
    private String registrationCapital;
    @ExcelCell(index=22)
    private String paidInCapital;
    @ExcelCell(index=23)
    private Integer numOfBranches;
    @ExcelCell(index=24)
    private String unifiedSocialCreditCode;
    @ExcelCell(index=25)
    private Boolean regFinancialAccountingType;
    @ExcelCell(index=26)
    private String taxRegStatus;
    @ExcelCell(index=27)
    private String taxCreditRating;
    @ExcelCell(index=28)
    private String applicableAccountingRule;
    @ExcelCell(index=29)
    private String lowValueConsumablesAmortizationMethod;
    @ExcelCell(index=30)
    private String depreciationMethod;

    @ExcelCell(index=31)
    private String accountingSoftware;
    @ExcelCell(index=32)
    private Boolean completeRecordTotalInstitutions;
    @ExcelCell(index=33)
    private String taxClientPersonName;
    @ExcelCell(index=34)
    private String taxClientPersonPhoneNum;
    @ExcelCell(index=35)
    private String taxClientPersonIdNum;
    @ExcelCell(index=36)
    private String ticketHolderName;
    @ExcelCell(index=37)
    private String ticketHolderPhoneNum;
    @ExcelCell(index=38)
    private String nationalTaxHallAddress;
    @ExcelCell(index=39)
    private String nationalTaxAdministratorName;
    @ExcelCell(index=40)
    private String nationalTaxAdministratorPhoneNum;

    @ExcelCell(index=41)
    private String localTaxHallAddress;
    @ExcelCell(index=42)
    private String localTaxAdministratorName;
    @ExcelCell(index=43)
    private String localTaxAdministratorPhoneNum;
    @ExcelCell(index=44)
    private String etaWebsite;
    @ExcelCell(index=45)
    private Boolean signTripartiteAgreement;
    @ExcelCell(index=46)
    private String reportingCurrency;
    @ExcelCell(index=47)
    private Date consolidationTime;
    @ExcelCell(index=48)
    private String taxAgent;
    @ExcelCell(index=49)
    private String taxAgentContact;
    @ExcelCell(index=50)
    private Byte taxReturnBusinessType;

    @ExcelCell(index=51)
    private Boolean smallMeagerProfit;
    @ExcelCell(index=52)
    private Boolean listedCompany;
    @ExcelCell(index=53)
    private Integer applicableAccountingStandardsOrAccountingSystems;
    @ExcelCell(index=54)
    private String taxPayerNumberVat;
    @ExcelCell(index=55)
    private String taxPayerNumberCit;
    @ExcelCell(index=56)
    private String taxClientPersonEmailAddress;
    @ExcelCell(index=57)
    private String bankAccountName;
    @ExcelCell(index=58)
    private String bankAccountNumber;
    @ExcelCell(index=59)
    private String legalPersonPhoneNumber;
    @ExcelCell(index=60)
    private String legalPersonLandlineNum;
    @ExcelCell(index=61)
    private String legalPersonEmailAddress;
    @ExcelCell(index=62)
    private String regFinancialOfficerName;
    @ExcelCell(index=63)
    private String regFinancialOfficerPhoneNum;
    @ExcelCell(index=64)
    private String regFinancialOfficerLandlineNum;
    @ExcelCell(index=65)
    private String regFinancialOfficerEmailAddress;
    @ExcelCell(index=66)
    private String actualBusinessAddress;
    @ExcelCell(index=67)
    private Long secondaryApprovalAmount;
    @ExcelCell(index=68)
    private Date fiscalYearDeadline;
    @ExcelCell(index=69)
    private String businessRegistrationNumber;
    @ExcelCell(index=70)
    private Float parValue;
    @ExcelCell(index=71)
    private Long issuedShares;
    @ExcelCell(index=72)
    private String directors;
    @ExcelCell(index=73)
    private String otherFacts;
    @ExcelCell(index=74)
    private Date logoutTime;
    @ExcelCell(index=75)
    private String taxRuleIntroduction;
    @ExcelCell(index=76)
    private String country;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    public String getTaxPayerNumber() {
        return taxPayerNumber;
    }

    public void setTaxPayerNumber(String taxPayerNumber) {
        this.taxPayerNumber = taxPayerNumber;
    }

    public String getRegionId() {
        return regionId;
    }

    public void setRegionId(String regionId) {
        this.regionId = regionId;
    }

    public String getRegionName() {
        return regionName;
    }

    public void setRegionName(String regionName) {
        this.regionName = regionName;
    }

    public String getStructureId() {
        return structureId;
    }

    public void setStructureId(String structureId) {
        this.structureId = structureId;
    }

    public String getStructureName() {
        return structureName;
    }

    public void setStructureName(String structureName) {
        this.structureName = structureName;
    }

    public String getIndustryId() {
        return industryId;
    }

    public void setIndustryId(String industryId) {
        this.industryId = industryId;
    }

    public String getIndustryName() {
        return industryName;
    }

    public void setIndustryName(String industryName) {
        this.industryName = industryName;
    }

    public String getAreaName() {
        return areaName;
    }

    public void setAreaName(String areaName) {
        this.areaName = areaName;
    }

    public String getAreaId() {
        return areaId;
    }

    public void setAreaId(String areaId) {
        this.areaId = areaId;
    }

    public String getBusinessUnitId() {
        return businessUnitId;
    }

    public void setBusinessUnitId(String businessUnitId) {
        this.businessUnitId = businessUnitId;
    }

    public String getBusinessUnitName() {
        return businessUnitName;
    }

    public void setBusinessUnitName(String businessUnitName) {
        this.businessUnitName = businessUnitName;
    }

    public Boolean getActive() {
        return isActive;
    }

    public void setActive(Boolean active) {
        isActive = active;
    }

    public String getEnglishName() {
        return englishName;
    }

    public void setEnglishName(String englishName) {
        this.englishName = englishName;
    }

    public String getAbbreviation() {
        return abbreviation;
    }

    public void setAbbreviation(String abbreviation) {
        this.abbreviation = abbreviation;
    }

    public Date getFoundationDate() {
        return foundationDate;
    }

    public void setFoundationDate(Date foundationDate) {
        this.foundationDate = foundationDate;
    }

    public String getRegistrationLocation() {
        return registrationLocation;
    }

    public void setRegistrationLocation(String registrationLocation) {
        this.registrationLocation = registrationLocation;
    }

    public String getRegistrationLocationEn() {
        return registrationLocationEn;
    }

    public void setRegistrationLocationEn(String registrationLocationEn) {
        this.registrationLocationEn = registrationLocationEn;
    }

    public String getLegalPersonName() {
        return legalPersonName;
    }

    public void setLegalPersonName(String legalPersonName) {
        this.legalPersonName = legalPersonName;
    }

    public String getBusinessScope() {
        return businessScope;
    }

    public void setBusinessScope(String businessScope) {
        this.businessScope = businessScope;
    }

    public String getRegStatus() {
        return regStatus;
    }

    public void setRegStatus(String regStatus) {
        this.regStatus = regStatus;
    }

    public String getArchitectureType() {
        return architectureType;
    }

    public void setArchitectureType(String architectureType) {
        this.architectureType = architectureType;
    }

    public String getNationalEconomicIndustry() {
        return nationalEconomicIndustry;
    }

    public void setNationalEconomicIndustry(String nationalEconomicIndustry) {
        this.nationalEconomicIndustry = nationalEconomicIndustry;
    }

    public Boolean getEngageNationalProhibitIndustry() {
        return engageNationalProhibitIndustry;
    }

    public void setEngageNationalProhibitIndustry(Boolean engageNationalProhibitIndustry) {
        this.engageNationalProhibitIndustry = engageNationalProhibitIndustry;
    }

    public String getRegistrationCapital() {
        return registrationCapital;
    }

    public void setRegistrationCapital(String registrationCapital) {
        this.registrationCapital = registrationCapital;
    }

    public String getPaidInCapital() {
        return paidInCapital;
    }

    public void setPaidInCapital(String paidInCapital) {
        this.paidInCapital = paidInCapital;
    }

    public Integer getNumOfBranches() {
        return numOfBranches;
    }

    public void setNumOfBranches(Integer numOfBranches) {
        this.numOfBranches = numOfBranches;
    }

    public String getUnifiedSocialCreditCode() {
        return unifiedSocialCreditCode;
    }

    public void setUnifiedSocialCreditCode(String unifiedSocialCreditCode) {
        this.unifiedSocialCreditCode = unifiedSocialCreditCode;
    }

    public Boolean getRegFinancialAccountingType() {
        return regFinancialAccountingType;
    }

    public void setRegFinancialAccountingType(Boolean regFinancialAccountingType) {
        this.regFinancialAccountingType = regFinancialAccountingType;
    }

    public String getTaxRegStatus() {
        return taxRegStatus;
    }

    public void setTaxRegStatus(String taxRegStatus) {
        this.taxRegStatus = taxRegStatus;
    }

    public String getTaxCreditRating() {
        return taxCreditRating;
    }

    public void setTaxCreditRating(String taxCreditRating) {
        this.taxCreditRating = taxCreditRating;
    }

    public String getApplicableAccountingRule() {
        return applicableAccountingRule;
    }

    public void setApplicableAccountingRule(String applicableAccountingRule) {
        this.applicableAccountingRule = applicableAccountingRule;
    }

    public String getLowValueConsumablesAmortizationMethod() {
        return lowValueConsumablesAmortizationMethod;
    }

    public void setLowValueConsumablesAmortizationMethod(String lowValueConsumablesAmortizationMethod) {
        this.lowValueConsumablesAmortizationMethod = lowValueConsumablesAmortizationMethod;
    }

    public String getDepreciationMethod() {
        return depreciationMethod;
    }

    public void setDepreciationMethod(String depreciationMethod) {
        this.depreciationMethod = depreciationMethod;
    }

    public String getAccountingSoftware() {
        return accountingSoftware;
    }

    public void setAccountingSoftware(String accountingSoftware) {
        this.accountingSoftware = accountingSoftware;
    }

    public Boolean getCompleteRecordTotalInstitutions() {
        return completeRecordTotalInstitutions;
    }

    public void setCompleteRecordTotalInstitutions(Boolean completeRecordTotalInstitutions) {
        this.completeRecordTotalInstitutions = completeRecordTotalInstitutions;
    }

    public String getTaxClientPersonName() {
        return taxClientPersonName;
    }

    public void setTaxClientPersonName(String taxClientPersonName) {
        this.taxClientPersonName = taxClientPersonName;
    }

    public String getTaxClientPersonPhoneNum() {
        return taxClientPersonPhoneNum;
    }

    public void setTaxClientPersonPhoneNum(String taxClientPersonPhoneNum) {
        this.taxClientPersonPhoneNum = taxClientPersonPhoneNum;
    }

    public String getTaxClientPersonIdNum() {
        return taxClientPersonIdNum;
    }

    public void setTaxClientPersonIdNum(String taxClientPersonIdNum) {
        this.taxClientPersonIdNum = taxClientPersonIdNum;
    }

    public String getTicketHolderName() {
        return ticketHolderName;
    }

    public void setTicketHolderName(String ticketHolderName) {
        this.ticketHolderName = ticketHolderName;
    }

    public String getTicketHolderPhoneNum() {
        return ticketHolderPhoneNum;
    }

    public void setTicketHolderPhoneNum(String ticketHolderPhoneNum) {
        this.ticketHolderPhoneNum = ticketHolderPhoneNum;
    }

    public String getNationalTaxHallAddress() {
        return nationalTaxHallAddress;
    }

    public void setNationalTaxHallAddress(String nationalTaxHallAddress) {
        this.nationalTaxHallAddress = nationalTaxHallAddress;
    }

    public String getNationalTaxAdministratorName() {
        return nationalTaxAdministratorName;
    }

    public void setNationalTaxAdministratorName(String nationalTaxAdministratorName) {
        this.nationalTaxAdministratorName = nationalTaxAdministratorName;
    }

    public String getNationalTaxAdministratorPhoneNum() {
        return nationalTaxAdministratorPhoneNum;
    }

    public void setNationalTaxAdministratorPhoneNum(String nationalTaxAdministratorPhoneNum) {
        this.nationalTaxAdministratorPhoneNum = nationalTaxAdministratorPhoneNum;
    }

    public String getLocalTaxHallAddress() {
        return localTaxHallAddress;
    }

    public void setLocalTaxHallAddress(String localTaxHallAddress) {
        this.localTaxHallAddress = localTaxHallAddress;
    }

    public String getLocalTaxAdministratorName() {
        return localTaxAdministratorName;
    }

    public void setLocalTaxAdministratorName(String localTaxAdministratorName) {
        this.localTaxAdministratorName = localTaxAdministratorName;
    }

    public String getLocalTaxAdministratorPhoneNum() {
        return localTaxAdministratorPhoneNum;
    }

    public void setLocalTaxAdministratorPhoneNum(String localTaxAdministratorPhoneNum) {
        this.localTaxAdministratorPhoneNum = localTaxAdministratorPhoneNum;
    }

    public String getEtaWebsite() {
        return etaWebsite;
    }

    public void setEtaWebsite(String etaWebsite) {
        this.etaWebsite = etaWebsite;
    }

    public Boolean getSignTripartiteAgreement() {
        return signTripartiteAgreement;
    }

    public void setSignTripartiteAgreement(Boolean signTripartiteAgreement) {
        this.signTripartiteAgreement = signTripartiteAgreement;
    }

    public String getReportingCurrency() {
        return reportingCurrency;
    }

    public void setReportingCurrency(String reportingCurrency) {
        this.reportingCurrency = reportingCurrency;
    }

    public Date getConsolidationTime() {
        return consolidationTime;
    }

    public void setConsolidationTime(Date consolidationTime) {
        this.consolidationTime = consolidationTime;
    }

    public String getTaxAgent() {
        return taxAgent;
    }

    public void setTaxAgent(String taxAgent) {
        this.taxAgent = taxAgent;
    }

    public String getTaxAgentContact() {
        return taxAgentContact;
    }

    public void setTaxAgentContact(String taxAgentContact) {
        this.taxAgentContact = taxAgentContact;
    }

    public Byte getTaxReturnBusinessType() {
        return taxReturnBusinessType;
    }

    public void setTaxReturnBusinessType(Byte taxReturnBusinessType) {
        this.taxReturnBusinessType = taxReturnBusinessType;
    }

    public Boolean getSmallMeagerProfit() {
        return smallMeagerProfit;
    }

    public void setSmallMeagerProfit(Boolean smallMeagerProfit) {
        this.smallMeagerProfit = smallMeagerProfit;
    }

    public Boolean getListedCompany() {
        return listedCompany;
    }

    public void setListedCompany(Boolean listedCompany) {
        this.listedCompany = listedCompany;
    }

    public Integer getApplicableAccountingStandardsOrAccountingSystems() {
        return applicableAccountingStandardsOrAccountingSystems;
    }

    public void setApplicableAccountingStandardsOrAccountingSystems(Integer applicableAccountingStandardsOrAccountingSystems) {
        this.applicableAccountingStandardsOrAccountingSystems = applicableAccountingStandardsOrAccountingSystems;
    }

    public String getTaxPayerNumberVat() {
        return taxPayerNumberVat;
    }

    public void setTaxPayerNumberVat(String taxPayerNumberVat) {
        this.taxPayerNumberVat = taxPayerNumberVat;
    }

    public String getTaxPayerNumberCit() {
        return taxPayerNumberCit;
    }

    public void setTaxPayerNumberCit(String taxPayerNumberCit) {
        this.taxPayerNumberCit = taxPayerNumberCit;
    }

    public String getTaxClientPersonEmailAddress() {
        return taxClientPersonEmailAddress;
    }

    public void setTaxClientPersonEmailAddress(String taxClientPersonEmailAddress) {
        this.taxClientPersonEmailAddress = taxClientPersonEmailAddress;
    }

    public String getBankAccountName() {
        return bankAccountName;
    }

    public void setBankAccountName(String bankAccountName) {
        this.bankAccountName = bankAccountName;
    }

    public String getBankAccountNumber() {
        return bankAccountNumber;
    }

    public void setBankAccountNumber(String bankAccountNumber) {
        this.bankAccountNumber = bankAccountNumber;
    }

    public String getLegalPersonPhoneNumber() {
        return legalPersonPhoneNumber;
    }

    public void setLegalPersonPhoneNumber(String legalPersonPhoneNumber) {
        this.legalPersonPhoneNumber = legalPersonPhoneNumber;
    }

    public String getLegalPersonLandlineNum() {
        return legalPersonLandlineNum;
    }

    public void setLegalPersonLandlineNum(String legalPersonLandlineNum) {
        this.legalPersonLandlineNum = legalPersonLandlineNum;
    }

    public String getLegalPersonEmailAddress() {
        return legalPersonEmailAddress;
    }

    public void setLegalPersonEmailAddress(String legalPersonEmailAddress) {
        this.legalPersonEmailAddress = legalPersonEmailAddress;
    }

    public String getRegFinancialOfficerName() {
        return regFinancialOfficerName;
    }

    public void setRegFinancialOfficerName(String regFinancialOfficerName) {
        this.regFinancialOfficerName = regFinancialOfficerName;
    }

    public String getRegFinancialOfficerPhoneNum() {
        return regFinancialOfficerPhoneNum;
    }

    public void setRegFinancialOfficerPhoneNum(String regFinancialOfficerPhoneNum) {
        this.regFinancialOfficerPhoneNum = regFinancialOfficerPhoneNum;
    }

    public String getRegFinancialOfficerLandlineNum() {
        return regFinancialOfficerLandlineNum;
    }

    public void setRegFinancialOfficerLandlineNum(String regFinancialOfficerLandlineNum) {
        this.regFinancialOfficerLandlineNum = regFinancialOfficerLandlineNum;
    }

    public String getRegFinancialOfficerEmailAddress() {
        return regFinancialOfficerEmailAddress;
    }

    public void setRegFinancialOfficerEmailAddress(String regFinancialOfficerEmailAddress) {
        this.regFinancialOfficerEmailAddress = regFinancialOfficerEmailAddress;
    }

    public Long getSecondaryApprovalAmount() {
        return secondaryApprovalAmount;
    }

    public void setSecondaryApprovalAmount(Long secondaryApprovalAmount) {
        this.secondaryApprovalAmount = secondaryApprovalAmount;
    }

    public Date getFiscalYearDeadline() {
        return fiscalYearDeadline;
    }

    public void setFiscalYearDeadline(Date fiscalYearDeadline) {
        this.fiscalYearDeadline = fiscalYearDeadline;
    }

    public String getBusinessRegistrationNumber() {
        return businessRegistrationNumber;
    }

    public void setBusinessRegistrationNumber(String businessRegistrationNumber) {
        this.businessRegistrationNumber = businessRegistrationNumber;
    }

    public Float getParValue() {
        return parValue;
    }

    public void setParValue(Float parValue) {
        this.parValue = parValue;
    }

    public Long getIssuedShares() {
        return issuedShares;
    }

    public void setIssuedShares(Long issuedShares) {
        this.issuedShares = issuedShares;
    }

    public String getDirectors() {
        return directors;
    }

    public void setDirectors(String directors) {
        this.directors = directors;
    }

    public String getOtherFacts() {
        return otherFacts;
    }

    public void setOtherFacts(String otherFacts) {
        this.otherFacts = otherFacts;
    }

    public Boolean getIsActive() {
        return isActive;
    }

    public void setIsActive(Boolean isActive) {
        this.isActive = isActive;
    }

    public String getActualBusinessAddress() {
        return actualBusinessAddress;
    }

    public void setActualBusinessAddress(String actualBusinessAddress) {
        this.actualBusinessAddress = actualBusinessAddress;
    }

    public Date getLogoutTime() {
        return logoutTime;
    }

    public void setLogoutTime(Date logoutTime) {
        this.logoutTime = logoutTime;
    }

    public String getTaxRuleIntroduction() {
        return taxRuleIntroduction;
    }

    public void setTaxRuleIntroduction(String taxRuleIntroduction) {
        this.taxRuleIntroduction = taxRuleIntroduction;
    }

    public String getCountry() {
        return country;
    }

    public void setCountry(String country) {
        this.country = country;
    }
}
