package pwc.taxtech.atms.dto.organization;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import pwc.taxtech.atms.common.util.PwCIdSerialize;

import java.io.Serializable;
import java.util.Date;

/**
 *
 * This class was generated by MyBatis Generator.
 * This class corresponds to the database table organization_extra
 *
 * @mbg.generated do_not_delete_during_merge
 */
public class OrganizationExtraDto implements Serializable {
    /**
     * Database Column Remarks:
     *   系统唯一编号
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.id
     *
     * @mbg.generated
     */

    @JsonSerialize(using = PwCIdSerialize.class)
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private Long id;

    /**
     * Database Column Remarks:
     *   机构编号.对应机构编号
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.organization_id
     *
     * @mbg.generated
     */
    private String organizationId;

    /**
     * Database Column Remarks:
     *   统一社会信用代码.例：XR23T345DFG4562。与纳税人识别号一致，页面用纳税人识别号描述
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.unified_social_credit_code
     *
     * @mbg.generated
     */
    private String unifiedSocialCreditCode;

    /**
     * Database Column Remarks:
     *   登记方式。1-独立 0-非独立
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.reg_financial_accounting_type
     *
     * @mbg.generated
     */
    private Boolean regFinancialAccountingType;

    /**
     * Database Column Remarks:
     *   税务登记状态
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.tax_reg_status
     *
     * @mbg.generated
     */
    private String taxRegStatus;

    /**
     * Database Column Remarks:
     *   纳税信用评级.ABCD等等
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.tax_credit_rating
     *
     * @mbg.generated
     */
    private String taxCreditRating;

    /**
     * Database Column Remarks:
     *   适用会计制度.企业会计制度/金融企业会计制度/小企业会计准则/企业会计准则
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.applicable_accounting_rule
     *
     * @mbg.generated
     */
    private String applicableAccountingRule;

    /**
     * Database Column Remarks:
     *   低值易耗品摊销方法.一次摊销法/分期摊销法/五五摊销法 
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.low_value_consumables_amortization_method
     *
     * @mbg.generated
     */
    private String lowValueConsumablesAmortizationMethod;

    /**
     * Database Column Remarks:
     *   折旧方法.年限平均法（直线法）/工作量法/年数总和法/双倍余额递减法
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.depreciation_method
     *
     * @mbg.generated
     */
    private String depreciationMethod;

    /**
     * Database Column Remarks:
     *   会计核算软件. Oracle 或其他
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.accounting_software
     *
     * @mbg.generated
     */
    private String accountingSoftware;

    /**
     * Database Column Remarks:
     *   是否完成总分机构备案.1-是，0-否
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.complete_record_total_institutions
     *
     * @mbg.generated
     */
    private Boolean completeRecordTotalInstitutions;

    /**
     * Database Column Remarks:
     *   办税人姓名
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.tax_client_person_name
     *
     * @mbg.generated
     */
    private String taxClientPersonName;

    /**
     * Database Column Remarks:
     *   办税人电话
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.tax_client_person_phone_num
     *
     * @mbg.generated
     */
    private String taxClientPersonPhoneNum;

    /**
     * Database Column Remarks:
     *   办税人身份证号
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.tax_client_person_id_num
     *
     * @mbg.generated
     */
    private String taxClientPersonIdNum;

    /**
     * Database Column Remarks:
     *   购票人姓名
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.ticket_holder_name
     *
     * @mbg.generated
     */
    private String ticketHolderName;

    /**
     * Database Column Remarks:
     *   购票人电话
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.ticket_holder_phone_num
     *
     * @mbg.generated
     */
    private String ticketHolderPhoneNum;

    /**
     * Database Column Remarks:
     *   主管税局地址(原国税)
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.national_tax_hall_address
     *
     * @mbg.generated
     */
    private String nationalTaxHallAddress;

    /**
     * Database Column Remarks:
     *   主管税局名称(原国税)
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.national_tax_administrator_name
     *
     * @mbg.generated
     */
    private String nationalTaxAdministratorName;

    /**
     * Database Column Remarks:
     *   主管税局电话(原国税)
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.national_tax_administrator_phone_num
     *
     * @mbg.generated
     */
    private String nationalTaxAdministratorPhoneNum;

    /**
     * Database Column Remarks:
     *   主管税局地址(原地税)
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.local_tax_hall_address
     *
     * @mbg.generated
     */
    private String localTaxHallAddress;

    /**
     * Database Column Remarks:
     *   主管税局名称(原地税)
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.local_tax_administrator_name
     *
     * @mbg.generated
     */
    private String localTaxAdministratorName;

    /**
     * Database Column Remarks:
     *   主管税局电话(原地税)
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.local_tax_administrator_phone_num
     *
     * @mbg.generated
     */
    private String localTaxAdministratorPhoneNum;

    /**
     * Database Column Remarks:
     *   电子税局网址
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.eta_website
     *
     * @mbg.generated
     */
    private String etaWebsite;

    /**
     * Database Column Remarks:
     *   三方协议是否签订.1-是，0-否
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.sign_tripartite_agreement
     *
     * @mbg.generated
     */
    private Boolean signTripartiteAgreement;

    /**
     * Database Column Remarks:
     *   记账本位币
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.reporting_currency
     *
     * @mbg.generated
     */
    private String reportingCurrency;

    /**
     * Database Column Remarks:
     *   并表期间
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.consolidation_time
     *
     * @mbg.generated
     */
    private Date consolidationTime;

    /**
     * Database Column Remarks:
     *   财年截止日.(国际化特有字段)
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.fiscal_year_deadline
     *
     * @mbg.generated
     */
    private Date fiscalYearDeadline;

    /**
     * Database Column Remarks:
     *   税务代理
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.tax_agent
     *
     * @mbg.generated
     */
    private String taxAgent;

    /**
     * Database Column Remarks:
     *   税务代理联系方式
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.tax_agent_contact
     *
     * @mbg.generated
     */
    private String taxAgentContact;

    /**
     * Database Column Remarks:
     *   其他情况说明.(国际化特有字段)
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.other_facts
     *
     * @mbg.generated
     */
    private String otherFacts;

    /**
     * Database Column Remarks:
     *   纳税申报企业类型.100/210/220/230/311/312（填写代码）
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.tax_return_business_type
     *
     * @mbg.generated
     */
    private Integer taxReturnBusinessType;

    /**
     * Database Column Remarks:
     *   小型微利企业.1是/0否
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.small_meager_profit
     *
     * @mbg.generated
     */
    private Boolean smallMeagerProfit;

    /**
     * Database Column Remarks:
     *   上市公司.1是-境内/是   0-境外/否
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.listed_company
     *
     * @mbg.generated
     */
    private Boolean listedCompany;

    /**
     * Database Column Remarks:
     *   采用一般企业财务报表格式
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.applicable_accounting_standards_or_accounting_systems
     *
     * @mbg.generated
     */
    private Integer applicableAccountingStandardsOrAccountingSystems;

    /**
     * Database Column Remarks:
     *   增值税纳税人识别号。仅国际化有
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.tax_payer_number_vat
     *
     * @mbg.generated
     */
    private String taxPayerNumberVat;

    /**
     * Database Column Remarks:
     *   企业所得税纳税人识别号。仅国际化有
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.tax_payer_number_cit
     *
     * @mbg.generated
     */
    private String taxPayerNumberCit;

    /**
     * Database Column Remarks:
     *   办税人邮箱。
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.tax_client_person_email_address
     *
     * @mbg.generated
     */
    private String taxClientPersonEmailAddress;

    /**
     * Database Column Remarks:
     *   三方协议开户银行名称.bank_account_name
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.bank_account_name
     *
     * @mbg.generated
     */
    private String bankAccountName;

    /**
     * Database Column Remarks:
     *   银行账户号码
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.bank_account_number
     *
     * @mbg.generated
     */
    private String bankAccountNumber;

    /**
     * Database Column Remarks:
     *   法定代表人/负责人姓名.
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.legal_person_name
     *
     * @mbg.generated
     */
    private String legalPersonName;

    /**
     * Database Column Remarks:
     *   法定代表人/负责人手机
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.legal_person_phone_number
     *
     * @mbg.generated
     */
    private String legalPersonPhoneNumber;

    /**
     * Database Column Remarks:
     *   法定代表人/负责人座机
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.legal_person_landline_num
     *
     * @mbg.generated
     */
    private String legalPersonLandlineNum;

    /**
     * Database Column Remarks:
     *   法定代表人/负责人邮箱
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.legal_person_email_address
     *
     * @mbg.generated
     */
    private String legalPersonEmailAddress;

    /**
     * Database Column Remarks:
     *   注册登记财务负责人姓名
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.reg_financial_officer_name
     *
     * @mbg.generated
     */
    private String regFinancialOfficerName;

    /**
     * Database Column Remarks:
     *   注册登记财务负责人电话
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.reg_financial_officer_phone_num
     *
     * @mbg.generated
     */
    private String regFinancialOfficerPhoneNum;

    /**
     * Database Column Remarks:
     *   注册登记财务负责人座机
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.reg_financial_officer_landline_num
     *
     * @mbg.generated
     */
    private String regFinancialOfficerLandlineNum;

    /**
     * Database Column Remarks:
     *   注册登记财务负责人邮箱
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.reg_financial_officer_email_address
     *
     * @mbg.generated
     */
    private String regFinancialOfficerEmailAddress;

    /**
     * Database Column Remarks:
     *   二级审批金额
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.secondary_approval_amount
     *
     * @mbg.generated
     */
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private Long secondaryApprovalAmount;

    /**
     * Database Column Remarks:
     *   商业登记号码.Business registration number(国际化特有字段)
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.business_registration_number
     *
     * @mbg.generated
     */
    private String businessRegistrationNumber;

    /**
     * Database Column Remarks:
     *   Par Value(国际化特有字段).票面价值。票面价值是企业发行的股票上面所标明的金额，有的企业发行的股票上有票面价值，也有的企业发行的股票不标明票面价值。
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.par_value
     *
     * @mbg.generated
     */
    private Float parValue;

    /**
     * Database Column Remarks:
     *   Issued shares(国际化特有字段).发行股票
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.issued_shares
     *
     * @mbg.generated
     */
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private Long issuedShares;

    /**
     * Database Column Remarks:
     *   Directors(国际化特有字段).董事。以;间隔
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.directors
     *
     * @mbg.generated
     */
    private String directors;

    /**
     * Database Column Remarks:
     *   实际经营地址。例：杭州市余杭区九橙西溪创投中心
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.actual_business_address
     *
     * @mbg.generated
     */
    private String actualBusinessAddress;

    /**
     * Database Column Remarks:
     *   税制简介
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.tax_rule_introduction
     *
     * @mbg.generated
     */
    private String taxRuleIntroduction;

    /**
     * Database Column Remarks:
     *   审计要求
     *
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database column organization_extra.audit_requirements
     *
     * @mbg.generated
     */
    private String auditRequirements;

    private String architectureType;

    /**
     * This field was generated by MyBatis Generator.
     * This field corresponds to the database table organization_extra
     *
     * @mbg.generated
     */
    private static final long serialVersionUID = 1L;

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.id
     *
     * @return the value of organization_extra.id
     *
     * @mbg.generated
     */
    public Long getId() {
        return id;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.id
     *
     * @param id the value for organization_extra.id
     *
     * @mbg.generated
     */
    public void setId(Long id) {
        this.id = id;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.organization_id
     *
     * @return the value of organization_extra.organization_id
     *
     * @mbg.generated
     */
    public String getOrganizationId() {
        return organizationId;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.organization_id
     *
     * @param organizationId the value for organization_extra.organization_id
     *
     * @mbg.generated
     */
    public void setOrganizationId(String organizationId) {
        this.organizationId = organizationId == null ? null : organizationId.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.unified_social_credit_code
     *
     * @return the value of organization_extra.unified_social_credit_code
     *
     * @mbg.generated
     */
    public String getUnifiedSocialCreditCode() {
        return unifiedSocialCreditCode;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.unified_social_credit_code
     *
     * @param unifiedSocialCreditCode the value for organization_extra.unified_social_credit_code
     *
     * @mbg.generated
     */
    public void setUnifiedSocialCreditCode(String unifiedSocialCreditCode) {
        this.unifiedSocialCreditCode = unifiedSocialCreditCode == null ? null : unifiedSocialCreditCode.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.reg_financial_accounting_type
     *
     * @return the value of organization_extra.reg_financial_accounting_type
     *
     * @mbg.generated
     */
    public Boolean getRegFinancialAccountingType() {
        return regFinancialAccountingType;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.reg_financial_accounting_type
     *
     * @param regFinancialAccountingType the value for organization_extra.reg_financial_accounting_type
     *
     * @mbg.generated
     */
    public void setRegFinancialAccountingType(Boolean regFinancialAccountingType) {
        this.regFinancialAccountingType = regFinancialAccountingType;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.tax_reg_status
     *
     * @return the value of organization_extra.tax_reg_status
     *
     * @mbg.generated
     */
    public String getTaxRegStatus() {
        return taxRegStatus;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.tax_reg_status
     *
     * @param taxRegStatus the value for organization_extra.tax_reg_status
     *
     * @mbg.generated
     */
    public void setTaxRegStatus(String taxRegStatus) {
        this.taxRegStatus = taxRegStatus == null ? null : taxRegStatus.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.tax_credit_rating
     *
     * @return the value of organization_extra.tax_credit_rating
     *
     * @mbg.generated
     */
    public String getTaxCreditRating() {
        return taxCreditRating;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.tax_credit_rating
     *
     * @param taxCreditRating the value for organization_extra.tax_credit_rating
     *
     * @mbg.generated
     */
    public void setTaxCreditRating(String taxCreditRating) {
        this.taxCreditRating = taxCreditRating == null ? null : taxCreditRating.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.applicable_accounting_rule
     *
     * @return the value of organization_extra.applicable_accounting_rule
     *
     * @mbg.generated
     */
    public String getApplicableAccountingRule() {
        return applicableAccountingRule;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.applicable_accounting_rule
     *
     * @param applicableAccountingRule the value for organization_extra.applicable_accounting_rule
     *
     * @mbg.generated
     */
    public void setApplicableAccountingRule(String applicableAccountingRule) {
        this.applicableAccountingRule = applicableAccountingRule == null ? null : applicableAccountingRule.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.low_value_consumables_amortization_method
     *
     * @return the value of organization_extra.low_value_consumables_amortization_method
     *
     * @mbg.generated
     */
    public String getLowValueConsumablesAmortizationMethod() {
        return lowValueConsumablesAmortizationMethod;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.low_value_consumables_amortization_method
     *
     * @param lowValueConsumablesAmortizationMethod the value for organization_extra.low_value_consumables_amortization_method
     *
     * @mbg.generated
     */
    public void setLowValueConsumablesAmortizationMethod(String lowValueConsumablesAmortizationMethod) {
        this.lowValueConsumablesAmortizationMethod = lowValueConsumablesAmortizationMethod == null ? null : lowValueConsumablesAmortizationMethod.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.depreciation_method
     *
     * @return the value of organization_extra.depreciation_method
     *
     * @mbg.generated
     */
    public String getDepreciationMethod() {
        return depreciationMethod;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.depreciation_method
     *
     * @param depreciationMethod the value for organization_extra.depreciation_method
     *
     * @mbg.generated
     */
    public void setDepreciationMethod(String depreciationMethod) {
        this.depreciationMethod = depreciationMethod == null ? null : depreciationMethod.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.accounting_software
     *
     * @return the value of organization_extra.accounting_software
     *
     * @mbg.generated
     */
    public String getAccountingSoftware() {
        return accountingSoftware;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.accounting_software
     *
     * @param accountingSoftware the value for organization_extra.accounting_software
     *
     * @mbg.generated
     */
    public void setAccountingSoftware(String accountingSoftware) {
        this.accountingSoftware = accountingSoftware == null ? null : accountingSoftware.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.complete_record_total_institutions
     *
     * @return the value of organization_extra.complete_record_total_institutions
     *
     * @mbg.generated
     */
    public Boolean getCompleteRecordTotalInstitutions() {
        return completeRecordTotalInstitutions;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.complete_record_total_institutions
     *
     * @param completeRecordTotalInstitutions the value for organization_extra.complete_record_total_institutions
     *
     * @mbg.generated
     */
    public void setCompleteRecordTotalInstitutions(Boolean completeRecordTotalInstitutions) {
        this.completeRecordTotalInstitutions = completeRecordTotalInstitutions;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.tax_client_person_name
     *
     * @return the value of organization_extra.tax_client_person_name
     *
     * @mbg.generated
     */
    public String getTaxClientPersonName() {
        return taxClientPersonName;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.tax_client_person_name
     *
     * @param taxClientPersonName the value for organization_extra.tax_client_person_name
     *
     * @mbg.generated
     */
    public void setTaxClientPersonName(String taxClientPersonName) {
        this.taxClientPersonName = taxClientPersonName == null ? null : taxClientPersonName.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.tax_client_person_phone_num
     *
     * @return the value of organization_extra.tax_client_person_phone_num
     *
     * @mbg.generated
     */
    public String getTaxClientPersonPhoneNum() {
        return taxClientPersonPhoneNum;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.tax_client_person_phone_num
     *
     * @param taxClientPersonPhoneNum the value for organization_extra.tax_client_person_phone_num
     *
     * @mbg.generated
     */
    public void setTaxClientPersonPhoneNum(String taxClientPersonPhoneNum) {
        this.taxClientPersonPhoneNum = taxClientPersonPhoneNum == null ? null : taxClientPersonPhoneNum.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.tax_client_person_id_num
     *
     * @return the value of organization_extra.tax_client_person_id_num
     *
     * @mbg.generated
     */
    public String getTaxClientPersonIdNum() {
        return taxClientPersonIdNum;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.tax_client_person_id_num
     *
     * @param taxClientPersonIdNum the value for organization_extra.tax_client_person_id_num
     *
     * @mbg.generated
     */
    public void setTaxClientPersonIdNum(String taxClientPersonIdNum) {
        this.taxClientPersonIdNum = taxClientPersonIdNum == null ? null : taxClientPersonIdNum.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.ticket_holder_name
     *
     * @return the value of organization_extra.ticket_holder_name
     *
     * @mbg.generated
     */
    public String getTicketHolderName() {
        return ticketHolderName;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.ticket_holder_name
     *
     * @param ticketHolderName the value for organization_extra.ticket_holder_name
     *
     * @mbg.generated
     */
    public void setTicketHolderName(String ticketHolderName) {
        this.ticketHolderName = ticketHolderName == null ? null : ticketHolderName.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.ticket_holder_phone_num
     *
     * @return the value of organization_extra.ticket_holder_phone_num
     *
     * @mbg.generated
     */
    public String getTicketHolderPhoneNum() {
        return ticketHolderPhoneNum;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.ticket_holder_phone_num
     *
     * @param ticketHolderPhoneNum the value for organization_extra.ticket_holder_phone_num
     *
     * @mbg.generated
     */
    public void setTicketHolderPhoneNum(String ticketHolderPhoneNum) {
        this.ticketHolderPhoneNum = ticketHolderPhoneNum == null ? null : ticketHolderPhoneNum.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.national_tax_hall_address
     *
     * @return the value of organization_extra.national_tax_hall_address
     *
     * @mbg.generated
     */
    public String getNationalTaxHallAddress() {
        return nationalTaxHallAddress;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.national_tax_hall_address
     *
     * @param nationalTaxHallAddress the value for organization_extra.national_tax_hall_address
     *
     * @mbg.generated
     */
    public void setNationalTaxHallAddress(String nationalTaxHallAddress) {
        this.nationalTaxHallAddress = nationalTaxHallAddress == null ? null : nationalTaxHallAddress.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.national_tax_administrator_name
     *
     * @return the value of organization_extra.national_tax_administrator_name
     *
     * @mbg.generated
     */
    public String getNationalTaxAdministratorName() {
        return nationalTaxAdministratorName;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.national_tax_administrator_name
     *
     * @param nationalTaxAdministratorName the value for organization_extra.national_tax_administrator_name
     *
     * @mbg.generated
     */
    public void setNationalTaxAdministratorName(String nationalTaxAdministratorName) {
        this.nationalTaxAdministratorName = nationalTaxAdministratorName == null ? null : nationalTaxAdministratorName.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.national_tax_administrator_phone_num
     *
     * @return the value of organization_extra.national_tax_administrator_phone_num
     *
     * @mbg.generated
     */
    public String getNationalTaxAdministratorPhoneNum() {
        return nationalTaxAdministratorPhoneNum;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.national_tax_administrator_phone_num
     *
     * @param nationalTaxAdministratorPhoneNum the value for organization_extra.national_tax_administrator_phone_num
     *
     * @mbg.generated
     */
    public void setNationalTaxAdministratorPhoneNum(String nationalTaxAdministratorPhoneNum) {
        this.nationalTaxAdministratorPhoneNum = nationalTaxAdministratorPhoneNum == null ? null : nationalTaxAdministratorPhoneNum.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.local_tax_hall_address
     *
     * @return the value of organization_extra.local_tax_hall_address
     *
     * @mbg.generated
     */
    public String getLocalTaxHallAddress() {
        return localTaxHallAddress;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.local_tax_hall_address
     *
     * @param localTaxHallAddress the value for organization_extra.local_tax_hall_address
     *
     * @mbg.generated
     */
    public void setLocalTaxHallAddress(String localTaxHallAddress) {
        this.localTaxHallAddress = localTaxHallAddress == null ? null : localTaxHallAddress.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.local_tax_administrator_name
     *
     * @return the value of organization_extra.local_tax_administrator_name
     *
     * @mbg.generated
     */
    public String getLocalTaxAdministratorName() {
        return localTaxAdministratorName;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.local_tax_administrator_name
     *
     * @param localTaxAdministratorName the value for organization_extra.local_tax_administrator_name
     *
     * @mbg.generated
     */
    public void setLocalTaxAdministratorName(String localTaxAdministratorName) {
        this.localTaxAdministratorName = localTaxAdministratorName == null ? null : localTaxAdministratorName.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.local_tax_administrator_phone_num
     *
     * @return the value of organization_extra.local_tax_administrator_phone_num
     *
     * @mbg.generated
     */
    public String getLocalTaxAdministratorPhoneNum() {
        return localTaxAdministratorPhoneNum;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.local_tax_administrator_phone_num
     *
     * @param localTaxAdministratorPhoneNum the value for organization_extra.local_tax_administrator_phone_num
     *
     * @mbg.generated
     */
    public void setLocalTaxAdministratorPhoneNum(String localTaxAdministratorPhoneNum) {
        this.localTaxAdministratorPhoneNum = localTaxAdministratorPhoneNum == null ? null : localTaxAdministratorPhoneNum.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.eta_website
     *
     * @return the value of organization_extra.eta_website
     *
     * @mbg.generated
     */
    public String getEtaWebsite() {
        return etaWebsite;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.eta_website
     *
     * @param etaWebsite the value for organization_extra.eta_website
     *
     * @mbg.generated
     */
    public void setEtaWebsite(String etaWebsite) {
        this.etaWebsite = etaWebsite == null ? null : etaWebsite.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.sign_tripartite_agreement
     *
     * @return the value of organization_extra.sign_tripartite_agreement
     *
     * @mbg.generated
     */
    public Boolean getSignTripartiteAgreement() {
        return signTripartiteAgreement;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.sign_tripartite_agreement
     *
     * @param signTripartiteAgreement the value for organization_extra.sign_tripartite_agreement
     *
     * @mbg.generated
     */
    public void setSignTripartiteAgreement(Boolean signTripartiteAgreement) {
        this.signTripartiteAgreement = signTripartiteAgreement;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.reporting_currency
     *
     * @return the value of organization_extra.reporting_currency
     *
     * @mbg.generated
     */
    public String getReportingCurrency() {
        return reportingCurrency;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.reporting_currency
     *
     * @param reportingCurrency the value for organization_extra.reporting_currency
     *
     * @mbg.generated
     */
    public void setReportingCurrency(String reportingCurrency) {
        this.reportingCurrency = reportingCurrency == null ? null : reportingCurrency.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.consolidation_time
     *
     * @return the value of organization_extra.consolidation_time
     *
     * @mbg.generated
     */
    public Date getConsolidationTime() {
        return consolidationTime;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.consolidation_time
     *
     * @param consolidationTime the value for organization_extra.consolidation_time
     *
     * @mbg.generated
     */
    public void setConsolidationTime(Date consolidationTime) {
        this.consolidationTime = consolidationTime;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.fiscal_year_deadline
     *
     * @return the value of organization_extra.fiscal_year_deadline
     *
     * @mbg.generated
     */
    public Date getFiscalYearDeadline() {
        return fiscalYearDeadline;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.fiscal_year_deadline
     *
     * @param fiscalYearDeadline the value for organization_extra.fiscal_year_deadline
     *
     * @mbg.generated
     */
    public void setFiscalYearDeadline(Date fiscalYearDeadline) {
        this.fiscalYearDeadline = fiscalYearDeadline;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.tax_agent
     *
     * @return the value of organization_extra.tax_agent
     *
     * @mbg.generated
     */
    public String getTaxAgent() {
        return taxAgent;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.tax_agent
     *
     * @param taxAgent the value for organization_extra.tax_agent
     *
     * @mbg.generated
     */
    public void setTaxAgent(String taxAgent) {
        this.taxAgent = taxAgent == null ? null : taxAgent.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.tax_agent_contact
     *
     * @return the value of organization_extra.tax_agent_contact
     *
     * @mbg.generated
     */
    public String getTaxAgentContact() {
        return taxAgentContact;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.tax_agent_contact
     *
     * @param taxAgentContact the value for organization_extra.tax_agent_contact
     *
     * @mbg.generated
     */
    public void setTaxAgentContact(String taxAgentContact) {
        this.taxAgentContact = taxAgentContact == null ? null : taxAgentContact.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.other_facts
     *
     * @return the value of organization_extra.other_facts
     *
     * @mbg.generated
     */
    public String getOtherFacts() {
        return otherFacts;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.other_facts
     *
     * @param otherFacts the value for organization_extra.other_facts
     *
     * @mbg.generated
     */
    public void setOtherFacts(String otherFacts) {
        this.otherFacts = otherFacts == null ? null : otherFacts.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.tax_return_business_type
     *
     * @return the value of organization_extra.tax_return_business_type
     *
     * @mbg.generated
     */
    public Integer getTaxReturnBusinessType() {
        return taxReturnBusinessType;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.tax_return_business_type
     *
     * @param taxReturnBusinessType the value for organization_extra.tax_return_business_type
     *
     * @mbg.generated
     */
    public void setTaxReturnBusinessType(Integer taxReturnBusinessType) {
        this.taxReturnBusinessType = taxReturnBusinessType;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.small_meager_profit
     *
     * @return the value of organization_extra.small_meager_profit
     *
     * @mbg.generated
     */
    public Boolean getSmallMeagerProfit() {
        return smallMeagerProfit;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.small_meager_profit
     *
     * @param smallMeagerProfit the value for organization_extra.small_meager_profit
     *
     * @mbg.generated
     */
    public void setSmallMeagerProfit(Boolean smallMeagerProfit) {
        this.smallMeagerProfit = smallMeagerProfit;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.listed_company
     *
     * @return the value of organization_extra.listed_company
     *
     * @mbg.generated
     */
    public Boolean getListedCompany() {
        return listedCompany;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.listed_company
     *
     * @param listedCompany the value for organization_extra.listed_company
     *
     * @mbg.generated
     */
    public void setListedCompany(Boolean listedCompany) {
        this.listedCompany = listedCompany;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.applicable_accounting_standards_or_accounting_systems
     *
     * @return the value of organization_extra.applicable_accounting_standards_or_accounting_systems
     *
     * @mbg.generated
     */
    public Integer getApplicableAccountingStandardsOrAccountingSystems() {
        return applicableAccountingStandardsOrAccountingSystems;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.applicable_accounting_standards_or_accounting_systems
     *
     * @param applicableAccountingStandardsOrAccountingSystems the value for organization_extra.applicable_accounting_standards_or_accounting_systems
     *
     * @mbg.generated
     */
    public void setApplicableAccountingStandardsOrAccountingSystems(Integer applicableAccountingStandardsOrAccountingSystems) {
        this.applicableAccountingStandardsOrAccountingSystems = applicableAccountingStandardsOrAccountingSystems;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.tax_payer_number_vat
     *
     * @return the value of organization_extra.tax_payer_number_vat
     *
     * @mbg.generated
     */
    public String getTaxPayerNumberVat() {
        return taxPayerNumberVat;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.tax_payer_number_vat
     *
     * @param taxPayerNumberVat the value for organization_extra.tax_payer_number_vat
     *
     * @mbg.generated
     */
    public void setTaxPayerNumberVat(String taxPayerNumberVat) {
        this.taxPayerNumberVat = taxPayerNumberVat == null ? null : taxPayerNumberVat.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.tax_payer_number_cit
     *
     * @return the value of organization_extra.tax_payer_number_cit
     *
     * @mbg.generated
     */
    public String getTaxPayerNumberCit() {
        return taxPayerNumberCit;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.tax_payer_number_cit
     *
     * @param taxPayerNumberCit the value for organization_extra.tax_payer_number_cit
     *
     * @mbg.generated
     */
    public void setTaxPayerNumberCit(String taxPayerNumberCit) {
        this.taxPayerNumberCit = taxPayerNumberCit == null ? null : taxPayerNumberCit.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.tax_client_person_email_address
     *
     * @return the value of organization_extra.tax_client_person_email_address
     *
     * @mbg.generated
     */
    public String getTaxClientPersonEmailAddress() {
        return taxClientPersonEmailAddress;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.tax_client_person_email_address
     *
     * @param taxClientPersonEmailAddress the value for organization_extra.tax_client_person_email_address
     *
     * @mbg.generated
     */
    public void setTaxClientPersonEmailAddress(String taxClientPersonEmailAddress) {
        this.taxClientPersonEmailAddress = taxClientPersonEmailAddress == null ? null : taxClientPersonEmailAddress.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.bank_account_name
     *
     * @return the value of organization_extra.bank_account_name
     *
     * @mbg.generated
     */
    public String getBankAccountName() {
        return bankAccountName;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.bank_account_name
     *
     * @param bankAccountName the value for organization_extra.bank_account_name
     *
     * @mbg.generated
     */
    public void setBankAccountName(String bankAccountName) {
        this.bankAccountName = bankAccountName == null ? null : bankAccountName.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.bank_account_number
     *
     * @return the value of organization_extra.bank_account_number
     *
     * @mbg.generated
     */
    public String getBankAccountNumber() {
        return bankAccountNumber;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.bank_account_number
     *
     * @param bankAccountNumber the value for organization_extra.bank_account_number
     *
     * @mbg.generated
     */
    public void setBankAccountNumber(String bankAccountNumber) {
        this.bankAccountNumber = bankAccountNumber == null ? null : bankAccountNumber.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.legal_person_name
     *
     * @return the value of organization_extra.legal_person_name
     *
     * @mbg.generated
     */
    public String getLegalPersonName() {
        return legalPersonName;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.legal_person_name
     *
     * @param legalPersonName the value for organization_extra.legal_person_name
     *
     * @mbg.generated
     */
    public void setLegalPersonName(String legalPersonName) {
        this.legalPersonName = legalPersonName == null ? null : legalPersonName.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.legal_person_phone_number
     *
     * @return the value of organization_extra.legal_person_phone_number
     *
     * @mbg.generated
     */
    public String getLegalPersonPhoneNumber() {
        return legalPersonPhoneNumber;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.legal_person_phone_number
     *
     * @param legalPersonPhoneNumber the value for organization_extra.legal_person_phone_number
     *
     * @mbg.generated
     */
    public void setLegalPersonPhoneNumber(String legalPersonPhoneNumber) {
        this.legalPersonPhoneNumber = legalPersonPhoneNumber == null ? null : legalPersonPhoneNumber.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.legal_person_landline_num
     *
     * @return the value of organization_extra.legal_person_landline_num
     *
     * @mbg.generated
     */
    public String getLegalPersonLandlineNum() {
        return legalPersonLandlineNum;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.legal_person_landline_num
     *
     * @param legalPersonLandlineNum the value for organization_extra.legal_person_landline_num
     *
     * @mbg.generated
     */
    public void setLegalPersonLandlineNum(String legalPersonLandlineNum) {
        this.legalPersonLandlineNum = legalPersonLandlineNum == null ? null : legalPersonLandlineNum.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.legal_person_email_address
     *
     * @return the value of organization_extra.legal_person_email_address
     *
     * @mbg.generated
     */
    public String getLegalPersonEmailAddress() {
        return legalPersonEmailAddress;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.legal_person_email_address
     *
     * @param legalPersonEmailAddress the value for organization_extra.legal_person_email_address
     *
     * @mbg.generated
     */
    public void setLegalPersonEmailAddress(String legalPersonEmailAddress) {
        this.legalPersonEmailAddress = legalPersonEmailAddress == null ? null : legalPersonEmailAddress.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.reg_financial_officer_name
     *
     * @return the value of organization_extra.reg_financial_officer_name
     *
     * @mbg.generated
     */
    public String getRegFinancialOfficerName() {
        return regFinancialOfficerName;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.reg_financial_officer_name
     *
     * @param regFinancialOfficerName the value for organization_extra.reg_financial_officer_name
     *
     * @mbg.generated
     */
    public void setRegFinancialOfficerName(String regFinancialOfficerName) {
        this.regFinancialOfficerName = regFinancialOfficerName == null ? null : regFinancialOfficerName.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.reg_financial_officer_phone_num
     *
     * @return the value of organization_extra.reg_financial_officer_phone_num
     *
     * @mbg.generated
     */
    public String getRegFinancialOfficerPhoneNum() {
        return regFinancialOfficerPhoneNum;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.reg_financial_officer_phone_num
     *
     * @param regFinancialOfficerPhoneNum the value for organization_extra.reg_financial_officer_phone_num
     *
     * @mbg.generated
     */
    public void setRegFinancialOfficerPhoneNum(String regFinancialOfficerPhoneNum) {
        this.regFinancialOfficerPhoneNum = regFinancialOfficerPhoneNum == null ? null : regFinancialOfficerPhoneNum.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.reg_financial_officer_landline_num
     *
     * @return the value of organization_extra.reg_financial_officer_landline_num
     *
     * @mbg.generated
     */
    public String getRegFinancialOfficerLandlineNum() {
        return regFinancialOfficerLandlineNum;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.reg_financial_officer_landline_num
     *
     * @param regFinancialOfficerLandlineNum the value for organization_extra.reg_financial_officer_landline_num
     *
     * @mbg.generated
     */
    public void setRegFinancialOfficerLandlineNum(String regFinancialOfficerLandlineNum) {
        this.regFinancialOfficerLandlineNum = regFinancialOfficerLandlineNum == null ? null : regFinancialOfficerLandlineNum.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.reg_financial_officer_email_address
     *
     * @return the value of organization_extra.reg_financial_officer_email_address
     *
     * @mbg.generated
     */
    public String getRegFinancialOfficerEmailAddress() {
        return regFinancialOfficerEmailAddress;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.reg_financial_officer_email_address
     *
     * @param regFinancialOfficerEmailAddress the value for organization_extra.reg_financial_officer_email_address
     *
     * @mbg.generated
     */
    public void setRegFinancialOfficerEmailAddress(String regFinancialOfficerEmailAddress) {
        this.regFinancialOfficerEmailAddress = regFinancialOfficerEmailAddress == null ? null : regFinancialOfficerEmailAddress.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.secondary_approval_amount
     *
     * @return the value of organization_extra.secondary_approval_amount
     *
     * @mbg.generated
     */
    public Long getSecondaryApprovalAmount() {
        return secondaryApprovalAmount;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.secondary_approval_amount
     *
     * @param secondaryApprovalAmount the value for organization_extra.secondary_approval_amount
     *
     * @mbg.generated
     */
    public void setSecondaryApprovalAmount(Long secondaryApprovalAmount) {
        this.secondaryApprovalAmount = secondaryApprovalAmount;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.business_registration_number
     *
     * @return the value of organization_extra.business_registration_number
     *
     * @mbg.generated
     */
    public String getBusinessRegistrationNumber() {
        return businessRegistrationNumber;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.business_registration_number
     *
     * @param businessRegistrationNumber the value for organization_extra.business_registration_number
     *
     * @mbg.generated
     */
    public void setBusinessRegistrationNumber(String businessRegistrationNumber) {
        this.businessRegistrationNumber = businessRegistrationNumber == null ? null : businessRegistrationNumber.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.par_value
     *
     * @return the value of organization_extra.par_value
     *
     * @mbg.generated
     */
    public Float getParValue() {
        return parValue;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.par_value
     *
     * @param parValue the value for organization_extra.par_value
     *
     * @mbg.generated
     */
    public void setParValue(Float parValue) {
        this.parValue = parValue;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.issued_shares
     *
     * @return the value of organization_extra.issued_shares
     *
     * @mbg.generated
     */
    public Long getIssuedShares() {
        return issuedShares;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.issued_shares
     *
     * @param issuedShares the value for organization_extra.issued_shares
     *
     * @mbg.generated
     */
    public void setIssuedShares(Long issuedShares) {
        this.issuedShares = issuedShares;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.directors
     *
     * @return the value of organization_extra.directors
     *
     * @mbg.generated
     */
    public String getDirectors() {
        return directors;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.directors
     *
     * @param directors the value for organization_extra.directors
     *
     * @mbg.generated
     */
    public void setDirectors(String directors) {
        this.directors = directors == null ? null : directors.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.actual_business_address
     *
     * @return the value of organization_extra.actual_business_address
     *
     * @mbg.generated
     */
    public String getActualBusinessAddress() {
        return actualBusinessAddress;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.actual_business_address
     *
     * @param actualBusinessAddress the value for organization_extra.actual_business_address
     *
     * @mbg.generated
     */
    public void setActualBusinessAddress(String actualBusinessAddress) {
        this.actualBusinessAddress = actualBusinessAddress == null ? null : actualBusinessAddress.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.tax_rule_introduction
     *
     * @return the value of organization_extra.tax_rule_introduction
     *
     * @mbg.generated
     */
    public String getTaxRuleIntroduction() {
        return taxRuleIntroduction;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.tax_rule_introduction
     *
     * @param taxRuleIntroduction the value for organization_extra.tax_rule_introduction
     *
     * @mbg.generated
     */
    public void setTaxRuleIntroduction(String taxRuleIntroduction) {
        this.taxRuleIntroduction = taxRuleIntroduction == null ? null : taxRuleIntroduction.trim();
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method returns the value of the database column organization_extra.audit_requirements
     *
     * @return the value of organization_extra.audit_requirements
     *
     * @mbg.generated
     */
    public String getAuditRequirements() {
        return auditRequirements;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method sets the value of the database column organization_extra.audit_requirements
     *
     * @param auditRequirements the value for organization_extra.audit_requirements
     *
     * @mbg.generated
     */
    public void setAuditRequirements(String auditRequirements) {
        this.auditRequirements = auditRequirements == null ? null : auditRequirements.trim();
    }

    public String getArchitectureType() {
        return architectureType;
    }

    public void setArchitectureType(String architectureType) {
        this.architectureType = architectureType;
    }

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table organization_extra
     *
     * @mbg.generated
     */
    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", id=").append(id);
        sb.append(", organizationId=").append(organizationId);
        sb.append(", unifiedSocialCreditCode=").append(unifiedSocialCreditCode);
        sb.append(", regFinancialAccountingType=").append(regFinancialAccountingType);
        sb.append(", taxRegStatus=").append(taxRegStatus);
        sb.append(", taxCreditRating=").append(taxCreditRating);
        sb.append(", applicableAccountingRule=").append(applicableAccountingRule);
        sb.append(", lowValueConsumablesAmortizationMethod=").append(lowValueConsumablesAmortizationMethod);
        sb.append(", depreciationMethod=").append(depreciationMethod);
        sb.append(", accountingSoftware=").append(accountingSoftware);
        sb.append(", completeRecordTotalInstitutions=").append(completeRecordTotalInstitutions);
        sb.append(", taxClientPersonName=").append(taxClientPersonName);
        sb.append(", taxClientPersonPhoneNum=").append(taxClientPersonPhoneNum);
        sb.append(", taxClientPersonIdNum=").append(taxClientPersonIdNum);
        sb.append(", ticketHolderName=").append(ticketHolderName);
        sb.append(", ticketHolderPhoneNum=").append(ticketHolderPhoneNum);
        sb.append(", nationalTaxHallAddress=").append(nationalTaxHallAddress);
        sb.append(", nationalTaxAdministratorName=").append(nationalTaxAdministratorName);
        sb.append(", nationalTaxAdministratorPhoneNum=").append(nationalTaxAdministratorPhoneNum);
        sb.append(", localTaxHallAddress=").append(localTaxHallAddress);
        sb.append(", localTaxAdministratorName=").append(localTaxAdministratorName);
        sb.append(", localTaxAdministratorPhoneNum=").append(localTaxAdministratorPhoneNum);
        sb.append(", etaWebsite=").append(etaWebsite);
        sb.append(", signTripartiteAgreement=").append(signTripartiteAgreement);
        sb.append(", reportingCurrency=").append(reportingCurrency);
        sb.append(", consolidationTime=").append(consolidationTime);
        sb.append(", fiscalYearDeadline=").append(fiscalYearDeadline);
        sb.append(", taxAgent=").append(taxAgent);
        sb.append(", taxAgentContact=").append(taxAgentContact);
        sb.append(", otherFacts=").append(otherFacts);
        sb.append(", taxReturnBusinessType=").append(taxReturnBusinessType);
        sb.append(", smallMeagerProfit=").append(smallMeagerProfit);
        sb.append(", listedCompany=").append(listedCompany);
        sb.append(", applicableAccountingStandardsOrAccountingSystems=").append(applicableAccountingStandardsOrAccountingSystems);
        sb.append(", taxPayerNumberVat=").append(taxPayerNumberVat);
        sb.append(", taxPayerNumberCit=").append(taxPayerNumberCit);
        sb.append(", taxClientPersonEmailAddress=").append(taxClientPersonEmailAddress);
        sb.append(", bankAccountName=").append(bankAccountName);
        sb.append(", bankAccountNumber=").append(bankAccountNumber);
        sb.append(", legalPersonName=").append(legalPersonName);
        sb.append(", legalPersonPhoneNumber=").append(legalPersonPhoneNumber);
        sb.append(", legalPersonLandlineNum=").append(legalPersonLandlineNum);
        sb.append(", legalPersonEmailAddress=").append(legalPersonEmailAddress);
        sb.append(", regFinancialOfficerName=").append(regFinancialOfficerName);
        sb.append(", regFinancialOfficerPhoneNum=").append(regFinancialOfficerPhoneNum);
        sb.append(", regFinancialOfficerLandlineNum=").append(regFinancialOfficerLandlineNum);
        sb.append(", regFinancialOfficerEmailAddress=").append(regFinancialOfficerEmailAddress);
        sb.append(", secondaryApprovalAmount=").append(secondaryApprovalAmount);
        sb.append(", businessRegistrationNumber=").append(businessRegistrationNumber);
        sb.append(", parValue=").append(parValue);
        sb.append(", issuedShares=").append(issuedShares);
        sb.append(", directors=").append(directors);
        sb.append(", actualBusinessAddress=").append(actualBusinessAddress);
        sb.append(", taxRuleIntroduction=").append(taxRuleIntroduction);
        sb.append(", auditRequirements=").append(auditRequirements);
        sb.append("]");
        return sb.toString();
    }
}