package pwc.taxtech.atms.dto.stdaccount;

import com.fasterxml.jackson.annotation.JsonProperty;

import java.util.List;

public class StandardAccountDto {
    private String id;
    private String code;
    private String name;
    private String parentCode;
    private String fullName;
    private int number;
    private Boolean expanded;
    private Integer acctProp;
    private Integer subProp;
    private Integer acctLevel;
    private int direction;
    private Boolean isLeaf;
    private int ruleType;
    private Boolean isActive;
    private String englishName;
    @JsonProperty("industryID")
    private String industryId;
    private String title;
    private String etsName;

    private String etsCode;

    private List<StandardAccountDto> children;

    private String treeLevel;

    /// <summary>
    /// 父级科目名称
    /// </summary>
    /// <value>
    /// The name of the parent.
    /// </value>
    private String parentName;

    /// <summary>
    /// 父级科目全名
    /// </summary>
    /// <value>
    /// The full name of the parent.
    /// </value>
    private String parentFullName;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getParentCode() {
        return parentCode;
    }

    public void setParentCode(String parentCode) {
        this.parentCode = parentCode;
    }

    public String getFullName() {
        return fullName;
    }

    public void setFullName(String fullName) {
        this.fullName = fullName;
    }

    public int getNumber() {
        return number;
    }

    public void setNumber(int number) {
        this.number = number;
    }

    public Boolean getExpanded() {
        return expanded;
    }

    public void setExpanded(Boolean expanded) {
        this.expanded = expanded;
    }

    public Integer getAcctProp() {
        return acctProp;
    }

    public void setAcctProp(Integer acctProp) {
        this.acctProp = acctProp;
    }

    public Integer getSubProp() {
        return subProp;
    }

    public void setSubProp(Integer subProp) {
        this.subProp = subProp;
    }

    public Integer getAcctLevel() {
        return acctLevel;
    }

    public void setAcctLevel(Integer acctLevel) {
        this.acctLevel = acctLevel;
    }

    public int getDirection() {
        return direction;
    }

    public void setDirection(int direction) {
        this.direction = direction;
    }

    public Boolean getIsLeaf() {
        return this.isLeaf;
    }

    public void setIsLeaf(Boolean leaf) {
        this.isLeaf = leaf;
    }

    public int getRuleType() {
        return ruleType;
    }

    public void setRuleType(int ruleType) {
        this.ruleType = ruleType;
    }

    public Boolean getIsActive() {
        return this.isActive;
    }

    public void setIsActive(Boolean active) {
        this.isActive = active;
    }

    public String getEnglishName() {
        return englishName;
    }

    public void setEnglishName(String englishName) {
        this.englishName = englishName;
    }

    public String getIndustryId() {
        return industryId;
    }

    public void setIndustryId(String industryId) {
        this.industryId = industryId;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getEtsName() {
        return etsName;
    }

    public void setEtsName(String etsName) {
        this.etsName = etsName;
    }

    public String getEtsCode() {
        return etsCode;
    }

    public void setEtsCode(String etsCode) {
        this.etsCode = etsCode;
    }

    public List<StandardAccountDto> getChildren() {
        return children;
    }

    public void setChildren(List<StandardAccountDto> children) {
        this.children = children;
    }

    public String getTreeLevel() {
        return treeLevel;
    }

    public void setTreeLevel(String treeLevel) {
        this.treeLevel = treeLevel;
    }

    public String getParentName() {
        return parentName;
    }

    public void setParentName(String parentName) {
        this.parentName = parentName;
    }

    public String getParentFullName() {
        return parentFullName;
    }

    public void setParentFullName(String parentFullName) {
        this.parentFullName = parentFullName;
    }

}
