package pwc.taxtech.atms.dto.vatdto;

import com.fasterxml.jackson.annotation.JsonProperty;
import pwc.taxtech.atms.constant.enums.FormulaDataSourceType;

import java.math.BigDecimal;
import java.util.Date;

public class AssetDetailDataSourceDto extends FormulaDataSourceDto {
    public AssetDetailDataSourceDto() {
        super();
        this.setType(FormulaDataSourceType.AssetListSource.getCode());
    }

    public String assetNumber;
    public String assetGroupName;
    @JsonProperty("assetDetailGroupID")
    public String assetDetailGroupId;
    public String assetDescription;
    public Date buyDate;
    public Date depreciationDate;
    public Integer depreciationPeriod;
    public BigDecimal acquisitionValue;
    public BigDecimal adjustmentValue;
    public Date disposedDate;
    public BigDecimal residualRate;
    public BigDecimal yearDepreciationAmount;
    public BigDecimal yearAdjustmentAmount;
    public BigDecimal yearEndValue;
    public Integer status;
    public BigDecimal accountAcquisitionValue;
    public BigDecimal accountMonthDepreciationAmount;
    public BigDecimal accountYearDepreciationAmount;
    public BigDecimal accountTotalepreciationAmount;
    public Integer taxDepreciationPeriod;
    public Integer taxToLastYearDepreciationPeriod;
    public Integer taxToCurrentYearDepreciationPeriod;
    public Integer taxYearDepreciationPeriod;
    public BigDecimal taxMonthDepreciationAmount;
    public BigDecimal taxToCurrentYearDepreciationAmount;
    public BigDecimal taxCurrentYearDepreciationAmount;
    public BigDecimal totalDifferenceAmount;
    public BigDecimal yearDifferenceAmount;
    public Integer assetType;
    public Boolean isRetain;
    public String assetDetailGroupName;
    //判断是取哪一列的值
    public int dataType;
    public Integer detailGroupType;

    public String getAssetNumber() {
        return this.assetNumber;
    }

    public void setAssetNumber(String assetNumber) {
        this.assetNumber = assetNumber;
    }

    public String getAssetGroupName() {
        return this.assetGroupName;
    }

    public void setAssetGroupName(String assetGroupName) {
        this.assetGroupName = assetGroupName;
    }

    public String getAssetDetailGroupId() {
        return this.assetDetailGroupId;
    }

    public void setAssetDetailGroupId(String assetDetailGroupId) {
        this.assetDetailGroupId = assetDetailGroupId;
    }

    public String getAssetDescription() {
        return this.assetDescription;
    }

    public void setAssetDescription(String assetDescription) {
        this.assetDescription = assetDescription;
    }

    public Date getBuyDate() {
        return this.buyDate;
    }

    public void setBuyDate(Date buyDate) {
        this.buyDate = buyDate;
    }

    public Date getDepreciationDate() {
        return this.depreciationDate;
    }

    public void setDepreciationDate(Date depreciationDate) {
        this.depreciationDate = depreciationDate;
    }

    public Integer getDepreciationPeriod() {
        return this.depreciationPeriod;
    }

    public void setDepreciationPeriod(Integer depreciationPeriod) {
        this.depreciationPeriod = depreciationPeriod;
    }

    public BigDecimal getAcquisitionValue() {
        return this.acquisitionValue;
    }

    public void setAcquisitionValue(BigDecimal acquisitionValue) {
        this.acquisitionValue = acquisitionValue;
    }

    public BigDecimal getAdjustmentValue() {
        return this.adjustmentValue;
    }

    public void setAdjustmentValue(BigDecimal adjustmentValue) {
        this.adjustmentValue = adjustmentValue;
    }

    public Date getDisposedDate() {
        return this.disposedDate;
    }

    public void setDisposedDate(Date disposedDate) {
        this.disposedDate = disposedDate;
    }

    public BigDecimal getResidualRate() {
        return this.residualRate;
    }

    public void setResidualRate(BigDecimal residualRate) {
        this.residualRate = residualRate;
    }

    public BigDecimal getYearDepreciationAmount() {
        return this.yearDepreciationAmount;
    }

    public void setYearDepreciationAmount(BigDecimal yearDepreciationAmount) {
        this.yearDepreciationAmount = yearDepreciationAmount;
    }

    public BigDecimal getYearAdjustmentAmount() {
        return this.yearAdjustmentAmount;
    }

    public void setYearAdjustmentAmount(BigDecimal yearAdjustmentAmount) {
        this.yearAdjustmentAmount = yearAdjustmentAmount;
    }

    public BigDecimal getYearEndValue() {
        return this.yearEndValue;
    }

    public void setYearEndValue(BigDecimal yearEndValue) {
        this.yearEndValue = yearEndValue;
    }

    public Integer getStatus() {
        return this.status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public BigDecimal getAccountAcquisitionValue() {
        return this.accountAcquisitionValue;
    }

    public void setAccountAcquisitionValue(BigDecimal accountAcquisitionValue) {
        this.accountAcquisitionValue = accountAcquisitionValue;
    }

    public BigDecimal getAccountMonthDepreciationAmount() {
        return this.accountMonthDepreciationAmount;
    }

    public void setAccountMonthDepreciationAmount(BigDecimal accountMonthDepreciationAmount) {
        this.accountMonthDepreciationAmount = accountMonthDepreciationAmount;
    }

    public BigDecimal getAccountYearDepreciationAmount() {
        return this.accountYearDepreciationAmount;
    }

    public void setAccountYearDepreciationAmount(BigDecimal accountYearDepreciationAmount) {
        this.accountYearDepreciationAmount = accountYearDepreciationAmount;
    }

    public BigDecimal getAccountTotalepreciationAmount() {
        return this.accountTotalepreciationAmount;
    }

    public void setAccountTotalepreciationAmount(BigDecimal accountTotalepreciationAmount) {
        this.accountTotalepreciationAmount = accountTotalepreciationAmount;
    }

    public Integer getTaxDepreciationPeriod() {
        return this.taxDepreciationPeriod;
    }

    public void setTaxDepreciationPeriod(Integer taxDepreciationPeriod) {
        this.taxDepreciationPeriod = taxDepreciationPeriod;
    }

    public Integer getTaxToLastYearDepreciationPeriod() {
        return this.taxToLastYearDepreciationPeriod;
    }

    public void setTaxToLastYearDepreciationPeriod(Integer taxToLastYearDepreciationPeriod) {
        this.taxToLastYearDepreciationPeriod = taxToLastYearDepreciationPeriod;
    }

    public Integer getTaxToCurrentYearDepreciationPeriod() {
        return this.taxToCurrentYearDepreciationPeriod;
    }

    public void setTaxToCurrentYearDepreciationPeriod(Integer taxToCurrentYearDepreciationPeriod) {
        this.taxToCurrentYearDepreciationPeriod = taxToCurrentYearDepreciationPeriod;
    }

    public Integer getTaxYearDepreciationPeriod() {
        return this.taxYearDepreciationPeriod;
    }

    public void setTaxYearDepreciationPeriod(Integer taxYearDepreciationPeriod) {
        this.taxYearDepreciationPeriod = taxYearDepreciationPeriod;
    }

    public BigDecimal getTaxMonthDepreciationAmount() {
        return this.taxMonthDepreciationAmount;
    }

    public void setTaxMonthDepreciationAmount(BigDecimal taxMonthDepreciationAmount) {
        this.taxMonthDepreciationAmount = taxMonthDepreciationAmount;
    }

    public BigDecimal getTaxToCurrentYearDepreciationAmount() {
        return this.taxToCurrentYearDepreciationAmount;
    }

    public void setTaxToCurrentYearDepreciationAmount(BigDecimal taxToCurrentYearDepreciationAmount) {
        this.taxToCurrentYearDepreciationAmount = taxToCurrentYearDepreciationAmount;
    }

    public BigDecimal getTaxCurrentYearDepreciationAmount() {
        return this.taxCurrentYearDepreciationAmount;
    }

    public void setTaxCurrentYearDepreciationAmount(BigDecimal taxCurrentYearDepreciationAmount) {
        this.taxCurrentYearDepreciationAmount = taxCurrentYearDepreciationAmount;
    }

    public BigDecimal getTotalDifferenceAmount() {
        return this.totalDifferenceAmount;
    }

    public void setTotalDifferenceAmount(BigDecimal totalDifferenceAmount) {
        this.totalDifferenceAmount = totalDifferenceAmount;
    }

    public BigDecimal getYearDifferenceAmount() {
        return this.yearDifferenceAmount;
    }

    public void setYearDifferenceAmount(BigDecimal yearDifferenceAmount) {
        this.yearDifferenceAmount = yearDifferenceAmount;
    }

    public Integer getAssetType() {
        return this.assetType;
    }

    public void setAssetType(Integer assetType) {
        this.assetType = assetType;
    }

    public Boolean getIsRetain() {
        return this.isRetain;
    }

    public void setIsRetain(Boolean retain) {
        this.isRetain = retain;
    }

    public String getAssetDetailGroupName() {
        return this.assetDetailGroupName;
    }

    public void setAssetDetailGroupName(String assetDetailGroupName) {
        this.assetDetailGroupName = assetDetailGroupName;
    }

    public int getDataType() {
        return this.dataType;
    }

    public void setDataType(int dataType) {
        this.dataType = dataType;
    }

    public Integer getDetailGroupType() {
        return this.detailGroupType;
    }

    public void setDetailGroupType(Integer detailGroupType) {
        this.detailGroupType = detailGroupType;
    }
}
