package pwc.taxtech.atms.dto.vatdto;

import org.apache.poi.ss.formula.OperationEvaluationContext;
import pwc.taxtech.atms.constant.DataSourceName;
import pwc.taxtech.atms.constant.enums.FormulaDataSourceType;
import pwc.taxtech.atms.dpo.CellTemplatePerGroupDto;
import pwc.taxtech.atms.vat.entity.PeriodCellData;
import pwc.taxtech.atms.vat.service.impl.report.functions.FormulaContext;

import java.math.BigDecimal;

public class ReportCellTableSUMIFDataSourceDto extends DataSourceDto  {
    private String tag = "RSUMIF";
    private String name;
    private Integer year;
    private Integer period;
    private Integer columnIndex;
    private String columnName;
    private Integer rowIndex;
    private String rowName;
    private String reportTemplateId;
    private String reportName;
    private String cellDataId;
    private String cellTemplateId;
    private Boolean isOnlyManualInput;
    private Integer type;
    private Integer resultType;
    private BigDecimal amount;
    private String tableName;
    private String filter;
    private String filterValue;

    public String getTableName() {
        return tableName;
    }

    public void setTableName(String tableName) {
        this.tableName = tableName;
    }

    public String getFilter() {
        return filter;
    }

    public void setFilter(String filter) {
        this.filter = filter;
    }

    public String getFilterValue() {
        return filterValue;
    }

    public void setFilterValue(String filterValue) {
        this.filterValue = filterValue;
    }

    public ReportCellTableSUMIFDataSourceDto() {
        this.type = FormulaDataSourceType.Report.getCode();
    }

    public  void  insertData(OperationEvaluationContext o, FormulaContext formulaContext) {
        this.rowIndex = o.getRowIndex();
        this.columnIndex = o.getColumnIndex();
        this.cellTemplateId = null;
        this.period = formulaContext.getPeriod();
        this.reportTemplateId = formulaContext.getReportTemplateGroupId().toString();
        this.year = formulaContext.getYear();
        this.isOnlyManualInput = false;
        this.reportName = formulaContext.getReportTemplateGroupId().toString();
        this.name = DataSourceName.ReportDataSource;
    }

    public  void  insertQMYEData(OperationEvaluationContext o, FormulaContext formulaContext) {
        this.tag = "QMYE";
        this.rowIndex = o.getRowIndex();
        this.columnIndex = o.getColumnIndex();
        this.cellTemplateId = null;
        this.period = formulaContext.getPeriod();
        this.reportTemplateId = formulaContext.getReportTemplateGroupId().toString();
        this.year = formulaContext.getYear();
        this.isOnlyManualInput = false;
        this.reportName = formulaContext.getReportTemplateGroupId().toString();
        this.name = DataSourceName.ReportDataSource;
    }



    public String getTag() {
        return this.tag;
    }

    public void setTag(String tag) {
        this.tag = tag;
    }

    @Override
    public String getName() {
        return this.name;
    }

    @Override
    public void setName(String name) {
        this.name = name;
    }

    @Override
    public Integer getYear() {
        return this.year;
    }

    @Override
    public void setYear(Integer year) {
        this.year = year;
    }

    @Override
    public Integer getPeriod() {
        return this.period;
    }

    @Override
    public void setPeriod(Integer period) {
        this.period = period;
    }

    @Override
    public Integer getColumnIndex() {
        return this.columnIndex;
    }

    @Override
    public void setColumnIndex(Integer columnIndex) {
        this.columnIndex = columnIndex;
    }

    @Override
    public String getColumnName() {
        return this.columnName;
    }

    @Override
    public void setColumnName(String columnName) {
        this.columnName = columnName;
    }

    @Override
    public Integer getRowIndex() {
        return this.rowIndex;
    }

    @Override
    public void setRowIndex(Integer rowIndex) {
        this.rowIndex = rowIndex;
    }

    @Override
    public String getRowName() {
        return this.rowName;
    }

    @Override
    public void setRowName(String rowName) {
        this.rowName = rowName;
    }

    @Override
    public String getReportTemplateId() {
        return this.reportTemplateId;
    }

    @Override
    public void setReportTemplateId(String reportTemplateId) {
        this.reportTemplateId = reportTemplateId;
    }

    public String getReportName() {
        return this.reportName;
    }

    public void setReportName(String reportName) {
        this.reportName = reportName;
    }

    @Override
    public String getCellDataId() {
        return this.cellDataId;
    }

    @Override
    public void setCellDataId(String cellDataId) {
        this.cellDataId = cellDataId;
    }

    @Override
    public String getCellTemplateId() {
        return this.cellTemplateId;
    }

    @Override
    public void setCellTemplateId(String cellTemplateId) {
        this.cellTemplateId = cellTemplateId;
    }

    public Boolean getIsOnlyManualInput() {
        return this.isOnlyManualInput;
    }

    public void setIsOnlyManualInput(Boolean onlyManualInput) {
        this.isOnlyManualInput = onlyManualInput;
    }

    @Override
    public Integer getType() {
        return this.type;
    }

    @Override
    public void setType(Integer type) {
        this.type = type;
    }

    @Override
    public Integer getResultType() {
        return this.resultType;
    }

    @Override
    public void setResultType(Integer resultType) {
        this.resultType = resultType;
    }

    @Override
    public BigDecimal getAmount() {
        return this.amount;
    }

    @Override
    public void setAmount(BigDecimal amount) {
        this.amount = amount;
    }


    @Override
    public String toString() {
        return "ReportCellTableSUMIFDataSourceDto{" +
                "tag='" + tag + '\'' +
                ", name='" + name + '\'' +
                ", year=" + year +
                ", period=" + period +
                ", columnIndex=" + columnIndex +
                ", columnName='" + columnName + '\'' +
                ", rowIndex=" + rowIndex +
                ", rowName='" + rowName + '\'' +
                ", reportTemplateId='" + reportTemplateId + '\'' +
                ", reportName='" + reportName + '\'' +
                ", cellDataId='" + cellDataId + '\'' +
                ", cellTemplateId='" + cellTemplateId + '\'' +
                ", isOnlyManualInput=" + isOnlyManualInput +
                ", type=" + type +
                ", resultType=" + resultType +
                ", amount=" + amount +
                ", tableName='" + tableName + '\'' +
                ", filter='" + filter + '\'' +
                ", filterValue='" + filterValue + '\'' +
                '}';
    }

}
