package pwc.taxtech.atms.service.impl;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.springframework.stereotype.Service;
import pwc.taxtech.atms.dpo.BillDetailDto;
import pwc.taxtech.atms.dto.billDetail.BillDetailParam;
import pwc.taxtech.atms.dto.billDetail.BillDetailResult;
import pwc.taxtech.atms.vat.dao.InvoiceRecordMapper;
import pwc.taxtech.atms.vat.entity.InvoiceRecord;

import javax.annotation.Resource;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class BillDetailService extends BaseService {

    @Resource
    private InvoiceRecordMapper invoiceRecordMapper;


    public PageInfo<BillDetailResult> queryPage(BillDetailParam param) {
        Page page = PageHelper.startPage(param.getPageInfo().getPageIndex(), param.getPageInfo().getPageSize());
        List<BillDetailDto> dataList = invoiceRecordMapper.queryBillWithRevenueConf(param.getBillType(), param.getCustomer(), param.getBillNumber(), param.getRevenueCofId(), param.getBillContent(), param.getDepartment(), param.getBillTaxRat(), param.getBillDate(), param.getProjectId(), param.getPeriod(), param.getQueryDate());
        PageInfo<BillDetailResult> pageInfo = new PageInfo<>(dataList.stream()
                .map(o -> {
                    BillDetailResult detailResult = new BillDetailResult();
                    beanUtil.copyProperties(o, detailResult);
                    if (detailResult.getModifyRevenueCofId() != null) {
                        detailResult.setRevenueCofId(detailResult.getModifyRevenueCofId());
                        detailResult.setRevenueConfName(detailResult.getModifyRevenueCofName());
                    }
                    return detailResult;
                }).collect(Collectors.toList()));
        pageInfo.setTotal(page.getTotal());
        return pageInfo;
    }

    public List<String> queryBillTypeGroupBy(String projectId, Integer period) {
        return invoiceRecordMapper.queryBillTypeGroupBy(projectId, period);
    }

    public void updateBillDetail(InvoiceRecord billDetail) {
        if (billDetail.getRevenueCofId() != null && billDetail.getId() != null) {
            billDetail.setModifyRevenueCofId(billDetail.getRevenueCofId());
            invoiceRecordMapper.updateByPrimaryKeySelective(billDetail);
        }

    }
}
