package pwc.taxtech.atms.vat.service.impl.report.functions;

import pwc.taxtech.atms.entity.Project;
import pwc.taxtech.atms.vat.service.impl.FormulaAgent;

public class FormulaContext {
    private String projectId;
    private Long reportTemplateGroupId;
    private Long reportId;
    private String organizationId;
    private Integer period;
    private Integer year;
    private Boolean isYear;
    private String indexResultId;
    private Integer yearBeginPeriod;
    private Integer yearEndPeriod;
    private Boolean ifRound;
    private Boolean isValidation;
    private Boolean isDetailed;
    private Boolean isIndexAnalysis;
    private Boolean cacheHasIndexCode;

    /**
     * 如果BB公式在cache中取上期失败，是否去上期取
     */
    private Boolean ifCalcStackValue;

    /**
     * 如果为99，则实时计算；如果为-1，则不用于判断是否实时计算；其他情况会在对应时机计算并保存
     */
    private Integer calculateStatus;

    private FormulaAgent formulaAgent;

    //private Map<String, FormulaResult> replaceSpecialCellFormulaDic;

    public static FormulaContext extractContextFromProject(Project project){
        FormulaContext formulaContext = new FormulaContext();
        formulaContext.setProjectId(project.getId());
        formulaContext.setYear(project.getYear());
        formulaContext.setIfRound(true);
        formulaContext.setOrganizationId(project.getOrganizationId());
        formulaContext.setIfRound(true);
        return formulaContext;
    }

    public FormulaContext fixedFormula(Integer period,Long reportTemplateGroupId,FormulaAgent agent){
        this.period=period;
        this.formulaAgent=agent;
        this.reportTemplateGroupId=reportTemplateGroupId;
        this.isYear=(period==0);
        return this;
    }

    public String getProjectId() {
        return this.projectId;
    }

    public void setProjectId(String projectId) {
        this.projectId = projectId;
    }

    public Long getReportTemplateGroupId() {
        return this.reportTemplateGroupId;
    }

    public void setReportTemplateGroupId(Long reportTemplateGroupId) {
        this.reportTemplateGroupId = reportTemplateGroupId;
    }

    public Long getReportId() {
        return this.reportId;
    }

    public void setReportId(Long reportId) {
        this.reportId = reportId;
    }

    public String getOrganizationId() {
        return this.organizationId;
    }

    public void setOrganizationId(String organizationId) {
        this.organizationId = organizationId;
    }

    public Integer getPeriod() {
        return this.period;
    }

    public void setPeriod(Integer period) {
        this.period = period;
    }

    public Integer getYear() {
        return this.year;
    }

    public void setYear(Integer year) {
        this.year = year;
    }

    public Boolean getIsYear() {
        return this.isYear;
    }

    public void setIsYear(Boolean year) {
        this.isYear = year;
    }

    public String getIndexResultId() {
        return this.indexResultId;
    }

    public void setIndexResultId(String indexResultId) {
        this.indexResultId = indexResultId;
    }

    public Integer getYearBeginPeriod() {
        return this.yearBeginPeriod;
    }

    public void setYearBeginPeriod(Integer yearBeginPeriod) {
        this.yearBeginPeriod = yearBeginPeriod;
    }

    public Integer getYearEndPeriod() {
        return this.yearEndPeriod;
    }

    public void setYearEndPeriod(Integer yearEndPeriod) {
        this.yearEndPeriod = yearEndPeriod;
    }

    public Boolean getIfRound() {
        return this.ifRound;
    }

    public void setIfRound(Boolean ifRound) {
        this.ifRound = ifRound;
    }

    public Boolean getIsValidation() {
        return this.isValidation;
    }

    public void setIsValidation(Boolean validation) {
        this.isValidation = validation;
    }

    public Boolean getIsDetailed() {
        return this.isDetailed;
    }

    public void setIsDetailed(Boolean detailed) {
        this.isDetailed = detailed;
    }

    public Boolean getIsIndexAnalysis() {
        return this.isIndexAnalysis;
    }

    public void setIsIndexAnalysis(Boolean indexAnalysis) {
        this.isIndexAnalysis = indexAnalysis;
    }

    public Boolean getCacheHasIndexCode() {
        return this.cacheHasIndexCode;
    }

    public void setCacheHasIndexCode(Boolean cacheHasIndexCode) {
        this.cacheHasIndexCode = cacheHasIndexCode;
    }

    public Boolean getIfCalcStackValue() {
        return this.ifCalcStackValue;
    }

    public void setIfCalcStackValue(Boolean ifCalcStackValue) {
        this.ifCalcStackValue = ifCalcStackValue;
    }

    public Integer getCalculateStatus() {
        return this.calculateStatus;
    }

    public void setCalculateStatus(Integer calculateStatus) {
        this.calculateStatus = calculateStatus;
    }

    public FormulaAgent getFormulaAgent() {
        return this.formulaAgent;
    }

    public void setFormulaAgent(FormulaAgent formulaAgent) {
        this.formulaAgent = formulaAgent;
    }
}
