package pwc.taxtech.atms.vat.service.impl.report.functions;

import org.apache.poi.ss.formula.OperationEvaluationContext;
import org.apache.poi.ss.formula.eval.EvaluationException;
import org.apache.poi.ss.formula.eval.NumberEval;
import org.apache.poi.ss.formula.eval.StringEval;
import org.apache.poi.ss.formula.eval.ValueEval;
import org.apache.poi.ss.formula.functions.FreeRefFunction;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import pwc.taxtech.atms.exception.Exceptions;
/**
 * author kevin
 */
import java.math.BigDecimal;

import static pwc.taxtech.atms.common.util.FormulaUtil.resolverString;

public class SUM extends FunctionBase implements FreeRefFunction {
    final static ValueEval defaultEval = new StringEval("0");
    static final Logger LOGGER = LoggerFactory.getLogger(BB.class);
    public BigDecimal cellValue;

    public SUM(FormulaContext formulaContext) {
        super(formulaContext);
    }

    @Override
    public ValueEval evaluate(ValueEval[] valueEvals, OperationEvaluationContext operationEvaluationContext) {

        for (int i = 0, j = valueEvals.length; i < j; i++) {
            try {
                return new NumberEval(sum(getData(parameter(resolverString(valueEvals, operationEvaluationContext, i)))).doubleValue());
            } catch (EvaluationException e) {
                e.printStackTrace();
                return defaultEval;
            }
        }
        return defaultEval;
    }

    //检查参数合法性
    public String parameter(String parameter) {
        if (parameter.length() != 2){

            throw Exceptions.parameterError;
        }
        return parameter;
    }

    //数据获取
    public BigDecimal getData(String cellPos) {
        String cellCol = cellPos.substring(0, 1);
        String cellRow = cellPos.substring(1, 1);
        Long reportTemplateGroupId = formulaContext.getReportTemplateGroupId();
        return BigDecimal.valueOf(Long.parseLong(agent.getCellDataByPos(reportTemplateGroupId, formulaContext.getPeriod(), cellRow, cellCol, formulaContext.getProjectId()).get(0).getData()));

    }

    //进行sum计算
    public BigDecimal sum(BigDecimal bigDecimal) {
        cellValue.add(bigDecimal);
        return cellValue;
    }

}
