package pwc.taxtech.atms.vat.service.impl.report.functions;

import org.apache.poi.ss.formula.OperationEvaluationContext;
import org.apache.poi.ss.formula.eval.NumberEval;
import org.apache.poi.ss.formula.eval.ValueEval;
import org.apache.poi.ss.formula.functions.FreeRefFunction;
import pwc.taxtech.atms.constant.enums.FormulaDataSourceDetailType;

import java.math.BigDecimal;
import java.util.*;


/**
 *  预提重分类  获取预提费用
 */
public class YT extends FunctionBase implements FreeRefFunction {

    public YT(FormulaContext formulaContext) {
        super(formulaContext);
    }

    @Override
    public ValueEval evaluate(ValueEval[] args, OperationEvaluationContext ec) {
        try{
            List<Object> dataSource = new ArrayList<>();

            String formulaExpression = "YT()";

            logger.debug(formulaExpression);

            //预提
            BigDecimal advance = agent.getAdvance(formulaContext.getProjectId());
            //已批准标准发票金额
            BigDecimal approvedStandardInvoiceAmount = agent.getApprovedStandardInvoiceAmount(formulaContext.getProjectId());

            BigDecimal value =  advance.subtract(approvedStandardInvoiceAmount);

            Long dataSourceId = saveDataSource(ec, Collections.singletonList(dataSource),
                    FormulaDataSourceDetailType.AssetDetailDataSourceDto,
                    value, formulaContext.getPeriod(), formulaContext.getReportTemplateGroupId(), formulaContext.getProjectId());
            saveFormulaBlock(0, ec, formulaExpression,  value, dataSourceId, formulaContext.getProjectId());
            return new NumberEval(value.doubleValue());
        }catch (Exception e){
            return new NumberEval(0.00);
        }
    }
}