package pwc.taxtech.atms;

import java.util.HashMap;
import java.util.Map;

/**
 * @Auther: Gary J Li
 * @Date: 26/02/2019 13:50
 * @Description:
 */
public enum OrgKV {

    orgId("organizationId", "机构代码"),
    registrationCapital("registrationCapital", "注册资本"),
    paidInCapital("paidInCapital", "实缴资本"),
    regStatus("regStatus", "经营状态"),
    foundationDate("foundationDate", "成立日期"),
    legalCode("legalCode", "统一社会信用代码"),
    taxPayerNumber("taxPayerNumber", "纳税人识别号"),
//    dontKnow("clientCode", "注册号"),
//    dontKnow1("?", "组织机构代码"),
    registrationType("registrationType", "公司类型"),
    nationalEconomicIndustry("nationalEconomicIndustry", "所属行业"),//所属国民经济行业
//    area("area", "所属地区"),
    englishName("englishName", "英文名"),
    employeesNumEnd("employeesNumEnd", "参保人数"),
    registerAddress("registerAddress", "企业地址"),
    businessScope("businessScope", "经营范围"),
    eNum("eNum", "序号"),
    investorName("investorName", "股东（发起人）"),
    investmentRadio("investmentRadio", "持股比例"),//投资比例
    investmentAmount("investmentAmount", "认缴出资额"),//投资金额
    investmentAmount1("investmentAmount", "认缴出资额(万元)"),//投资金额
    investmentAmount2("investmentAmount", "认缴出资额(万美元)"),//投资金额
//    registrationCapital("registrationCapital", "认缴出资日期"),
    payableCapitalContributionAmount("payableCapitalContributionAmount", "实缴出资额(万元)"),//实缴出资金额
//    registrationCapital("registrationCapital", "实缴出资日期"),
    createTime("createTime", "变更日期"),
    comment("comment", "变更项目"),
    originalState("originalState", "变更前"),
    updateState("updateState", "变更后");

    private String attribute;

    private String name;

    public static final Map<String, String> Map = new HashMap<>();

    static {
        for (OrgKV kv : OrgKV.values()) {
            Map.put(kv.getName(), kv.getAttribute());
        }
    }

    OrgKV(String attribute, String name) {
        this.attribute = attribute;
        this.name = name;
    }

    public String getAttribute() {
        return attribute;
    }

    public String getName() {
        return name;
    }
}


