import Vue from 'vue'
import Router from 'vue-router'
import ChartApp from './views/ChartApp'
import Panel from './components/Panel'
import Mine from './components/Mine'

Vue.use(Router)

export default new Router({
    routes: [
        {
            path: '/',
            name: '',
            component: ChartApp,
            children: [
                {path: '/', name: 'panel', component: Panel},
                {path: 'mine', name: 'mine', component: Mine}
            ]
        },
        {
            path: '/about',
            name: 'about',
            // route level code-splitting
            // this generates a separate chunk (about.[hash].js) for this route
            // which is lazy-loaded when the route is visited.
            component: () => import(/* webpackChunkName: "about" */ './views/About.vue')
        }
    ]
})
