package pwc.taxtech.atms.web.controller;


import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;
import pwc.taxtech.atms.dto.ApiResultDto;
import pwc.taxtech.atms.web.service.OrangeHeapService;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;

@RestController
@RequestMapping("/OrangeHeap")
public class OrangeHeapController {

    @Resource
    private OrangeHeapService tableauService;

    private static Logger logger = LoggerFactory.getLogger(OrangeHeapController.class);
    //以上是示范代码
    //TODO 加入其他图表

    // 模板
//    @ResponseBody
//    @GetMapping("taxComparison")
//    public ApiResultDto getTaxComparison() {
//        return ApiResultDto.success(tableauService.getTaxComparison().orElse(StringUtils.EMPTY));
//    }

    @ResponseBody
    @GetMapping("getTableauTaxCategoryUnreturnedTax")
    public ApiResultDto getTableauTaxCategoryUnreturnedTax(HttpServletRequest request) {
        logger.info("进入税种未返还税金分析=~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
        return ApiResultDto.success(tableauService.getTableauTaxCategoryUnreturnedTax(request).orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauDistrictUnreturnedTax")
    public ApiResultDto getTableauDistrictUnreturnedTax(HttpServletRequest request) {
        logger.info("地区未返还税金分析=~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
        return ApiResultDto.success(tableauService.getTableauDistrictUnreturnedTax(request).orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauUnreturnedAndReturnedTax")
    public ApiResultDto getTableauUnreturnedAndReturnedTax(HttpServletRequest request) {
        return ApiResultDto.success(tableauService.getTableauUnreturnedAndReturnedTax(request).orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauCostAnalysis")
    public ApiResultDto getTableauCostAnalysis(HttpServletRequest request) {
        return ApiResultDto.success(tableauService.getTableauCostAnalysis(request).orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauDistrictProfitAndLoss")
    public ApiResultDto getTableauDistrictProfitAndLoss(HttpServletRequest request) {
        return ApiResultDto.success(tableauService.getTableauDistrictProfitAndLoss(request).orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauCompanyProfitAndLoss")
    public ApiResultDto getTableauCompanyProfitAndLoss(HttpServletRequest request) {
        return ApiResultDto.success(tableauService.getTableauCompanyProfitAndLoss(request).orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauDriverAndEmployee")
    public ApiResultDto getTableauDriverAndEmployee(HttpServletRequest request) {
        return ApiResultDto.success(tableauService.getTableauDriverAndEmployee(request).orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauGmvAndSubsidy")
    public ApiResultDto getTableauGmvAndSubsidy(HttpServletRequest request) {
        return ApiResultDto.success(tableauService.getTableauGmvAndSubsidy(request).orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauFileArrangement")
    public ApiResultDto getTableauFileArrangement(HttpServletRequest request) {
        return ApiResultDto.success(tableauService.getTableauFileArrangement(request).orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauGlobalOverview")
    public ApiResultDto getTableauGlobalOverview(HttpServletRequest request) {
        return ApiResultDto.success(tableauService.getTableauGlobalOverview(request).orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauGlobalBusiness")
    public ApiResultDto getTableauGlobalBusiness(HttpServletRequest request) {
        return ApiResultDto.success(tableauService.getTableauGlobalBusiness(request).orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauMexicanTax")
    public ApiResultDto getTableauMexicanTax(HttpServletRequest request) {
        return ApiResultDto.success(tableauService.getTableauMexicanTax(request).orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauAustralianTax")
    public ApiResultDto getTableauAustralianTax(HttpServletRequest request) {
        return ApiResultDto.success(tableauService.getTableauAustralianTax(request).orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauBrazilianTax")
    public ApiResultDto getTableauBrazilianTax(HttpServletRequest request) {
        return ApiResultDto.success(tableauService.getTableauBrazilianTax(request).orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauOtherTaxAnalysis")
    public ApiResultDto getTableauOtherTaxAnalysis(HttpServletRequest request) {
        return ApiResultDto.success(tableauService.getTableauOtherTaxAnalysis(request).orElse(StringUtils.EMPTY));
    }

}
