﻿$(function () {
    // store login info.
    var loginModel = {};
    var checkResult = {};
    var cookie = document.cookie;

    var ticket = "";

    var failFullLoginCount = 0, failMemberLoginCount = 0;

    if (!window.console) window.console = {};
    if (!window.console.log) window.console.log = function () { };

    jQuery.fn.center = function (outerWidth, outerHeight) {
        this.parent().css('position', 'relative');
        this.css('position', 'absolute');
        this.css('top', '50%');
        this.css('left', '50%');
        this.css('margin-left', '-' + (outerWidth || $(this).outerWidth()) / 2 + 'px');
        this.css('margin-top', '-' + (outerHeight || $(this).outerHeight()) / 2 + 'px');
        return this;
    };

    jQuery.fn.centerScreen = function (outerWidth, outerHeight) {
        this.css('position', 'fixed');
        this.css('top', '50%');
        this.css('left', '50%');
        this.css('margin-left', '-' + (outerWidth || $(this).outerWidth()) / 2 + 'px');
        this.css('margin-top', '-' + (outerHeight || $(this).outerHeight()) / 2 + 'px');
        return this;
    };

    var createIndicator = function () {
        $('.loadingImg').show();
    };

    var createIndicatorRemove = function () {
        $('.loadingImg').hide();
    }

    var loginForm = (function () {
        var mainForm = $('#mainForm');

        // first time initilize 
        var switchToDefault = function () {
            switchTo('#loginFull');
            $('loginFullEmail').focus();
        };

        var resetLoginModel = function (email, password,ticket,type) {
            loginModel = {
                email: email,
                password: password,
                ticket:ticket,
                type:type
            };
        }

        var canSwitch = function (element) {
            return element && element.parents('form').hasClass('show');
        };

        var focusFirst = function (targetForm) {
            if (targetForm) {
                var first = targetForm.find('input[type=text],input[type=password],input[type=email]').first();
                if (first) {
                    first.focus();
                }
            }
        };

        // switch to specified form
        var switchTo = function (target) {
            var currentForm = mainForm.find('form.show');
            var targetForm = $(target);
            if (currentForm.length > 0) {
                var current = currentForm.first();
                current.fadeOut(300, function () {
                    current.removeClass('show');
                    mainForm.stop().animate({
                        width: (parseInt(targetForm.css('width')) - 60) + 'px',
                        height: (parseInt(targetForm.css('height')) - 20) + 'px'
                    }, 600, function () {
                        mainForm.css('height', 'auto');
                        targetForm.addClass('show');
                        targetForm.fadeIn(500);
                        focusFirst(targetForm);
                    });
                });
            } else {
                targetForm.fadeIn(400, function () {
                    targetForm.addClass('show');
                    focusFirst(targetForm);
                });
            }

            // if navigate happens, reset the fail count
            failFullLoginCount = 0;
            failMemberLoginCount = 0;
        };

        // go back to full login
        var backToLoginFull = function (from) {
            //prevent if in animate state
            if (canSwitch(from)) {
                switchTo('#loginFull');
            }
        };

        // go back to member list
        var backToMemeberList = function (from) {
            //prevent if in animate state
            if (canSwitch(from)) {
                switchTo('#memberList');
            }
        };

        return {
            switchTo: switchTo,
            canSwitch: canSwitch,
            backToLoginFull: backToLoginFull,
            backToMemeberList: backToMemeberList,
            switchToDefault: switchToDefault,
            resetLoginModel: resetLoginModel
        };
    })();

    var responseType = {
        Success: 0,
        EmptyEmail: 1,
        EmptyPassword: 2,
        EmailNotExist: 3,
        WrongPassword: 4,
        Inactive: 5,
        Expired: 6,
        UnKnown: 7,
        Unauthorized: 8
    };

    var resources = {
        emailNotExists: '用户名不存在',
        wrongPassword: '用户名或密码错误',
        inactiveAccount: '用户被锁定',
        expiredAccount: '该用户不在有效期内',
        unknownError: '未知异常',
        emailRequired: '请输入用户名',
        passwordRequired: '请输入密码',
        unauthorizedError: '没有权限登陆当前系统',
        email4Pwd: {
            required: '请输入用户名',
            emailNotExists: '用户名不合法，请重新输入'
        }
    };

    var constant = {
        cache: {
            cachePrex: 'atms.webadmin.data.',
            defaultCacheTime: '00000000'
        }
    };

    var getUrlParm = function (name) {
        var searchUrl = window.location.search;
        if (searchUrl && searchUrl.length > 0) {
            var paramList = searchUrl.substr(1).split('&');
            for (var i = 0; i < paramList.length; i++) {
                var pair = paramList[i].split('=');
                if (pair && pair.length > 1 && pair[0] === name) {
                    return decodeURIComponent(pair[1]);
                }
            }
        };
        return '';
    };

    // invoke login action
    var login = function (sender, failCallBack) {
        sender.attr('disabled', true);
        var token = $('input[name="__RequestVerificationToken"]').val();
        var headers = {
            '__RequestVerificationToken': token,
            withCredentials: true
        };
        var loadingIndicator = createIndicator();
        $.ajax({
            type: 'POST',
            headers: headers,
            url: "LogOn",
            cache: false,
            data: JSON.stringify(loginModel),
            contentType: "application/json; charset=utf-8",
            success: function (data) {
                if (data) {
                    checkResult = data;
                    var mainForm = $('#mainForm');
                    if (data.CheckState === responseType.Success) {
                        $('#logo_text').animate({
                            opacity: 0.1
                        }, 500);
                        mainForm.fadeOut(600, function () {
                            var returnUrl = getUrlParm('ReturnUrl');
                            var spec = ['/', '\\'];
                            if (returnUrl && returnUrl.length > 0 && $.inArray(returnUrl.substr(0, 1), spec) > -1)
                                returnUrl = returnUrl.substr(1);

                            removeExpiredLocalCache(data, returnUrl);
                        });
                    } else {
                        sender.removeAttr('disabled');
                        failCallBack();
                        console.log(data.Message);
                        //if failed 5 times, send password 
                        //mainForm.trigger('failLogin', {});
                    }
                }
            },
            complete: function () {
                createIndicatorRemove();
            }
        });
    };

    var sendPassword = function (email, sender, success, failCallBack) {
        sender.attr('disabled', true);
        var token = $('input[name="__RequestVerificationToken"]').val();
        var headers = {
            '__RequestVerificationToken': token,
            withCredentials: true
        };
        var loadingIndicator = createIndicator();
        $.ajax({
            type: 'POST',
            headers: headers,
            url: "ForgetPassword",
            data: JSON.stringify(loginModel),
            contentType: "application/json; charset=utf-8",
            success: function (data) {
                //no return message
                loginForm.switchTo('#forget_password_form_sucess');
            },
            complete: function () {
                createIndicatorRemove();
                sender.removeAttr('disabled');
            }
        });
    };

    var setErrorStyle = function (error, element) {
        if (element.hasClass('has-error')) {
            element.parent().addClass('has-error');
            error.insertAfter(element);
            error.addClass('label');
            error.addClass('label-danger');
        }
    };

    //uses to remove expired localstorage cache after login successfully
    var removeExpiredLocalCache = function (data, returnUrl) {
        $.ajax({
            type: 'GET',
            url: data.ApiHost + '/api/v1/cache/' +
            'getallcache',
            data: {},
            contentType: "application/json; charset=utf-8",
            success: function (cachelist) {
                cachelist.push({
                    cacheKey: '/api/v1/user/getUserPermission',
                    cacheTime: '11',
                });

                $('#wait').css('display', 'block');
                var prefixCache = constant.cache.cachePrex;
                var localCacheList = [];

                //get all caches from localstorage
                for (var i = 0, len = localStorage.length; i < len; ++i) {
                    localCacheList.push(localStorage.key(i));
                }

                cachelist.forEach(function (cache) {

                    var cacheKey = cache.cacheKey;
                    var cacheTime = cache.cacheTime;

                    //get all cache in localstore and loop thorgh to remove those expired cache
                    localCacheList.forEach(function (localCacheKey) {

                        if (localCacheKey.indexOf(cacheKey) >= 0) {

                            var strCacheObject = localStorage.getItem(localCacheKey);
                            var cacheObject = $.parseJSON(strCacheObject);

                            if (cacheObject !== null &&
                                cacheObject.value !== undefined &&
                                cacheObject.value.cacheTime !== cacheTime) {

                                console.log(localCacheKey + ' was removed');
                                localStorage.removeItem(localCacheKey);
                            }
                        }
                    });
                });

                //ensure the expired caches were all removed before redirect to other page
                window.location = '/' + returnUrl;
            }
        });
    };

    // add validation: server side 
    // Case: Email not exists
    $.validator.addMethod('emailNotExists', function () {
        return checkResult.CheckState !== responseType.EmailNotExist;
    }, resources.emailNotExists);

    // Case: Wrong password
    $.validator.addMethod('wrongPassword', function () {
        return checkResult.CheckState !== responseType.WrongPassword;
    }, resources.wrongPassword);

    // Case: Inactive account
    $.validator.addMethod('inactiveAccount', function () {
        return checkResult.CheckState !== responseType.Inactive;
    }, resources.inactiveAccount);

    // Case: Find the user if in the proper database
    $.validator.addMethod('expiredAccount', function () {
        return checkResult.CheckState !== responseType.Expired;
    }, resources.expiredAccount);

    // Case: Find the user if in the proper database
    $.validator.addMethod('unknownError', function () {
        return checkResult.CheckState !== responseType.UnKnown;
    }, resources.unknownError);

    // Case: Find the user if can not access project
    $.validator.addMethod('unauthorizedError', function () {
        return checkResult.CheckState !== responseType.Unauthorized;
    }, resources.unauthorizedError);

    // add validation for full login
    var validatorFull = $("#loginFull").validate({
        errorClass: "has-error",
        rules: {
            loginFullEmail: {
                required: true,
                emailNotExists: true,
                inactiveAccount: true,
                expiredAccount: true,
                unauthorizedError: true
            },
            loginFullPwd: {
                required: true,
                wrongPassword: true,
                unknownError: true,
            }
        },
        messages: {
            loginFullEmail: {
                required: resources.emailRequired,
                emailNotExists: resources.emailNotExists,
                inactiveAccount: resources.inactiveAccount,
                expiredAccount: resources.expiredAccount,
                unauthorizedError: resources.unauthorizedError
            },
            loginFullPwd: {
                required: resources.passwordRequired,
                wrongPassword: resources.wrongPassword,
                unknownError: resources.unknownError,
            }
        },
        errorPlacement: function (error, element) {
            setErrorStyle(error, element);
        }
    });


    // add validation for forgot password
    var validatorFindPassword = $("#forget_password_form").validate({
        errorClass: "has-error",
        rules: {
            findFullEmail: {
                required: true,
                emailNotExists: true,
                inactiveAccount: true,
                expiredAccount: true,
                unknownError: true,
            }
        },
        messages: {
            findFullEmail: {
                required: resources.email4Pwd.required,
                emailNotExists: resources.email4Pwd.emailNotExists,
                inactiveAccount: resources.inactiveAccount,
                expiredAccount: resources.expiredAccount,
                unknownError: resources.unknownError,
            }
        },
        errorPlacement: function (error, element) {
            setErrorStyle(error, element);
        }
    });

    var resetErrorStatus = function () {

        var currentForm = $('#mainForm').find('form.show');
        $.each(currentForm.children(), function (index, element) {
            $(element).parent().removeClass('has-error');
            var hasError = $(element).children('input.has-error[type="text"],input.has-error[type="email"],input.has-error[type="password"]').length > 0;
            if (hasError) {
                if (!$(element).hasClass('has-error')) {
                    $(element).addClass('has-error');
                }
                $(element).parent().addClass('has-error');
            } else {
                $(element).removeClass('has-error');
                $(element).parent().removeClass('has-error');
            }
        });
    };

    if(""!==cookie&&getCookie("ddTicket")){
        ticket = getCookie("ddTicket");
        loginForm.resetLoginModel("DD", "DD",ticket,1);
        login($(this), function () {
            // todo DD logOut
            setTimeout(function () {
                resetErrorStatus();
            }, 20);
        });
    }

    function getCookie(name) {
        var list = cookie.split("; ");
        for(var i = 0; i < list.length; i++) {
            var arr = list[i].split("=");
            if(arr[0] == name)
                return decodeURIComponent(arr[1]);
        }
        return "";
    }
    // initialize
    // bind events

    // full login: login with email and password
    $('#btnFullLogin').on('click', function (e) {
        e.preventDefault();
        resetErrorStatus();
        if (!($('#loginFull').valid())) {
            // fix bug 1888
            // validatorFull.focusInvalid();
            return;
        }
        // set the login data to post
        loginForm.resetLoginModel($('#loginFullEmail').val(), $('#loginFullPwd').val(),ticket,0);
        login($(this), function () {
            if (!$('#loginFull').valid()) {
                //fix bug 1888
                // validatorFull.focusInvalid();
            }
            //checkResult = {};
            failFullLoginCount++;
            setTimeout(function () {
                resetErrorStatus();
            }, 20);
        });
    });

    // bind click event to all the 'Back to login' link - navigate to full login
    $('a[rel=loginfull]').on('click', function (e) {
        e.preventDefault();
        loginForm.backToLoginFull($(this));
    });

    // bind click event to all the 'Back to login' link - navigate to member login
    $('a[rel=userchoose]').on('click', function (e) {
        e.preventDefault();
        loginForm.backToMemeberList($(this));
    });

    // Forgot password - from full login
    $('#btnShowForgotPwd').on('click', function (e) {
        e.preventDefault();
        // switch to find password 
        loginForm.switchTo('#forget_password_form');
    });

    // full login - from Forgot password
    $('.btnLoginFrame').on('click', function (e) {
        e.preventDefault();
        // switch to full login
        loginForm.switchTo('#loginFull');
    });

    // back to enter password
    $('#btnBackToEnterPwd').on('click', function (e) {
        e.preventDefault();
        loginForm.switchTo('#enterPwd');
    });

    // Send password - first time login
    $('#btnSendPwd').on('click', function (e) {
        e.preventDefault();
        resetErrorStatus();
        if (!($('#forget_password_form').valid())) {
            validatorFindPassword.focusInvalid();
            return;
        }

        loginForm.resetLoginModel($('#findFullEmail').val(), null,ticket,0);
        // send password over email user entered
        sendPassword($('#findFullEmail').val(), $(this), function () {
            // case of send email success
            loginForm.switchTo('#emailSent1');
        }
            //fail
            , function () {
                if (!$('#forget_password_form').valid()) {
                    validatorFindPassword.focusInvalid();
                }
                //checkResult = {};
                resetErrorStatus();
            });
    });


    // HotKey: listen to Enter/Up/Down key events
    $(document.body).keydown(function (e) {
        var btnFullLogin = $('#btnFullLogin');
        var btnSendPwd4Fail = $('#btnSendPwd');

        if (e.which === 13) {
            e.preventDefault();

            if (btnFullLogin.is(':visible') && !btnFullLogin.is(':disabled')) {
                btnFullLogin.click();
            }
            else if (btnSendPwd4Fail.is(':visible') && !btnSendPwd4Fail.is(':disabled')) {
                btnSendPwd4Fail.click();
            }
        } else {
            //fix error message disappear issue
            checkResult = {};
        }
    });

    // check if any user logged before and decide to show which form
    loginForm.switchToDefault();
});