﻿infrastructureModule
    .controller('userListController', ['$scope', '$log', 'userService', 'uiGridConstants', 'SweetAlert', 'projectService', 'roleService', '$translate', 'enums',
        function($scope, $log, userService, uiGridConstants, SweetAlert, projectService, roleService, $translate, enums) {
            'use strict';

            /***********************************************************new code start*********************************************************/
            $scope.totalCount = 0;

            var showOperateLogPop = function() {
                $scope.isShowLog = true;
                // $('#showOperatePop').modal('show');
            };

            // 修改用户
            $scope.createUser = function() {

                $scope.userOperateType = constant.Operation.Add
                $scope.isUpdateUser = false;
                $scope.selectedUser = {};
            };


            //如果添加了用户，则刷新
            $scope.$watch('isUpdateUser', function(newValue, oldValue) {
                if (newValue) {
                    getUserList();
                }
            });


            var getUserList = function() {
                userService.getAllUserRoleList(constant.serviceType.VAT).success(function(data) {
                    if (data) {

                        data.forEach(function(row) {
                            var uniqRoleList = _.uniq(row.roleInfoList, function(item) {
                                return item.id });
                            row.roleNameList = _.map(uniqRoleList, function(x) {
                                return x.name; }).join(constant.comma);
                            row.statusDesc = row.status == constant.activeStatus.active ? $translate.instant('Enable') : $translate.instant('Disabled');
                        });

                        $scope.treeListSource = data;
                        //console.log("JSON: " + JSON.stringify(data));
                        $scope.setGridHeight();
                    }
                });
            };

            var loadTreeList = function() {
                $scope.userTreeOptions = {
                    bindingOptions: {
                        dataSource: 'treeListSource'
                    },
                    columns: [{
                        dataField: "userName",
                        caption: $translate.instant('PUserName'),
                        cellTemplate: function (container, options) {
                            try {
                                $('<a class="hyper-link">' + options.value + '</a>')
                                    .attr('href', '#/userDetail/' + options.row.data.ID)
                                    .appendTo(container);
                            }
                            catch (e) {
                                $log.error(e);
                            }
                        }
                    }, {
                        dataField: "email",
                        caption: $translate.instant('PE-mail')
                    }, {
                        dataField: "organizationName",
                        caption: $translate.instant('OrganizationID')

                    }, {
                        dataField: "roleNameList",
                        caption: $translate.instant('Role'),
                        width: 350

                    }, {
                        dataField: "statusDesc",
                        caption: $translate.instant('PStatus')

                    }],

                    loadPanel: {
                        enabled: false
                    },
                    scrolling: {
                        mode: "virtual"
                    },

                    keyExpr: "id",
                    parentIdExpr: "parentID",
                    selection: {
                        mode: "single"
                    },
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    showRowLines: true,
                    showColumnLines: true,
                    rowAlternationEnabled: true, //单双行颜色
                    noDataText: $translate.instant('NoDataText'),
                    showBorders: true,
                    //sorting: {
                    //    mode: "none"
                    //},
                    searchPanel: {
                        placeholder: $translate.instant('Search'),
                        width: 518,
                        visible: true
                    },
                    onContentReady: function (e) {
                        var totalCount = e.component.totalCount();
                        if (totalCount > 0) {
                            $scope.totalCount = totalCount;
                        }
                    },
                };

            };

            // 关于日志部分
            $scope.showOperateLogPop = function() {
                $scope.isShowLog = true;
            };

            var checkUserPermission = function () {

                var list = [];
                $scope.hasQueryPermission = false;
                $scope.hasAddPermission = false;
                $scope.hasEditPermission = false;

                var temp = constant.adminPermission.infrastructure.userManage;
                list.push(temp.queryCode);
                list.push(temp.addCode);
                list.push(temp.editCode);

                $scope.$root.checkUserPermissionList(list).success(function (data) {
                    $scope.hasQueryPermission = data[temp.queryCode];
                    $scope.hasAddPermission = data[temp.addCode];
                    $scope.hasEditPermission = data[temp.editCode];
                    if ($scope.hasQueryPermission)
                    {
                        getUserList();
                    }
                });
            };

            //init page
            (function initialize() {
                $log.debug('UserList.ctor()...');
                loadTreeList();
                checkUserPermission();
            })();
        }
    ]);
