﻿infrastructureModule
    .controller('UserManageListController', ['$state','$filter', '$scope', '$log', 'userService', 'orgService', 'SweetAlert', 'projectService', 'roleService', '$translate', 'enums', 'businessUnitService', 'areaService', '$timeout', 'loginContext',
        function ($state,$filter, $scope, $log, userService, orgService, SweetAlert, projectService, roleService, $translate, enums, businessUnitService, areaService, $timeout, loginContext) {
            'use strict';

            /***********************************************************new code start*********************************************************/
            var orgTree, roleTree;
            $scope.orgTree = orgTree = {};
            $scope.roleTree = roleTree = {};

            // 机构列表树
            $scope.getOrgListToJson = function () {
                $scope.doing_async = true;

                orgService.getOrgListToJson(0).success(function (data) {


                    var filterData = [];
                    if (loginContext.userName && loginContext.userName.toLowerCase() === "simon") {
                        data.forEach(function (row) {
                            if (row && row.data.industryID === '10') {
                                filterData.push(row);
                            }
                        });
                    } else {
                        filterData = data;
                    }

                    $scope.orgTreeData = filterData;
                    $scope.doing_async = false;
                }).error(function (data) {
                    $log.debug(JSON.stringify(data));
                });
            };

            // 单击机构
            $scope.singleClickOrg = function (org) {
                if (org.selected) {
                    org.selected = false;
                    $scope.selectOrgList.splice(jQuery.inArray(org, $scope.selectOrgList), 1);
                } else {
                    org.selected = true;
                    $scope.selectOrgList.push(org);
                }

                queryOnPage();
            };

            // 事业部单选
            $scope.singleClickBusinessUnit = function (businessUnitModel) {
                if (businessUnitModel.selected) {
                    businessUnitModel.selected = false;
                    $scope.selectBusinessUnitList.splice(jQuery.inArray(businessUnitModel, $scope.selectBusinessUnitList), 1);
                } else {
                    businessUnitModel.selected = true;
                    $scope.selectBusinessUnitList.push(businessUnitModel);
                }

                queryOnPage();
            };

            // 区域单选
            $scope.singleClickArea = function (model) {
                if (model.selected) {
                    model.selected = false;
                    $scope.selectAreaList.splice(jQuery.inArray(model, $scope.selectAreaList), 1);
                } else {
                    model.selected = true;
                    $scope.selectAreaList.push(model);
                }

                queryOnPage();
            };

            // 角色单选
            $scope.singleClickRole = function (model) {
                if (!model.data.roleCategoryId) {
                    // 是角色分类，不是角色
                    return;
                }
                if (model.selected) {
                    model.selected = false;
                    $scope.selectRoleList.splice(jQuery.inArray(model, $scope.selectRoleList), 1);
                } else {
                    model.selected = true;
                    $scope.selectRoleList.push(model);
                }

                queryOnPage();
            };

            // 添加用户
            $scope.addUser = function () {
                if ($scope.userOperateType === constant.Operation.Add) {
                    $scope.userOperateType = null;
                }

                $scope.userOperateType = constant.Operation.Add;
                $scope.isUpdateUser = false;
                $scope.selectedUser = null;
            };

            // 修改用户
            $scope.updateUser = function (user, $event) {
                if ($scope.userOperateType === constant.Operation.Edit) {
                    $scope.userOperateType = null;
                }

                $scope.userOperateType = constant.Operation.Edit;
                $scope.isUpdateUser = false;
                $scope.selectedUser = { id: user.id };
                $event.stopPropagation();
            };

            // 禁用用户
            $scope.disableUser = function (user, $event) {
                if ($scope.userOperateType === constant.Operation.Disable) {
                    $scope.userOperateType = null;
                }

                $scope.userOperateType = constant.Operation.Disable;
                $scope.isUpdateUser = false;
                $scope.selectedUser = { id: user.id, userName: user.userName };
                $event.stopPropagation();
            };

            // 启用用户
            $scope.enableUsers = function (user, $event) {
                if ($scope.userOperateType === constant.Operation.Enable) {
                    $scope.userOperateType = null;
                }

                $scope.userOperateType = constant.Operation.Enable;
                $scope.isUpdateUser = false;
                $scope.selectedUser = { id: user.id, userName: user.userName };
                $event.stopPropagation();
            };

            // 角色树列表
            var getRoleTreeList = function () {
                $scope.doing_async_role = true;
                $scope.roleTreeData = [];
                roleService.getRoleTreeList().success(function (data) {
                    $scope.roleTreeData = data;
                    $scope.doing_async_role = false;
                    setRoleColor();
                    getAllUserRoleList();
                });
            };

            // 颜色模板
            var colorPanel = {

                // 颜色列表
                // yellow,orange,gold
                colorList: ['admin-color', 'role-color1', 'role-color2', 'manager-color', 'normal-color'],

                createNew: function () {
                    var colorPanelInstance = {};
                    colorPanelInstance.index = -1;
                    colorPanelInstance.getNextColor = function () {
                        if (colorPanelInstance.index >= colorPanel.colorList.length - 1) {
                            colorPanelInstance.index = 0;
                        } else {
                            colorPanelInstance.index++;
                        }

                        return colorPanel.colorList[colorPanelInstance.index];
                    }

                    return colorPanelInstance;
                }
            };

            // 颜色实例
            var colorPanelInstance = colorPanel.createNew();

            // 颜色板
            var roleColorPanel = {};
            // 设置颜色
            var setRoleColor = function () {

                if ($scope.roleTreeData && $scope.roleTreeData.length > 0) {
                    $scope.roleTreeData.forEach(function (roleType) {
                        if (roleType.children && roleType.children.length > 0) {
                            roleType.children.forEach(function (role) {
                                roleColorPanel[role.data.id] = colorPanelInstance.getNextColor();
                            });
                        }
                    });
                };
            };


            // 获取区域列表
            var getAreaList = function () {
                // body...
                areaService.getAreaList(0).success(function (data) {
                    $scope.areaList = data;
                });
            };

            // 事业部-机构树列表
            $scope.getBusinessUnitOrganizationStaticsTreeList = function () {
                $scope.selectAreaType = false;
                $scope.doing_async = true;
                $scope.areaTreeData = [];
                orgService.getBusinessUnitOrganizationStaticsTreeList().success(function (data) {
                    if (data && data.length > 0) {
                        data.forEach(function (row) {
                            row.count = row.data.organizationCount;
                            row.isShowCount = true;
                        });
                    }

                    $scope.areaTreeData = data;
                    $scope.doing_async = false;
                    return areaTree.expand_level_function();
                });
            };

            // 选中角色节点
            $scope.selectRoleNode = function (branch) {

            };

            // 选择区域节点
            $scope.selectOrgTreeNode = function (branch) {

                // branch.data
                $scope.selectOrgBranch = branch;
                queryOnPage();
            };

            $scope.goToUserDetail = function (userID) {
                $state.go('userDetail', { id: userID });
            };

            $scope.toggleUserStatus = function () {
                if ($scope.showActiveUser) {
                    $scope.showActiveUser = false;
                } else {
                    $scope.showActiveUser = true;
                }

                queryOnPage();
            };


            $scope.selectTab = function (index) {
                if (index === $scope.selectTabIndex) {
                    return;
                }

                $scope.selectTabIndex = index;
                clearStaticsAndQueryInfo();
                getAllUserRoleList();
            };

            var clearStaticsAndQueryInfo = function () {
                clearOrgTree($scope.orgTreeData);
                clearArea();
                clearBusinessUnit();
                clearRole();
                initParams();
            };

            // 获取事业部列表
            var getBusinessUnitList = function () {
                businessUnitService.getBusinessUnitList().success(function (data) {
                    data = _.filter(data, function (row) {

                        return row.isActive;
                    });
                    $scope.businessUnitList = data;
                });
            };

            var dataType = {
                isPrefixNumber: function (value) {
                    var reg = /^\d+/;
                    if (reg.test(value)) {
                        return true;
                    } else {
                        return false;
                    }
                },
                isPrefixChar: function (value) {
                    var reg = /^[a-zA-Z]+/;
                    if (reg.test(value)) {
                        return true;
                    } else {
                        return false;
                    }
                },
                isPrefixNumberOrChar: function (value) {
                    if (dataType.isPrefixNumber(value)) {
                        return true;
                    }

                    if (dataType.isPrefixChar(value)) {
                        return true;
                    }

                    return false;
                }
            }

            var sortByUserName = function (data) {
                if (data && data.length > 0) {

                    var charList = [];
                    var nocharList = [];

                    data.forEach(function (row) {
                        if (dataType.isPrefixNumberOrChar(row.userName)) {
                            row.userNameSort = row.userName;

                            if (row.userNameSort) {
                                row.userNameSort = row.userNameSort.toLowerCase();
                            }

                            charList.push(row);

                        } else {
                            nocharList.push(row);
                        }

                    });

                    charList = _.sortBy(charList, 'userNameSort');

                    nocharList = nocharList.sort(function compareFunction(param1, param2) {
                        return param1.userName.localeCompare(param2.userName, 'zh');
                    });

                    var all = _.union(charList, nocharList);
                    return all;
                }

                return data;
            };


            var getAllUserRoleList = function () {

                if ($scope.selectTabIndex === 1) {
                    roleService.getAllUserRoleList().success(function (data) {

                        data = _.filter(data, function (row) {
                            return row.userName && row.userName.toLowerCase() !== "admin";
                        });

                        if (loginContext.userName.toLowerCase() === "simon") {
                            data = _.filter(data, function (row) {
                                return row.userName !== "aaa" && row.userName !== "bbb";
                            });
                        }

                        // 先排序
                        data = sortByUserName(data);
                        $scope.originalUserRoleList = data;
                        var copy = angular.copy($scope.originalUserRoleList);
                        // $scope.userRoleList = _.filter(copy, function(row) {
                        //     return copy.status !== enums.userStatus.disabled;
                        // });
                        $scope.userRoleList = copy;

                        queryOnPage();
                    });

                } else {

                    roleService.getAllOwnUserRoleList().success(function (data) {
                        data = _.filter(data, function (row) {

                            return row.userName && row.userName.toLowerCase() !== "admin";
                        });

                        if (loginContext.userName.toLowerCase() === "simon") {
                            data = _.filter(data, function (row) {
                                return row.userName !== "aaa" && row.userName !== "bbb";
                            });
                        }

                        // 先排序
                        data = sortByUserName(data);
                        $scope.originalUserRoleList = data;
                        var copy = angular.copy($scope.originalUserRoleList);

                        // $scope.userRoleList = _.filter(copy, function(row) {
                        //     return copy.status !== enums.userStatus.disabled;
                        // });

                        $scope.userRoleList = copy;
                        queryOnPage();
                    });
                }
            };

            var renderStatics = function () {
                setOrgTreeCount($scope.orgTreeData);
                setBusinessUnitCount();
                setAreaCount();
                setRoleCount();
            };

            // 设置机构树的用户个数
            var setOrgTreeCount = function (orgTreeList) {
                // isShowCount, count
                if (orgTreeList && orgTreeList.length > 0) {
                    orgTreeList.forEach(function (row) {
                        var userList = _.filter($scope.userRoleList, function (data) {
                            return data.organizationID === row.data.id;
                        });

                        if (userList && userList.length > 0) {
                            var userNameList = _.uniq(_.pluck(userList, 'userName'));
                            row.count = userNameList.length;
                            row.isShowCount = true;
                        } else {
                            row.isShowCount = false;
                            row.count = 0;
                        }

                        setOrgTreeCount(row.children);
                    });
                }
            };

            // 清除机构树设置信息
            var clearOrgTree = function (orgTreeList) {
                if (orgTreeList && orgTreeList.length > 0) {
                    orgTreeList.forEach(function (row) {
                        row.isShowCount = false;
                        row.count = 0;
                        row.selected = false;
                        clearOrgTree(row.children);
                    });
                }
            };

            // 事业部的count
            var setBusinessUnitCount = function () {
                if ($scope.businessUnitList && $scope.businessUnitList.length > 0) {
                    for (var i = 0; i < $scope.businessUnitList.length; i++) {
                        var row = $scope.businessUnitList[i];
                        var query = _.filter($scope.userRoleList, function (user) {
                            return user.businessUnitID === row.id;
                        });

                        if (query && query.length > 0) {
                            var userNameList = _.uniq(_.pluck(query, 'userName'));
                            row.count = userNameList.length;
                            row.isShowCount = true;
                            row.count = query.length;
                        } else {
                            row.isShowCount = false;
                            row.count = 0;
                        }
                    }
                }
            };

            // 清除事业部设置信息
            var clearBusinessUnit = function () {
                if ($scope.businessUnitList && $scope.businessUnitList.length > 0) {
                    for (var i = 0; i < $scope.businessUnitList.length; i++) {
                        var row = $scope.businessUnitList[i];
                        row.isShowCount = false;
                        row.count = 0;
                        row.selected = false;
                    }
                }
            };

            // 设置区域统计
            var setAreaCount = function () {
                if ($scope.areaList && $scope.areaList.length > 0) {
                    for (var i = 0; i < $scope.areaList.length; i++) {
                        var row = $scope.areaList[i];
                        var query = _.filter($scope.userRoleList, function (user) {
                            return user.areaID === row.id;
                        });

                        if (query && query.length > 0) {
                            var userNameList = _.uniq(_.pluck(query, 'userName'));
                            row.count = userNameList.length;
                            row.isShowCount = true;
                            row.count = query.length;
                        } else {
                            row.isShowCount = false;
                            row.count = 0;
                        }
                    }
                }
            };

            // 清除区域设置信息
            var clearArea = function () {
                if ($scope.areaList && $scope.areaList.length > 0) {
                    for (var i = 0; i < $scope.areaList.length; i++) {
                        var row = $scope.areaList[i];


                        row.isShowCount = false;
                        row.count = 0;
                        row.selected = false;

                    }
                }
            };

            // 设置角色个数
            var setRoleCount = function () {
                if ($scope.roleTreeData && $scope.roleTreeData.length > 0) {
                    $scope.roleTreeData.forEach(function (roleType) {

                        // 角色分类
                        if (roleType.children && roleType.children.length > 0) {
                            roleType.children.forEach(function (role) {
                                // 角色
                                var query = _.filter($scope.userRoleList, function (data) {
                                    var roleQuery = _.filter(data.roleInfoList, function (roleInfo) {
                                        return roleInfo.id === role.data.id;
                                    });

                                    if (roleQuery && roleQuery.length > 0) {
                                        return true;
                                    } else {
                                        return false;
                                    }
                                });

                                if (query && query.length > 0) {
                                    var userNameList = _.uniq(_.pluck(query, 'userName'));
                                    role.count = userNameList.length;
                                    role.isShowCount = true;
                                    role.count = query.length;
                                } else {
                                    role.isShowCount = false;
                                    role.count = 0;
                                }
                            });
                        }
                    });
                }
            };

            // 清除角色
            var clearRole = function () {
                if ($scope.roleTreeData && $scope.roleTreeData.length > 0) {
                    $scope.roleTreeData.forEach(function (roleType) {

                        // 角色分类
                        if (roleType.children && roleType.children.length > 0) {
                            roleType.children.forEach(function (role) {
                                // 角色
                                role.isShowCount = false;
                                role.count = 0;
                                role.selected = false;
                            });
                        }
                    });
                }
            };

            // 页面级别筛选
            var queryOnPage = function () {
                $scope.disabledUsersCount = 0;
                if (!$scope.originalUserRoleList || $scope.originalUserRoleList.length === 0) {
                    return;
                }

                var result = [];

                for (var i = 0; i < $scope.originalUserRoleList.length; i++) {
                    var user = $scope.originalUserRoleList[i];

                    // 根据用户名或者邮箱做筛选
                    if ($scope.queryUser) {

                        // 转换大小写
                        var userName = user.userName ? user.userName.toLowerCase() : '';
                        var email = user.email ? user.email.toLowerCase() : '';
                        var businessUnit = user.businessUnitName ? user.businessUnitName.toLowerCase() : '';
                        var area = user.areaName ? user.areaName.toLowerCase() : '';
                        var org = user.organizationName ? user.organizationName.toLowerCase() : '';

                        var userNameExist = !(userName.indexOf($scope.queryUser.toLowerCase()) === -1);
                        var emailExist = !(email.indexOf($scope.queryUser.toLowerCase()) === -1);
                        var businessUnitExist = !(businessUnit.indexOf($scope.queryUser.toLowerCase()) === -1);
                        var areaExist = !(area.indexOf($scope.queryUser.toLowerCase()) === -1);
                        var orgExist = !(org.indexOf($scope.queryUser.toLowerCase()) === -1);

                        var userRoleExist = false;

                        user.roleInfoList.forEach(function (m) {
                            if (!(m.name.indexOf($scope.queryUser.toLowerCase()) === -1)) {
                               userRoleExist = true;
                           }
                        });

                        var isExist = userNameExist || emailExist || businessUnitExist || userRoleExist || areaExist || orgExist;

                        if (!isExist) {
                            continue;
                        }

                        // 只显示禁用的用户
                        if (!$scope.showActiveUser && user.status != enums.userStatus.disabled) {
                            continue;
                        }

                    } else {
                        // 用户状态筛选
                        // 只显示启用的
                        /*if ($scope.showActiveUser && user.status === enums.userStatus.disabled) {
                            continue;
                        }*/

                        // 只显示禁用的用户
                        if (!$scope.showActiveUser && user.status != enums.userStatus.disabled) {
                            continue;
                        }
                    }

                    // 根据机构做筛选
                    if ($scope.selectOrgBranch && user.organizationID != $scope.selectOrgBranch.data.id) {
                        continue;
                    }

                    // 机构筛选
                    if ($scope.selectOrgList && $scope.selectOrgList.length > 0) {
                        var query = _.filter($scope.selectOrgList, function (row) {
                            return row.data.id === user.organizationID;
                        });

                        if (!query || query.length == 0) {
                            continue;
                        }
                    }

                    // 事业部筛选
                    if ($scope.selectBusinessUnitList && $scope.selectBusinessUnitList.length > 0) {
                        var query = _.filter($scope.selectBusinessUnitList, function (row) {
                            return row.ID === user.businessUnitID;
                        });

                        if (!query || query.length == 0) {
                            continue;
                        }
                    }

                    // 区域
                    if ($scope.selectAreaList && $scope.selectAreaList.length > 0) {
                        var query = _.filter($scope.selectAreaList, function (row) {
                            return row.ID === user.areaID;
                        });

                        if (!query || query.length == 0) {
                            continue;
                        }
                    }

                    // 角色筛选
                    if ($scope.selectRoleList && $scope.selectRoleList.length > 0) {
                        var roleIdList = _.pluck(user.roleInfoList, 'ID');

                        var query = _.filter($scope.selectRoleList, function (row) {
                            return roleIdList.indexOf(row.data.id) > -1;
                        });

                        if (!query || query.length == 0) {
                            continue;
                        }
                    }

                    user.roleInfoList.forEach(function (role) {
                        role.theme = roleColorPanel[role.id];
                    });


                    result.push(user);
                }

                $scope.userRoleList = result;

                if ($scope.showActiveUser && !$scope.queryUser) {
                    var disabledUser = _.filter($scope.originalUserRoleList, function (data) {
                        return data.status === enums.userStatus.disabled;
                    });

                    if (disabledUser) {
                        $scope.disabledUsersCount = disabledUser.length;
                    }

                } else {
                    var disabledUser = _.filter($scope.userRoleList, function (data) {
                        return data.status === enums.userStatus.disabled;
                    });

                    if (disabledUser) {
                        $scope.disabledUsersCount = disabledUser.length;
                    }
                }


                // 先排序
                //sort();
                $scope.curPage = 1;

                computePager($scope.curPage);
                //creatPager($scope.userRoleList.length, $scope.curPage);
                renderStatics();
            };


            //var creatPager = function (totalPage, curPage) {
            //    $scope.creatPage = $("#userManagePager").createPage({
            //        pageCount: totalPage,
            //        current: curPage,
            //        backFn: function (p) {
            //            //单击回调方法，p是当前页码
            //            computePager(p);
            //        }
            //    });

            //    $('#userManagePager').css('display', 'inline-block');
            //};

            var computePager = function (pageIndex) {
                $scope.curPage = pageIndex;
                if ($scope.userRoleList && $scope.userRoleList.length > 0) {
                    $scope.queryResult.pageInfo.totalCount = $scope.userRoleList.length;
                    var totalPage = parseInt($scope.queryResult.pageInfo.totalCount / $scope.queryResult.pageInfo.pageSize);
                    totalPage = $scope.queryResult.pageInfo.totalCount % $scope.queryResult.pageInfo.pageSize == 0 ? totalPage : totalPage + 1;
                    $scope.queryResult.pageInfo.totalPage = totalPage;

                    $scope.creatPage = $("#userManagePager").createPage({
                        pageCount: totalPage,
                        current: $scope.curPage,
                        backFn: function (p) {
                            //单击回调方法，p是当前页码
                            computePager(p);
                        }
                    });

                    $('#userManagePager').css('display', 'inline-block');
                    getList();

                } else {
                    $scope.curPage = 1;
                    $scope.creatPage = $("#userManagePager").createPage({
                        pageCount: 0,
                        current: $scope.curPage,
                        backFn: function (p) {
                            //单击回调方法，p是当前页码
                            computePager(p);
                        }
                    });

                    $scope.queryResult.list = [];
                    $('#userManagePager').css('display', 'inline-block');
                }
            };

            // 前台分页
            var getList = function () {
                var startIndex = ($scope.curPage - 1) * $scope.queryResult.pageInfo.pageSize;
                var endIndex = $scope.curPage * $scope.queryResult.pageInfo.pageSize;


                var resultList = [];

                var userNameList = '';
                if (endIndex < $scope.userRoleList.length) {
                    resultList = $scope.userRoleList.slice(startIndex, endIndex);

                    userNameList = _.pluck(resultList, 'userName').join(',');
                } else {
                    resultList = $scope.userRoleList.slice(startIndex);
                }

                for (var i = 0; i < resultList.length; i++) {
                    var row = resultList[i];
                    if (i >= 9) {
                        row.popoverPlace = "top-right";
                    } else {
                        row.popoverPlace = 'bottom-right';
                    }
                }

                return $timeout(function () {
                    $scope.queryResult.list = resultList;
                }, 100);
            };

            var sort = function () {
                $scope.userRoleList = _.sortBy($scope.userRoleList, 'userName');
                if (!$scope.sortAsc) {
                    $scope.userRoleList = $scope.userRoleList.reverse();
                }
            };

            $scope.modifySort = function () {
                if ($scope.sortAsc) {
                    $scope.sortAsc = false;
                } else {
                    $scope.sortAsc = true;
                }

                queryOnPage();
            };


            // 查询用户事件
            $scope.queryUserEvent = function () {
                if ($scope.queryUser) {
                    clearOrgTree($scope.orgTreeData);
                    clearArea();
                    clearBusinessUnit();
                    clearRole();

                    $scope.selectOrgList = [];

                    // 选择事业部
                    $scope.selectBusinessUnitList = [];

                    $scope.selectAreaList = [];

                    // 查询角色
                    $scope.selectRoleList = [];
                }

                queryOnPage();
            };

            // 清除输入的查询用户条件
            $scope.clearQueryUser = function () {
                $scope.queryUser = '';
                queryOnPage();
            };

            $scope.showMoreOrgClick = function () {
                if ($scope.showMoreOrg) {
                    $scope.showMoreOrg = false;
                    $scope.showMoreOrgStr = $translate.instant('ShowMore');

                } else {
                    $scope.showMoreOrg = true;
                    $scope.showMoreOrgStr = $translate.instant('Packup');
                }
            };

            $scope.showMoreBusinessUnitClick = function () {
                if ($scope.showMoreBusinessUnit) {
                    $scope.showMoreBusinessUnit = false;
                    $scope.showMoreBusinessUnitStr = $translate.instant('ShowMore');

                } else {
                    $scope.showMoreBusinessUnit = true;
                    $scope.showMoreBusinessUnitStr = $translate.instant('Packup');
                }
            };

            $scope.showMoreAreaToggle = function () {
                if ($scope.showMoreArea) {
                    $scope.showMoreArea = false;
                    $scope.showMoreAreaStr = $translate.instant('ShowMore');
                } else {
                    $scope.showMoreArea = true;
                    $scope.showMoreAreaStr = $translate.instant('Packup');
                }
            };

            $scope.showMoreRoleToggle = function () {
                if ($scope.showMoreRole) {
                    $scope.showMoreRole = false;
                } else {
                    $scope.showMoreRole = true;
                }
            }

            // 添加或者编辑机构成功之后，刷新当前页面的数据
            $scope.$watch('isUpdateUser', function (newValue, oldValue) {
                if (newValue) {
                    getAllUserRoleList();
                }
            });

            $scope.selectUserRole = function (x, $event) {
                x.isOpen = true;
                $event.stopPropagation();
            }

            // 关于日志部分
            $scope.showOperateLogPop = function () {
                $scope.isShowLog = true;
            };
            var initParams = function () {
                $scope.doExport=doExport;
                // 机构默认显示
                $scope.showMoreOrg = true;
                $scope.showMoreOrgStr = $translate.instant('ShowMore');

                // 区域默认简化显示
                $scope.showMoreArea = false;
                $scope.showMoreAreaStr = $translate.instant('ShowMore');

                // 事业部默认简化显示
                $scope.showMoreBusinessUnit = false;
                $scope.showMoreBusinessUnitStr = $translate.instant('ShowMore');
                // 角色默认简化显示
                $scope.showMoreRole = false;
                // 选择机构
                $scope.selectOrgList = [];

                // 选择事业部
                $scope.selectBusinessUnitList = [];

                // 查询用户
                $scope.queryUser = '';

                // 查询区域
                $scope.selectAreaList = [];

                // 查询角色
                $scope.selectRoleList = [];

                // 取第几页数据
                $scope.curPage = 1;

                $scope.sortAsc = true;

                $scope.isShowBoard = true;

                $scope.showActiveUser = true;

                $scope.templateUrl = 'userRolePopoverTemplate.html';
            };

            $scope.getUserBodyHeight = function () {
                var right_container = $('.right-container').height();
                var tool_bar = $('.tool-bar').height();
                var height = right_container - tool_bar - 53;

                return {
                    height: height + 'px'
                }
            };



            var getUserPermission = function () {

                var list = [];

                var userManageTemp = constant.adminPermission.infrastructure.userManage;
                list.push(userManageTemp.addCode);
                list.push(userManageTemp.editCode);

                $scope.$root.checkUserPermissionList(list).success(function (data) {
                    $scope.hasAddPermission = data[userManageTemp.addCode];
                    $scope.hasEditPermission = data[userManageTemp.editCode];
                });
            };

            var doExport = function () {
                var localDate=$filter('date')(new  Date(), 'yyyyMMddHHmmss');
                var fileName = '用户信息列表'+localDate;
                userService.downloadFile($scope.userRoleList,fileName).then(function (data) {
                    if (data) {
                        ackMessageBox.success(translate('FileExportSuccess'));
                    }
                });
            };

            $scope.stopPropagation = function ($event) {
                $event.stopPropagation();
            };

            //init page
            (function initialize() {
                $log.debug('UserManageController.ctor()...');

                $scope.hasAddPermission = false;

                $scope.hasEditPermission = false;

                // 默认选择可访问tab
                $scope.selectTabIndex = 0;
                initParams();
                getUserPermission();
                // 用户编辑框ID
                $scope.getOrgListToJson();
                getRoleTreeList();
                getBusinessUnitList();
                getAreaList();


                $scope.queryResult = {
                    pageInfo: {
                        totalCount: 0,
                        pageSize: 12,
                        list: []
                    }
                };
            })();
        }
    ]);
