﻿systemConfigurationModule.directive('declarationFormConfiguration', ['$log',
    function ($log) {
        'use strict';
        $log.debug('declarationFormConfiguration.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/admin/systemConfiguration/declarationFormConfiguration/declaration-form-configuration.html' + '?_=' + Math.random(),
            replace: true,
            scope: {
                templateGroupId: '@',
                templateId: '@',
                cellTemplateId: '@'
            },
            controller: 'DeclarationFormConfigurationController',
            link: function (scope, element) {
                $("#editReportFormulaPop").draggable({ cursor: "cursor", scroll: true, cancel: 'input, label, .btn, .form-control, .close, div.label, .has-error' });
                $("#editReportFormulaPop").resizable({
                    minHeight: 610,
                    maxHeight: 610,
                    minWidth: 500
                });
                //$(".editReportFormulaPop-modal-content").draggable({ cursor: "cursor", scroll: true, cancel: 'input, label, .btn, .form-control, .close, div.label, .has-error' });

                $(".left").on("click", function (e) {
                    e.stopPropagation();
                });

                $('#btnCancel').on('click', function () {
                    $('.templates-save-form').css('display', 'none');
                });

                // Work-around for DX grid height issue.
                $('#editReportFormulaPop').on('shown.bs.modal', function () {
                    scope.refreshGrids();
                });

                scope.refreshGrids = function () {
                    $("#voucherGrid").dxDataGrid("instance").refresh();
                    //$("#modelGrid").dxDataGrid("instance").refresh();
                };

                scope.toggleSaveAs = function () {
                    $('.templates-save-form').css('display', 'block');
                };

                scope.showLeftMenu = function () {
                    if ($('.left').is(":hidden")) {
                        $(".left").slideDown('slow');
                    } else {
                        $(".left").slideUp('slow');
                    }

                    $(document).one("click", function () {
                        $(".left").slideUp('slow');
                    });
                    event.stopPropagation();
                };

                scope.renderFinish = function () {
                    $('.templates-menus').first().addClass('active');
                };

                scope.refreshCategorySelect = function (data) {
                    // Change the appearance of isteven-multi-select, show the checkboxes of the
                    // options which were hidden, but the checkboxes always toggle twice.
                    // Add this to make checkboxes which were hidden work correctly.
                    var idx = _.findIndex(scope.invoiceOption.categoryOptions, { 'key': data.key });
                    if (idx >= 0) {
                        var chkbox = element.find('.invoice-category-select .multiSelectItem .checkbox:eq(' + idx + ')');
                        if (data.ticked && !chkbox.prop('checked')) {
                            chkbox.prop('checked', true);
                        }
                        else if (!data.ticked && chkbox.prop('checked')) {
                            chkbox.prop('checked', false);
                        }
                    }
                };

                scope.refreshTaxRateSelect = function (data) {
                    // Change the appearance of isteven-multi-select, show the checkboxes of the
                    // options which were hidden, but the checkboxes always toggle twice.
                    // Add this to make checkboxes which were hidden work correctly.
                    var idx = _.findIndex(scope.invoiceOption.rateOptions, { 'key': data.key });
                    if (idx >= 0) {
                        var chkbox = element.find('.tax-rate-select .multiSelectItem .checkbox:eq(' + idx + ')');
                        if (data.ticked && !chkbox.prop('checked')) {
                            chkbox.prop('checked', true);
                        }
                        else if (!data.ticked && chkbox.prop('checked')) {
                            chkbox.prop('checked', false);
                        }
                    }
                };
            }
        };
    }
]).directive('repeatDone', function () {
    return {
        link: function (scope, element, attrs) {
            if (scope.$last) {
                scope.$eval(attrs.repeatDone);

                $('.template-menu').on('click', function () {
                    $(this).parent().parent().parent().children().each(function () {
                        $(this).removeClass('active');
                    });
                    $(this).parent().parent().addClass('active');
                });

                $('.templates-menu').on('click', function () {
                    $(this).parent().parent().children().each(function () {
                        $(this).removeClass('active');
                    });
                    $(this).parent().addClass('active');
                });

                $('.templates-menus').on('click', function () {
                    $(this).parent().children().each(function () {
                        $(this).removeClass('active');
                    });
                    $(this).addClass('active');
                });
            }
        }
    }
});