﻿analysisModule.controller('domesticDataImportController', ['$scope','$filter', '$log', '$translate', '$timeout', '$q', '$interval'
    , 'apiInterceptor', 'Upload', 'vatImportService', 'SweetAlert', 'uiGridConstants', '$uibModal'
    , 'vatSessionService', 'enums', 'vatOperationLogService'
    , 'projectService', 'vatCommonService','templateService','orgService',
    function ($scope,$filter, $log, $translate, $timeout, $q, $interval
        , apiInterceptor, Upload, vatImportService, SweetAlert, uiGridConstants, $uibModal
        , vatSessionService, enums, vatOperationLogService
        , projectService, vatCommonService,templateService,orgService) {
        'use strict';

        var comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年" + vatSessionService.month + "月";
        $scope.period = $scope.periodId;
        $scope.moduleid = enums.vatModuleEnum.Import_TrialBalance;
        $scope.chunkSize = 100000;
        $scope.success = false;      
        $scope.showErrorTable = false;
        $scope.showInitTable = false;
        $scope.showImportTable = false;
        $scope.isSelectPeriod = true;
        $scope.isShowImportTotalBtn = true;
        $scope.projectID = vatSessionService.project.id;
        $scope.startRowNum = 2;
        $scope.validationType = 0;
        $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
        $scope.sheetInfo = { selectedSheetName: '', selectedSheetIndex: 0 };
        $scope.balanceInputList = [];
        $scope.toInputList = [];
        $scope.importEnum = { Import: 0, CoverImport: 1, AddImport: 2 }; //导入方式
        $scope.selectedPeriod = null;
        $scope.showTotalSecondRow = false;

        $scope.importExcelFileUrlList = {
            taxData : apiInterceptor.webApiHostUrl + '/Analysis/DomesitcExcelFile',
            returnTax : apiInterceptor.webApiHostUrl + '/Analysis/DomesitcExcelFile',
            gmvSubsidy : apiInterceptor.webApiHostUrl + '/Analysis/DomesitcExcelFile',
            employeeNum : apiInterceptor.webApiHostUrl + '/Analysis/DomesitcExcelFile',
            driverNum : apiInterceptor.webApiHostUrl + '/Analysis/DomesitcExcelFile'
        };

        $scope.maxTitleLength = constant.maxButtonTitleLength;
        $scope.companyList = [];
        $scope.checkedCompanyList = [];
        $scope.checkedCompanyCodeList = [];
        $scope.checkedCompanyTypeList = "";
        $scope.selectCompany = '';


        $scope.showTaxGrid = false;
        $scope.showReturnTaxGrid = false;
        $scope.showGMVSubsidyGrid = false;
        $scope.showEmployeeNumGrid = false;
        $scope.showDriverNumGrid = false;
        $scope.importType = 0;
        $scope.selectType;

        $scope.domesticDataList = constant.domesticDataList;

        var date = new Date();
        var year = date.getFullYear();
        var month = date.getMonth()+1;
        $scope.selectedDate = new Date(year,date.getMonth(),1);
        $scope.startDate = new Date(year - 20, 1, 1);
        $scope.endDate = new Date(year + 20, 1, 1);
        $scope.viewMode = 1;
        $scope.dateFormat = $translate.instant('dateFormat4YearMonth');

        $scope.importExcelFile = null;
        if(month.length<2){
            $scope.UploadPeriodTime = year+" - 0"+month;
        }else{
            $scope.UploadPeriodTime = year+" - "+month;
        }

        //写日志
        var logDto = {
            ID: '',
            OperationName: '',
            ModuleID: $scope.moduleid,
            OperationObject: $translate.instant('ProfitAndLossStatement'),
            OperationType: '',
            OperationContent: '',
            OriginalState: '',
            UpdateState: '',
            CreatorID: vatSessionService.logUser.ID,
            Comment: comment,
            IP: '',
            Period: $scope.period
        };

        //初始化ack-pagination
        $scope.pagingOptions = {
            pageIndex: 1, //当前页码
            totalItems: 0, //总数据
            totalPages: 10, //总页数
            maxSize: 5, //分页数字的限制。
            pageSize: constant.page.pageSizeArrary[3], //每页多少条数据,100条
            pageSizeString: constant.page.pageSizeArrary[3].toString(),
            firstPage: $translate.instant('PagingFirstPage'),
            previousPage: $translate.instant('PagingPreviousPage'),
            nextPage: $translate.instant('PagingNextPage'),
            lastPage: $translate.instant('PagingLastPage'),
        };

        //初始化查询参数
        $scope.queryParams = {
            pageInfo: {
                totalCount: 0,
                pageIndex: 0,
                pageSize: 0,
                totalPage: 0,
            },
            periodId: $scope.period,
            serviceTypeId: $scope.serviceTypeId,
            projectId: $scope.projectID
        };


        var param = {
            companyName : $scope.selectCountry,
            type: $scope.importType,
            period: $scope.UploadPeriodTime
        };

        //分页获取数据
        $scope.eventService = {
            refreshInvoiceDataGrid: function () {
                $log.debug("refreshInvoiceDataGrid");
            }
        };

        var downloadTemplate = function () {
            templateService.downloadAnalysisTemplate($scope.importType).success(function (data, status, headers) {
                var fileName = '';
                constant.anlTemplateNameList.forEach(function (m) {
                    if (m.code === $scope.importType) {
                        fileName = m.name;
                    }
                });
                var octetStreamMime = 'application/octet-stream';
                var contentType = headers('content-type') || octetStreamMime;
                if (window.navigator.msSaveBlob) {
                    var blob = new Blob([data], {
                        type: contentType
                    });
                    navigator.msSaveBlob(blob, fileName);
                } else {
                    var urlCreator = window.URL || window.webkitURL || window.mozURL || window.msURL;
                    if (urlCreator) {
                        var a = document.createElement('a');
                        var blob = new Blob([data], {
                            type: contentType
                        });
                        var url = urlCreator.createObjectURL(blob);
                        a.href = url;
                        a.target = '_blank';
                        a.download = fileName+".xlsx";
                        document.body.appendChild(a);
                        a.click();
                    }
                }
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        };

        var doExport = function () {
            var localDate=$filter('date')(new  Date(), 'yyyyMMddHHmmss');
            var fileName = '';
            constant.anlDownLoadFileNameList.forEach(function (m) {
                if (m.code === $scope.importType) {
                    fileName = m.name + $scope.UploadPeriodTime+"_" +localDate;
                }
            });
            // param.companyName = $scope.selectCompany;
            param.type = $scope.importType;
            param.period = $scope.UploadPeriodTime;
            vatImportService.downloadDomesticFile(param,fileName).then(function (data) {
                if (data) {
                    ackMessageBox.success(translate('FileExportSuccess'));
                }
            });
        };

        //导入事件
        var doUpload = function () {

            var impExl = $scope.importExcelFile;
            var deferred = $q.defer();
            var token = $('input[name="__RequestVerificationToken"]').val();

            if (!impExl) {
                SweetAlert.warning($translate.instant('PleaseSelectFileFirst'));
                return;
            }

            var url = getUploadUrl();

            var period = $scope.UploadPeriodTime;

            Upload.upload({
                url: url,
                data: {
                    // companyName:$scope.selectCompany,
                    period: period,
                    type: $scope.importType
                },
                file: impExl,
                headers: {
                    'Access-Control-Allow-Origin': '*',
                    Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken(),
                    __RequestVerificationToken: token,
                    withCredentials: true
                },
                __RequestVerificationToken: token,
                withCredentials: true
            }).then(function(resp) {
                var ret = resp.data;
                $('#busy-indicator-container').hide();
                deferred.resolve();
                if (ret.result) {
                    logDto.UpdateState = $translate.instant('ImportSuccess');
                    vatOperationLogService.addOperationLog(logDto);
                    SweetAlert.success($translate.instant('ImportSuccess'));
                } else {
                    if (ret.resultMsg && ret.resultMsg.length > 0) {
                        SweetAlert.warning($translate.instant(ret.resultMsg));
                    }else{
                        SweetAlert.error($translate.instant('ImportFailed'));
                    }
                }
                refreshGrid();
            }, function(resp) {
                deferred.resolve();
                if (resp.statusText === 'HttpRequestValidationException') {
                    SweetAlert.warning($translate.instant('HttpRequestValidationException'));
                } else {
                    SweetAlert.warning('SaveFail');
                }
                SweetAlert.error($translate.instant('ImportFail'));
                console.log('Error status: ' + resp.status);
            }, function(evt) {
                deferred.resolve();
                var progressPercentage = parseInt(100.0 * evt.loaded / evt.total);
                $log.debug('progress: ' + progressPercentage + '% ' + evt.config.data.file.name);
            });
        };

        var getUploadUrl = function(){
            var url = "";
            switch ($scope.importType) {
                case 0:
                    url = $scope.importExcelFileUrlList.taxData;
                    break;
                case 1:
                    url = $scope.importExcelFileUrlList.returnTax;
                    break;
                case 2:
                    url = $scope.importExcelFileUrlList.gmvSubsidy;
                    break;
                case 3:
                    url = $scope.importExcelFileUrlList.employeeNum;
                    break;
                case 4:
                    url = $scope.importExcelFileUrlList.driverNum;
                    break;
                default:
                    break;
            }
            return url;
        };

        var refreshGrid = function () {
            switch ($scope.importType) {
                case 0:
                    getImportTax();
                    break;
                case 1:
                    getImportReturnTax();
                    break;
                case 2:
                    getImportGMVSubsidy();
                    break;
                case 3:
                    getImportEmployeeNum();
                    break;
                case 4:
                    getImportDriverNum();
                    break;
                default:
                    break;
            }
        };

        var getGridHeight = function () {
            if ($scope.isLoadComplete) {
                return { height: ($('.balance-ouput-grid-wrapper').height()) + "px" };
            }
            else {
                return { height: 0 + "px" };
            }
        };

        var loadTaxDatagrid = function () {
            $scope.taxGridOptions = {
                bindingOptions: {
                    dataSource: 'taxGridSource'
                },
                showBorders: true,
                columns: [{
                    dataField: "companyName",
                    width: '28%',
                    allowHeaderFiltering: false,
                    caption: $translate.instant('CompanyName')
                }, {
                    dataField: "segment1",
                    allowHeaderFiltering: false,
                    caption: $translate.instant('BuildingTax'),
                    width: '12%'
                }, {
                    dataField: "segment2",
                    allowHeaderFiltering: false,
                    width: '12%',
                    caption: $translate.instant('EducationSurcharge')
                }, {
                    dataField: "segment3",
                    allowHeaderFiltering: false,
                    width: '12%',
                    caption: $translate.instant('UrbanEducationSurcharge')
                }, {
                    dataField: "segment4",
                    allowHeaderFiltering: false,
                    width: '12%',
                    caption: $translate.instant('EmployeeTax')
                }, {
                    dataField: "segment5",
                    allowHeaderFiltering: false,
                    width: '12%',
                    caption: $translate.instant('DriverTax')
                }, {
                    dataField: "segment6",
                    allowHeaderFiltering: false,
                    width: '12%',
                    caption: $translate.instant('StampDuty')
                }
                ],
                onContentReady: function (e) {
                    $scope.taxInstance = e.component;
                    var totalCount = e.component.totalCount();
                    if (totalCount > 0) {
                        $scope.totalCount = totalCount;
                    }
                },
                loadPanel: {
                    enabled: false
                },
                selection: {
                    mode: "single"
                },
                grouping: {
                    autoExpandAll: false
                },
                allowColumnResizing: true,
                allowColumnReordering:true,
                columnAutoWidth: true,
                showRowLines: true,
                showColumnLines: true,
                rowAlternationEnabled: true,  //单双行颜色
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                headerFilter: {
                    visible: false,
                    texts: {
                        cancel: $translate.instant('Cancel'),
                        ok: $translate.instant('Confirm'),
                        emptyValue: $translate.instant('Empty'),
                        selectAllText: $translate.instant('SelectAll')
                    }
                },
                paging: {
                    pageSize: constant.page.pageSize
                },
                pager: {
                    showPageSizeSelector: true,
                    allowedPageSizes: constant.page.pageSizeArrary,
                    showInfo: true
                }
            };
            getImportTax();
        };

        var getImportTax = function () {
            // param.companyName = $scope.selectCompany;
            param.type = $scope.importType;
            param.period = $scope.UploadPeriodTime;
            vatImportService.displayAnalysisImportData(param).success(function (data) {
                if (data.data) {
                    $scope.taxGridSource = data.data;
                }else {
                    SweetAlert.error($translate.instant('SystemError'));
                }
            });
        };

        var loadReturnTaxDatagrid = function () {
            $scope.returnTaxGridOptions = {
                bindingOptions: {
                    dataSource: 'returnTaxGridSource'
                },
                showBorders: true,
                columns: [{
                    dataField: "companyName",
                    width: '25%',
                    allowHeaderFiltering: false,
                    caption: $translate.instant('CompanyName')
                }, {
                    dataField: "segment1",
                    allowHeaderFiltering: false,
                    caption: $translate.instant('VATRefund'),
                    width: '15%'
                }, {
                    dataField: "segment2",
                    allowHeaderFiltering: false,
                    width: '15%',
                    caption: $translate.instant('UrbanConstructionTaxRefund')
                }, {
                    dataField: "segment3",
                    allowHeaderFiltering: false,
                    width: '15%',
                    caption: $translate.instant('EducationFeeSurcharge')
                }, {
                    dataField: "segment4",
                    allowHeaderFiltering: false,
                    width: '15%',
                    caption: $translate.instant('LocalEducationFeeSurcharge')
                }, {
                    dataField: "segment5",
                    allowHeaderFiltering: false,
                    width: '15%',
                    caption: $translate.instant('PersonalIncomeTaxReturn')
                }],
                onContentReady: function (e) {
                    $scope.accountingRateListInstance = e.component;
                    var totalCount = e.component.totalCount();
                    if (totalCount > 0) {
                        $scope.totalCount = totalCount;
                    }
                },
                loadPanel: {
                    enabled: false
                },
                selection: {
                    mode: "single"
                },
                grouping: {
                    autoExpandAll: false
                },
                allowColumnResizing: true,
                allowColumnReordering:true,
                columnAutoWidth: true,
                showRowLines: true,
                showColumnLines: true,
                rowAlternationEnabled: true,  //单双行颜色
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                headerFilter: {
                    visible: false,
                    texts: {
                        cancel: $translate.instant('Cancel'),
                        ok: $translate.instant('Confirm'),
                        emptyValue: $translate.instant('Empty'),
                        selectAllText: $translate.instant('SelectAll')
                    }
                },
                paging: {
                    pageSize: constant.page.pageSize
                },
                pager: {
                    showPageSizeSelector: false,
                    allowedPageSizes: constant.page.pageSizeArrary,
                    showInfo: true
                }
            };
            getImportReturnTax();
        };

        var getImportReturnTax = function () {
            // param.companyName = $scope.selectCompany;
            param.type = $scope.importType;
            param.period = $scope.UploadPeriodTime;
            vatImportService.displayAnalysisImportData(param).success(function (data) {
                if (data.data) {
                    $scope.returnTaxGridSource = data.data;
                }else {
                    SweetAlert.error($translate.instant('SystemError'));
                }
            });
        };

        var loadGMVSubsidyDatagrid = function () {
            $scope.GMVSubsidyGridOptions = {
                bindingOptions: {
                    dataSource: 'GMVSubsidyGridSource'
                },
                showBorders: true,
                columns: [{
                    dataField: "businessLine",
                    width: '28%',
                    allowHeaderFiltering: false,
                    caption: $translate.instant('BusinessLine')
                }, {
                    dataField: "segment1",
                    allowHeaderFiltering: false,
                    caption: $translate.instant('OrderChainRatio'),
                    width: '12%'
                }, {
                    dataField: "segment2",
                    allowHeaderFiltering: false,
                    width: '12%',
                    caption: $translate.instant('GmvChainRatio')
                }, {
                    dataField: "segment3",
                    allowHeaderFiltering: false,
                    width: '12%',
                    caption: $translate.instant('BSubsidyRate')
                }, {
                    dataField: "segment4",
                    allowHeaderFiltering: false,
                    width: '12%',
                    caption: $translate.instant('BEndLinkRatio')
                }, {
                    dataField: "segment5",
                    allowHeaderFiltering: false,
                    width: '12%',
                    caption: $translate.instant('CSubsidyRate')
                }, {
                    dataField: "segment6",
                    allowHeaderFiltering: false,
                    width: '12%',
                    caption: $translate.instant('CEndLinkRatio')
                }],
                onContentReady: function (e) {
                    $scope.GMVSubsidyInstance = e.component;
                    var totalCount = e.component.totalCount();
                    if (totalCount > 0) {
                        $scope.totalCount = totalCount;
                    }
                },
                loadPanel: {
                    enabled: false
                },
                selection: {
                    mode: "single"
                },
                grouping: {
                    autoExpandAll: false
                },
                allowColumnResizing: true,
                allowColumnReordering:true,
                columnAutoWidth: true,
                showRowLines: true,
                showColumnLines: true,
                rowAlternationEnabled: true,  //单双行颜色
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                headerFilter: {
                    visible: false,
                    texts: {
                        cancel: $translate.instant('Cancel'),
                        ok: $translate.instant('Confirm'),
                        emptyValue: $translate.instant('Empty'),
                        selectAllText: $translate.instant('SelectAll')
                    }
                },
                paging: {
                    pageSize: constant.page.pageSize
                },
                pager: {
                    showPageSizeSelector: true,
                    allowedPageSizes: constant.page.pageSizeArrary,
                    showInfo: true
                }
            };
            getImportGMVSubsidy();
        };

        var getImportGMVSubsidy = function () {
            // param.companyName = $scope.selectCompany;
            param.type = $scope.importType;
            param.period = $scope.UploadPeriodTime;
            vatImportService.displayAnalysisImportData(param).success(function (data) {
                if (data.data) {
                    $scope.GMVSubsidyGridSource = data.data;
                }else {
                    SweetAlert.error($translate.instant('SystemError'));
                }
            });
        };

        var loadEmployeeNumDatagrid = function () {
            $scope.employeeNumGridOptions = {
                bindingOptions: {
                    dataSource: 'employeeNumGridSource'
                },
                showBorders: true,
                columns: [{
                    dataField: "id",
                    visible: false,
                    allowHeaderFiltering: false,
                    caption: $translate.instant('id')
                }, {
                    dataField: "companyName",
                    allowHeaderFiltering: false,
                    width: '40%',
                    caption: $translate.instant('CompanyName')
                }, {
                    dataField: "fullTimeAmount",
                    width: '15%',
                    allowHeaderFiltering: false,
                    caption: $translate.instant('FullTimeAmount')
                }, {
                    dataField: "internAmount",
                    allowHeaderFiltering: false,
                    caption: $translate.instant('InternAmount'),
                    width: '15%'
                }, {
                    dataField: "vendorAmount",
                    allowHeaderFiltering: false,
                    width: '15%',
                    caption: $translate.instant('VendorAmount')
                }, {
                    dataField: "totalAmount",
                    allowHeaderFiltering: false,
                    width: '15%',
                    caption: $translate.instant('EmployeeTotalAmount')
                }],
                onContentReady: function (e) {
                    $scope.employeeNumInstance = e.component;
                    var totalCount = e.component.totalCount();
                    if (totalCount > 0) {
                        $scope.totalCount = totalCount;
                    }
                },
                loadPanel: {
                    enabled: false
                },
                selection: {
                    mode: "single"
                },
                grouping: {
                    autoExpandAll: false
                },
                allowColumnResizing: true,
                allowColumnReordering:true,
                columnAutoWidth: true,
                showRowLines: true,
                showColumnLines: true,
                rowAlternationEnabled: true,  //单双行颜色
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                headerFilter: {
                    visible: false,
                    texts: {
                        cancel: $translate.instant('Cancel'),
                        ok: $translate.instant('Confirm'),
                        emptyValue: $translate.instant('Empty'),
                        selectAllText: $translate.instant('SelectAll')
                    }
                },
                paging: {
                    pageSize: constant.page.pageSize
                },
                pager: {
                    showPageSizeSelector: true,
                    allowedPageSizes: constant.page.pageSizeArrary,
                    showInfo: true
                }
            };
            getImportEmployeeNum();
        };

        var getImportEmployeeNum = function () {
            // param.companyName = $scope.selectCompany;
            param.type = $scope.importType;
            param.period = $scope.UploadPeriodTime;
            vatImportService.displayAnalysisImportData(param).success(function (data) {
                if (data.data) {
                    $scope.employeeNumGridSource = data.data;
                }else {
                    SweetAlert.error($translate.instant('SystemError'));
                }
            });
        };

        var loadDriverNumDatagrid = function () {
            $scope.driverNumGridOptions = {
                bindingOptions: {
                    dataSource: 'driverNumGridSource'
                },
                showBorders: true,
                columns: [{
                    dataField: "id",
                    visible: false,
                    allowHeaderFiltering: false,
                    caption: $translate.instant('id')
                }, {
                    dataField: "driverType",
                    width: '50%',
                    allowHeaderFiltering: false,
                    caption: $translate.instant('DriverType')
                }, {
                    dataField: "driverNum",
                    allowHeaderFiltering: false,
                    caption: $translate.instant('DriverNum'),
                    width: '50%'
                }],
                onContentReady: function (e) {
                    $scope.driverNumInstance = e.component;
                    var totalCount = e.component.totalCount();
                    if (totalCount > 0) {
                        $scope.totalCount = totalCount;
                    }
                },
                loadPanel: {
                    enabled: false
                },
                selection: {
                    mode: "single"
                },
                grouping: {
                    autoExpandAll: false
                },
                allowColumnResizing: true,
                allowColumnReordering:true,
                columnAutoWidth: true,
                showRowLines: true,
                showColumnLines: true,
                rowAlternationEnabled: true,  //单双行颜色
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                headerFilter: {
                    visible: false,
                    texts: {
                        cancel: $translate.instant('Cancel'),
                        ok: $translate.instant('Confirm'),
                        emptyValue: $translate.instant('Empty'),
                        selectAllText: $translate.instant('SelectAll')
                    }
                },
                paging: {
                    pageSize: constant.page.pageSize
                },
                pager: {
                    showPageSizeSelector: true,
                    allowedPageSizes: constant.page.pageSizeArrary,
                    showInfo: true
                }
            };
            getImportDriverNum();
        };

        var getImportDriverNum = function () {
            // param.companyName = $scope.selectCompany;
            param.type = $scope.importType;
            param.period = $scope.UploadPeriodTime;
            vatImportService.displayAnalysisImportData(param).success(function (data) {
                if (data.data) {
                    $scope.driverNumGridSource = data.data;
                }else {
                    SweetAlert.error($translate.instant('SystemError'));
                }
            });
        };

        //加载文档后操作
        var initImportFile = function (fileName) {
            var arr = fileName.name.split('.');
            if (arr[arr.length - 1] !== 'xls' && arr[arr.length - 1] !== 'xlsx') {
                SweetAlert.warning($translate.instant('ImportFileInvalidType'));
                return;
            }
            $scope.fileName = fileName.name;
            //初始化数据
            $scope.selectedMappingList = [];
            $scope.ImportErrorTab = false;
            $scope.ImportErrorTag = false;
        };


        //日志
        var showOperateLogPop = function () {
            $scope.isShowLog = true;
        };


        var initPagingControl = function (totalItemsCount) {
            $scope.pagingOptions.totalItems = totalItemsCount;
        };


        // 检查用户机构权限
        var checkUserOrganizationPermissionList = function () {

            var list = [];

            var userManageTemp = constant.vatPermission.dataImport.balanceSheet;
            list.push(userManageTemp.importCode);
            $scope.hasImportPermission = false;
            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasImportPermission = data[userManageTemp.importCode];
            });
        };


        //控制明细信息中删除权限
        var getUserPermission = function () {
            var list = [];
            var code = constant.vatPermission.dataImport.balanceSheet.importCode;
            list.push(code);

            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasEditPermission = data[code];
            });
        };


        var setButtonWrapStyle = function () {
            if ($scope.fileName) {
                return { width: "100%" };
            }
        };

        var setGridStyle = function () {
            if ($scope.showTotalSecondRow) {
                return { 'margin-top': '60px' }
            }
            else {
                return { 'margin-top': '55px' }
            }
        };

        var initDatePicker = function () {
            var ele1 = $("#periodDatepicker");
            ele1.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                viewMode: $scope.viewMode,
                minViewMode: $scope.viewMode,
                autoclose: true, //选中之后自动隐藏日期选择框
                clearBtn: true, //清除按钮
                todayBtn: false, //今日按钮
                format: $scope.dateFormat //日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            });
            ele1.datepicker("setDate", $scope.selectedDate);
        };

        var initParam = function () {
            $scope.doUpload = doUpload;
            $scope.doExport = doExport;
            $scope.downloadTemplate = downloadTemplate;
            $scope.initPagingControl = initPagingControl;
            $scope.setButtonWrapStyle = setButtonWrapStyle;
            $scope.getGridHeight = getGridHeight;
            $scope.showOperateLogPop = showOperateLogPop;
            $scope.setGridStyle = setGridStyle;
        };

        var initCompanyList = function () {
            orgService.getOrgListByUserId().success(function (data) {
                if (data) {
                    $scope.companyList = data;
                }
            });
        };

        $scope.selectCompanyEvent = function(i){
            $scope.selectCompany=i.name;
            refreshGrid();
        };

        $scope.selectOne = function () {
            $scope.checkedCompanyList = [];
            angular.forEach($scope.companyList , function (i) {
                var index = $scope.checkedCompanyList.indexOf(i.id);
                if(i.checked && index === -1) {
                    $scope.checkedCompanyList.push(i);
                } else if (!i.checked && index !== -1){
                    $scope.checkedCompanyList.splice(index, 1);
                }
            });

            $scope.selectedAll = $scope.companyList.length === $scope.checkedCompanyList.length;

            $scope.checkedCompanyTypeList = "";
            $scope.checkedCompanyCodeList = [];
            angular.forEach($scope.checkedCompanyList,function (i) {
                $scope.checkedCompanyTypeList += i.name+";";
                $scope.checkedCompanyCodeList.push(i.id);
            });
            console.log($scope.checkedCompanyList);
        };

        $scope.selectAll = function () {
            if($scope.selectedAll) {
                $scope.selectedOne = true;
                $scope.checkedCompanyList = [];
                angular.forEach($scope.companyList, function (i, index) {
                    $scope.checkedCompanyList.push(i);
                    i.checked = true;
                })
            }else {
                $scope.selectedOne = false;
                $scope.checkedCompanyList = [];
                angular.forEach($scope.companyList, function (i, index) {
                    i.checked = false;
                })
            }
            $scope.checkedCompanyTypeList = "";
            $scope.checkedCompanyCodeList = [];
            angular.forEach($scope.checkedCompanyList,function (i) {
                $scope.checkedCompanyTypeList += i.name;
                $scope.checkedCompanyCodeList.push(i.id);
            });
            console.log($scope.checkedCompanyList);
        };

        $scope.changeTab = function(i){
            $scope.importType = i.code;
            $scope.selectType = i.type;
            $scope.showTaxGrid = false;
            $scope.showReturnTaxGrid = false;
            $scope.showGMVSubsidyGrid = false;
            $scope.showEmployeeNumGrid = false;
            $scope.showDriverNumGrid = false;
            switch (i.code) {
                case 0:
                    $scope.showTaxGrid = true;
                    loadTaxDatagrid();
                    break;
                case 1:
                    $scope.showReturnTaxGrid = true;
                    loadReturnTaxDatagrid();
                    break;
                case 2:
                    $scope.showGMVSubsidyGrid = true;
                    loadGMVSubsidyDatagrid();
                    break;
                case 3:
                    $scope.showEmployeeNumGrid = true;
                    loadEmployeeNumDatagrid();
                    break;
                case 4:
                    $scope.showDriverNumGrid = true;
                    loadDriverNumDatagrid();
                    break;
                default:
                    break;
            }
        };

        //开始
        (function initialize() {
            $log.debug('domesticDataImportController.ctor()...');
            initParam();
            checkUserOrganizationPermissionList();
            getUserPermission();
            initCompanyList();
            initDatePicker();

            $scope.$watch('importExcelFile', function (newValue, oldValue) {
                if (newValue !== null && newValue !== oldValue) {
                    initImportFile(newValue);
                }
            });

            $scope.$watch('UploadPeriodTime', function (newValue, oldValue) {
                refreshGrid();
            });

            $timeout(function () {
                $scope.isLoadComplete = true;
            }, 500);
        })();
    }
]);