﻿citModule.controller('citOrganizationDashboardController', ['$scope', '$log', '$translate', '$timeout', '$q', '$interval',
    'loginContext', 'apiInterceptor', 'SweetAlert', 'dashboardConfigSummaryService', '$stateParams', 'vatSessionService',
    'citSessionService', 'modelConfigurationService', 'canvasUtil', 'vatDashboardService',
    function ($scope, $log, $translate, $timeout, $q, $interval, loginContext, apiInterceptor, SweetAlert, dashboardConfigSummaryService,
        $stateParams, vatSessionService, citSessionService, modelConfigurationService, canvasUtil, vatDashboardService) {
        'use strict';

        var thisData = {
            organizationId: '',
            year: citSessionService.year,
            period: 13
        };

        var thisConstant = {
            dashSignSeparator: '-',
            rowCountPerPage: 9,
            orgColumn: 'v1',
            prefixField: 'v',
            tableBeginXml: '<w:tbl><w:tblPr><w:tblW w:w="5000" w:type="pct"/><w:tblLook w:val="04A0" w:firstRow="1" w:lastRow="0" w:firstColumn="1" w:lastColumn="0" w:noHBand="0" w:noVBand="1"/></w:tblPr><w:tblGrid>',
            tableEndXml: '</w:tbl>',
            tableColDefXml: '<w:gridCol w:w="2000"/>',
            tableColBeginXml: '</w:tblGrid><w:tr>',
            headerFirstCellBeginXml: '<w:tc><w:tcPr><w:tcW w:w="2000" w:type="dxa"/><w:tcBorders><w:bottom w:val="single" w:sz="12" w:space="0" w:color="A5A5A5" w:themeColor="accent3"/></w:tcBorders></w:tcPr><w:p><w:pPr><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr></w:pPr><w:r><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:b/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr><w:t>',
            headerCellBeginXml: '<w:tc><w:tcPr><w:tcW w:w="2000" w:type="dxa"/><w:tcBorders><w:bottom w:val="single" w:sz="12" w:space="0" w:color="A5A5A5" w:themeColor="accent3"/></w:tcBorders></w:tcPr><w:p><w:pPr><w:jc w:val="right"/><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr></w:pPr><w:r><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:b/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr><w:t>',
            headerCellEndXml: '</w:t></w:r></w:p></w:tc>',
            firstCellBeginXml: '<w:tc><w:tcPr><w:tcW w:w="2000" w:type="dxa"/><w:tcBorders><w:top w:val="single" w:sz="12" w:space="0" w:color="A5A5A5" w:themeColor="accent3"/><w:bottom w:val="single" w:sz="2" w:space="0" w:color="A5A5A5" w:themeColor="accent3"/></w:tcBorders></w:tcPr><w:p><w:pPr><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr></w:pPr><w:r><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:b/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr><w:t>',
            cellBeginXml: '<w:tc><w:tcPr><w:tcW w:w="2000" w:type="dxa"/><w:tcBorders><w:top w:val="single" w:sz="12" w:space="0" w:color="A5A5A5" w:themeColor="accent3"/><w:bottom w:val="single" w:sz="2" w:space="0" w:color="A5A5A5" w:themeColor="accent3"/></w:tcBorders></w:tcPr><w:p><w:pPr><w:jc w:val="right"/><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr></w:pPr><w:r><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:color w:val="ED7D31" w:themeColor="accent2"/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr><w:t>',
            rowBeginXml: '<w:tr>',
            rowEndXml: '</w:tr>',
            chartPrefix: 'chart-'
        };

        var webHost = loginContext.apiHost;
        $scope.downloadPath = webHost + '/Resource/AnalyticExportReport.docx';
        $scope.showExportButton = false;

        var thisDateService = {

            // 转换为页面展示数据
            parseShowData: function (data) {
                if (data && data.length > 0) {
                    data.forEach(function (row) {
                        var values = _.values(row.header);
                        var keys = _.keys(row.header);
                        var length = keys ? keys.length : 0;
                        row.keys = keys;
                        row.headerObj = JSON.parse(row.headerObj);
                        var headerKey = _.keys(row.header);
                        var headerArr = _.pairs(row.header);
                        var monthIdx = '';
                        var headerValue = _.map(headerArr, function (x) {
                            if (x[1] === '月份') {
                                monthIdx = x[0];
                                x[1] = $translate.instant('MonthDimension');
                            }
                            else if (x[1] === '年份') {
                                x[1] = $translate.instant('YearDimension');
                            }
                            return x[1];
                        });

                        row.header = _.object(headerKey, headerValue);

                        if (!_.isEmpty(monthIdx)) {
                            _.each(row.data, function (x) {
                                x[monthIdx] = $translate.instant('Month' + x[monthIdx]);
                            });
                        }
                    });
                }

                return data;
            },

            // 查询汇总数据
            querySummaryProcess: function () {

                dashboardConfigSummaryService.queryOrganizationData(thisData.organizationId,thisData.year,thisData.period).success(function (data) {
                    // 进行数据转换    
                    //data[0].isShowChart = false;
                    $scope.querySummaryResult = thisDateService.parseShowData(data);
                    data.forEach(function (m) {
                        if (!_.isNull(m.modelTips)) {
                            m.modelTips.forEach(function (r) {
                                thisDateService.setRiskTipStyle(r);
                            });
                        }                        
                    });

                    $timeout(function () {
                        thisDateService.drawTableList($scope.querySummaryResult);
                    }, 200);

                    // console.log(JSON.stringify($scope.querySummaryResult));
                });
            },

            drawTableList: function (data) {
                if (data && data.length > 0) {
                    data.forEach(function (row) {
                        thisDateService.drawTable(row);
                    });
                }
            },

            drawTable: function (node) {

                if (_.isEmpty(node.data)) {
                    node.isEmpty = true;
                }
                else {
                    node.isEmpty = false;
                var vatGallery = thisDateService.createGalleryData(node);

                var itemTemplate = function (item, index) {
                    var columns = thisDateService.createColumns(node);

                    return $('<div class="gallery-table"/>').dxDataGrid({
                        dataSource: item.dataValue,
                        width: '100%',
                        showRowLines: true,
                        showColumnLines: false,
                        noDataText: '',
                        showBorders: false,
                        cellHintEnabled: true,
                        format: { type: 'fixedPoint', precision: 2 },
                        columns: columns
                    });

                };
                var galleryWidget = $("#" + node.id).dxGallery({
                    dataSource: vatGallery,
                    // height: 260,
                    width: "458px",
                    loop: false,
                    showIndicator: true,
                    showNavButtons: true,
                    itemTemplate: itemTemplate,

                }).dxGallery("instance");
                }
            },
            // 构造GalleryData
            createGalleryData: function (node) {

                var index = Math.ceil(node.data.length / thisConstant.rowCountPerPage);
                // var x = node.data.length % thisConstant.rowCountPerPage;
                // if (x !== 0) {
                //     index = index + 1;
                // }

                var result = [];
                for (var i = 0; i < index; i++) {
                    var item = {};
                    item.id = i;
                    item.dataValue = [];
                    var start = i * thisConstant.rowCountPerPage;
                    for (var j = start; j < start + thisConstant.rowCountPerPage; j++) {
                        var rowData = angular.copy(node.data[j]);
                        if (!rowData) {
                            continue;
                        }

                        for (var k = 1; k < node.headerObj.length; k++) {
                            var dataModel = node.headerObj[k];
                            var field = thisConstant.prefixField + (k + 1);
                            if (dataModel.dataType === 1) {
                                rowData[field] = Number(rowData[field]).formatAmount();

                            } else if (dataModel.dataType === 3) {
                                rowData[field] = rowData[field] == 1 ? '是' : '否';
                            } else {
                                var percentData = Number(rowData[field]) * 100;
                                rowData[field] = Number(percentData).formatAmount() + '%';
                            }
                        }

                        item.dataValue.push(rowData);
                    }

                    result.push(item);
                }

                return result;
            },

            // 构造列表
            createColumns: function (node) {
                var result = [];
                node.keys.forEach(function (key) {
                    var item = {};
                    item.dataField = key,
                        item.caption = node.header[key];
                    item.alignment = 'center';
                    if (key !== thisConstant.orgColumn) {
                        item.format = { type: 'fixedPoint' };
                        item.cssClass = 'orange-color';
                        item.alignment = 'right';
                    }

                    result.push(item);
                });

                return result;
            },


            setRiskTipStyle: function (risk) {
                if (risk.hasRisk) {
                    return { color: '#b4122a' }
                }               
            },
         
            toggleChart: function ($event,node) {
                var target = $event.target;
                node.isShowChart = !node.isShowChart;
            }
        };

        $scope.hasCheckedDirtyData = false;
        $scope.progressBarValue = 0;
        $scope.processBarModalInstance = null;
        $scope.intervalId = null;
        $scope.hasCheckedDirtyDataSuccess = false;


        function timer() {
            $scope.$apply(function () {
                $scope.progressBarValue++;
                if (!$scope.hasCheckedDirtyDataSuccess) {
                    $scope.processBarMax++;
                }
            });
        }

        $scope.processBarMax = 100;
        $scope.hasCheckedFinished = false;
        $scope.progressBarOptions = {
            min: 0,
            width: "95%",
            bindingOptions: {
                value: 'progressBarValue',
                max: 'processBarMax'
            },
            statusFormat: function (value) {
                return "计算进度: " + (value * 100).toFixed(0) + "%";
            },
            onComplete: function (e) {
                //重新计算模型数据结束后加载图表。
                thisDateService.querySummaryProcess();
            }
        };

        //删除图表
        $scope.deleteChartConfig = function (id) {
            SweetAlert.swal({
                title: $translate.instant('ConfirmDelete'),
                text: $translate.instant('deleteChart') + "?",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#DD6B55",
                confirmButtonText: $translate.instant('Confirm'),
                cancelButtonText: $translate.instant('Cancel'),
                closeOnConfirm: true
            }, function (isConfirm) {
                if (isConfirm) {
                    vatDashboardService.deleteConfigById(id).success(function () {
                        SweetAlert.success($translate.instant('DeleteSuccess'));
                        thisDateService.querySummaryProcess();
                    });
                }
            });
        };

        var mainModule = {

            // 初始化参数
            initParams: function () {
                if ($stateParams.id) {
                    thisData.organizationId = $stateParams.id;
                } else {
                    thisData.organizationId = vatSessionService.project.organizationID;
                }

                citSessionService.dashboardSingelOrganizationId = thisData.organizationId;

                var queryMonth = citSessionService.lastDashboardSummaryQueryMonth;
                if (!_.isEmpty(queryMonth) && queryMonth.indexOf('-') >= 0) {
                    var dateStrs = queryMonth.split('-');
                    thisData.year = Number(dateStrs[0]);
                    thisData.period = Number(dateStrs[1]);
                } else {
                    thisData.year = vatSessionService.project.year;
                    thisData.period = citSessionService.month;
                }

                // Start for Edmond: CIT demo: Tax_Tech_Demo(2017)
                if (thisData.organizationId === '00e3a331-d491-4baa-895e-ca47d9bab690' && thisData.year === 2017 && thisData.period === 13) {
                    $scope.showExportButton = true;
                }
                // End for Edmond: CIT demo
            },

            // 入口函数
            main: function () {
                mainModule.initParams();
                if ($scope.hasCheckedDirtyData) {
                    thisDateService.querySummaryProcess();
                } else {
                    modelConfigurationService.organizationsHasDirtyData(thisData.organizationId, citSessionService.querySummayDashboardModel.year, 2).success(function (result) {
                        if (result) {
                            SweetAlert.swal({
                                title: $translate.instant('OrganizationsHasDirtyData'),
                                text: '',
                                type: "warning",
                                showCancelButton: true,
                                confirmButtonColor: "#DD6B55",
                                confirmButtonText: $translate.instant('Confirm'),
                                cancelButtonText: $translate.instant('Cancel'),
                                closeOnConfirm: true
                            }, function (isConfirm) {
                                if (isConfirm) {

                                    var parentElem = angular.element($('#organizationDirtyProcessBarContainer'));
                                    $scope.processBarModalInstance = $uibModal.open({
                                        ariaLabelledBy: 'modal-title',
                                        ariaDescribedBy: 'modal-body',
                                        templateUrl: 'dirtyDataProcessBar.html',
                                        windowClass: 'data-table',
                                        appendTo: parentElem,
                                        backdrop: 'static',
                                        scope: $scope
                                    });

                                    $scope.intervalId = setInterval(timer, 50);

                                    //重新计算模型数据
                                    modelConfigurationService.updateOrganizationsModelDirtyData(thisData.organizationId, citSessionService.querySummayDashboardModel.year, 2).success(function () {
                                        $scope.hasCheckedDirtyDataSuccess = true;
                                    });
                                } else {
                                    thisDateService.querySummaryProcess();
                                }
                            });
                        } else {
                            thisDateService.querySummaryProcess();
                        }
                    });
                    $scope.hasCheckedDirtyData = true;
                }
            },

            loadFile: function (url, callback) {
                JSZipUtils.getBinaryContent(url, callback);
            },

            generateDoc: function (doc) {
                var tableContent = thisConstant.tableBeginXml;
                var colNum = doc.keys.length;
                var rowNum = doc.data.length;
                for (var i = 0; i < colNum; i++) {
                    tableContent += thisConstant.tableColDefXml;
                }

                tableContent += thisConstant.tableColBeginXml;

                for (var i = 0; i < colNum; i++) {
                    tableContent = tableContent
                        + (i === 0 ? thisConstant.headerFirstCellBeginXml : thisConstant.headerCellBeginXml)
                        + doc.header[doc.keys[i]] + thisConstant.headerCellEndXml;
                }

                tableContent += thisConstant.rowEndXml;

                for (var j = 0; j < rowNum; j++) {
                    tableContent += thisConstant.rowBeginXml;

                    for (var i = 0; i < colNum; i++) {
                        var dataModel = doc.headerObj[i];
                        var data = doc.data[j][doc.keys[i]];
                        if (i > 0) {
                            if (dataModel.dataType === 1) {
                                data = Number(data).formatAmount();

                            } else if (dataModel.dataType === 3) {
                                data = data == 1 ? '是' : '否';
                            }
                            else {
                                var percentData = Number(data) * 100;
                                data = Number(percentData).formatAmount() + '%';
                            }
                        }

                        if (i === 0) {
                            tableContent = tableContent + thisConstant.firstCellBeginXml
                                + data + thisConstant.headerCellEndXml;
                        }
                        else {
                            tableContent = tableContent + thisConstant.cellBeginXml
                                + data + thisConstant.headerCellEndXml;
                        }
                    }

                    tableContent += thisConstant.rowEndXml;
                }

                tableContent += thisConstant.tableEndXml;

                return {
                    chartName: doc.name,
                    chartContent: thisConstant.chartPrefix + doc.id,
                    riskTip: _.isArray(doc.modelTips) ? doc.modelTips : [],
                    tableContent: tableContent
                };
            },

            generateDocImages: function () {
                var opts = {
                    centered: true,
                    getImage: function (tagValue, tagName) {
                        return canvasUtil.toBinaryData(document.getElementById(tagValue));
                    },
                    getSize: function (img, tagValue, tagName) {
                        return [550, 250];
                    }
                }

                var imageModule = new ImageModule(opts);
                return imageModule;
            },

            exportChart: function (chart) {
                var exportModel = mainModule.generateDoc(chart);

                var exportDocName = chart.name + '.docx';
                var templateName = '/ExportTemplate/DashboardExportTemplate.docx';

                mainModule.loadFile(templateName + '?_=' + Math.random(), function (err, content) {
                    if (err) { throw e };
                    var zip = new JSZip2(content);
                    var imageModule = mainModule.generateDocImages();
                    var doc = new docxtemplater().attachModule(imageModule).loadZip(zip);
                    doc.setData(exportModel);
                    try {
                        doc.render();
                    }
                    catch (err) {
                        $log.info(err);
                        swal({
                            title: '导出发生一个错误，请重试',
                            confirmButtonColor: "#dc6000",
                            confirmButtonText: "确定",
                            closeOnConfirm: true,
                            type: "error"
                        });
                        return;
                    }

                    var out = doc.getZip().generate({
                        type: "blob",
                        mimeType: "application/vnd.openxmlformats-officedocument.wordprocessingml.document",
                    });
                    saveAs(out, exportDocName);
                })
            }
        };

        //重新计算模型完成时执行
        $scope.$watch('progressBarValue', function (newValue) {
            if (newValue == $scope.processBarMax) {
                $scope.processBarModalInstance.dismiss({ $value: 'cancel' });
                clearInterval($scope.intervalId);
            }
        });

        var getUserPermission = function () {
            var list = [];
            var queryCode = constant.citPermission.dataAnalysis.dashboard.querySummaryDashboardCode;
            var editCode = constant.citPermission.dataAnalysis.dashboard.singleOrgIndexDashboardCode;
            list.push(queryCode);
            list.push(editCode);
            $scope.hasQueryPermission = false;
            $scope.hasEditPermission = false;
            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasQueryPermission = data[queryCode];
                $scope.hasEditPermission = data[editCode];
            });
        };

        //开始
        (function initialize() {
            $log.debug('citOrganizationDashboardController.ctor()...');

            if (citSessionService.urlFromAnalyze) {
                $scope.urlFromAnalyze = 'citAnalyzeOrganizeDashboardConfig';
            } else {
                $scope.urlFromAnalyze = 'citReportAnalysisDashboardConfig';
            }

            $scope.exportChart = mainModule.exportChart;
            $scope.setRiskTipStyle = thisDateService.setRiskTipStyle;
            $scope.setRowblockStyle = thisDateService.setRowblockStyle;
            $scope.toggleChart = thisDateService.toggleChart;
            mainModule.main();
            getUserPermission();
        })();
    }
]);