﻿citModule.controller('CitPreviewAssetListController', ['$scope', '$log', '$translate', '$timeout', '$compile', '$uibModal', 'apiInterceptor', 'Upload',
    'assetListService', 'SweetAlert', '$q', 'uiGridConstants', '$interval', 'vatSessionService', 'citSessionService', 'vatImportService', 'loginContext',
    'browserService', 'enums', 'vatOperationLogService', 'projectService', 'vatCommonService', 'ackMessageBox',
    function ($scope, $log, $translate, $timeout, $compile, $uibModal, apiInterceptor, Upload, assetListService, SweetAlert, $q, uiGridConstants,
              $interval, vatSessionService, citSessionService, vatImportService, loginContext, browserService, enums, vatOperationLogService, projectService,
              vatCommonService, ackMessageBox) {
        'use strict';

        var projectId = vatSessionService.project.id;
        var taxAccountCompare = 2;
        var successCount = 0;
        var uploadUrl = apiInterceptor.webApiHostUrl + '/asset/assetsImport';
        var webHost = loginContext.apiHost;
        var chunkSize = 100000;
        var resumable = true;
        var curYear = vatSessionService.project.year;
        var comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年";
        var projectDbName = vatSessionService.project.dbName;
        var serviceErrorMsg = $translate.instant('PleaseContactAdministrator');
        var targetArray = [];

        //写日志
        $scope.moduleid = enums.vatModuleEnum.Import_AssetDiffData;
        var logDto = {
            ID: '',
            OperationName: '',
            ModuleID: $scope.moduleid,
            OperationObject: $translate.instant('AssetListImport'),
            OperationType: '',
            OperationContent: '',
            OriginalState: '',
            UpdateState: '',
            CreatorID: vatSessionService.logUser.ID,
            Comment: comment,
            IP: '',
            Period: '',
        };

        //初始化ack-pagination
        $scope.pagingOptions = {
            pageIndex: 1, //当前页码
            totalItems: 0, //总数据
            totalPages: 10, //总页数
            maxSize: 5, //分页数字的限制。
            pageSize: 20,
            //pageSize: constant.page.pageSizeArrary[3], //每页多少条数据,100条
            pageSizeString: constant.page.pageSizeArrary[3].toString(),
            firstPage: $translate.instant('PagingFirstPage'),
            previousPage: $translate.instant('PagingPreviousPage'),
            nextPage: $translate.instant('PagingNextPage'),
            lastPage: $translate.instant('PagingLastPage'),
        };
        //导入方式
        $scope.importEnum = { Import: 0, CoverImport: 1, AddImport: 2 };
        $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
        $scope.sheetInfo = { selectedSheetName: '', selectedSheetIndex: 0 };
        $scope.invoiceData = [];
        $scope.errorMsgMap = [];
        //初始化参数
        $scope.showErrorTable = false;
        $scope.showInitTable = false;
        $scope.showImportTable = false
        $scope.isShowImportTotalBtn = true;
        $scope.SelectAll = false;

        //初始化列数据
        var initColumns = function () {

            //初始化进项发票汇总表列名
            $scope.incomeInvoiceTotalColumns = [
                $translate.instant('PleaseSelectColumn'),
                $translate.instant('AssetNumber'),
                $translate.instant('AssetGroupName'),
                $translate.instant('AssetDescription'),
                $translate.instant('BuyDate'),
                $translate.instant('DepreciationDate'),
                $translate.instant('DepreciationPeriod'),
                $translate.instant('AcquisitionValue'),
                $translate.instant('AdjustmentValue'),
                $translate.instant('DisposedDate'),
                $translate.instant('ResidualRate'),
                $translate.instant('YearDepreciationAmount'),
                $translate.instant('YearAdjustmentAmount'),
                $translate.instant('YearEndValue'),
                $translate.instant('AssetStatus')
            ];
            $scope.initIncomeInvoiceTotalColumnsIndex = _.range(1, $scope.incomeInvoiceTotalColumns.length);

            //必须进行map的列
            $scope.mustMappingTotalColumns = [
                $translate.instant('AssetNumber'),
                $translate.instant('AssetGroupName'),
                //$translate.instant('AssetDescription'),
                $translate.instant('BuyDate'),
                //$translate.instant('DepreciationDate'),
                $translate.instant('DepreciationPeriod'),
                $translate.instant('AcquisitionValue'),
                //$translate.instant('AdjustmentValue'),
                //$translate.instant('DisposedDate'),
                $translate.instant('ResidualRate'),
                $translate.instant('YearDepreciationAmount'),
                //$translate.instant('YearAdjustmentAmount'),
                $translate.instant('YearEndValue'),
                //$translate.instant('AssetStatus')
            ];
        };

        //发票信息汇总数据表选择列名事件
        //parentIndex：当前列号
        //index：下拉列表中选项的序号
        var mappingColumn = function (parentIndex, index, colName) {
            if (colName) {
                var oldColumn = $scope.selectedColumnMap[parentIndex];
                var newColumn = $scope.incomeInvoiceTotalColumns[index];
                //如果新的选择项与老的选择项一致，则不进行操作
                if (oldColumn === newColumn) {
                    return;
                }
                else {
                    $scope.selectedColumnMap[parentIndex] = colName;

                    if (colName !== $translate.instant('PleaseSelectColumn')) {
                        //如果当前选择的不是"请选择列名",则将选项从数组中移除
                        $scope.incomeInvoiceTotalColumns.splice(index, 1);

                        if (oldColumn && oldColumn !== $translate.instant('PleaseSelectColumn')) {
                            //将老的选项追加到选项列表中
                            $scope.incomeInvoiceTotalColumns.push(oldColumn);
                        }
                    }
                    else {
                        //如果当前选中的是"请选择列名",则将该列原来的列名追加到选项列表中
                        if (oldColumn) {
                            $scope.incomeInvoiceTotalColumns.push(oldColumn);
                        }
                    }
                }
            }
            //$log.debug($scope.selectedColumnMap);
        };

        //上传文件
        var uploadfile = function (file) {
            var url = uploadUrl;

            if (file) {

                successCount = 0;
                if (!file.$error) {
                    var tempFileName = PWC.newGuid() + '.dat';
                    var token = $('input[name="__RequestVerificationToken"]').val();

                    Upload.upload({
                        url: uploadUrl,
                        data: {
                            filename: file.name,
                            tempFileName: tempFileName
                        },
                        file: file,
                        // resumeChunkSize: resumable ? chunkSize : null,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken(),
                            __RequestVerificationToken: token,
                            withCredentials: true
                        },
                        __RequestVerificationToken: token,
                        withCredentials: true
                    }).then(uploadSuccess).error(function(){
                        SweetAlert('哪就错了，瞎报错');
                    });
                }
            }
        };

        //上传成功
        var uploadSuccess = function (resp) {

            successCount++;
            if (successCount === 1) {
                $scope.tempFileName = resp.data;
                // changeSheet(0);
            }
        };

        //选择sheet
        function changeSheet(selectedSheet) {
            var sheetIndex = _.findIndex($scope.sheetData.sheetNameList, function (num) {
                return num.name === selectedSheet.name;
            })
            $scope.sheetInfo.selectedSheetIndex = sheetIndex === -1 ? 0 : sheetIndex;
            refreshTable();
        };

        //刷新列表
        function refreshTable() {
            $scope.showErrorTable = false;
            if (_.isString($scope.tempFileName)) {
                $scope.selectedColumnMap = [];
                //$scope.columnNum = 0;
                $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
                vatImportService.getFileContent($scope.tempFileName, $scope.sheetInfo.selectedSheetIndex, 0).success(function (data) {
                    if (data.result === false) {
                        $scope.showInitTable = true;
                        $scope.showImportTable = false;
                        //initTableTitle();
                        SweetAlert.warning(data.resultMsg);
                    }
                    else {
                        $scope.showInitTable = false;
                        $scope.showImportTable = true
                    }
                    $scope.sheetData = data;
                    var sheetNameObjectArray = [];
                    data.sheetNameList.forEach(function (v) {
                        sheetNameObjectArray.push({ 'name': v });
                    });
                    $scope.sheetData.sheetNameList = sheetNameObjectArray;
                    $scope.sheetInfo.selectedSheetName = $scope.sheetData.sheetNameList[$scope.sheetInfo.selectedSheetIndex];
                    citSessionService.dataChanged = true;
                    $scope.invoiceData = $scope.sheetData.dataList.slice(0, $scope.sheetData.dataList.length);
                    initColumns();
                    //加入index序号
                    var index = 1;
                    $scope.invoiceData.forEach(function (v) {
                        v.index = index++;
                    });
                }).error(function () {
                    SweetAlert.error(serviceErrorMsg);
                });
            }
        };

        //转换没有选中的列值
        function undefinedToNull(inputData,type) {
            if (PWC.isNullOrEmpty(inputData)) {
                if (type == 0)
                {
                    return 0;
                }
                if (type == 1)
                {
                    return null;
                }
                else
                {
                    return 0;
                }
            }
            else {
                return inputData;
            }
        }

        //获取导入的Excel信息
        function getImportExcelData(startRow) {
            //将需要导入的数据组装到list中
            var inputList = [];
            for (var i = startRow - 1; i < $scope.sheetData.dataList.length; i++) {
                var invoiceInfo = {
                    'Index': $scope.sheetData.dataList[i].index,//行号
                    'AssetNumber': $scope.sheetData.dataList[i][$.inArray($translate.instant('AssetNumber'), $scope.selectedColumnMap)],
                    'AssetGroupName': $scope.sheetData.dataList[i][$.inArray($translate.instant('AssetGroupName'), $scope.selectedColumnMap)],
                    'AssetDescription': undefinedToNull($scope.sheetData.dataList[i][$.inArray($translate.instant('AssetDescription'), $scope.selectedColumnMap)],1),
                    'BuyDate': $scope.sheetData.dataList[i][$.inArray($translate.instant('BuyDate'), $scope.selectedColumnMap)],
                    'DepreciationDate': undefinedToNull($scope.sheetData.dataList[i][$.inArray($translate.instant('DepreciationDate'), $scope.selectedColumnMap)],1),
                    'DepreciationPeriod': undefinedToNull($scope.sheetData.dataList[i][$.inArray($translate.instant('DepreciationPeriod'), $scope.selectedColumnMap)],0),
                    'AcquisitionValue': $scope.sheetData.dataList[i][$.inArray($translate.instant('AcquisitionValue'), $scope.selectedColumnMap)],
                    'AdjustmentValue': undefinedToNull($scope.sheetData.dataList[i][$.inArray($translate.instant('AdjustmentValue'), $scope.selectedColumnMap)],0),
                    'DisposedDate': undefinedToNull($scope.sheetData.dataList[i][$.inArray($translate.instant('DisposedDate'), $scope.selectedColumnMap)],1),
                    'ResidualRate': undefinedToNull($scope.sheetData.dataList[i][$.inArray($translate.instant('ResidualRate'), $scope.selectedColumnMap)],0),
                    'YearDepreciationAmount': undefinedToNull($scope.sheetData.dataList[i][$.inArray($translate.instant('YearDepreciationAmount'), $scope.selectedColumnMap)],0),
                    'YearAdjustmentAmount': undefinedToNull($scope.sheetData.dataList[i][$.inArray($translate.instant('YearAdjustmentAmount'), $scope.selectedColumnMap)],0),
                    'YearEndValue': undefinedToNull($scope.sheetData.dataList[i][$.inArray($translate.instant('YearEndValue'), $scope.selectedColumnMap)],0),
                    'Status': $scope.sheetData.dataList[i][$.inArray($translate.instant('AssetStatus'), $scope.selectedColumnMap)],
                };
                inputList.push(invoiceInfo);
            }
            return inputList;
        }

        //1.判断是否有没有map的必须列和起始行输入格式是否正确
        var ColumnsMapCheckIncomeInvoice = function () {
            var result = true;
            //1：判断是否有没有map的必须列
            var notMappedColumns = '';
            if ($scope.selectedColumnMap.length >= 0) {
                var count1 = 0;
                $scope.mustMappingTotalColumns.forEach(function (m) {
                    if (m !== $translate.instant('PleaseSelectColumn')) {
                        if ($.inArray(m, $scope.selectedColumnMap) < 0) {
                            notMappedColumns += m + ',';
                            count1++;
                        }
                    }
                });
                if (count1) {
                    result = false;
                    //加入到错误列表中
                    $scope.errorMsgMap.push(
                        {
                            'errorType': $translate.instant('ColumnsMapErrorType'),
                            'errorCount': count1,
                            'errorContent': $translate.instant('ColumnsMapErrorMsg').formatObj({ columns: notMappedColumns.substring(0, notMappedColumns.length - 1) })
                        });
                }
            }
            //2:判断起始行输入框输入内容是否合理
            var startNumberCheckMsg = '';
            var startRowNum = $('#StartRowNum').val();
            if (startRowNum === '') {
                result = false;
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('StartRowError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('StartRowNull')
                    });
            }
            else if (parseInt(startRowNum) > $scope.sheetData.dataList.length) {
                result = false;
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('StartRowError'),
                        'errorCount': 1,
                        'errorContent': $translate.instant('StartRowNumberCheckMsg')
                    });
            }
            return result;
        };

        //前端验证
        function frontEndValidData(inputList) {
            //4.购入日期验证，不能为空，且格式正确
            var buyDateCheckMsg = '';
            var count1 = 0;
            //产品编号不能为空
            var assetNumberCheckMsg = '';
            var count2 = 0;
            //资产类别不能为空
            var groupNameCheckMsg = '';
            var count3 = 0;
            //原值不能为空
            var acquisitionValueCheckMsg = '';
            var count4 = 0;
            //数字类型验证
            var amountNumberCheckMsg = '';
            var count5 = 0;

            inputList.forEach(function (m) {
                //购入日期为空
                if (PWC.isNullOrEmpty(m.BuyDate)) {
                    buyDateCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('BuyDateNullMsg') + '<br />';
                    count1++;
                }
                //日期格式错误
                else if (!PWC.checkDateType(m.BuyDate)) {
                    buyDateCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('BuyDateErrorMsg') + '<br />';
                    count1++;
                }
                if (PWC.isNullOrEmpty(m.AssetNumber)) {
                    assetNumberCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('AssetNumberNullMsg') + '<br />';
                    count2++;
                }
                if (PWC.isNullOrEmpty(m.AssetGroupName)) {
                    groupNameCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('AssetGroupNameNullMsg') + '<br />';
                    count3++;
                }
                if (PWC.isNullOrEmpty(m.AcquisitionValue)) {
                    acquisitionValueCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('AcquisitionValueNullMsg') + '<br />';
                    count4++;
                }
                //开始折旧日期格式错误
                if (!PWC.isNullOrEmpty(m.DepreciationDate) && !PWC.checkDateType(m.DepreciationDate)) {
                    amountNumberCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('DepreciationDate') + $translate.instant('DataTypeErrorMsg') + '<br />';
                    count5++;
                }
                if (!PWC.isNullOrEmpty(m.DisposedDate) && !PWC.checkDateType(m.DisposedDate)) {
                    amountNumberCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('DisposedDate') + $translate.instant('DataTypeErrorMsg') + '<br />';
                    count5++;
                }
                //判断是否为数字
                if (isNaN(Number(m.DepreciationPeriod))) {
                    amountNumberCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('DepreciationPeriod') + $translate.instant('DataTypeErrorMsg') + ';<br />';
                    count5++;
                }
                if (isNaN(Number(m.AcquisitionValue))) {
                    amountNumberCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('AcquisitionValue') + $translate.instant('DataTypeErrorMsg') + ';<br />';
                    count5++;
                }
                if (isNaN(Number(m.AdjustmentValue))) {
                    amountNumberCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('AdjustmentValue') + $translate.instant('DataTypeErrorMsg') + ';<br />';
                    count5++;
                }
                if (isNaN(Number(m.ResidualRate))) {
                    amountNumberCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('ResidualRate') + $translate.instant('DataTypeErrorMsg') + ';<br />';
                    count5++;
                }
                if (isNaN(Number(m.YearDepreciationAmount))) {
                    amountNumberCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('YearDepreciationAmount') + $translate.instant('DataTypeErrorMsg') + ';<br />';
                    count5++;
                }
                if (isNaN(Number(m.YearAdjustmentAmount))) {
                    amountNumberCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('YearDepreciationAmount') + $translate.instant('DataTypeErrorMsg') + ';<br />';
                    count5++;
                }
                if (isNaN(Number(m.YearEndValue))) {
                    amountNumberCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('YearEndValue') + $translate.instant('DataTypeErrorMsg') + ';<br />';
                    count5++;
                }

            });

            if (count1 > 0) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('BuyDateType'),
                        'errorCount': count1,
                        'errorContent': buyDateCheckMsg
                    });
            }
            if (count2 > 0) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('AssetNumberType'),
                        'errorCount': count2,
                        'errorContent': assetNumberCheckMsg
                    });
            }
            if (count3 > 0) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('AssetGroupNameType'),
                        'errorCount': count3,
                        'errorContent': groupNameCheckMsg
                    });
            }
            if (count4 > 0) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('AcquisitionValueType'),
                        'errorCount': count4,
                        'errorContent': acquisitionValueCheckMsg
                    });
            }
            if (count5 > 0) {
                $scope.errorMsgMap.push(
                    {
                        'errorType': $translate.instant('DataTypeError'),
                        'errorCount': count5,
                        'errorContent': amountNumberCheckMsg
                    });
            }
        }

        //简易导入,importType来分辨是覆盖导入还是追加导入
        $scope.importDataNew = function(importType){

            var a =  projectId;
            if (!$scope.file || !$scope.file.name) {

                SweetAlert.warning($translate.instant('SelectImportFileRequired'));
                return;
            }

            var tempFileName = PWC.newGuid() + '.dat';

            var token = $('input[name="__RequestVerificationToken"]').val();
            // updateProgressToZero();
            Upload.upload({
                url: uploadUrl,
                data: {
                    filename: $scope.file.name,
                    tempFileName: tempFileName,
                    projectId: projectId
                },
                file: $scope.file,
                resumeChunkSize: resumable ? $scope.chunkSize : null,
                headers: {
                    'Access-Control-Allow-Origin': '*',
                    Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken(),
                    __RequestVerificationToken: token,
                    withCredentials: true
                }, withCredentials: true
            }).then(function(resp){

                assetListService.getAssetGroupResultData(projectId).success(function (groupResultData) {
                    $scope.assetGroupResultDataSource = groupResultData.data;
                });
                // $scope.assetGroupResultDataSource = resp.data;
                InitGrid(false);
                $scope.saveGroupType = 1;
                $scope.isDisabled = true;
                //为方便开发暂时先改为false
                $scope.isDisabled = false;
                $scope.modalInstance = $uibModal.open({
                    animation: false,
                    backdrop: 'static',
                    keyboard: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'set-asset-group-modal.html',
                    scope: $scope,
                    windowClass: "set-asset-list-modal"
                });
            });
        };

        //点击导入按钮时，进行导入操作---原方法
        function importData(importType) {
            $scope.errorMsgMap = [];
            //设置数据导入时的起始行,默认设置从第一行开始
            var startRowNum = 1;
            if ($('#StartRowNum').val()) {
                startRowNum = $('#StartRowNum').val();
            }
            if (!$scope.fileName) {
                SweetAlert.warning($translate.instant('PleaseSelectFileFirst'));
                return;
            }
            //判断是否有没有map的必须列和起始行输入格式是否正确
            if (!ColumnsMapCheckIncomeInvoice()) {
                $('#errorListModal').modal('show');
                return;
            }
            //日志对象
            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = $scope.fileName;
            if (importType === $scope.importEnum.Import) {
                logDto.OperationName = $translate.instant('ImportOutputInvoice');
                logDto.OperationType = enums.vatLogOperationTypeEnum.Import;
            }
            else if (importType === $scope.importEnum.CoverImport) {
                logDto.OperationName = $translate.instant('CoverImportOutputInvoice');
                logDto.OperationType = enums.vatLogOperationTypeEnum.CoverImport;
            }
            else if (importType === $scope.importEnum.AddImport) {
                logDto.OperationName = $translate.instant('AddImportOutputInvoice');
                logDto.OperationType = enums.vatLogOperationTypeEnum.AddImport;
            }
            //获取数据
            var inputList = getImportExcelData(startRowNum);
            //前台数据验证
            frontEndValidData(inputList);
            if ($scope.errorMsgMap.length > 0) {
                $('#errorListModal').modal('show');
                return;
            }
            else {
                assetListService.importAssetList(inputList, importType).success(function (or) {
                    //修改状态
                    vatCommonService.importSetProjectStatus(projectDbName, -1, constant.DictionaryDictKey.WFImportAsset, enums.FinishStatusEnum.Finished);
                    if (or && or.result) {
                        logDto.UpdateState = $translate.instant('ImportSuccess');
                        vatOperationLogService.addOperationLog(logDto);
                        initDataFromDB();
                        $scope.fileName = '';
                        getValidationList();
                        //有没有分类的数据
                        if (or.data && or.data.length > 0) {
                            var index = 1;
                            or.data.forEach(function (v) {
                                v.index = index++;
                            });
                            $scope.assetGroupResultDataSource = or.data;
                            InitGrid(false);
                            $scope.saveGroupType = 1;
                            $scope.isDisabled = true;
                            $scope.modalInstance = $uibModal.open({
                                animation: false,
                                backdrop: 'static',
                                keyboard: false,
                                ariaLabelledBy: 'modal-title',
                                ariaDescribedBy: 'modal-body',
                                templateUrl: 'set-asset-group-modal.html',
                                scope: $scope,
                                windowClass: "set-asset-list-modal"
                            });
                        }
                        else {
                            SweetAlert.success($translate.instant('ImportSuccess'));
                        }
                    }
                    else {
                        logDto.UpdateState = $translate.instant('ImportFail');
                        vatOperationLogService.addOperationLog(logDto);
                        SweetAlert.error($translate.instant('ImportFail'));
                    }
                }).error(function () {
                    logDto.UpdateState = $translate.instant('ImportFail');
                    vatOperationLogService.addOperationLog(logDto);

                    SweetAlert.error(serviceErrorMsg);
                });
            }
        }

        //获取后台验证信息----原方法
        function getValidationList() {
            vatImportService.getValidationList(enums.EnumValidationType.AssetDiffData, 0).success(function (data) {
                if (data.length > 0) {
                    var index = 1;
                    data.forEach(function (v) {
                        v.index = index++;
                    });
                    $scope.errorList = data;
                    $scope.gridOptionsErrorMsg.data = data;

                    showErrTab();
                    $scope.toggleErrorTab();
                    $scope.showErrorTable = true;
                }
                else {
                    $scope.errorList = [];
                    $scope.gridOptionsErrorMsg.data = [];
                    $scope.showErrorTable = false;
                    $scope.ImportErrorTab = false;
                    $scope.ImportErrorTag = false;
                }
            }).error(function () {
                SweetAlert.error(serviceErrorMsg);
            });
        }

        //从数据库获取销项数据
        function initDataFromDB() {
            $scope.showInitTable = true;
            $scope.showImportTable = false;
            citSessionService.dataChanged = false;
            $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
            $scope.invoiceData = [];

            $scope.ImportTotalCount = 0;
            $scope.ImportTotalAccountAcquisitionValue = 0;
            $scope.ImportTotalAccountYearDepreciationAmount = 0;
            $scope.ImportTotalTaxCurrentYearDepreciationAmount = 0;
            $scope.ImportTotalYearDifferenceAmount = 0

            assetListService.getAssetListData().success(function (rsp) {

                if (rsp && rsp.length > 0) {
                    $scope.isShowImportTotalBtn = false;
                    initPagingControl(rsp.length);
                    var skipCount = ($scope.pagingOptions.pageIndex - 1) * $scope.pagingOptions.pageSize;
                    var pagingData = _.chain(rsp).rest(skipCount).first($scope.pagingOptions.pageSize).value();
                    getValidationList();
                    var dataList = pagingData;
                    var index = 1;
                    dataList.forEach(function (v) {
                        v.index = index++;
                    });
                    $scope.assetDBData = _.clone(dataList);
                    //合计列
                    rsp.forEach(function (v) {
                        $scope.ImportTotalAccountAcquisitionValue += v.accountAcquisitionValue;
                        $scope.ImportTotalAccountYearDepreciationAmount += v.accountYearDepreciationAmount;
                        $scope.ImportTotalTaxCurrentYearDepreciationAmount += v.taxCurrentYearDepreciationAmount;
                        if(v.isRetain == 1){
                            $scope.ImportTotalYearDifferenceAmount += v.yearDifferenceAmount;
                        }
                    });
                    $scope.ImportTotalCount = rsp.length;
                    $scope.ImportTotalAccountAcquisitionValue = PWC.round($scope.ImportTotalAccountAcquisitionValue, 2);
                    $scope.ImportTotalAccountYearDepreciationAmount = PWC.round($scope.ImportTotalAccountYearDepreciationAmount, 2);
                    $scope.ImportTotalTaxCurrentYearDepreciationAmount = PWC.round($scope.ImportTotalTaxCurrentYearDepreciationAmount, 2);
                    $scope.ImportTotalYearDifferenceAmount = PWC.round($scope.ImportTotalYearDifferenceAmount, 2);
                }
            }).error(function () {
                SweetAlert.error(serviceErrorMsg);
            });
        }

        //根据分类获取数据
        function getAssetResultList(assetType) {

            $scope.TotalCount = 0;
            $scope.TotalAccountAcquisitionValue = 0;
            $scope.TotalAccountYearDepreciationAmount = 0;
            $scope.TotalTaxCurrentYearDepreciationAmount = 0;
            $scope.TotalYearDifferenceAmount = 0
            assetListService.getAssetResultList(assetType,projectId,taxAccountCompare).success(function (assetListData) {

                var data = assetListData.data;
                if (data) {
                    var index = 1;
                    data.forEach(function (v) {
                        v.index = index++;
                        $scope.TotalAccountAcquisitionValue += v.accountAcquisitionValue;
                        $scope.TotalAccountYearDepreciationAmount += v.accountYearDepreciationAmount;
                        $scope.TotalTaxCurrentYearDepreciationAmount += v.taxCurrentYearDepreciationAmount;
                        if(v.isRetain == 1){
                            $scope.TotalYearDifferenceAmount += v.yearDifferenceAmount;
                        }
                    });
                    $scope.assetsResultData = data;
                    $scope.TotalCount = data.length;
                    $scope.TotalAccountAcquisitionValue = PWC.round($scope.TotalAccountAcquisitionValue, 2);
                    $scope.TotalAccountYearDepreciationAmount = PWC.round($scope.TotalAccountYearDepreciationAmount, 2);
                    $scope.TotalTaxCurrentYearDepreciationAmount = PWC.round($scope.TotalTaxCurrentYearDepreciationAmount, 2);
                    $scope.TotalYearDifferenceAmount = PWC.round($scope.TotalYearDifferenceAmount, 2);
                }
            });
        }

        function setErrorWrapCssDefault() {
            $('#content-resizer').css('bottom', '10px');

            $('#topIcon').css({ bottom: '-501px' });

            $('.error-info-wrapper').css('height', '0px');
        };

        function showErrTab() {
            $scope.ImportErrorTab = true;
            $scope.ImportErrorTag = true;
            $scope.errorMsg = $translate.instant('ImportAssetErrorMsg').formatObj({ "NumberOfError": $scope.errorList.length });

        };

        var initPagingControl = function (totalItemsCount) {
            $scope.pagingOptions.totalItems = totalItemsCount;
        }

        //显示明细
        var dealDetail = function () {
            return '<div ng-if="row.entity.isShowDetail === 1" class="ui-grid-cell-contents"><span><a  ng-click="grid.appScope.openTab(row.entity.erpCheckTypeId,row.entity.validationDetails)">查看明细</a><span></div>' +
                '<div  ng-if="row.entity.isShowDetail !== 1" class="ui-grid-cell-contents" title="{{row.entity.validationDetails}}"><span>{{row.entity.validationDetails}}<span></div>';
        }

        //初始化dx控件
        function initDxGrid() {
            var dupColumns = [
                { caption: $translate.instant('ImportErrorPopUpNoCol'), dataField: "index", width: 50 },
                { caption: $translate.instant('AssetNumber'), dataField: "assetNumber" },
                { caption: $translate.instant('AssetGroupName'), dataField: "assetGroupName", },
                { caption: $translate.instant('AssetDescription'), dataField: "assetDescription", },
                { caption: $translate.instant('BuyDate'), dataField: "buyDate", dataType: "date", format: "yyyy-MM-dd", },
                { caption: $translate.instant('DepreciationDate'), dataField: "depreciationDate", dataType: "date", format: "yyyy-MM-dd", },
                { caption: $translate.instant('DepreciationPeriod'), dataField: "depreciationPeriod", format: { type: 'fixedPoint', precision: 0 } },
                { caption: $translate.instant('AcquisitionValue'), dataField: "acquisitionValue", format: { type: 'fixedPoint', precision: 2 } },
                { caption: $translate.instant('AdjustmentValue'), dataField: "adjustmentValue", format: { type: 'fixedPoint', precision: 2 } },
                { caption: $translate.instant('DisposedDate'), dataField: "disposedDate", dataType: "date", format: "yyyy-MM-dd", },
                { caption: $translate.instant('ResidualRate'), dataField: "residualRate", format: { type: 'fixedPoint', precision: 2 } },
                { caption: $translate.instant('YearDepreciationAmount'), dataField: "yearDepreciationAmount", format: { type: 'fixedPoint', precision: 2 } },
                { caption: $translate.instant('YearAdjustmentAmount'), dataField: "yearAdjustmentAmount", format: { type: 'fixedPoint', precision: 2 } },
                { caption: $translate.instant('YearEndValue'), dataField: "yearEndValue", format: { type: 'fixedPoint', precision: 2 } },
            ];

            $scope.gridInitDataOption = {
                columns: dupColumns,
                bindingOptions: {
                    "dataSource": "assetDBData"
                },
                onInitialized: function (e) {
                    $scope.assetImportGridInstance = e.component;
                },
                hoverStateEnabled: true,
                scrolling: { mode: "virtual" },
                noDataText: $translate.instant('AccountVoucher_DataGrid_NoDataText'),
                height: '99%',
            }
        }

        //初始化编辑d资产分类（asset_group_result）ataGrid
        var InitGrid = function (showAdd) {
            $scope.assetsGridOptions = {
                bindingOptions: {
                    dataSource: 'assetGroupResultDataSource',
                },
                keyExpr: "id",
                paging: {
                    enabled: false
                },
                editing: {
                    mode: "batch",
                    allowUpdating: true,
                },
                onInitialized: function (e) {
                    $scope.assetGroupGridInstance = e.component;
                },
                showBorders: true,
                hoverStateEnabled: true,
                onCellPrepared: function (e) {
                    if (e.rowType === "header" && PWC.isNullOrEmpty(e.column.caption)) {
                        e.cellElement.empty();
                        e.cellElement.append("操作");
                        e.cellElement.addClass('herder-center');
                    }
                    if (e.rowType === "data" && e.column.command === "edit") {
                        var isEditing = e.row.isEditing,
                            $links = e.cellElement.find(".dx-link");
                        if (isEditing) {
                            $links.filter(".dx-link-save").addClass("column-color");
                            $links.filter(".dx-link-cancel").addClass("column-color");
                        } else {
                            $links.filter(".dx-link-edit").addClass("column-color");
                            $links.filter(".dx-link-delete").addClass("column-color");
                        }
                    }
                },
                columns: [
                    {
                        caption: $translate.instant('ImportErrorPopUpNoCol'), dataField: "index", width: 50, allowEditing: false,

                    },
                    {
                        caption: $translate.instant('AssetGroupName'), dataField: "assetName", width: 150, allowEditing: false,
                    },
                    {
                        caption: $translate.instant('LevelOneGroup'), dataField: "assetGroupId",
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('LevelOneGroupValidation')
                        }],
                        setCellValue: function (rowData, value) {
                            rowData.assetGroupId = value;

                            var aseetDetailList = _.filter($scope.detailGroupListDataSource, function (item) {
                                return item.assetGroupId == value;
                            });
                            if (aseetDetailList.length == 0) {
                                rowData.assetDetailGroupId = null;
                                rowData.taxDepreciationPeriod = null;
                            }
                            else {
                                rowData.assetDetailGroupId = aseetDetailList[0].id;
                                rowData.taxDepreciationPeriod = aseetDetailList[0].groupYear * 12;
                            };
                        },
                        lookup: {
                            dataSource: $scope.groupListDataSource,
                            displayExpr: "assetGroupName",
                            valueExpr: "id"
                        }
                    },
                    {
                        caption: $translate.instant('LevelTwoGroup'), dataField: "assetDetailGroupId",
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('LevelTwoGroupValidation')
                        }],
                        setCellValue: function (rowData, value) {
                            rowData.assetDetailGroupId = value;

                            var aseetDetailList = _.filter($scope.detailGroupListDataSource, function (item) {
                                return item.id == value;
                                return item.id == value;
                            });
                            if (aseetDetailList.length > 0) {
                                rowData.taxDepreciationPeriod = aseetDetailList[0].groupYear * 12;
                            }
                        },
                        lookup: {
                            dataSource: function (options) {

                                return {
                                    store: $scope.detailGroupListDataSource,
                                    filter: options.data ? ["assetGroupId", "=", options.data.assetGroupId] : null
                                };
                            },
                            displayExpr: "detailGroupName",
                            valueExpr: "id"
                        }
                    },
                    {
                        caption: $translate.instant('DepreciationPeriod'), dataField: "taxDepreciationPeriod", width: 100,
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('DepreciationPeriodValidation')
                        }],
                    }
                ],
                width: '99%',
                onToolbarPreparing: function (e) {
                    var toolbarItems = e.toolbarOptions.items;
                    var toolbarItems = e.toolbarOptions.items;
                    _.each(toolbarItems, function (item) {
                        if (item.name === 'saveButton' || item.name == 'revertButton') {
                            item.visible = false;
                        }
                    });
                }
            };
        }

        //初始化dx控件
        function initAssetResultDxGrid() {

            var dupColumns = [
                { caption: $translate.instant('ImportErrorPopUpNoCol'), dataField: "index", width: 50, allowEditing: false, fixed: true },
                { caption: $translate.instant('AssetNumber'), dataField: "assetNumber", width: 120, allowEditing: false, fixed: true },
                { caption: $translate.instant('AssetGroupName'), dataField: "assetGroupName", width: 120, allowEditing: false, fixed: true },
                { caption: $translate.instant('AssetDescription'), dataField: "assetDescription", width: 200, allowEditing: false, fixed: true },
                {
                    caption: $translate.instant('AccountData'), alignment: 'center',
                    columns: [
                        { caption: $translate.instant('BuyDate'), dataField: "buyDate", dataType: "date", format: "yyyy-MM-dd", width: 100, allowEditing: false },
                        { caption: $translate.instant('DepreciationDate'), dataField: "depreciationDate", dataType: "date", format: "yyyy-MM-dd", width: 100, allowEditing: false },
                        { caption: $translate.instant('DepreciationPeriod'), dataField: "depreciationPeriod", format: { type: 'fixedPoint', precision: 0 }, width: 100, allowEditing: false },
                        { caption: $translate.instant('AcquisitionValue'), dataField: "accountAcquisitionValue", format: { type: 'fixedPoint', precision: 2 }, width: 100, allowEditing: false },
                        //{ caption: $translate.instant('AdjustmentValue'), dataField: "adjustmentValue", format: { type: 'fixedPoint', precision: 2 } },
                        { caption: $translate.instant('DisposedDate'), dataField: "disposedDate", dataType: "date", format: "yyyy-MM-dd", width: 100, allowEditing: false },
                        { caption: $translate.instant('ResidualRate'), dataField: "residualRate", format: { type: 'percent', precision: 2 }, width: 80, allowEditing: false },
                        { caption: $translate.instant('PerMonthDepreciationAmount'), dataField: "accountMonthDepreciationAmount", format: { type: 'fixedPoint', precision: 2 }, width: 100, allowEditing: false },
                        { caption: $translate.instant('YearDepreciationAmount'), dataField: "accountYearDepreciationAmount", format: { type: 'fixedPoint', precision: 2 }, width: 100, allowEditing: false },
                        { caption: $translate.instant('AccountTotalepreciationAmount'), dataField: "accountTotalepreciationAmount", format: { type: 'fixedPoint', precision: 2 }, width: 100, allowEditing: false },
                        { caption: $translate.instant('YearEndValue'), dataField: "yearEndValue", format: { type: 'fixedPoint', precision: 2 }, width: 100, allowEditing: false },
                    ]
                },
                {
                    caption: $translate.instant('TaxData'), alignment: 'center',
                    columns: [
                        { caption: $translate.instant('TaxGroupType'), dataField: "taxGroupName", width: 200, allowEditing: false },
                        { caption: $translate.instant('DepreciationPeriod'), dataField: "taxDepreciationPeriod", format: { type: 'fixedPoint', precision: 0 }, width: 100, allowEditing: true },
                        { caption: $translate.instant('TaxToLastYearDepreciationPeriod'), dataField: "taxToLastYearDepreciationPeriod", format: { type: 'fixedPoint', precision: 0 }, width: 150, allowEditing: false },
                        { caption: $translate.instant('TaxToCurrentYearDepreciationPeriod'), dataField: "taxToCurrentYearDepreciationPeriod", format: { type: 'fixedPoint', precision: 0 }, width: 150, allowEditing: false },
                        { caption: $translate.instant('TaxYearDepreciationPeriod'), dataField: "taxYearDepreciationPeriod", format: { type: 'fixedPoint', precision: 0 }, width: 100, allowEditing: false },
                        { caption: $translate.instant('PerMonthDepreciationAmount'), dataField: "taxMonthDepreciationAmount", format: { type: 'fixedPoint', precision: 2 }, width: 100, allowEditing: false },
                        { caption: $translate.instant('YearDepreciationAmount'), dataField: "taxCurrentYearDepreciationAmount", format: { type: 'fixedPoint', precision: 2 }, width: 100, allowEditing: false },
                        { caption: $translate.instant('AccountTotalepreciationAmount'), dataField: "taxToCurrentYearDepreciationAmount", format: { type: 'fixedPoint', precision: 2 }, width: 100, allowEditing: false },
                    ]
                },
                {
                    caption: $translate.instant('AssetDifferent'), alignment: 'center',
                    columns: [
                        { caption: $translate.instant('TotalDifferenceAmount'), dataField: "totalDifferenceAmount", format: { type: 'fixedPoint', precision: 2 }, width: 100, allowEditing: false },
                        { caption: $translate.instant('YearDifferenceAmount'), dataField: "yearDifferenceAmount", format: { type: 'fixedPoint', precision: 2 }, width: 100, allowEditing: false },
                    ]
                },
                {
                    caption: $translate.instant('IsRetain'), alignment: 'center', dataField: "isRetain", dataType: "boolean", width: 120, allowEditing: true
                },
            ];

            $scope.assetsResultGridOptions = {
                columns: dupColumns,
                bindingOptions: {
                    "dataSource": "assetsResultData",
                },
                editing: {
                    mode: "batch",
                    allowUpdating:true,
                },
                onInitialized: function (e) {
                    $scope.dataGridInstance = e.component;
                },
                onCellPrepared: function (e) {
                    if (e.rowType === "header") {

                        if (e.column.caption === $translate.instant('ImportErrorPopUpNoCol') ||
                            e.column.caption === $translate.instant('AssetNumber') ||
                            e.column.caption === $translate.instant('AssetGroupName') ||
                            e.column.caption === $translate.instant('AssetDescription'))
                        {
                            e.cellElement.addClass('herder-center');
                            e.cellElement.append($compile(inputElement)($scope));
                        }
                        if(e.column.caption === $translate.instant('IsRetain'))
                        {
                            e.cellElement.empty();
                            var inputElement = $('<input type="checkbox" ng-model="SelectAll" ng-click="selectAllAsset()">{{\'isRetainDifference\' | translate}}</input>');
                            e.cellElement.addClass('herder-center');
                            e.cellElement.append($compile(inputElement)($scope));
                        }
                        if(e.column.caption === $translate.instant('IsRetain'))
                        {
                            e.cellElement.empty();
                            var inputElement = $('<input type="checkbox" ng-model="SelectAll" ng-click="selectAllAsset()">{{\'isRetainDifference\' | translate}}</input>');
                            e.cellElement.addClass('herder-center');
                            e.cellElement.append($compile(inputElement)($scope));
                        }
                    }
                },
                loadPanel: {
                    enabled: true
                },
                paging: {
                    pageSize: 100,
                },
                searchPanel: {
                    visible: true,
                    width: 240,
                    placeholder: $translate.instant('SearchPlaceholder')
                },
                showBorders: true,
                hoverStateEnabled: true,
                //scrolling: { mode: "virtual" },
                noDataText: $translate.instant('AccountVoucher_DataGrid_NoDataText'),
                height: '99%',
                filterRow: {
                    visible: true
                },
                onRowUpdating: function (e) {
                    var data = $.extend({}, e.oldData, e.newData);
                    if(data.isRetain == true)
                    {
                        data.isRetain =1;
                    }
                    else  if(data.isRetain == false)
                    {
                        data.isRetain =0;
                    }
                    targetArray.push(data);
                },
                onToolbarPreparing: function (e) {
                    var toolbarItems = e.toolbarOptions.items;
                    var savebutton = _.find(e.toolbarOptions.items, function (m) { return m.name === "saveButton" });
                    var defaultFun = savebutton.options.onClick;
                    var saveAsset = function () {
                        defaultFun();
                        assetListService.updateAssetResultList(targetArray,projectId).success(function (data) {
                            if (data) {
                                getAssetResultList($scope.displayType - 1);
                                SweetAlert.success($translate.instant('SaveSuccess'));
                                targetArray = [];
                            }
                            else
                            {
                                SweetAlert.error(serviceErrorMsg);
                                targetArray = [];
                            }
                        }).error(function () {
                            SweetAlert.error(serviceErrorMsg);
                            targetArray = [];
                        });
                    }
                    savebutton.options.onClick = saveAsset;
                }
            }
        }
        //税会差异选项内容
        $scope.applyFilterTypes = [{
            key: "2",
            name: $translate.instant('AllTheItems')
        }, {
            key: "0",
            name: $translate.instant('TaxDepreciation')+"<"+$translate.instant('AccountDepreciation')
        }, {
            key: "1",
            name: $translate.instant('TaxDepreciation')+">="+$translate.instant('AccountDepreciation')
        }];
        //初始化税会差异选项
        $scope.taxAccountDifferenceOptions = {
            items: $scope.applyFilterTypes,
            value: $scope.applyFilterTypes[0].key,
            valueExpr: "key",
            displayExpr: "name",
            onValueChanged: function(data) {

                taxAccountCompare = data.value;
                getAssetResultList($scope.displayType - 1);
            }
        };

        //获取数据服务
        var getGroupList = function () {

            var deferred = $q.defer();
            assetListService.getAssetGroupListData().success(function (data) {

                if (data.data) {
                    $scope.groupListDataSource = data.data;
                    deferred.resolve(data.data);
                }
            }).error(function (ex) {
                $log.error(ex);
                SweetAlert.error(serviceErrorMsg);
            });
            return deferred.promise;
        };

        //获取导入后数据
        var getGroupDetailList = function () {

            var deferred = $q.defer();
            assetListService.getAssetDetailGroupListData().success(function (data) {

                if (data.data) {
                    $scope.detailGroupListDataSource = data.data;
                    deferred.resolve(data.data);
                }
            }).error(function (ex) {
                $log.error(ex);
                SweetAlert.error(serviceErrorMsg);
            });
            return deferred.promise;
        };

        //验证分类信息是否分类完毕
        var validationAssetGroupList = function () {
            var isOk = true;
            _.each($scope.assetGroupResultDataSource, function (m) {
                if (PWC.isNullOrEmpty(m.assetName)
                    || PWC.isNullOrEmpty(m.assetGroupId)
                    || PWC.isNullOrEmpty(m.assetDetailGroupId)
                    || PWC.isNullOrEmpty(m.taxDepreciationPeriod)) {
                    isOk = false;
                }
            });
            return isOk;
        }

        //选中所有行操作
        $scope.selectAllAsset = function () {
            var isRetain = 0;
            if ($scope.SelectAll) {
                isRetain = 1;
                $scope.assetsResultData.forEach(function (m) {
                    m.isRetain = 1;
                });
            }
            else {
                isRetain = 0;
                $scope.assetsResultData.forEach(function (m) {
                    m.isRetain = 0;
                });
            }
            assetListService.batchUpdateIsRetain($scope.displayType -1,projectId, isRetain);
        }

        //验证信息
        $scope.openTab = function (errorType, rowdata) {
            var data = JSON.parse(rowdata);
            if (errorType === 110) {
                dispalyDiffDataValidation(data);
            }
        }

        //显示本年与上年数据差异界面
        var dispalyDiffDataValidation = function (data) {
            //$scope.devgridDataSource = data;
            $scope.gridPeriodOptions = {
                columnAutoWidth: true,
                columns: [
                    { caption: $translate.instant('AssetNumber'), dataField: "AssetNumber", textalign: "center" },
                    { caption: $translate.instant('LastYear'), dataField: "LastYear", textalign: "center" },
                    {
                        caption: $translate.instant('LastAcquisitionValue'), dataField: "LastAcquisitionValue",
                        textalign: "right", format: { type: 'fixedPoint', precision: 2 }
                    },
                    { caption: $translate.instant('CurrentYear'), dataField: "CurrentYear", textalign: "center" },
                    {
                        caption: $translate.instant('CurrentAcquisitionValue'), dataField: "CurrentAcquisitionValue",
                        textalign: "right", format: { type: 'fixedPoint', precision: 2 }
                    }
                ],
                dataSource: data,
                hoverStateEnabled: true,
                loadPanel: {
                    enabled: true
                },
                paging: {
                    pageSize: 20
                },
            };

            $scope.validateModalInstance = $uibModal.open({
                animation: false,
                backdrop: 'static',
                keyboard: false,
                ariaLabelledBy: 'modal-title',
                ariaDescribedBy: 'modal-body',
                templateUrl: 'set-asset-validate-modal.html',
                scope: $scope,
                windowClass: "period-validation-modal"
            });
        }

        //关闭验证详细页面
        $scope.cancelValidateAsset = function () {
            if ($scope.validateModalInstance) {
                $scope.validateModalInstance.close();
            }
        }

        //日志
        $scope.showOperateLogPop = function () {
            $scope.isShowLog = true;
        };

        //显示验证信息
        $scope.toggleErrorTab = function () {
            $scope.ImportErrorTag = !$scope.ImportErrorTag;

            // topIcon and content-resize gapBottom 15px
            if (!$scope.ImportErrorTag) {
                setErrorWrapCssDefault();
            } else {

                if (parseInt($('#content-resizer').css('bottom')) < 100) {
                    $('#content-resizer').css('bottom', '150px');
                    $('#content-resizer').css('z-index', '2');
                    $('#topIcon').css({ bottom: '-200px' });
                    $('.error-info-wrapper').css('height', '150px');
                }
            }
        };

        $scope.getGridHeight = function () {
            if ($scope.isLoadComplete) {
                return { height: ($('.balance-ouput-grid-wrapper').height() - 20) + "px" };
            }
            else {
                return { height: 0 + "px" };
            }
        };

        $scope.getErrorGridHeight = function () {
            if ($scope.isLoadComplete) {
                var y = $("#error-info-wrapper").height();
                // Enough space
                if (y > constant.UIGrid.gapHeight) {
                    y = y - constant.UIGrid.gapHeight;
                    return { height: y + "px" };
                } else {

                    return { height: '0px' };
                }
            }
            return {};
        };

        //显示图标
        $scope.errorLevelToString = function (errorLevel) {
            if (errorLevel === 0) {
                return '/app-resources/images/vat/error.png';
            }
            if (errorLevel === 1) {
                return '/app-resources/images/vat/warning.png';
            }
            if (errorLevel === 2) {
                return '/app-resources/images/vat/tips.png';
            }
            else {
                return '/app-resources/images/vat/tips.png';
            }
        }

        $scope.pagingService = {
            refreshInvoiceDataGrid: function () {
                $log.debug("refreshInvoiceDataGrid");
                initDataFromDB();
            },
        };

        //切换tab
        $scope.switchTab = function (event, type) {
            $('.nav-tab span').each(function () {
                $(this).removeClass('active');
            });
            $(event.target).addClass('active');
            if ($scope.displayType !== type)
            {
                $scope.displayType = type;
                if (type > 1) {
                    getAssetResultList($scope.displayType - 1);
                }
                else {
                    $scope.assetImportGridInstance.refresh();
                }
            }
        };

        //弹出分类界面，1、先获取asset_group_result表中的数据，并赋值给数据集assetGroupResultDataSource
        $scope.setAssetsGroup = function () {
            assetListService.getAssetGroupResultData(projectId).success(function (groupResultData) {
                var data = groupResultData.data;
                if (data) {
                    var index = 1;
                    data.forEach(function (v) {
                        v.index = index++;
                    });
                    //orgAssetGroupList = angular.copy(data);
                    $scope.assetGroupResultDataSource = data;
                }
                //初始化资产分类Grid
                InitGrid(true);
                //此值传入后台用来分辨当前是导入文件时的保存资产分类或者是直接点击资产分类按钮保存资产分类
                $scope.saveGroupType = 2;
                $scope.isDisabled = false;
                $scope.modalInstance = $uibModal.open({
                    animation: false,
                    backdrop: 'static',
                    keyboard: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'set-asset-group-modal.html',
                    scope: $scope,
                    windowClass: "set-asset-list-modal"
                });
            }).error(function (ex) {
                $log.error(ex);
                SweetAlert.error(serviceErrorMsg);
            });
        };

        //保存分类信息
        $scope.saveAssetGroupInfo = function () {

            var dataGrid = $('#assetsGroupGrid').dxDataGrid("instance");
            dataGrid.saveEditData();
            if (validationAssetGroupList())
            {
                assetListService.saveAssetGroupInfo($scope.assetGroupResultDataSource, $scope.saveGroupType, projectId).success(function (data) {

                    if (data) {
                        SweetAlert.success($translate.instant('SaveSuccess'));
                        if ($scope.modalInstance) {
                            $scope.modalInstance.close();
                        }
                    }
                }).error(function () {
                    SweetAlert.error(serviceErrorMsg);
                });
            }
            else
            {
                ackMessageBox.warning($translate.instant('PleaseSetAssetGroupInfo'));
            }
        };

        //关闭弹出框
        $scope.cancelAsset = function () {
            if ($scope.modalInstance) {
                $scope.modalInstance.close();
            }
        };

        //是否显示星号
        $scope.isNeedMappingColumn = function (col) {
            if ($scope.mustMappingTotalColumns.indexOf(col) > -1) {
                return true;
            }
            else {
                return false;
            }
        }

        //验证信息数据源
        $scope.gridOptionsErrorMsg = {
            rowHeight: constant.UIGrid.rowHeight,
            selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
            enableSorting: false,
            enableColumnMenus: false,
            enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
            enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
            columnDefs: [
                {
                    name: $translate.instant('Icon'), width: '5%', cellTemplate: '<div class="ui-grid-cell-contents"><span><img data-ng-src="{{grid.appScope.errorLevelToString(row.entity.errorLevel)}}"><span></div>'
                },
                {
                    name: $translate.instant('SequenceNo'), width: '5%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}<span></div>'
                },
                {
                    name: $translate.instant('ErrorResult'), width: '20%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.validationResult}}<span></div>'
                },
                {
                    name: $translate.instant('ErrorCount'), width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.number}}<span></div>'
                },
                {
                    name: $translate.instant('ErrorDetail'), width: '35%', cellTemplate: dealDetail,
                },
                {
                    name: $translate.instant('ValidationTips'), width: '25%', cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.validationTips}}"><span>{{row.entity.validationTips}}<span></div>'
                },
            ],
            onRegisterApi: function (gridApi) {
                $scope.errorGridApi = gridApi;

                $interval(function () {
                    $scope.errorGridApi.core.handleWindowResize();
                }, 500, 60 * 60 * 8);
            }
        };

        //控制明细信息中删除权限
        var getUserPermission = function () {

            var list = [];
            $scope.editCode = constant.citPermission.dataImport.assetList.importCode;
            list.push($scope.editCode);
            $scope.hasEditPermission = false;
            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {

                $scope.hasEditPermission = data[$scope.editCode];
                //$scope.dataGridInstance.option("editing.allowUpdating", $scope.hasEditPermission);
                //$scope.dataGridInstance.refresh();
                //$scope.assetGroupGridInstance.option("editing.allowUpdating", $scope.hasEditPermission);
                //$scope.assetGroupGridInstance.refresh();

            });
        };

        //开始
        (function initialize() {
            $log.debug('ImportOutputInvoiceController.ctor()...');
            /**************************************** function start*************************************************/
            $scope.displayType = 2;
            $scope.saveGroupType = 1;
            $scope.isDisabled = false;
            $scope.selectedColumnMap = [];
            $scope.incomeInvoiceTotalColumns = [];
            $scope.initIncomeInvoiceTotalColumnsIndex = [];
            $scope.changeSheet = changeSheet;
            $scope.mappingColumn = mappingColumn;
            $scope.importData = importData;
            initColumns();
            initDxGrid();
            initAssetResultDxGrid();
            getAssetResultList(1);
            // initDataFromDB();
            getGroupList();
            getGroupDetailList();
            getUserPermission();
            // $scope.$watch('fileNameWrapper', function (newValue, oldValue) {
            //     if (newValue != null && newValue !== oldValue) {
            //         //设置上传文件名
            //         var arr = newValue.name.split('.');
            //         if (arr[arr.length - 1] !== 'xls' && arr[arr.length - 1] !== 'xlsx' && arr[arr.length - 1] !== 'xlsm') {
            //             SweetAlert.warning($translate.instant('ImportFileInvalidType'));
            //             return;
            //         }
            //         $scope.fileName = newValue.name;
            //         uploadfile($scope.fileNameWrapper);
            //         $scope.ImportErrorTab = false;
            //         $scope.ImportErrorTag = false;
            //         $('#StartRowNum').val('2');
            //     }
            // });

            $timeout(function () {
                if ($scope.dataGridInstance)
                {
                    $scope.dataGridInstance.option("editing.allowUpdating", $scope.hasEditPermission);
                    $scope.dataGridInstance.refresh();
                }
            }, 1000);

        })();
    }
]);