﻿citModule.controller('citDistributionTableController', ['$rootScope','$scope', '$log', '$filter','$translate', '$timeout', 'SweetAlert', '$q', 'uiGridConstants', '$interval', 'citPreviewService', 'citReportService','browserService', 'vatSessionService', 'region', 'enums', 'vatExportService',
    function ($rootScope,$scope, $log,$filter, $translate, $timeout, SweetAlert, $q, uiGridConstants, $interval, citPreviewService, citReportService, browserService, vatSessionService, region, enums, vatExportService) {
        'use strict';

        $scope.startDate = new Date(vatSessionService.project.year, 0, 1);
        $scope.endDate = new Date(vatSessionService.project.year, 11, 31);
        $scope.dateFormat = $translate.instant('dateFormat4Year');
        $scope.startMonth = vatSessionService.month;
        $scope.endMonth = vatSessionService.month;
        $scope.totalMoneyAmount = 0;
        $scope.totalTaxAmount = 0;
        $scope.totalBusinessIncome = 0;
        $scope.totalEmployeeRemuneration = 0;
        $scope.totalTotalAssets = 0;


        var minDate = [1, vatSessionService.project.year];
        // var minDate = moment().startOf('month').subtract(0, 'months');
        var maxDate = [12, vatSessionService.project.year];
        var setDate = [
            [vatSessionService.project.year],
            [vatSessionService.project.year]];

        //初始化期间
        var initPeriods = function () {
            var curMonth = new Date().getMonth() + 1;

            $scope.queryParams = {
                pageInfo: {},
                periodStart: '',
                periodEnd: '',
                totalBusinessIncome: $scope.totalBusinessIncome,
                totalEmployeeRemuneration:$scope.totalEmployeeRemuneration,
                totalTotalAssets:$scope.totalEmployeeRemuneration,
                projectId: vatSessionService.project.id
            };
        };

        //从数据库中load数据
        var loadJournalEntryDataFromDB = function () {
             //初始化查询信息
            $scope.queryParams = {
                pageInfo: {
                    totalCount: $scope.pagingOptions.totalItems,
                    pageIndex: $scope.pagingOptions.pageIndex,
                    pageSize: $scope.pagingOptions.pageSize,
                    totalPage: 0
                },
                periodStart: '',
                periodEnd: '',
                totalBusinessIncome: $scope.totalBusinessIncome,
                totalEmployeeRemuneration:$scope.totalEmployeeRemuneration,
                totalTotalAssets:$scope.totalEmployeeRemuneration,
                projectId: vatSessionService.project.id
            };

            $scope.getDataFromDatabase($scope.queryParams);
        };

        $scope.getDataFromDatabase = function (queryParams){
            citReportService.getDistributionTables(queryParams).success(function (resp) {

                if (resp.data) {
                    // minDate = data.
                    var index = 1;
                    resp.data.list.forEach(function (v) {
                        v.index = index++;
                    });
                    // $scope.gridOptions.data = resp.data.list;
                    $scope.gridDataSource = resp.data.list;

                    $scope.pagingOptions.totalItems = resp.data.total;
                }
            });
        };

        //将选择了的查询条件显示在grid上方
        var doDataFilter = function (removeData) {
            if ($scope.queryParams.periodStart > $scope.queryParams.periodEnd) {
                $scope.queryParams.periodEnd = $scope.queryParams.periodStart;
            }

            //设置需要去掉的查询条件的值为空
            if (!PWC.isNullOrEmpty(removeData)) {
                var removeItem = removeData.split("|");
                removeItem.forEach(function (v) {
                    $scope.queryParams[v] = null;

                    // if ($scope.queryParams.subjectCode === null) {
                    //     $scope.queryParams.subjectCode = '';
                    // }
                    // if ($scope.queryParams.subjectName === null) {
                    //     $scope.queryParams.subjectName = '';
                    // }
                    // if ($scope.queryParams.orgCode === null) {
                    //     $scope.queryParams.orgCode = '';
                    // }
                    // if ($scope.queryParams.orgName === null) {
                    //     $scope.queryParams.orgName = '';
                    // }
                    // if ($scope.queryParams.documentDate === null) {
                    //     $scope.queryParams.documentDate = '';
                    // }
                });
            }

            loadJournalEntryDataFromDB();
            $('.filter-button').popover("hide");
        };

        //去掉所有的查询条件，重新load数据
        var doDataFilterReset = function () {
            $scope.queryParams = {
                pageInfo: {},
                periodStart: '',
                periodEnd: '',
                subjectCode: null,
                subjectName: null,
                orgCode: null,
                orgName: null,
                documentDate: null,
                projectId: vatSessionService.project.id
            };
            $scope.queryParams.periodStart = $scope.startMonth;
            $scope.queryParams.periodEnd = $scope.endMonth;
            loadJournalEntryDataFromDB();
            $('.filter-button').popover("hide");
        };

        var prepareSummary = function () {
            // do something before show popover
        };

        //在popover打开时执行事件
        var showPopover = function () {
            $timeout(function () {
                initDatePickers();
            }, 500);
        };

        //初始化时间控件
        var initDatePickers = function () {
            //认证开始时间
            var ele1 = $("#certificationDateStart");
            ele1.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                language: region,
                autoclose: true,//选中之后自动隐藏日期选择框
                clearBtn: true,//清除按钮
                todayBtn: false,//今日按钮
                format: $scope.dateFormat//日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            });
            ele1.datepicker("setDate", $scope.queryParams.certificationDateStart);
            //认证结束时间
            var ele2 = $("#certificationDateEnd");
            ele2.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                language: region,
                autoclose: true,//选中之后自动隐藏日期选择框
                clearBtn: true,//清除按钮
                todayBtn: false,//今日按钮
                format: $scope.dateFormat//日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            })
            ele2.datepicker("setDate", $scope.queryParams.certificationDateEnd);
        };

        var downloadJE = function () {
            citReportService.initExportDTData($scope.queryParams).success(function (data, status, headers) {
                if(status===204){
                    SweetAlert.warning("没有数据可以下载");
                    return;
                }
                vatExportService.exportToExcel(data, status, headers, 'A202000.xlsx');
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        };

        $scope.startCalculateData = function () {
            citReportService.generateDistributionTable($scope.queryParams).success(function (data) {

                $scope.totalBusinessIncome = data.data.totalBusinessIncome;
                $scope.totalEmployeeRemuneration = data.data.totalEmployeeRemuneration;
                $scope.totalTotalAssets = data.data.totalTotalAssets;
                loadJournalEntryDataFromDB();
                // if(status===204){
                //     SweetAlert.warning("没有数据可以下载");
                //     return;
                // }
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        };


        //刷新页面
        $scope.refreshConfigGrid = function () {
            loadJournalEntryDataFromDB();
        };

        (function initialize() {
            $log.debug('citDistributionTableController.ctor()...');

            //分页的设置
            $scope.pagingOptions = {
                pageIndex: 1,  //当前页码
                totalItems: 0,  //总数据
                pageSize: 20,  //每页多少条数据
                pageSizeString:"20"
            };

            $('#input-invoice-period-picker').focus(function () {
                $('.filter-button').popover("hide");
            });
            //初始化month-picker
            $('#input-invoice-period-picker').rangePicker({
                minDate: minDate,
                maxDate: maxDate,
                setDate: setDate,
                ConfirmBtnText: $translate.instant('Confirm'),
                CancelBtnText: $translate.instant('ButtonCancel')
            })
                .on('datePicker.done', function (e, result) {
                    //开始月份
                    var startMonth = result[0][1] * 100 + result[0][0];
                    //结束月份
                    var endMonth = result[1][1] * 100 + result[1][0];
                    $scope.startMonth = startMonth;
                    $scope.endMonth = endMonth;

                    $scope.queryParams.periodStart = startMonth;
                    $scope.queryParams.periodEnd = endMonth;
                    loadJournalEntryDataFromDB();
                });

            $scope.gridOptions = {
                bindingOptions: {
                    dataSource: 'gridDataSource'
                },
                showBorders: true,
                columns: [
                    {caption: $translate.instant('TaxPayerNumber'), dataField: "taxPayerNumber",width: 200},
                    {caption: $translate.instant('OrgName'), dataField: "orgName",width: 300},
                    {
                        caption: $translate.instant('BusinessIncome'),
                        dataField: "businessIncome",
                        format: {type: 'fixedPoint', precision: 2},
                        width: 200
                    },
                    {
                        caption: $translate.instant('EmployeeRemuneration'),
                        dataField: "employeeRemuneration",
                        format: {type: 'fixedPoint', precision: 2},
                        width: 200
                    },
                    {
                        caption: $translate.instant('TotalAssets'),
                        dataField: "totalAssets",
                        format: {type: 'fixedPoint', precision: 2},
                        width: 200
                    },
                    {
                        caption: $translate.instant('DistributionRatio'),
                        dataField: "distributionRatio",
                        format: {type: 'fixedPoint', precision: 2},
                        width: 200
                    }
                ],
                // onContentReady: function (e) {
                //     $scope.extractFinancialInstance = e.component;
                //     var totalCount = e.component.totalCount();
                //     if (totalCount > 0) {
                //         $scope.totalCount = totalCount;
                //     }
                // },
                loadPanel: {
                    enabled: true
                },
                selection: {
                    mode: "single"
                },
                grouping: {
                    autoExpandAll: false
                },
                paging: {
                    pageSize: 20
                },
                allowColumnResizing: true,
                columnAutoWidth: true,
                showRowLines: true,
                showColumnLines: true,
                rowAlternationEnabled: true,  //单双行颜色
                noDataText: $translate.instant('NoDataText'),
                summary: {
                    totalItems: [
                        {
                            column: 'orgName',
                            customizeText: function (item) {
                                return $translate.instant('Subtotal');
                            }
                        },
                        {
                            column: 'businessIncome',
                            summaryType: 'sum',
                            customizeText: function (data) {
                                return data.value.formatAmount(2);
                            }
                        },
                        {
                            column: 'employeeRemuneration',
                            summaryType: 'sum',
                            customizeText: function (data) {
                                return data.value.formatAmount(2);
                            }
                        },
                        {
                            column: 'totalAssets',
                            summaryType: 'sum',
                            customizeText: function (data) {
                                return data.value.formatAmount(2);
                            }
                        },
                        {
                            column: 'distributionRatio',
                            summaryType: 'sum',
                            customizeText: function (data) {
                                return data.value.formatAmount(2);
                            }
                        }
                    ]
                }
            };


            $scope.doDataFilter = doDataFilter;
            $scope.doDataFilterReset = doDataFilterReset;
            $scope.prepareSummary = prepareSummary;
            $scope.showPopover = showPopover;
            $scope.downloadJE = downloadJE;

            initPeriods();
            //初始化查询条件-期间范围
            $scope.queryParams.periodStart = vatSessionService.year * 100 + vatSessionService.month;
            $scope.queryParams.periodEnd = vatSessionService.year * 100 + vatSessionService.month;
            $scope.queryParams.organizationId = vatSessionService.project.organizationID;
            if($rootScope.currentLanguage === 'en-us'){
                $('.periodInput')[0].style.left = "280px";
            }else{
                $('.periodInput')[0].style.left = "150px";
            }
            loadJournalEntryDataFromDB();
        })();
    }
]);




