﻿// Account select tree view, select multiple accounts with checkboxes
commonModule.directive('accountMultiSelector', ['$log', '$translate',
    function ($log, $translate) {
        'use strict';
        $log.debug('accountMultiSelector.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/common/controls/account-multi-selector/account-multi-selector.html' + '?_=' + Math.random(),
            replace: true,
            scope: {
                accountDataSource: '=*',
                isShow: '=',
                selectedAccountCodes: '=',
                title: '=',
                isSingleMode: '=?',
                selectorOptions: '=?',
                selectorApi: '=?' // In: onSelectorClose, onSelectorConfirm; Out: getGridInstance
            },
            link: function (scope, element) {
                scope.columnDefs = [{
                    caption: $translate.instant('SubjectCode'),
                    dataField: 'code',
                    isIdentity: true
                }, {
                    caption: $translate.instant('SubjectName'),
                    dataField: 'name'
                }, {
                    caption: $translate.instant('SubjectDirection'),
                    dataField: 'directionName'
                }, {
                    caption: $translate.instant('SubjectType'),
                    dataField: 'AcctPropName'
                }, {
                    visible: false,
                    dataField: 'parentCode',
                    isParentKey: true
                }];

                scope.parentCheckable = true;
            }
        };
    }
]);