﻿commonModule.controller('modelAnalysisReportController', ['$scope', '$translate', '$uibModal', 'modelConfigurationService', '$compile', '$q', 'dxDataGridService',
    function ($scope, $translate, $uibModal, modelConfigurationService, $compile, $q, dxDataGridService) {
        'use strict';

        $scope.trans = {
            OPCancel: $translate.instant('Cancel'),
            OPConfirm: $translate.instant('Confirm'),
            OPDelete: $translate.instant('Delete'),
            OPDeleteSelected: $translate.instant('DeleteSelected'),
            OPEdit: $translate.instant('Edit'),
            OTAddSuccess: $translate.instant('AddSuccess'),
            OTBoolFalse: $translate.instant('False'),
            OTBoolTrue: $translate.instant('True'),
            OTDeleteConfirm: $translate.instant('ConfirmToDelete'),
            OTDeleteSelected: $translate.instant('DeleteSelected'),
            OTDeleteSuccess: $translate.instant('DeleteSuccess'),
            OTEditSuccess: $translate.instant('EditSuccess'),
            OTNoDataText: $translate.instant('NoDataText'),
            OTSearch: $translate.instant('Search'),
        };

        $scope.isModelBackFill = (typeof $scope.isModelBackFill) === "string" ? $scope.isModelBackFill === "true" : !!$scope.isModelBackFill;

        var ENTRIES_CHECK_COLUMNS = [
            {
                dataField: "showIndex",
                caption: $translate.instant('Model_ColNO'),
                width: "5.5em",
                allowEditing: false,
                alignment: "center",
                visible: !$scope.isModelBackFill
            },
            {
                allowEditing: false,
                alignment: "center",
                dataField: "isException",
                caption: $translate.instant('Model_ColStatus'),
                width: "8em"
            },
            {
                allowEditing: false,
                alignment: "left",
                dataField: "name",
                caption: $translate.instant('ModelName'),
                width: "40%"
            },
            {
                allowEditing: false,
                alignment: "center",
                dataField: "voucherNum",
                caption: $translate.instant('Model_ColVoucherNumberCount'),
                width: "6.5em",
                visible: !$scope.isModelBackFill
            },
            {
                allowEditing: false,
                alignment: "center",
                dataField: "isFilter",
                caption: $translate.instant('Model_ColFilterIssue'),
                width: "6.5em",
                visible: !$scope.isModelBackFill
            },
            {
                allowEditing: false,
                alignment: "center",
                dataField: "voucherDoubts",
                caption: $translate.instant('IssueNumber'),
                width: "5.5em"
            },
            {
                allowEditing: false,
                dataField: "debitRelevantAmt",
                dataType: 'number',
                caption: $translate.instant('Model_ColDebitAcctualAmount'),
                width: "8.5em",
                alignment: "right",
                format: {
                    type: "fixedPoint",
                    precision: 2
                }
            },
            {
                allowEditing: false,
                dataField: "creditRelevantAmt",
                dataType: 'decimal',
                caption: $translate.instant('Model_ColCreditAcctualAmount'),
                width: "8.5em",
                alignment: "right",
                format: {
                    type: "fixedPoint",
                    precision: 2
                }
            },
            {
                allowEditing: false,
                alignment: "left",
                dataField: "description",
                caption: $translate.instant('Model_ColModelDescription'),
                width: "60%",
                visible: !$scope.isModelBackFill
            },
            {
                allowEditing: true,
                alignment: "right",
                dataField: "writeBackData",
                caption: "回填金额",
                dataType: "number",
                width: "8em",
                visible: false,
                format: {
                    type: "fixedPoint",
                    precision: 2
                }
            }
        ];

        var INDEX_ANALYSIS_COLUMNS = [
            {
                alignment: "center",
                dataField: "showIndex",
                caption: $translate.instant('Model_ColNO'),
                width: "5.5em",
                allowEditing: false,
                visible: !$scope.isModelBackFill
            },
            {
                alignment: "center",
                dataField: "isException",
                caption: $translate.instant('Model_ColStatus'),
                width: "8em"
            },
            {
                alignment: "left",
                dataField: "name",
                caption: $translate.instant('ModelName'),
                width: "40%"
            },
            {
                alignment: "center",
                dataField: "mainValue",
                caption: $translate.instant('Model_ColCalculatedValue'),
                width: "6.5em"
            },
            {
                alignment: "left",
                dataField: "description",
                caption: $translate.instant('Model_ColModelDescription'),
                width: "60%",
                visible: !$scope.isModelBackFill
            },
            {
                dataField: "monthExplain",
                caption: $translate.instant('Model_ColMonthlyWarningValue'),
                width: "9.5em",
                alignment: "left"
            },
            {
                alignment: "left",
                dataField: "yearExplain",
                caption: $translate.instant('Model_ColYearWarningValue'),
                width: "9.5em"
            }
        ];

        var INDEX_ANALYSIS_GENERAL_LEDGER_COLUMNS = [
            {
                dataField: "acctCode",
                caption: $translate.instant('AccountVoucher_AccountCode'),
                width: "20%"
            },
            {
                dataField: "accountName",
                caption: $translate.instant('AccountVoucher_AccountName'),
                width: "30%"
            },
            {
                alignment: "center",
                caption: "期初余额",
                columns: [
                    {
                        alignment: "right",
                        caption: $translate.instant('AccountVoucher_DataGrid_ColDebit'),
                        dataField: "begDebitBal",
                        format: {
                            type: "fixedPoint",
                            precision: 2
                        },
                        width: 120
                    },
                    {
                        alignment: "right",
                        caption: $translate.instant('AccountVoucher_DataGrid_ColCredit'),
                        dataField: "begCreditBal",
                        format: {
                            type: "fixedPoint",
                            precision: 2
                        },
                        width: 120
                    }
                ]
            },
            {
                alignment: "center",
                caption: "累计发生额",
                columns: [
                    {
                        alignment: "right",
                        caption: $translate.instant('AccountVoucher_DataGrid_ColDebit'),
                        dataField: "debitBal",
                        format: {
                            type: "fixedPoint",
                            precision: 2
                        },
                        width: 120
                    },
                    {
                        alignment: "right",
                        caption: $translate.instant('AccountVoucher_DataGrid_ColCredit'),
                        dataField: "creditBal",
                        format: {
                            type: "fixedPoint",
                            precision: 2
                        },
                        width: 120
                    }
                ]
            },
            {
                alignment: "center",
                caption: "期末余额",
                columns: [
                    {
                        alignment: "right",
                        caption: $translate.instant('AccountVoucher_DataGrid_ColDebit'),
                        dataField: "endDebitBal",
                        format: {
                            type: "fixedPoint",
                            precision: 2
                        },
                        width: 120
                    },
                    {
                        alignment: "right",
                        caption: $translate.instant('AccountVoucher_DataGrid_ColCredit'),
                        dataField: "endCreditBal",
                        format: {
                            type: "fixedPoint",
                            precision: 2
                        },
                        width: 120
                    }
                ]
            }
        ];

        //检查请求参数是否符合网络请求规范,减少异常的网络访问
        var checkRequestAccessible = function () {
            var accessible = true;
            accessible &= $scope.modelType === 1 || $scope.modelType === 2;
            accessible &= _.isString($scope.categoryId) && !!$scope.categoryId;
            accessible &= _.isString($scope.organizationId) && !!$scope.organizationId;
            accessible &= $.isNumeric($scope.industryId);
            accessible &= $.isNumeric($scope.serviceTypeId);
            accessible &= $.isNumeric($scope.projectYear);
            accessible &= $.isNumeric($scope.periodFrom);
            accessible &= $.isNumeric($scope.periodTo);
            return !!accessible;
        };

        var loadEntriesCheckData = function () {
            var viewModel = $scope.analysisResult.entriesCheck;
            viewModel.dataSource = [];

            var apiFunc = modelConfigurationService.getEntriesModelResultByCategory;
            apiFunc($scope.categoryId, $scope.serviceTypeId, $scope.organizationId, $scope.industryId, $scope.periodFrom, $scope.periodTo).then(function (response) {
                viewModel.dataSource = response.data;
                viewModel.isLoaded = true;
            });
        };

        var loadIndexAnalysisData = function () {
            var viewModel = $scope.analysisResult.indexAnalysis;
            viewModel.dataSource = [];

            var apiFunc = modelConfigurationService.getIndexModelResultByCategory;
            apiFunc($scope.categoryId, $scope.serviceTypeId, $scope.organizationId, $scope.industryId).then(function (response) {
                viewModel.dataSource = response.data;
                viewModel.isLoaded = true;
            });
        };

        //检查请求参数是否符合网络请求规范,减少异常的网络访问
        var checkModelBackFillRequestAccessible = function () {
            var accessible = true;
            accessible &= $scope.modelType === 1 || $scope.modelType === 2;
            accessible &= _.isString($scope.cellDataId) && !!$scope.cellDataId;
            accessible &= $.isArray($scope.modelIdList);
            accessible &= $.isNumeric($scope.projectYear);
            accessible &= $.isNumeric($scope.periodFrom);
            accessible &= $.isNumeric($scope.periodTo);
            return !!accessible;
        };

        var loadModelBackFillEntriesCheckData = function () {
            var viewModel = $scope.analysisResult.entriesCheck;
            viewModel.dataSource = [];

            var paramModel = {
                cellDataId: $scope.cellDataId,
                modelIdList: $scope.modelIdList
            };

            var apiFunc = modelConfigurationService.getEntriesModelResultByCellInfo;
            apiFunc(paramModel).then(function (response) {
                var data = response.data;

                for (var i = 0; i < data.length; i++) {
                    data[i].originalWriteBackData = data[i].writeBackData;
                }

                var hasWriteBackData = _.any(data, function (e) {
                    return !!e.originalWriteBackData;
                });

                if (hasWriteBackData && !!viewModel.dataGridInstance) {
                    viewModel.dataGridInstance.columnOption("writeBackData", "visible", true);
                }

                viewModel.dataSource = data;
                viewModel.isLoaded = true;
            });
        };

        var loadModelBackFillIndexAnalysisData = function () {
            var viewModel = $scope.analysisResult.indexAnalysis;
            viewModel.dataSource = [];

            var apiFunc = modelConfigurationService.getIndexModelResultByCellInfo;
            apiFunc($scope.modelIdList).then(function (reason) {
                viewModel.dataSource = reason.data;
                viewModel.isLoaded = true;
            });
        };

        var loadIndexAnalysisGeneralLedgerData = function () {
            var glViewModel = $scope.indexAnalysisGeneralLedger;
            glViewModel.dataSource = [];

            var apiFunc = modelConfigurationService.getGL;
            apiFunc(glViewModel.resultId, glViewModel.periodFrom, glViewModel.periodTo).then(function (reason) {
                glViewModel.dataSource = reason.data;
            });
        };

        //重新加载所有数据
        var reloadAnalysisResultData = function () {
            $scope.analysisResult.selectedRow = null;

            $scope.analysisResult.entriesCheck.isLoaded = false;
            $scope.analysisResult.entriesCheck.dataSource = [];

            $scope.analysisResult.indexAnalysis.isLoaded = false;
            $scope.analysisResult.indexAnalysis.dataSource = [];

            var checkRst = $scope.isModelBackFill ? checkModelBackFillRequestAccessible() : checkRequestAccessible();
            if (!checkRst)
                return;

            if ($scope.isModelBackFill)
                $scope.modelType === 1 ? loadModelBackFillIndexAnalysisData() : loadModelBackFillEntriesCheckData();
            else
                $scope.modelType === 1 ? loadIndexAnalysisData() : loadEntriesCheckData();
        };

        var calcResizableHeightLimit = function () {
            //计算 dataGrid 能调整的高度
            var viewModel = $scope.analysisResult[($scope.modelType & 1) === 1 ? "indexAnalysis" : "entriesCheck"];
            if ((!viewModel.dataSource) || viewModel.dataSource.length < 1) {
                $scope.analysisResult.height = $scope.element.height();
                $scope.analysisResult.selectedRow = null;
                return;
            }

            var gvMinHeight = 34 + (viewModel.dataSource.length >= 3 ? 3 : viewModel.dataSource.length) * 32;
            var gvMaxHeight = 34 + (viewModel.dataSource.length >= 10 ? 10 : viewModel.dataSource.length) * 32;

            //计算 dxResizable 能调整的高度
            var minHeight = $scope.element.height() - 5 - gvMaxHeight;
            var maxHeight = $scope.element.height() - 5 - gvMinHeight;

            var resizableInstance = $scope.dxResizableOption.dxResizableInstance;
            var opHeight = resizableInstance.option("height");
            var opMaxHeight = resizableInstance.option("maxHeight");
            var opMinHeight = resizableInstance.option("minHeight");
            if (maxHeight !== opMaxHeight)
                resizableInstance.option("maxHeight", maxHeight);

            if (minHeight !== opMinHeight)
                resizableInstance.option("minHeight", minHeight);

            var height = opHeight;
            if (opHeight < minHeight)
                height = minHeight;
            if (opHeight > maxHeight)
                height = maxHeight;
            if (height !== opHeight)
                resizableInstance.option("height", height);
        };

        $scope.$watch("modelType", function (newValue, oldValue) {
            var selectedRows = [];
            var viewModel = $scope.analysisResult;

            if (newValue === 1) {
                if (!viewModel.indexAnalysis.isLoaded) {
                    $scope.isModelBackFill ? loadModelBackFillIndexAnalysisData() : loadIndexAnalysisData();
                }
                else if (!!viewModel.indexAnalysis.dataGridInstance) {
                    selectedRows = viewModel.indexAnalysis.dataGridInstance.getSelectedRowsData();
                }
            }
            else {
                if (!viewModel.entriesCheck.isLoaded) {
                    $scope.isModelBackFill ? loadModelBackFillEntriesCheckData() : loadEntriesCheckData();
                }
                else if (!!viewModel.entriesCheck.dataGridInstance) {
                    selectedRows = viewModel.entriesCheck.dataGridInstance.getSelectedRowsData();
                }
            }

            $scope.analysisResult.selectedRow = selectedRows.length > 0 ? selectedRows[0] : null;
        });

        $scope.$watch("selectedRow", function (newValue, oldValue) {
            calcResizableHeightLimit();
        });

        $scope.$on("EditModelWriteBack", function (event, data) {
            var viewModel = $scope.analysisResult.entriesCheck;
            viewModel.dataGridInstance.option("editing.allowUpdating", true);
            viewModel.dataGridInstance.columnOption("writeBackData", "visible", true);
        });

        $scope.$on("CancelEditModelWriteBack", function (event, data) {
            var viewModel = $scope.analysisResult.entriesCheck;
            var hasWriteBackData = _.any(viewModel.dataSource, function (e) {
                return !!e.originalWriteBackData;
            });

            for (var i = 0; i < viewModel.dataSource.length; i++) {
                viewModel.dataSource[i].writeBackData = viewModel.dataSource[i].originalWriteBackData;
            }

            viewModel.dataGridInstance.option("editing.allowEditing", false);
            viewModel.dataGridInstance.columnOption("writeBackData", "visible", hasWriteBackData);
        });

        $scope.$on("CheckModelWriteBackHasChanged", function (event, data) {
            var viewModel = $scope.analysisResult.entriesCheck;
            viewModel.dataGridInstance.saveEditData();

            if (!$scope.modelDataSourceId)
                $scope.modelDataSourceId = PWC.newGuid();

            var eventData = {cellDataId: $scope.cellDataId, dataSourceId: $scope.modelDataSourceId};
            eventData.haveChanged = _.any(viewModel.dataSource, function (e) {
                return e.originalWriteBackData !== e.writeBackData;
            });

            var originalWriteBackData = _.filter(viewModel.dataSource, function (e) {
                return !!e.originalWriteBackData;
            });
            eventData.originalWriteBackData = [];
            _.each(originalWriteBackData, function (e) {
                eventData.originalWriteBackData.push({key: e.id, value: e.originalWriteBackData});
            });

            var currentWriteBackData = _.filter(viewModel.dataSource, function (e) {
                return !!e.writeBackData;
            });
            eventData.currentWriteBackData = [];
            _.each(currentWriteBackData, function (e) {
                eventData.currentWriteBackData.push({key: e.id, value: e.writeBackData});
            });

            $scope.$emit("ModelWriteBackHasChanged", eventData);

            //提交事件后修改 DataGrid 不能修改
            var hasWriteBackData = _.any(viewModel.dataSource, function (e) {
                return !!e.writeBackData;
            });

            viewModel.dataGridInstance.option("editing.allowEditing", false);
            viewModel.dataGridInstance.columnOption("writeBackData", "visible", hasWriteBackData);
        });

        $scope.dxResizableOption = {
            dxResizableInstance: null,
            width: "100%",
            height: 200,
            minHeight: 0,
            maxHeight: 500,
            handles: "top",
            onInitialized: function (e) {
                $scope.dxResizableOption.dxResizableInstance = e.component;
            },
            onResizeStart: function (e) {
                calcResizableHeightLimit();
            },
            onResize: function (e) {
                //计算 dataGrid 能调整的高度
                var height = $scope.element.height() - 5 - e.height;
                $scope.analysisResult.height = height;
            }
        };

        $scope.analysisResult = {
            entriesCheck: {
                isLoaded: false,
                dataGridInstance: null,
                dataSource: [],
                //在 模型回填中需要用到合计汇总信息
                dxDataGridSummary: {
                    totalItems: [
                        {
                            column: 'voucherDoubts',
                            customizeText: function (data) {
                                return $translate.instant('Subtotal');
                            }
                        },
                        {
                            column: 'debitRelevantAmt',
                            displayFormat: "{0}",
                            summaryType: 'sum',
                            valueFormat: {
                                type: "fixedPoint",
                                precision: 2
                            }
                        },
                        {
                            column: 'creditRelevantAmt',
                            displayFormat: "{0}",
                            summaryType: 'sum',
                            valueFormat: {
                                type: "fixedPoint",
                                precision: 2
                            }
                        },
                        {
                            column: 'writeBackData',
                            displayFormat: "{0}",
                            summaryType: 'sum',
                            valueFormat: {
                                type: "fixedPoint",
                                precision: 2
                            }
                        }
                    ]
                },
                writeBackData: null,
                dxDataGridOptions: {
                    bindingOptions: {
                        dataSource: "analysisResult.entriesCheck.dataSource",
                        height: "analysisResult.height"
                    },
                    columns: ENTRIES_CHECK_COLUMNS,
                    onCellPrepared: function (e) {
                        if (e.rowType != "data")
                            return;

                        if (e.column.dataField === "isException") {
                            $(e.cellElement).html(e.value ? "<span><i class='fa fa-exclamation-circle'></i>系统检测异常</span>" : "<span><i class='fa fa-check-circle'></i>系统检测正常</span>");
                        }

                        if (e.column.dataField === "voucherNum") {
                            $(e.cellElement).html("<span class=\"voucher-num\">" + (e.value > 0 && e.data.isFilter == 1 ? e.value : "-") + "</span>");
                        }

                        if (e.column.dataField === "isFilter") {
                            if (e.data.isFilter == 1 && e.data.voucherNum > 0) {
                                var editorBtn = $("<div class=\"filter-btn\" ng-disabled=\"!hasFilterIssuePermission\"><span class=\"fa fa-ellipsis-h\"></span></div>");
                                editorBtn.attr("ng-click", "vouchersAndEntriesModal.openModal($event,1)");
                                $(e.cellElement).html($compile(editorBtn)($scope));
                            } else {
                                $(e.cellElement).html("<span class=\"voucher-num\">-</span>");
                            }
                        }

                        if (e.column.dataField === "voucherDoubts" && e.value > 0) {
                            $(e.cellElement).html("<div class=\"voucher-doubts\"><span>" + e.value + "</span></div>");
                        }
                    },
                    onInitialized: function (e) {
                        $scope.analysisResult.entriesCheck.dataGridInstance = e.component;
                        dxDataGridService.fixContentOverflowWithMaxHeight(e.component);
                    },
                    onSelectionChanged: function (e) {
                        if (e.selectedRowsData.length < 1)
                            return;

                        var data = e.selectedRowsData[0];

                        $scope.analysisResult.selectedRow = data;

                        $scope.analysisDetailResult.modelName = data.name;
                        $scope.analysisDetailResult.modelDesc = data.description;
                    }
                }
            },
            indexAnalysis: {
                isLoaded: false,
                dataGridInstance: null,
                dataSource: [],
                dxDataGridOptions: {
                    bindingOptions: {
                        dataSource: "analysisResult.indexAnalysis.dataSource",
                        height: "analysisResult.height"
                    },
                    columns: INDEX_ANALYSIS_COLUMNS,
                    onCellPrepared: function (e) {
                        if (e.rowType !== "data")
                            return;

                        if (e.column.dataField === "isException") {
                            $(e.cellElement).html(e.value ? "<span><i class='fa fa-exclamation-circle'></i>系统检测异常</span>" : "<span><i class='fa fa-check-circle'></i>系统检测正常</span>");
                        }
                    },
                    onInitialized: function (e) {
                        $scope.analysisResult.indexAnalysis.dataGridInstance = e.component;
                        dxDataGridService.fixContentOverflowWithMaxHeight(e.component);
                        dxDataGridService.registerRowDbClick(e.component);
                    },
                    onRowDbClick: function (e) {
                        if ($scope.hasQueryPermission) {
                            $scope.indexAnalysisGeneralLedger.openModal(e.data);
                        }
                    },
                    onSelectionChanged: function (e) {
                        if (e.selectedRowsData.length < 1)
                            return;

                        var data = e.selectedRowsData[0];
                        $scope.analysisResult.selectedRow = data;

                        $scope.analysisDetailResult.modelName = data.name;
                        $scope.analysisDetailResult.modelDesc = data.description;

                        var maxSqence = _.max(data.indexAnalysisDetailResults, function (element) {
                            return element.sequence
                        });
                        var resultDetailDataList = [];
                        var searchData = data.indexAnalysisDetailResults;
                        var isShowMonthJudge = !PWC.isNullOrEmpty(data.monthExplain);
                        var tempColumns = [];
                        tempColumns.push({
                            dataField: "period",
                            caption: "期间",
                            width: 70,
                            alignment: "center"
                        });

                        for (var i = 1; i <= 13; i++) {
                            var rowObj = {period: i === 13 ? "年度" : i};

                            for (var m = 1; m <= maxSqence.sequence; m++) {
                                var cellData = _.first(_.filter(searchData, function (element) {
                                    return (element.period === i && element.sequence === m);
                                }));
                                if (cellData) {
                                    if (cellData.displayType === 1 || cellData.displayType === 2) {
                                        rowObj["colmun" + m] = PWC.isNullOrEmpty(cellData.indexResult) ? 0 : parseFloat(cellData.indexResult);
                                    } else if (cellData.displayType === 3) {
                                        rowObj["colmun" + m] = cellData.indexResult === "1" ? '是' : '否';
                                    } else {
                                        rowObj["colmun" + m] = cellData.indexResult;
                                    }
                                    //是否添加月度判断
                                    if (isShowMonthJudge === true && cellData.isMainValue === 1) {
                                        if (i !== 13)
                                            rowObj["monthJudge"] = cellData.isMonExp === 1;
                                        else
                                            rowObj["monthJudge"] = cellData.isYearExp === 1;
                                    }

                                    //动态添加列
                                    if (i === 1) {
                                        var colmun = {};
                                        colmun.dataField = "colmun" + m,
                                            colmun.caption = cellData.indexName;
                                        if (cellData.displayType === 1) {
                                            colmun.format = {
                                                type: "fixedPoint",
                                                precision: 2
                                            };
                                        }
                                        if (cellData.displayType === 2) {
                                            colmun.format = {
                                                type: "percent",
                                                precision: 2
                                            };
                                        }
                                        if (cellData.displayType === 3) {
                                            colmun.format = {
                                                type: "bool",
                                                precision: 2
                                            };
                                        }
                                        tempColumns.push(colmun)
                                    }
                                    //设置基础信息
                                    if (i === 13) {
                                        if (cellData.isMainValue === 1) {
                                            resultDetailDataList.mainColmunName = cellData.indexName;
                                            if (cellData.displayType === 1 || cellData.displayType === 2) {
                                                if (cellData.displayType === 1) {
                                                    resultDetailDataList.mainValue = PWC.isNullOrEmpty(cellData.indexResult) ? PWC.round(0, 2) : PWC.round(cellData.indexResult, 2);
                                                } else {
                                                    resultDetailDataList.mainValue = PWC.isNullOrEmpty(cellData.indexResult) ? PWC.round(0, 2) + "%" : PWC.round(cellData.indexResult * 100, 2) + "%";
                                                }

                                            } else {
                                                $scope.indexResultData.mainValue = cellData.indexResult;
                                            }
                                            if (cellData.displayType === 3) {
                                                resultDetailDataList.yearException = cellData.isYearExp === 1;
                                            }
                                        }
                                    }
                                }
                            }

                            resultDetailDataList.push(rowObj);
                        }
                        //是否添加月度判断
                        if (isShowMonthJudge === true) {
                            var colmunJudge = {};
                            colmunJudge.dataField = "monthJudge";
                            colmunJudge.caption = "异常判断";
                            colmunJudge.dataType = "boolean";
                            colmunJudge.alignment = 'left';
                            tempColumns.push(colmunJudge)
                        }

                        $scope.analysisDetailResult.indexAnalysis.dataGridInstance.option("columns", tempColumns);
                        $scope.analysisDetailResult.indexAnalysis.dataSource = resultDetailDataList;
                    }
                }
            },
            height: null,
            selectedRow: null
        };

        $scope.analysisDetailResult = {
            indexAnalysis: {
                dataGridInstance: null,
                dataSource: [],
                dxDataGridOptions: {
                    bindingOptions: {
                        dataSource: "analysisDetailResult.indexAnalysis.dataSource"
                    },
                    onInitialized: function (e) {
                        $scope.analysisDetailResult.indexAnalysis.dataGridInstance = e.component;
                        dxDataGridService.fixContentOverflowWithMaxHeight(e.component);
                    }
                }
            },
            modelName: "",
            modelDesc: ""
        };

        //"分录比对->问题筛选" & "指标分析->总帐->明细账" 两个弹出框共用该模型
        $scope.vouchersAndEntriesModal = {
            title: null,
            subTitle: null,
            exportSupported: false,
            filterIssue: false,
            modelId: null,
            modelType: null,
            periodFrom: null,
            periodTo: null,
            serviceTypeId: null,
            //usage === 1:分录比对->问题筛选,usage === 2:指标分析->总帐->明细账
            openModal: function (event, usage) {
                var model = $scope.vouchersAndEntriesModal;
                model.filterIssue = usage === 1;
                model.exportSupported = usage === 2;

                if (usage === 1) {
                    model.periodFrom = $scope.periodFrom;
                    model.periodTo = $scope.periodTo;

                    var focusedRowData = $(event.originalEvent.currentTarget).closest("tr.dx-row").data("options").data;
                    model.modelId = focusedRowData.modelID;
                    model.modelType = focusedRowData.type;
                    model.serviceTypeId = focusedRowData.serviceTypeID;

                    model.title = "筛选问题";
                    model.subTitle = $translate.instant("EntryComparison") + "：" + focusedRowData.name;
                }
                else {
                    model.periodFrom = $scope.indexAnalysisGeneralLedger.periodFrom;
                    model.periodTo = $scope.indexAnalysisGeneralLedger.periodTo;

                    //TODO:未实现
                    model.modelId = event.data.balanceId;
                    model.modelType = $scope.modelType;
                    model.serviceTypeId = $scope.serviceTypeId;

                    model.title = "指标分析：";
                    model.subTitle = event.data.accountName + "分析/总帐/明细账";
                }

                var modalInstance = $uibModal.open({
                    animation: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    backdrop: "static",
                    templateUrl: "model-analysis-report-vouchers-and-entries-modal.html",
                    scope: $scope,
                    windowClass: "model-analysis-report-vouchers-and-entries-modal"
                });

                modalInstance.closed.then(function () {
                    if (usage === 1)
                        loadEntriesCheckData();
                });

                model.confirm = function ($event) {
                    if (usage === 1)
                        return;

                    var selectedRows = $(".model-analysis-report-vouchers-and-entries-modal [dx-data-grid]").dxDataGrid("instance").getSelectedRowsData();
                    var filterList = _.groupBy(selectedRows, function (item) {
                        return item.period + "_" + item.group + "_" + item.vid;
                    });

                    filterList = $.map(filterList, function (item) {
                        return {period: item[0].period, group: item[0].group, vid: item[0].vid};
                    });

                    var paramQuery = {};
                    paramQuery.modelId = model.modelId;
                    paramQuery.serviceTypeId = model.serviceTypeId;
                    paramQuery.modelType = model.modelType;
                    paramQuery.entriesList = filterList;
                    paramQuery.period = $scope.period;
                    modelConfigurationService.updateEntriesFiter(paramQuery).then(function (response) {
                        if (response.data.result)
                            modalInstance.close(response.data);
                    });
                };

                model.dismiss = function (reason) {
                    modalInstance.dismiss(reason);
                };
            }
        };

        //"指标分析->总帐" 弹出框模型
        $scope.indexAnalysisGeneralLedger = {
            dataSource: [],
            title: null,
            subTitle: null,
            periodFrom: null,
            periodTo: null,
            resultId: null,
            treeListOptions: {
                allowColumnResizing: true,
                bindingOptions: {
                    dataSource: "indexAnalysisGeneralLedger.dataSource"
                },
                columns: INDEX_ANALYSIS_GENERAL_LEDGER_COLUMNS,
                dataStructure: "plain",
                keyExpr: "acctCode",
                parentIdExpr: "parentCode",
                onCellPrepared: function (e) {
                    if (e.rowType === "header" && e.column.dataField === "acctCode") {
                        var icon = $("<div class=\"dx-treelist-icon-container\"><div class=\"dx-treelist-empty-space\"><span></span></div></div>");
                        icon.find(".dx-treelist-empty-space").addClass("dx-treelist-collapsed");
                        icon.find("span").attr("ng-click", "indexAnalysisGeneralLedger.toggleAllExpanded($event)");
                        e.cellElement.prepend($compile(icon)($scope));
                    }
                },
                onInitialized: function (e) {
                    dxDataGridService.registerRowDbClick(e.component);
                },


                onRowDbClick: function (e) {
                    $scope.vouchersAndEntriesModal.openModal(e, 2);
                }
            },
            openModal: function (indexAnalysisResultRow) {
                var modalInstance = $uibModal.open({
                    animation: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    backdrop: "static",
                    templateUrl: 'model-analysis-report-index-analysis-general-ledger-modal.html',
                    scope: $scope,
                    windowClass: "model-analysis-report-index-analysis-general-ledger-modal"
                });

                var glViewModel = $scope.indexAnalysisGeneralLedger;
                glViewModel.title = indexAnalysisResultRow.name;
                glViewModel.periodFrom = $scope.periodFrom;
                glViewModel.periodTo = $scope.periodTo;
                glViewModel.resultId = indexAnalysisResultRow.id;

                loadIndexAnalysisGeneralLedgerData();

                var rangePicker = null;
                modalInstance.rendered.then(function () {
                    //初始化期间选择控件
                    var input = $(".model-analysis-report-index-analysis-general-ledger-modal .modal-body .field .period-range input");
                    var monthList = [
                        $translate.instant('Month01'),
                        $translate.instant('Month02'),
                        $translate.instant('Month03'),
                        $translate.instant('Month04'),
                        $translate.instant('Month05'),
                        $translate.instant('Month06'),
                        $translate.instant('Month07'),
                        $translate.instant('Month08'),
                        $translate.instant('Month09'),
                        $translate.instant('Month10'),
                        $translate.instant('Month11'),
                        $translate.instant('Month12')
                    ];

                    input = input.rangePicker({
                        minDate: [1, $scope.projectYear],
                        maxDate: [12, $scope.projectYear],
                        setDate: [
                            [glViewModel.periodFrom, $scope.projectYear],
                            [glViewModel.periodTo, $scope.projectYear]
                        ],
                        months: monthList,
                        ConfirmBtnText: $translate.instant('Confirm'),
                        CancelBtnText: $translate.instant('ButtonCancel')
                    });
                    input.on('datePicker.done', function (e, result) {
                        $scope.indexAnalysisGeneralLedger.periodFrom = result[0][0];
                        $scope.indexAnalysisGeneralLedger.periodTo = result[1][0];
                        loadIndexAnalysisGeneralLedgerData();
                    });

                    rangePicker = $(input).data("_ranegPicker");
                });

                $scope.indexAnalysisGeneralLedger.dismiss = function (reason) {
                    modalInstance.dismiss(reason);
                    rangePicker.destroy();
                };
            }
        };

        (function initialize() {
            var customOption = {loadPanel: {enabled: false}};
            $.extend(true, $scope.analysisResult.entriesCheck.dxDataGridOptions, dxDataGridService.BASIC_GRID_OPTIONS, customOption);
            $.extend(true, $scope.analysisResult.indexAnalysis.dxDataGridOptions, dxDataGridService.BASIC_GRID_OPTIONS, customOption);
            $.extend(true, $scope.analysisDetailResult.indexAnalysis.dxDataGridOptions, dxDataGridService.BASIC_GRID_OPTIONS);
            $.extend(true, $scope.indexAnalysisGeneralLedger.treeListOptions, dxDataGridService.BASIC_GRID_OPTIONS, {keyExpr: "balanceId"});

            if ($scope.isModelBackFill) {
                $scope.analysisResult.entriesCheck.dxDataGridOptions.editing.mode = "cell";
                $scope.analysisResult.entriesCheck.dxDataGridOptions.summary = $scope.analysisResult.entriesCheck.dxDataGridSummary;

                $scope.$watchGroup(["cellDataId", "projectYear", "periodFrom", "periodTo"], function (newValue, oldValue) {
                    reloadAnalysisResultData();
                });
                $scope.$watchCollection("modelIdList", function (e) {
                    reloadAnalysisResultData();
                });
            }
            else {
                $scope.$watchGroup(["categoryId", "industryId", "organizationId", "serviceTypeId", "projectYear", "periodFrom", "periodTo"], function (newValue, oldValue) {
                    reloadAnalysisResultData();
                });
            }
        })();
    }
]);