﻿commonModule.
controller('OrgCityAreaUserController', ['$scope', 'orgService', '$log', 'uiGridTreeViewConstants', '$timeout', 'areaService', 'uiGridConstants', '$translate', '$interval', '$q',
    function ($scope, orgService, $log, uiGridTreeViewConstants, $timeout, areaService, uiGridConstants, $translate, $interval,$q) {
        'use strict';

        $scope.collapse = function () {
            $scope.gridApi.treeBase.expandAllRows();
        }

        $scope.getGridHeight = function () { 
            return {};
        };

        $scope.getOrgCityAreaUserCountList = function (orgId) {

            var deferred = $q.defer();
            var promise = deferred.promise;

            //var orgId = '81a3df63-b87d-4d7f-b3af-54169c13fa15';
            orgService.getOrgCityAreaUserCountList(orgId).success(function (data) {
                 
                data.forEach(function (row) {
                    if (row.level != null) {
                        row.$$treeLevel = parseInt(row.level);
                    }
                });

                //往uigrid填充数据并默认展开所有的节点
                $scope.areaORGGridList.data = data;

                $timeout(function () {
                    $scope.gridApi.treeBase.expandAllRows();

                }, 500);

                deferred.resolve(data);
            });

            return deferred.promise;
        };

        var areaORGGridInit = function () {
            $scope.areaORGGridList = {
                enableRowSelection: true,
                enableSelectAll: false,
                rowHeight: 30,
                enableRowHeaderSelection: false,
                modifierKeysToMultiSelect: false,
                enableHorizontalScrollbar: uiGridConstants.scrollbars.NEVER,
                enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,

                enableSorting: true,
                enableColumnMenus: false,
                enableFiltering: false,
                showTreeExpandNoChildren: false,
                enableFullRowSelection: true, //是否点击行任意位置后选中,默认为false
                multiSelect: false, // 是否可以选择多个,默认为true; 
                columnDefs: [{
                    field: 'orgName',
                    name: $translate.instant('OrgShortName'),
                    headerCellClass: '',

                    cellTemplate: '<div ng-class="{true: \'text-align-left\', false: \'text-align-left-padding\'}[!row.entity.isOrganization]"><span title="{{row.entity.orgName}}">{{row.entity.orgName|limitString:16}}</span></div>'
                }, {
                    field: 'orgCity',
                    name: $translate.instant('OrgCity'),
                    headerCellClass: '',

                    cellTemplate: '<div class="text-align-left"><span title="{{row.entity.orgCity}}">{{row.entity.orgCity|limitString:16}}</span></div>'
                }, {
                    field: 'orgArea',
                    name: $translate.instant('OrgArea'),
                    headerCellClass: '',

                    cellTemplate: '<div class="text-align-left"><span>{{row.entity.orgArea}}</span></div>'
                }, {
                    field: 'orgUserCount',
                    name: $translate.instant('OrgUser'),
                    headerCellClass: '',

                    cellTemplate: '<div class="text-align-left"><span>{{row.entity.orgUserCount}}</span></div>'
                }],
                onRegisterApi: function (gridApi) {
                     
                    $scope.gridApi = gridApi;

                    $scope.gridSelectCount = $scope.gridApi.selection.getSelectedRows().length;
                    var onRowsRenderedOff = gridApi.core.on.rowsRendered(null, function () {
                        onRowsRenderedOff(); // run once
                        PWC.triggerRowSelectOnClick('#etsGrid'); // requires '.ui-grid-canvas'
                    });
                    // call resize every 500 ms for 5 s after modal finishes opening - usually only necessary on a bootstrap modal
                    $interval(function () {
                        $scope.gridApi.core.handleWindowResize();
                    }, 500, 60 * 60 * 8);

                }
            };

        };

        $scope.test = function () {
            $scope.testOrgID = '81a3df63-b87d-4d7f-b3af-54169c13fa15';
            $scope.getOrgCityAreaUserCountList($scope.testOrgID).then(function () {
                
            });
        };


        (function initialize() {
            $log.debug('OrgCityAreaUserController.ctor()...');
             
            areaORGGridInit();

        })();
    }
]);