﻿commonModule.directive('orgUserList', ['$log', '$compile', '$timeout', '$interval',
    function ($log, $compile, $timeout, $interval) {
        'use strict';
        $log.debug('orgUserList.ctor()...');

        return {
            restrict: 'AE',
            templateUrl: '/app/common/controls/org-user-list/org-user-list.html' + '?_=' + Math.random(),
            replace: true,
            scope: {
                orgIdUserList: '=',
                isRenderCompletedUserList: '='
            },
            controller: 'OrgUserListController',
            link: function (scope, element) {
                scope.$watch('orgIdUserList', function (newValue, oldValue) {
                    if (newValue !== oldValue) {

                        var orgId = newValue.substring(0, newValue.indexOf('|'));
                        //refresh ui grid with new data
                        scope.getOrgUserList(orgId).then(function () {
                            scope.isRenderCompletedUserList = true;
                        });
                    }

                    //点击弹出的面板，禁止冒泡事件
                    $("#orgUserListPop").on("click", function (e) {
                        e.stopPropagation();
                    });
                     
                })
            }
        };
    }
]);