﻿// web service proxy for role
webservices.factory('cellCommentService', ['$http', 'apiConfig', function ($http, apiConfig) {
    'use strict';
    return {
        getCellComments: function (cellDataId) {
            return $http.get('/CellComment/List?cellDataId=' + cellDataId, apiConfig.createVat());
        },
        addCellComment: function (cellComment) {
            return $http.post('/CellComment/Add', cellComment, apiConfig.createVat());
        },
        deleteCellComment: function (commentId) {
            return $http.post('/CellComment/Delete/' + commentId, {}, apiConfig.createVat());
        },
        getCellInformation: function (data) {
            return $http.get('/CellComment/getCellInformation?sql=' + data.relSql, apiConfig.createVat());
        },
        loadEntryListDataList: function (data) {
            return $http.post('/CellComment/loadEntryListDataList', data, apiConfig.createVat());
        },
        updateAdjust : function (data) {
            return $http.post('/CellComment/updateAdjust', JSON.stringify(data), apiConfig.createVat({contentType: 'application/json;charset=UTF-8'}));
        },
        selectEntryLog : function (code, id ) {
            return $http.get('/CellComment/selectEntryLog?code=' + code +'&id=' +id, apiConfig.createVat());
        },
        addLog :function(data){
            return $http.post('/CellComment/addLog', data, apiConfig.createVat());
    }
    };
}]);