﻿/**
 * @author zhikai.z.wei
 * CIT数据预览页面service
 */
webservices.factory('citPreviewService', ['$http', 'apiConfig','FileSaver', function ($http, apiConfig,FileSaver) {
    'use strict';
    return {
        sample: function () {
            return $http.get('url', apiConfig.createVat());
        },

        /**
        根据条件获取日记账合并版
         */
        getJournalMerges : function(citJournalAdjustDto){
            return $http.post('/citDataPreview/getJournalMergeData', citJournalAdjustDto, apiConfig.createVat());
        },
        /**
         * 导出日记账合并版
         * @param citJournalAdjustDto
         * @returns {HttpPromise}
         */
        initExportJMData: function (citJournalAdjustDto) {
            return $http.post('/citDataPreview/exportJournalMergeData', citJournalAdjustDto, apiConfig.create({ responseType: 'arraybuffer' }));
        },
        generateTb: function (projectId) {
            return $http.post('/citImport/generateTb', {projectId : projectId}, apiConfig.create());
        },
        /**
         根据条件获取试算平衡表生成版
         */
        getTbGeneVerData : function(citTbGeneVerDto){
            return $http.post('/citDataPreview/getTbGeneVerData', citTbGeneVerDto, apiConfig.createVat());
        },
        /**
         * 导出试算平衡表Mapping版
         * @param citTbGeneVerDto
         * @returns {HttpPromise}
         */
        initExportTbGeneVerData: function (citTbGeneVerDto) {
            return $http.post('/citDataPreview/exportTbGeneVerData', citTbGeneVerDto, apiConfig.create({ responseType: 'arraybuffer' }));
        },
        /**
         根据条件获取试算平衡表生成版
         */
        getTbMappingData : function(citTbMappingVerDto){
            return $http.post('/citDataPreview/getTbMappingVerData', citTbMappingVerDto, apiConfig.createVat());
        },
        /**
         * 导出试算平衡表Mapping版
         * @param citJournalAdjustDto
         * @returns {HttpPromise}
         */
        initExportTbMappingVerData: function (citTbMappingVerDto) {
            return $http.post('/citDataPreview/exportTbMappingVerData', citTbMappingVerDto, apiConfig.create({ responseType: 'arraybuffer' }));
        },

        /****************************************************************************************************/

    };
}]);