﻿// web service proxy for menu
webservices.factory('permissionService', ['$http', '$q', 'apiConfig', 'httpCacheService',
    function ($http, $q, apiConfig, httpCacheService) {
        'use strict';

        return {
            getPermissionTreeList: function (serviceId) {
                return $http.get('/permission/getlist?serviceId=' + serviceId, apiConfig.create());
            },
            getDevTreePermissionsByRoleID: function (roleID, serviceType) {
                var config = { ignoreLoadingBar: false };
                return $http.get('/permission/getIvhTreePermissionsByRoleID?roleID=' + roleID + '&serviceType=' + serviceType, apiConfig.create(config));
            },
            getDevTreePermissionsByRoleIDList: function (roldIDList, serviceType) {
                return $http.post('/permission/getIvhTreePermissionsByRoleIDList?serviceType=' + serviceType, roldIDList, apiConfig.create());
            },
            //返回DevTreeDto list
            getAllPermissions: function (serviceType) {
                return $http.get('/permission/getAllPermissions?serviceType=' + serviceType, apiConfig.create());
                //return httpCacheService.get('/permission/getAllPermissions?serviceType=' + serviceType);
            },
            getPermissionListByRoleID: function (roleID, serviceType) {
                var config = { ignoreLoadingBar: false };
                return $http.get('/permission/getPermissionListByRoleID?roleID=' + roleID + '&serviceType=' + serviceType, apiConfig.create(config));
            }
        };
    }]);