﻿// worklist web service proxy
webservices.factory('worklistService', ['$http', 'apiConfig', function ($http, apiConfig) {
    'use strict';
    return {
        simpleSearch: function (criteria) {
            var config = { params: { json: JSON.stringify(criteria) }, isBusyRequest: true };
            return $http.get('/worklist/simple/search/result', apiConfig.create(config));
        },
        advancedSearch: function (criteria) {
            var config = { isBusyRequest: true };
            return $http.post('/worklist/advanced/search/result', criteria, apiConfig.create(config));
        },
        getShortcuts: function () {
            var config = { isBusyRequest: true };
            return $http.get('/worklist/shortcuts', apiConfig.create(config));
        },
        addShortcut: function (data) {
            var config = { isBusyRequest: true };
            return $http.post('/worklist/shortcuts', data, apiConfig.create(config));
        },
        deleteShortcut: function (id) {
            var config = { isBusyRequest: true };
            return $http.delete('/worklist/shortcuts/' + id, apiConfig.create(config));
        },
        setDefaultShortcut: function (id) {
            var config = { isBusyRequest: true };
            return $http.get('/worklist/shortcuts/default/' + id, apiConfig.create(config));
        }
    };
}]);