﻿dataImpModule.controller('extractInvoiceDataController', ['$scope', '$log', '$translate', '$timeout', '$q', '$interval'
    , 'apiInterceptor', 'Upload', 'vatImportService', 'SweetAlert', 'uiGridConstants', '$uibModal'
    , 'vatSessionService', 'enums', 'vatOperationLogService'
    , 'projectService', 'vatCommonService','orgService', 'dataImportService',
    function ($scope, $log, $translate, $timeout, $q, $interval
        , apiInterceptor, Upload, vatImportService, SweetAlert, uiGridConstants, $uibModal
        , vatSessionService, enums, vatOperationLogService
        , projectService, vatCommonService , orgService,dataImportService) {
        'use strict';

        var comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年" + vatSessionService.month + "月";
        $scope.period = $scope.periodId;
        $scope.moduleid = enums.vatModuleEnum.Import_TrialBalance;
        $scope.chunkSize = 100000;
        $scope.success = false;
        $scope.showErrorTable = false;
        $scope.showInitTable = false;
        $scope.showImportTable = false;
        $scope.isSelectPeriod = true;
        $scope.isShowImportTotalBtn = true;
        $scope.projectID = vatSessionService.project.id;
        $scope.startRowNum = 2;
        $scope.validationType = 0;
        $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
        $scope.sheetInfo = { selectedSheetName: '', selectedSheetIndex: 0 };
        $scope.balanceInputList = [];
        $scope.toInputList = [];
        $scope.importEnum = { Import: 0, CoverImport: 1, AddImport: 2, ApiImport: 2 }; //导入方式
        $scope.selectedPeriod = null;
        $scope.showTotalSecondRow = false;
        $scope.maxTitleLength = constant.maxButtonTitleLength;
        $scope.companyList = [];
        $scope.checkedCompanyList = [];
        $scope.checkedCompanyCodeList = [];
        $scope.checkedCompanyTypeList = "";

        $scope.fileTypeList = constant.fileTypeList;
        $scope.checkedFileList = [];
        $scope.checkedFileCodeList = [];
        $scope.checkedFileTypeList = "";

        var date = new Date();
        var year = date.getFullYear();
        var month = date.getMonth();
        $scope.selectedDate = new Date(vatSessionService.year, vatSessionService.month - 1, 1);
        $scope.startDate = new Date(year - 20, 1, 1);
        $scope.endDate = new Date(year + 20, 1, 1);
        $scope.viewMode = 1;
        $scope.dateFormat = $translate.instant('dateFormat4YearMonth');

        $scope.importExcelFile = null;
        $scope.UploadPeriodTime = null;

        //写日志
        var logDto = {
            ID: '',
            OperationName: '',
            ModuleID: $scope.moduleid,
            OperationObject: $translate.instant('redLetterInformationTable'),
            OperationType: '',
            OperationContent: '',
            OriginalState: '',
            UpdateState: '',
            CreatorID: vatSessionService.logUser.ID,
            Comment: comment,
            IP: '',
            Period: $scope.period,
        };

        //初始化ack-pagination
        $scope.pagingOptions = {
            pageIndex: 1, //当前页码
            totalItems: 0, //总数据
            totalPages: 10, //总页数
            maxSize: 5, //分页数字的限制。
            pageSize: constant.page.pageSizeArrary[3], //每页多少条数据,100条
            pageSizeString: constant.page.pageSizeArrary[3].toString(),
            firstPage: $translate.instant('PagingFirstPage'),
            previousPage: $translate.instant('PagingPreviousPage'),
            nextPage: $translate.instant('PagingNextPage'),
            lastPage: $translate.instant('PagingLastPage'),
        };

        //初始化查询参数
        $scope.queryParams = {
            pageInfo: {
                totalCount: 0,
                pageIndex: 0,
                pageSize: 0,
                totalPage: 0,
            },
            periodId: $scope.period,
            serviceTypeId: $scope.serviceTypeId,
            projectId: $scope.projectID
        };

        //分页获取数据
        $scope.eventService = {
            refreshInvoiceDataGrid: function () {
                $log.debug("refreshInvoiceDataGrid");
            }
        };

        //导入事件
        var callInvoiceApi = function () {
            var periodStr = $scope.UploadPeriodTime;

            dataImportService.callExtractInvoiceData($scope.checkedCompanyCodeList,periodStr,$scope.checkedFileCodeList).success(function (data) {
                if (data) {

                }
            });
        };

        var getGridHeight = function () {
            if ($scope.isLoadComplete) {
                return { height: ($('.balance-ouput-grid-wrapper').height()) + "px" };
            }
            else {
                return { height: 0 + "px" };
            }
        };

        var loadImportFDStatusInfoDatagrid = function () {

            $scope.importATStatusGridOptions = {
                bindingOptions: {
                    dataSource: 'ImportFDStatusGridSource'
                },
                showBorders: true,
                columns: [{
                    dataField: "id",
                    visible: false,
                    allowHeaderFiltering: false,
                    caption: $translate.instant('id')
                }, {
                    dataField: "taxpayerIdNum",
                    width: '15%',
                    allowHeaderFiltering: false,
                    caption: $translate.instant('TaxpayerIdNum')
                }, {
                    dataField: "companyCode",
                    allowHeaderFiltering: false,
                    caption: $translate.instant('CompanyCode'),
                    width: '15%'
                }, {
                    dataField: "companyName",
                    allowHeaderFiltering: false,
                    width: '27%',
                    caption: $translate.instant('CompanyName')
                }, {
                    dataField: "periodYear",
                    allowHeaderFiltering: false,
                    width: '5%',
                    caption: $translate.instant('YearPeriod')
                }, {
                    dataField: "periodMonth",
                    allowHeaderFiltering: false,
                    width: '10%',
                    caption: $translate.instant('TMSPeriod')
                }, {
                    dataField: "periodMonth",
                    allowHeaderFiltering: false,
                    width: '5%',
                    caption: $translate.instant('Period')
                }, {
                    dataField: "recordSize",
                    allowHeaderFiltering: false,
                    width: '8%',
                    caption: $translate.instant('RecordSize')
                }, {
                    dataField: "errorMsg",
                    allowHeaderFiltering: false,
                    width: '15%',
                    caption: $translate.instant('Status')
                }
                ],
                onContentReady: function (e) {
                    $scope.accountingRateListInstance = e.component;
                    var totalCount = e.component.totalCount();
                    if (totalCount > 0) {
                        $scope.totalCount = totalCount;
                    }
                },
                loadPanel: {
                    enabled: false
                },
                selection: {
                    mode: "single"
                },
                grouping: {
                    autoExpandAll: false
                },
                allowColumnResizing: true,
                columnAutoWidth: true,
                showRowLines: true,
                showColumnLines: true,
                rowAlternationEnabled: true,  //单双行颜色
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                headerFilter: {
                    visible: false,
                    texts: {
                        cancel: $translate.instant('Cancel'),
                        ok: $translate.instant('Confirm'),
                        emptyValue: $translate.instant('Empty'),
                        selectAllText: $translate.instant('SelectAll')
                    }
                }
            };
            getInvoiceDataStatus();
        };

        var getInvoiceDataStatus = function () {
            vatImportService.displayImportLog(constant.importFileType.ExtractInvoiceData).success(function (data) {
                if (data && data.list) {
                    $scope.ImportFDStatusGridSource = data.list;
                    $scope.pagingOptions.totalItems = data.pageInfo.totalCount;
                }else {
                    SweetAlert.error($translate.instant('SystemError'));
                }
            });
        };

        //日志
        var showOperateLogPop = function () {
            $scope.isShowLog = true;
        };


        var initPagingControl = function (totalItemsCount) {
            $scope.pagingOptions.totalItems = totalItemsCount;
        };


        // 检查用户机构权限
        var checkUserOrganizationPermissionList = function () {
            var list = [];
            var userManageTemp = constant.vatPermission.dataImport.balanceSheet;
            list.push(userManageTemp.importCode);
            $scope.hasImportPermission = false;
            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasImportPermission = data[userManageTemp.importCode];
            });
        };

        //控制明细信息中删除权限
        var getUserPermission = function () {
            var list = [];
            var code = constant.vatPermission.dataImport.balanceSheet.importCode;
            list.push(code);

            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasEditPermission = data[code];
            });
        };

        var setButtonWrapStyle = function () {
            if ($scope.fileName) {
                return { width: "100%" };
            }
        };

        var setGridStyle = function () {
            if ($scope.showTotalSecondRow) {
                return { 'margin-top': '60px' }
            }
            else {
                return { 'margin-top': '55px' }
            }
        };

        var initDatePicker = function () {
            var ele1 = $("#periodDatepicker");
            ele1.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                viewMode: $scope.viewMode,
                minViewMode: $scope.viewMode,
                autoclose: true, //选中之后自动隐藏日期选择框
                clearBtn: true, //清除按钮
                todayBtn: false, //今日按钮
                format: $scope.dateFormat //日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            });
            ele1.datepicker("setDate", $scope.selectedDate);
        };


        //-------------------------------------kevin insert begin -------------------------------------------

        var initCompanyList = function () {
            orgService.getOrgListByUserId().success(function (data) {
                if (data) {
                    $scope.companyList = data;
                }
            });
        };
        var exp = {
            showDropDownButton : true,
            bindingOptions : {
                value : 'checkedCompanyCodeList',
                dataSource : 'companyList'
            }
        }
        PWC.orgManySelect($scope, $translate, exp);

        $scope.selectDataType = {
            displayExpr: 'type',
            valueExpr: 'code',
            width: function() {
                return window.innerWidth / 4.5;
            },
            bindingOptions: {
                value: 'checkedFileCodeList',
                dataSource: 'fileTypeList'
            },
            height: '30px',
            placeholder: $translate.instant('PleaseSelected'),
            showClearButton: true,
            searchEnabled: true,
            noDataText: $translate.instant('RevenueNoOrgData'),
            showSelectionControls: true,
            visible : true,
            deferRendering : false
        };

        //-------------------------------------kevin  insert end -------------------------------------------
        $scope.selectOne = function () {
            $scope.checkedCompanyList = [];
            angular.forEach($scope.companyList , function (i) {
                var index = $scope.checkedCompanyList.indexOf(i.id);
                if(i.checked && index === -1) {
                    $scope.checkedCompanyList.push(i);
                } else if (!i.checked && index !== -1){
                    $scope.checkedCompanyList.splice(index, 1);
                }
            });

            $scope.selectedAll = $scope.companyList.length === $scope.checkedCompanyList.length;

            $scope.checkedCompanyTypeList = "";
            $scope.checkedCompanyCodeList = [];
            angular.forEach($scope.checkedCompanyList,function (i) {
                $scope.checkedCompanyTypeList += i.name+";";
                $scope.checkedCompanyCodeList.push(i.id);
            });
            console.log($scope.checkedCompanyList);
        };

        $scope.selectAll = function () {
            if($scope.selectedAll) {
                $scope.selectedOne = true;
                $scope.checkedCompanyList = [];
                angular.forEach($scope.companyList, function (i, index) {
                    $scope.checkedCompanyList.push(i);
                    i.checked = true;
                })
            }else {
                $scope.selectedOne = false;
                $scope.checkedCompanyList = [];
                angular.forEach($scope.companyList, function (i, index) {
                    i.checked = false;
                })
            }
            $scope.checkedCompanyTypeList = "";
            $scope.checkedCompanyCodeList = [];
            angular.forEach($scope.checkedCompanyList,function (i) {
                $scope.checkedCompanyTypeList += i.name;
                $scope.checkedCompanyCodeList.push(i.id);
            });
            console.log($scope.checkedCompanyList);
        };

        $scope.selectOneFileType = function () {
            $scope.checkedFileList = [];
            angular.forEach($scope.fileTypeList , function (i) {
                var index = $scope.checkedFileList.indexOf(i.code);
                if(i.checked && index === -1) {
                    $scope.checkedFileList.push(i);
                } else if (!i.checked && index !== -1){
                    $scope.checkedFileList.splice(index, 1);
                }
            });

            $scope.selectedAllFileType = $scope.fileTypeList.length === $scope.checkedFileList.length;

            $scope.checkedFileTypeList = "";
            $scope.checkedFileCodeList = [];
            angular.forEach($scope.checkedFileList,function (i) {
                $scope.checkedFileTypeList += i.type+";";
                $scope.checkedFileCodeList.push(i.code);
            });
            console.log($scope.checkedFileList);
        };

        $scope.selectAllFile = function () {
            if($scope.selectedAllFileType) {
                $scope.selectedOneFile = true;
                $scope.checkedFileList = [];
                angular.forEach($scope.fileTypeList, function (i, index) {
                    $scope.checkedFileList.push(i);
                    i.checked = true;
                })
            }else {
                $scope.selectedOneFile = false;
                $scope.checkedFileList = [];
                angular.forEach($scope.fileTypeList, function (i, index) {
                    i.checked = false;
                })
            }
            $scope.checkedFileTypeList = "";
            $scope.checkedFileCodeList = [];
            angular.forEach($scope.checkedFileList,function (i) {
                $scope.checkedFileTypeList += i.type+";";
                $scope.checkedFileCodeList.push(i.code);
            });
            console.log($scope.checkedFileList);
        };

        var initParam = function () {
            $scope.callInvoiceApi = callInvoiceApi;
            $scope.initPagingControl = initPagingControl;
            $scope.setButtonWrapStyle = setButtonWrapStyle;
            $scope.getGridHeight = getGridHeight;
            $scope.showOperateLogPop = showOperateLogPop;
            $scope.setGridStyle = setGridStyle;
        };

        //刷新页面
        $scope.refreshConfigGrid = function () {
            getInvoiceDataStatus();
        };

        //开始
        (function initialize() {
            $log.debug('ImportFDController.ctor()...');
            initParam();
            checkUserOrganizationPermissionList();
            getUserPermission();
            initCompanyList();
            loadImportFDStatusInfoDatagrid();
            initDatePicker();

            $timeout(function () {
                $scope.isLoadComplete = true;
            }, 500);
        })();
    }
]);