﻿vatModule.controller('vatChartAddController', ['$log', '$scope', '$translate', '$sce', 'dashboardService',
    function ($log, $scope, $translate, $sce, dashboardService) {
        'use strict';
        $log.debug('vatChartAddController.ctor()...');
        var queryItem = function () {
            if ($scope.queryStr) {
                $scope.queryResult = _.filter($scope.systemchartDicValue, function (item) {
                    return item.systemChartName.indexOf($scope.queryStr) >= 0
                });
                if ($scope.queryResult.length === 0) {
                    $scope.queryResult.push({ "systemChartName": "NoSearchContent" });
                }
                $scope.showSearch = true;
            } else {
                $scope.showSearch = false;
            }
        };
        var loadSystemChart = function () {
            // dashboardService.getSystemChartList().success(renderTreeMenu);
            $scope.systemchartDic = {
                "增值税指标分析": [
                  {
                      "systemChartID": "9b6a0e47-8979-451e-84dc-0d91c1d25044",
                      "systemChartName": "销项税额与进项税额对比",
                      "categoryName": "增值税指标分析",
                      "dataSourceName": null,
                      "defaultChartTypeValue": null,
                      "defaultArgumentField": null,
                      "defaultValueField": null,
                      "description": "本图表展示的是销项税额，进项税额以及两者差异情况。通过对比情况，可以发现销售与采购的不平衡之处， 从而合理分配销售与采购计划。",
                      "imgUrl": "../../../app-resources/images/addchart/output vs input.JPG",
                      "sortId": 0
                  },
                  {
                      "systemChartID": "5329c267-391b-4d5d-90d7-50fbdd0ef39a",
                      "systemChartName": "申报收入分类占比",
                      "categoryName": "增值税指标分析",
                      "dataSourceName": null,
                      "defaultChartTypeValue": null,
                      "defaultArgumentField": null,
                      "defaultValueField": null,
                      "description": "通过本图表可以了解申报收入中各个分类的占比情况。",
                      "imgUrl": "../../../app-resources/images/addchart/perclass.JPG",
                      "sortId": 0
                  },
                  {
                      "systemChartID": "42c7b2c5-882e-47d7-959e-5e72d2a80990",
                      "systemChartName": "销项税税率占比",
                      "categoryName": "增值税指标分析",
                      "dataSourceName": null,
                      "defaultChartTypeValue": null,
                      "defaultArgumentField": null,
                      "defaultValueField": null,
                      "description": "本图表展示的是销项税中各个税率的占比情况。通过占比情况，可以发现是否有税率上错报的异常情况。",
                      "imgUrl": "../../../app-resources/images/addchart/perrate.JPG",
                      "sortId": 0
                  },
                  {
                      "systemChartID": "d2692a00-6332-487e-b393-7997588a5d7b",
                      "systemChartName": "申报收入与营业收入对比",
                      "categoryName": "增值税指标分析",
                      "dataSourceName": null,
                      "defaultChartTypeValue": null,
                      "defaultArgumentField": null,
                      "defaultValueField": null,
                      "description": "本图表展示的是申报收入与营业收入对比情况。通过差异额，可以发现可能存在的不报、少报销售收入、少纳税款的问题。",
                      "imgUrl": "../../../app-resources/images/addchart/samplepic.JPG",
                      "sortId": 0
                  },
                  {
                      "systemChartID": "551e3d3e-5c16-4920-a3f3-b82f4f589c8f",
                      "systemChartName": "实缴税负变动",
                      "categoryName": "增值税指标分析",
                      "dataSourceName": null,
                      "defaultChartTypeValue": null,
                      "defaultArgumentField": null,
                      "defaultValueField": null,
                      "description": "本图表反映一般纳税人的增值税实际负担情况。",
                      "imgUrl": "../../../app-resources/images/addchart/samplepic.JPG",
                      "sortId": 0
                  }
                ],
                "财务指标分析": [
                  {
                      "systemChartID": "5b8911a9-657c-4a43-93c6-91eed630d93d",
                      "systemChartName": "主营业务收入变化",
                      "categoryName": "财务指标分析",
                      "dataSourceName": null,
                      "defaultChartTypeValue": null,
                      "defaultArgumentField": null,
                      "defaultValueField": null,
                      "description": "本图表展示的是主营业务收入情况。根据主营业务收入的波动情况，分析其合理性，查证和判断企业是否存在隐匿主营业务收入的情况。",
                      "imgUrl": "../../../app-resources/images/addchart/samplepic.JPG",
                      "sortId": 0
                  },
                  {
                      "systemChartID": "7b26243d-125f-41a3-91a7-c4bcb27540e5",
                      "systemChartName": "其他应收账款变化",
                      "categoryName": "财务指标分析",
                      "dataSourceName": null,
                      "defaultChartTypeValue": null,
                      "defaultArgumentField": null,
                      "defaultValueField": null,
                      "description": "本图表展示的是期末其他应收账款情况。通过其变动情况，可以查看有无发出的货物未计入申报或虚增的销售长期挂在该科目",
                      "imgUrl": "../../../app-resources/images/addchart/samplepic.JPG",
                      "sortId": 0
                  },
                  {
                      "systemChartID": "4bc2c26d-56ef-468d-b6a5-c689b69064c8",
                      "systemChartName": "应收账款变化",
                      "categoryName": "财务指标分析",
                      "dataSourceName": null,
                      "defaultChartTypeValue": null,
                      "defaultArgumentField": null,
                      "defaultValueField": null,
                      "description": "本图表展示的是期末应收账款情况",
                      "imgUrl": "../../../app-resources/images/addchart/samplepic.JPG",
                      "sortId": 0
                  }
                ]
            };
            $scope.systemchartDicValue = [];
            _.values($scope.systemchartDic).forEach(function (item) {
                $scope.systemchartDicValue = $scope.systemchartDicValue.concat(item);
            });
        };
        var initDefault = function () {
            $scope.selectedChart = {
                chartName: $translate.instant('AddChartDefault'),
                chartDescription: $sce.trustAsHtml(
                    $translate.instant("AddChartDescF") + "<br/>" +
                    $translate.instant("AddChartDescS") + "<br/>") +
                    $translate.instant("AddChartDescT"),
                imgUrl: "../../../app-resources/images/addchart/u6.png",
                systemchartId: '000000',
                showAddButton: false
            };
        };
        var ShowAddChart = function () {
            //initDefault();
            $("#addChart").modal('show');
        };
       
        var showDetail = function (item) {
            //if ($scope.noClick) {
            //    return false;
            //}
            $scope.selectedChart.chartName = item.systemChartName;
            $scope.selectedChart.chartDescription = item.description;
            $scope.selectedChart.imgUrl = item.imgUrl;
            $scope.selectedChart.systemchartId = item.systemChartID;
            $scope.selectedChart.showAddButton = true;
        };
        (function () {
            //----query---------
            $scope.showSearch = false;
            $scope.queryItem = queryItem;
            $scope.queryResult = [];
            $scope.queryStr = '';

            //-----list-------------
            $scope.systemchartDic = {};
            $scope.systemchartDicValue = [];
            $scope.selectedChart = {};
            initDefault();
            loadSystemChart();            

            $scope.ShowAddChart = ShowAddChart;

            //---detail-------------
            $scope.showDetail = showDetail;
            
        })();
    }]);