﻿invoiceModule.controller('gdInvoicePrintController', ['$log', '$scope', '$translate', '$document', '$uibModal', '$timeout',
    'vatOutputInvoiceManageService', 'SweetAlert', 'enums', '$state', 'loginContext', 'orgService',
    function($log, $scope, $translate, $document, $uibModal, $timeout, vatOutputInvoiceManageService, SweetAlert, enums, $state, loginContext, orgService) {
        'use strict';


        var mainModule = {
            InvoiceList: [],

            PrintInvoiceList: [],

            CurrentIndex: 0,

            LimitAmount: 0,

            main: function() {
                mainModule.getBDList();

                $scope.canDelete = true;

                // mainModule.test();
                $scope.currentModel = {
                    carList: []
                };

                mainModule.init();
                $scope.previousPage = mainModule.previousPage;
                $scope.nextPage = mainModule.nextPage;

                $scope.deleteCarsComfirm = mainModule.deleteCarsComfirm;

                $scope.printAll = function() {

                    if (mainModule.PrintInvoiceList && mainModule.PrintInvoiceList.length > 0) {

                        // 从零开始打印
                        // $scope.invoiceConfirmModel = {
                        //     type: 2,
                        //     taxControlDiskID: $scope.editModel.taxControlDisk.id,
                        // };

                        // $scope.invoiceConfirmType = constant.Operation.Open;

                        // $scope.invoiceConfirmFunction = function(param) {
                        //     mainModule.printReverse(0);
                        // };

                        mainModule.printReverse(0);
                    }
                };

                $scope.cancelPrintGDInvoice = function() {
                    $state.go("outputInvoiceManage.issuedInvoiceGdView");
                };

                $scope.setSelectBuyerInfo = mainModule.setSelectBuyerInfo;
                $scope.remarkChkChanged = mainModule.remarkChkChanged;

                $scope.progress = 0;
            },

            // 重新设置选中采购
            setSelectBuyerInfo: function() {

                if ($scope.currentModel.selectBuyer && $scope.currentModel) {
                    $scope.currentModel.buyerOrganizationName = $scope.currentModel.selectBuyer.name;
                    $scope.currentModel.buyerOrganizationEnglishName = $scope.currentModel.selectBuyer.englishName;
                    $scope.currentModel.buyerOrganizationTaxId = $scope.currentModel.selectBuyer.taxPayerNumber;
                    $scope.currentModel.buyerOrganizationCode = $scope.currentModel.selectBuyer.code;
                    $scope.currentModel.vrl = $scope.currentModel.selectBuyer.vehicleroutinglocation;
                    $scope.currentModel.buyerId = $scope.currentModel.selectBuyer.id
                    $scope.currentModel.buyerAddress = $scope.currentModel.selectBuyer.manufactureAddress;
                    $scope.currentModel.buyerPhoneNo = $scope.currentModel.selectBuyer.phoneNumber;
                    $scope.currentModel.buyerBankName = $scope.currentModel.selectBuyer.bankAccountName;

                    // 此为银行账号
                    $scope.currentModel.buyerACNo = $scope.currentModel.selectBuyer.bankAccountNumber;
                }

            },

            // 获取单张发票的限制额度
            getinvoiceQuota: function() {
                vatOutputInvoiceManageService.getInvoiceQuota().success(function(result) {
                    if (result.result) {
                        var str = result.data;
                        mainModule.LimitAmount = parseInt(result.data);
                        mainModule.dataParse();
                        mainModule.setCurrentModel(0);
                    }
                });
            },

            // 获取BD列表
            getBDList: function() {
                orgService.getBdList().success(function(res) {
                    $scope.bdDataSource = res;
                    mainModule.getinvoiceQuota();
                });
            },

            // 设置 页数
            setCurrentModel: function(index) {

                if (mainModule.PrintInvoiceList && mainModule.PrintInvoiceList.length > 0) {

                    if (mainModule.PrintInvoiceList.length <= index) {
                        index = mainModule.PrintInvoiceList.length - 1;
                    }

                    if (index < 0) {
                        index = 0;
                    }

                    mainModule.CurrentIndex = index;
                    $scope.currentModel = mainModule.PrintInvoiceList[mainModule.CurrentIndex];
                } else {
                    $scope.currentModel = {
                        carList: [],
                        remarkDisabled: true,
                    };
                }

                if (mainModule.CurrentIndex < mainModule.PrintInvoiceList.length - 1) {
                    $scope.canNext = true;
                } else {
                    $scope.canNext = false;
                }

                if (mainModule.CurrentIndex > 0) {
                    $scope.canPrevious = true;
                } else {
                    $scope.canPrevious = false;
                }

                $timeout(function() {

                    $scope.gridHeight = 52 + $scope.currentModel.carList.length * 34;

                    $scope.setInvoiceGridHeight();
                }, 50);

            },
            init: function() {
                $scope.currentModel.remarkReadOnly = true;

                $scope.currentModel.remarkDisabled = true;

                $scope.dxOptions = {
                    buyerTaxIDOpt: {
                        bindingOptions: {
                            value: 'currentModel.buyerOrganizationTaxId',
                        },
                        maxLength: 50
                    },

                    categoriesOpt: {
                        bindingOptions: {
                            value: 'currentModel.category',
                        },
                        maxLength: 50
                    },

                    buyerAddressOpt: {
                        bindingOptions: {
                            value: 'currentModel.buyerAddress',
                        },
                        maxLength: 50
                    },

                    buyerPhoneNoOpt: {
                        bindingOptions: {
                            value: 'currentModel.buyerPhoneNo',
                        },
                        maxLength: 50
                    },

                    bankNameOpt: {
                        bindingOptions: {
                            value: 'currentModel.buyerBankName',
                        },
                        maxLength: 50
                    },
                    buyerACNoOpt: {
                        bindingOptions: {
                            value: 'currentModel.buyerACNo',
                        },
                        maxLength: 50
                    },

                    invocieTypeOpt: {
                        bindingOptions: {
                            value: 'currentModel.invoiceType',
                        },
                        maxLength: 50
                    },
                    remarksOpt: {
                        bindingOptions: {
                            value: 'currentModel.remarks',
                            // readOnly: 'currentModel.remarkReadOnly',
                            disabled: 'currentModel.remarkDisabled'
                        },
                        activeStateEnabled: true,
                        maxLength: 255
                    },
                    entityOptions: {
                        bindingOptions: {
                            'value': 'currentModel.buyerId',
                            'dataSource': 'bdDataSource'
                        },
                        onSelectionChanged: function(args) {
                            $scope.currentModel.selectBuyer = args.selectedItem;
                            mainModule.setSelectBuyerInfo();
                        },
                        // showClearButton: true,
                        displayExpr: 'name',
                        valueExpr: 'id'
                    },
                    receiverOpt: {
                        bindingOptions: {
                            value: 'currentModel.receiver',
                        },
                        maxLength: 50
                    },
                    reviewerOpt: {
                        bindingOptions: {
                            value: 'currentModel.reviewer',
                        },
                        maxLength: 50
                    },
                    drawerOpt: {
                        bindingOptions: {
                            value: 'currentModel.drawer',
                        },
                        maxLength: 50
                    }
                };

                mainModule.initGrid();
            },

            // 上一页
            previousPage: function() {

                if ($scope.canPrevious) {
                    mainModule.CurrentIndex--;
                    mainModule.setCurrentModel(mainModule.CurrentIndex);
                }
            },

            // 下一页
            nextPage: function() {

                if ($scope.canNext) {
                    mainModule.CurrentIndex++;
                    mainModule.setCurrentModel(mainModule.CurrentIndex);
                }

            },
            initGrid: function() {
                $scope.invoiceGridOptions = {
                    bindingOptions: {
                        dataSource: 'currentModel.carList'
                    },
                    keyExpr: "outputInvoicePrintedID",
                    selection: {
                        mode: "multiple",
                        showCheckBoxesMode: 'always'
                    },
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    showRowLines: true,
                    showColumnLines: true,
                    rowAlternationEnabled: true,
                    showBorders: true,
                    noDataText: $translate.instant('NoDataText'),
                    selectAllText: $translate.instant('SelectAll'),
                    onContentReady: function(e) {
                        $scope.invoiceGridInstance = e.component;
                    },
                    onSelectionChanged: function(data) {
                        $scope.currentModel.deleteCarKeys = data.selectedRowKeys;
                        mainModule.onselectCars(data);
                    },
                    columns: [
                        { dataField: 'name', caption: $translate.instant('ItemName') },
                        { dataField: 'vin', caption: $translate.instant('Specifications') },
                        { dataField: 'unit', caption: $translate.instant('Unit') },
                        { dataField: 'quantity', caption: $translate.instant('Quantity') },
                        { dataField: 'price', caption: $translate.instant('UnitPrice'), format: { type: 'fixedPoint', precision: 2 } },
                        { dataField: 'amount', caption: $translate.instant('Amount'), format: { type: 'fixedPoint', precision: 2 } },
                        { dataField: 'taxRateData', caption: $translate.instant('TaxRate') }, //税额合计小写
                        { dataField: 'taxAmount', caption: $translate.instant('TaxAmount'), format: { type: 'fixedPoint', precision: 2 } }, //税额
                    ],
                    summary: {
                        totalItems: [{
                                column: 'price',
                                customizeText: function(item) {
                                    return $translate.instant('TotalPrice');
                                }
                            },
                            {
                                name: 'totalAmount',
                                column: 'amount',
                                summaryType: 'sum',
                                customizeText: function(data) {
                                    return data.value.formatAmount(2);
                                }
                            },
                            {
                                name: 'totalTaxAmount',
                                column: 'taxAmount',
                                summaryType: 'sum',
                                customizeText: function(data) {
                                    return data.value.formatAmount(2);
                                }
                            }
                        ]
                    }
                };
            },

            onselectCars: function(data) {
                // if (data.selectedRowKeys && $scope.currentModel.carList && data.selectedRowKeys.length === $scope.currentModel.carList.length) {
                //     // 不能点击
                //     $scope.canDelete = false;
                // } else {
                //     $scope.canDelete = true;
                // }
            },

            test: function() {
                var str = '[{\"id\":\"2c0ed51c-dc4b-4e26-bb01-22facaf8b0e8\",\"bdFapiaoEntity\":\"2066\",\"registrationLocalName\":\"tom li\",\"organizationCode\":\"2066\",\"companyVATIDTaxID\":\"234826348762384\",\"issuranceType\":\"SalesForce\",\"category\":\"小轿车\",\"vehicleModel\":\"Model S\",\"cabinConfiguration\":\"5\",\"caseNumber\":null,\"producingPlace\":\"美国\",\"certificateNumber\":\"\",\"importCertificateNumber\":\"H34234234234\",\"ciqNumber\":\"A234234234\",\"motorNumber\":\"T937459834\",\"vin\":\"5Y837438743743\",\"subtotalforFinalPayment\":650000,\"subtotalforFinalPaymentCH\":\"陆拾伍万\",\"invoiceCode\":\"\",\"invoiceNumber\":\"\",\"salesUnitName\":\"特斯拉汽车销售服务（xx）有限公司\",\"salesUnitPhoneNumber\":\"020-37253253\",\"salesTaxPayerNumber\":\"977277237575276354\",\"salesAccount\":\"23123123123\",\"salesAddress\":null,\"salesBankName\":\"花旗银行\",\"vatRateorLevyRate\":\"\",\"taxableSubtotal\":650000,\"mainTaxAuthoritiesCode\":\"XXX市 9274387293874\",\"excludeTaxPrice\":650000,\"taxPaymentCertificateNumber\":\"123123213\",\"tonnage\":null,\"limitPassengers\":null,\"productCompanyName\":\"tesla\",\"invoiceStatus\":0,\"createTime\":\"2017-08-28T18:10:08.277+08:00\",\"updateTime\":\"2017-09-01T15:07:15.9+08:00\",\"bdStatus\":\"Normal\",\"gdBdStatus\":\"Need Red-letter\",\"gdIssuedId\":null,\"caseCollectionDate\":\"2017-08-30\",\"bdIssuedDate\":\"2017-08-28T18:10:08.277+08:00\",\"gdTotalAmount\":null,\"gdInvoiceCode\":null,\"gdInvoiceNumber\":null,\"gdIssuedDate\":null,\"buyerOrganizationCode\":null,\"reasonList\":null,\"invoiceNo\":\"\",\"invoiceCase\":\"\",\"issuedDate\":\"2017-08-28\",\"amount\":650000,\"buyer\":\"tom li\"}]';

                mainModule.InvoiceList = JSON.parse(str);
            },

            getTax: function(data) {
                var rateStr = data.vatRateorLevyRate.replace('%', '');

                var taxRateDecimal = parseInt(rateStr);
                data.taxRateDecimal = taxRateDecimal / 100;

                var tax = data.amountAdjusted * taxRateDecimal;

                tax = tax / 100;
                return tax;
            },
            dataParse: function() {
                // 数据转换
                var salesUnitNameList = _.uniq(_.pluck(mainModule.InvoiceList, 'salesUnitName'));

                var printInvoiceList = [];
                if (salesUnitNameList && salesUnitNameList.length > 0) {
                    salesUnitNameList.forEach(function(row) {
                        var list = _.filter(mainModule.InvoiceList, function(t) {

                            return t.salesUnitName === row;
                        });

                        var first = list[0];

                        var carList = [];

                        var sumAmount = 0;
                        var totalTax = 0;
                        var count = 0;

                        // 选中BD
                        var obj = _.find($scope.bdDataSource, function(row) {
                            return row.name === first.salesUnitName;
                        });
                        var item = {

                            // 右边是 BD - user的角度
                            // 而这个页面是GD - BD角度，所以 买卖双方是看情况的
                            buyerOrganizationName: first.salesUnitName,
                            buyerOrganizationEnglishName: obj ? obj.englishName : null,
                            buyerOrganizationTaxId: first.salesTaxPayerNumber,
                            category: first.category,
                            buyerId: obj ? obj.id : null,
                            officer: loginContext.userName,
                            buyerAddress: first.salesAddress,
                            buyerPhoneNo: first.salesUnitPhoneNumber,
                            buyerBankName: first.salesBankName,
                            buyerACNo: obj ? obj.bankAccountNumber : null,
                            invoiceType: $translate.instant('SpecialVATInvoice'),
                            remarks: '',
                            carList: [],
                            issuanceDate: new Date().formatDateTime('yyyy-MM-dd'),
                            totalAmount: 0,
                            buyerOrganizationCode: obj ? obj.code : null,
                            totalTaxAmount: 0,
                            vrl: obj ? obj.vehicleroutinglocation : null,
                            selectBuyer: obj,
                            remarkDisabled: true
                        };

                        list.forEach(function(l) {

                            var taxCompute = mainModule.getTax(l);
                            var addsumAmount = sumAmount + totalTax + l.amountAdjusted + taxCompute;

                            if (count === 9 || addsumAmount > mainModule.LimitAmount) {
                                // 一张发票最多8条记录，且不能超过限制额度
                                var copyItem = angular.copy(item);
                                copyItem.totalAmount = sumAmount;
                                copyItem.totalTaxAmount = totalTax;
                                copyItem.totalAllAmount = copyItem.totalAmount + copyItem.totalTaxAmount;
                                copyItem.totalAllAmountData = copyItem.totalAllAmount.formatAmount();
                                copyItem.carList = carList;
                                printInvoiceList.push(copyItem);
                                count = 0;
                                sumAmount = 0;
                                totalTax = 0;
                                carList = [];
                            }

                            sumAmount += l.amountAdjusted;
                            totalTax += taxCompute;
                            var car = {
                                outputInvoicePrintedID: l.id,
                                name: l.brandandModelNumber,
                                vin: l.vin,
                                unit: '辆',
                                quantity: 1,
                                price: l.amountAdjusted,
                                priceData: l.amountAdjusted.formatAmount(),
                                amount: l.amountAdjusted,
                                amountData: l.amountAdjusted.formatAmount(),
                                taxRateData: l.vatRateorLevyRate,
                                taxRate: l.taxRateDecimal,
                                taxAmount: taxCompute,
                                taxAmountData: taxCompute.formatAmount()
                            };

                            if (!_.isEmpty(l.manualInput)) {
                                car.manualInputReasons = l.manualInput.reasonList.join(',');
                                car.manualInputEvidenceFiles = l.manualInput.evidenceFiles;
                            }

                            carList.push(car);
                            count++;
                        });


                        if (count > 0) {
                            var copyItem = angular.copy(item);
                            copyItem.totalAmount = sumAmount;
                            copyItem.totalTaxAmount = totalTax;
                            copyItem.totalAllAmount = copyItem.totalAmount + copyItem.totalTaxAmount;
                            copyItem.totalAllAmountData = copyItem.totalAllAmount.formatAmount();
                            copyItem.carList = carList;
                            printInvoiceList.push(copyItem);
                            count = 0;
                            sumAmount = 0;
                            totalTax = 0;
                            carList = [];
                        }

                    });
                }

                mainModule.PrintInvoiceList = printInvoiceList;
            },

            // 打印
            printReverse: function(index) {
                var thisObj = mainModule.PrintInvoiceList[index];
                var length = mainModule.PrintInvoiceList.length;

                var count = index + 1;
                // 无 车辆列表的 就不打印了
                if (!thisObj.carList || thisObj.carList.length === 0) {
                    if (index !== length - 1) {

                        $scope.progress = window.PWC.round((count / mainModule.PrintInvoiceList.length) * 100, 0);
                    } else {
                        $scope.progress = 100;

                        // 打印完成， 跳转已经打印列表
                        $state.go('outputInvoiceManage.issuedInvoiceSpecial');
                        return;
                    }

                    index++;
                    if (index < mainModule.PrintInvoiceList.length) {
                        mainModule.printReverse(index);
                    }

                    return;
                }

                thisObj.detailList = angular.copy(thisObj.carList);
                thisObj.detailList.forEach(function(r) {

                    var array = [];
                    if (r.manualInputEvidenceFiles && r.manualInputEvidenceFiles.length > 0) {
                        r.manualInputEvidenceFiles.forEach(function(m) {
                            array.push(m.data);
                        });

                        // r.manualInputEvidenceFiles = JSON.stringify(array);

                        // 上传文件暂时不存，解决报错的问题
                        r.manualInputEvidenceFiles = null;
                    }

                });

                vatOutputInvoiceManageService.printGDInvoice(thisObj).success(function(ret) {

                    if (ret.result) {
                        if (index !== length - 1) {
                            $scope.progress = window.PWC.round((count / mainModule.PrintInvoiceList.length) * 100, 0);
                        } else {
                            $scope.progress = 100;

                            // 打印完成， 跳转已经打印列表
                            $state.go('outputInvoiceManage.issuedInvoiceSpecial');
                            return;
                        }
                    }

                    index++;
                    if (index < mainModule.PrintInvoiceList.length) {
                        mainModule.printReverse(index);
                    }

                });
            },

            // 删除一行车辆发票
            deleteCars: function() {
                if ($scope.currentModel && $scope.currentModel.carList) {

                    var existsCarList = _.filter($scope.currentModel.carList, function(row) {
                        return $scope.currentModel.deleteCarKeys.indexOf(row.outputInvoicePrintedID) === -1;
                    });

                    if (existsCarList == null || existsCarList.length === 0) {
                        // celine:删除一张发票中所有item后直接将该发票删除，直接跳转到下一张发票。
                        // 如仅有一张则回到GD view界面，如为最后一张则跳转到前一张

                        mainModule.PrintInvoiceList.splice(mainModule.CurrentIndex, 1);


                        if (mainModule.PrintInvoiceList.length === 0) {
                            // 跳转到选择之前
                            SweetAlert.warning($translate.instant('DeleteSuccess'));
                            $state.go("outputInvoiceManage.issuedInvoiceGdView");
                        } else {
                            if (mainModule.CurrentIndex < mainModule.PrintInvoiceList.length) {
                                mainModule.setCurrentModel(mainModule.CurrentIndex);
                            } else {
                                var tempIndex = mainModule.CurrentIndex - 1;
                                mainModule.setCurrentModel(tempIndex);
                            }

                            SweetAlert.warning($translate.instant('DeleteSuccess'));
                        }

                        return;
                    }

                    $scope.currentModel.carList = existsCarList;

                    var sumAmount = 0;

                    var totalTax = 0;
                    $scope.currentModel.carList.forEach(function(row) {
                        sumAmount += row.amount;
                        totalTax += row.taxAmount;
                    });

                    $scope.currentModel.totalAmount = sumAmount;
                    $scope.currentModel.totalTaxAmount = totalTax;

                    $scope.currentModel.totalAllAmount = $scope.currentModel.totalAmount + $scope.currentModel.totalTaxAmount;
                    $scope.currentModel.totalAllAmountData = $scope.currentModel.totalAllAmount.formatAmount();

                    SweetAlert.warning($translate.instant('DeleteSuccess'));

                }
            },
            deleteCarsComfirm: function() {

                if (!$scope.currentModel.deleteCarKeys || $scope.currentModel.deleteCarKeys.length === 0) {
                    SweetAlert.warning($translate.instant('SelectAtLeastOne'));
                    return;
                }

                SweetAlert.swal({
                        title: $translate.instant('Confirm') + " " + $translate.instant('Delete') + '?',
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        confirmButtonText: $translate.instant('Confirm'),
                        cancelButtonText: $translate.instant('Cancel'),
                        closeOnConfirm: false,
                        closeOnCancel: true
                    },
                    function(isConfirm) {
                        if (isConfirm) {
                            mainModule.deleteCars();
                        }
                    });
            },

            // 备注选项修改
            remarkChkChanged: function() {
                if ($scope.currentModel.remarkChk) {
                    $scope.currentModel.remarkReadOnly = false;
                    $scope.currentModel.remarkDisabled = false;
                } else {
                    $scope.currentModel.remarkReadOnly = true;
                    $scope.currentModel.remarkDisabled = true;
                }
            }
        };

        (function initialize() {

            $log.debug('gdInvoicePrintController.ctor()...');

            if ($state.params.invoiceList) {
                mainModule.InvoiceList = $state.params.invoiceList;
            }

            mainModule.main();

        })();
    }
])