﻿invoiceModule.controller('gdViewByVINController', ['$log', '$timeout', '$scope', '$translate', 'vatOutputInvoiceManageService',
    'SweetAlert', 'enums', 'modalAdapterService',
    function ($log, $timeout, $scope, $translate, vatOutputInvoiceManageService, SweetAlert, enums,
        modalAdapterService) {
        var dateFormat = 'yyyy-MM-dd';
        var revertStatusList = _.invert(enums.GDBDStatusEnum);
        var revertGDStatusList = _.invert(enums.GDInvoiceStatusEnum);
        $scope.pleaseSelect = $translate.instant("ChoosePlaceholder");
        $scope.pleaseInput = $translate.instant('InputPlaceholder');
        $scope.noDataText = $translate.instant('NoDataText');
        $scope.masterDetailHeader = {
            invoiceNo: $translate.instant('InvoiceNo'),
            invoiceCode: $translate.instant('InvoiceCode'),
            invoiceCaseNum: $translate.instant('InvoiceCase'),
            issuedDate: $translate.instant('IssuedDate'),
            buyer: $translate.instant('Buyer'),
            amount: $translate.instant('Amount'),
            taxAmount: $translate.instant('TaxAmount'),
            totalAmount: $translate.instant('TotalAmount'),
            gdStatus: $translate.instant('GDInvoiceStatus'),
            status: $translate.instant('VehicleStatus')
        };
        $scope.pagingOptions = {
            pageIndex: 1,  //当前页码
            totalItems: 0,  //总数据
            pageSize: constant.page.pageSizeArrary[1],  //每页多少条数据 
        };
        $scope.gdVinDetailVariables = {
            selectedTableRows: [],
            pageName: $translate.instant('GDVinView'),
            selectedGDInvoice: null

        };
        $scope.gdVinSearchEntity = {
            invoiceNumberVaule: null,
            invoiceCodeVaule: null,
            vinValue: null,
            caseNumberValue: null,
            vehicleModelValue:null

        };
        $scope.gdVinInvoice = {
            invoiceNumberOptions: {
                bindingOptions: {
                    'value': 'gdVinSearchEntity.invoiceNumberVaule'
                },
                showClearButton: true,
                placeholder: $scope.pleaseInput
            },
            invoiceCodeOptions: {
                bindingOptions: {
                    'value': 'gdVinSearchEntity.invoiceCodeVaule'
                },
                showClearButton: true,
                placeholder: $scope.pleaseInput
            },
            vinOptions: {
                bindingOptions: {
                    'value': 'gdVinSearchEntity.vinValue'
                },
                showClearButton: true,
                placeholder: $scope.pleaseInput
            },
            caseNumberOptions: {
                bindingOptions: {
                    'value': 'gdVinSearchEntity.caseNumberValue'
                },
                showClearButton: true,
                placeholder: $scope.pleaseInput
            },
            vehicleModelColonOptions: {
                bindingOptions: {
                    'value': 'gdVinSearchEntity.vehicleModelValue',
                    'dataSource': 'vehicleModelSource'
                },
                showClearButton: true,
                displayExpr: 'name',
                valueExpr: 'id',
                placeholder: $scope.pleaseSelect
            },
            gdVinGridOptions: {
                bindingOptions: {
                    dataSource: 'vinList',
                    'height': 'height'
                },
                keyExpr: 'vin',
                noDataText: $scope.noDataText,
                columnAutoWidth: true,
                showRowLines: true,
                showBorders: true,
                columnChooser: {
                    enabled: true
                },
                paging: {
                    enabled: false
                },
                loadPanel: {
                    enabled: false,
                },
                //selection: {
                //    mode: 'multiple',
                //    showCheckBoxesMode: 'always'
                //},
                //onSelectionChanged: function (e) {
                //    var selectedVin = e.selectedRowsData; 
                //    var mainTable = $('#gdVinGrid').dxDataGrid('instance');
                //    _.each(selectedVin,function(item){
                //        $scope.gdVinDetailVariables.selectedTableRows.concat(item.gdInvoices);
                //        if (mainTable.isAdaptiveDetailRowExpanded(item.vin)) {
                //            $("#vin-" + key).dxDataGrid("instance").selectAll();
                //        }
                //    });

                //},
                //onRowExpanded:function(e){
                //    var key = e.key;
                //    var mainTable = $('#gdVinGrid').dxDataGrid('instance');
                //    if (mainTable.isRowSelected(key)) {
                //        $("#vin-" + key).dxDataGrid("instance").selectAll();
                //    }
                //    //deselectRows(keys)
                //},
                columns: [
                    { dataField: 'vin', caption: $translate.instant('VIN'), allowHeaderFiltering: false },
                    { dataField: 'vehicleModel', caption: $translate.instant('VehicleModel'), allowHeaderFiltering: false },
                    { dataField: 'count', caption: $translate.instant('InvoiceCount'), allowHeaderFiltering: false },
                    {
                        dataField: 'totalTaxAmount', caption: $translate.instant('TotalTaxAmount'),
                        format: { type: 'fixedPoint', precision: 2 }, allowHeaderFiltering: false
                    },
                    {
                        dataField: 'totalEffectiveAmount', caption: $translate.instant('TotalEffectiveAmount'),
                        format: { type: 'fixedPoint', precision: 2 }, allowHeaderFiltering: false
                    },
                ],
                masterDetail: {
                    enabled: true,
                    template: "gdInvoiceTemplate"
                },
                gdView: function (gdInvoices) {
                    return {
                        dataSource: gdInvoices,
                        noDataText: $scope.noDataText,
                        columnAutoWidth: true,
                        //showRowLines: true,
                        selection: {
                            mode: 'multiple',
                            showCheckBoxesMode: 'always'
                        },
                        onSelectionChanged: function (e) {
                            var selectedVin = e.currentSelectedRowKeys;
                            var deSelectArray = e.currentDeselectedRowKeys;
                            // var select
                            if (deSelectArray.length > 0) {
                                $scope.gdVinDetailVariables.selectedTableRows = _.difference($scope.gdVinDetailVariables.selectedTableRows, deSelectArray);
                            }
                            if (selectedVin.length > 0) {
                                $scope.gdVinDetailVariables.selectedTableRows = $scope.gdVinDetailVariables.selectedTableRows.concat(selectedVin);
                            }

                        },
                        showBorders: true,
                        columns: [
                          { dataField: 'gdInvoiceNumber', caption: $scope.masterDetailHeader.invoiceNo, allowHeaderFiltering: false },
                          { dataField: 'gdInvoiceCode', caption: $scope.masterDetailHeader.invoiceCode, allowHeaderFiltering: false },
                            {
                                dataField: 'gdStatus', caption: $scope.masterDetailHeader.gdStatus,
                                calculateDisplayValue: function (rowData) {
                                    return $translate.instant(revertGDStatusList[rowData.gdStatus]);
                                }
                            },
                          { dataField: 'invoiceCase', caption: $scope.masterDetailHeader.invoiceCaseNum, allowHeaderFiltering: false },
                          {
                              dataField: 'gdIssuedDate', caption: $scope.masterDetailHeader.issuedDate,
                              dataType: 'date', format: dateFormat, allowHeaderFiltering: false
                          },
                          { dataField: 'buyerOrganizationName', caption: $scope.masterDetailHeader.buyer, allowHeaderFiltering: false },
                           {
                               dataField: 'amount', caption: $scope.masterDetailHeader.amount,
                               format: { type: 'fixedPoint', precision: 2 }, allowHeaderFiltering: false
                           },
                          {
                              dataField: 'taxAmount', caption: $scope.masterDetailHeader.taxAmount,
                              format: { type: 'fixedPoint', precision: 2 }, allowHeaderFiltering: false
                          },
                           {
                               dataField: 'totalAmount', caption: $scope.masterDetailHeader.totalAmount,
                               format: { type: 'fixedPoint', precision: 2 }, allowHeaderFiltering: false,
                               calculateDisplayValue: function (rowData) {
                                   var r = 0;
                                   if (_.isNumber(rowData.amount)) {
                                       r += rowData.amount;
                                   }
                                   if (_.isNumber(rowData.taxAmount)) {
                                       r += rowData.taxAmount;
                                   }
                                   return r;
                               }
                           },
                            {
                                dataField: 'gdBdStatus', caption: $scope.masterDetailHeader.status,
                                calculateDisplayValue: function (rowData) {
                                    //fix 12875
                                    //if ($scope.invoiceStatus === enums.GDInvoiceStatusEnum.cancelled) {
                                    //    return $translate.instant(revertStatusList[enums.GDBDStatusEnum.cancelled]);
                                    //}
                                    return $translate.instant(revertStatusList[rowData.gdBdStatus]);
                                }
                            },
                            {
                                caption: $translate.instant('Details'),
                                cellTemplate: 'detailTemplate', allowHeaderFiltering: false
                            }

                        ]

                    };

                }
            }
        };

        $scope.eventService = {
            //隐藏或者展示搜索框
            showOrHideSearchBox: function () {
                $scope.hasShowMoreSearchBox = !$scope.hasShowMoreSearchBox;
                // $scope.eventService.refreshInvoiceDataGrid();
                $timeout(function () {
                    $scope.setInvoiceGridHeight();
                }, 500);
            },
            refreshInvoiceDataGrid: function () {
                var dataDto = {
                    parameters: $scope.gdVinSearchEntity,
                    pagingInfo: $scope.pagingOptions
                }
                vatOutputInvoiceManageService.getGDDetailByVin(dataDto).success(function (response) {
                    $scope.vinList = response.list;
                    $scope.pagingOptions.totalItems = response.pageInfo.totalCount;
                }).error(function () {
                    SweetAlert.error('', $translate.instant('CommonFail'));
                });
            },
            checkBeforCancel: function () {
                var list = $scope.gdVinDetailVariables.selectedTableRows;
                //过月的不能cancel
                var currentMonth = new Date().getMonth();//1-12
                var notValidMonthCount = 0;
                var notValidStatus = true;
                var isRed = false;
                _.each(list, function (item) {
                    var m = new Date(item.gdIssuedDate).getMonth();
                    notValidMonthCount = m === currentMonth ? notValidMonthCount : ++notValidMonthCount;
                    if (item.gdStatus !== enums.GDInvoiceStatusEnum.issued) {
                        notValidStatus = false;
                    }
                    if (item.isRedInvoice) {
                        //红票不能cancel
                        isRed = true;
                    }

                });
                var result = {
                    pass: notValidMonthCount === 0 && notValidStatus && !isRed,
                    notMatchMonth: notValidMonthCount,
                    notValidStatus: notValidStatus,
                    isRedInvoice: isRed
                }
                return result;
            },
            cancelInvoiceCore: function () {
                //只用了ID
                var gdIDs = _.map($scope.gdVinDetailVariables.selectedTableRows, function (item) {
                    return { id: item.gdInvoiceID };
                });
                var dto = {
                    items: gdIDs,
                    reprint: $scope.isReprint,
                    userName: null,
                    userID: null
                }
                //need call baiwang jie kou
                vatOutputInvoiceManageService.cancelGDInvoice(dto).success(function (response) {
                    if (response.result) {
                        //_.each($scope.gdVinDetailVariables.selectedTableRows, function (item) {
                        //    item.status = enums.GDInvoiceStatusEnum.cancelled;
                        //});
                        modalAdapterService.close(constant.OutputInvoiceCancalDialog, 'gd-vin-view');
                        $scope.eventService.refreshInvoiceDataGrid();
                    }
                }).error(function () {
                    SweetAlert.error('', $translate.instant('CommonFail'));
                });
            },
            cancelFapiao: function (reprint) {
                if (!$scope.gdVinDetailVariables.selectedTableRows || $scope.gdVinDetailVariables.selectedTableRows.length < 1) {
                    SweetAlert.warning($translate.instant('SelectBdInvoiceCheck'));
                    return;
                }
                var result = $scope.eventService.checkBeforCancel();
                if (result.pass) {
                    $scope.title = reprint ? $translate.instant("CancelReprintInvoiceGDTitle") : $translate.instant("CancelInvoiceGDTitle")
                    $scope.isReprint = reprint ? reprint : false;
                    modalAdapterService.open(constant.OutputInvoiceCancalDialog, 'gd-vin-view');
                } else {
                    var message = result.notMatchMonth === 0 ? "" : $translate.instant('HasNotMatchMonth') + result.notMatchMonth + $translate.instant('Separator');
                    message = result.notValidStatus ? message : message + $translate.instant('HasNotMatchStatus');
                    message = result.isRedInvoice ? message + $translate.instant('RedInvoiceWarrning') : message;
                    SweetAlert.warning('', message);
                }

            },
            cancelandPrintFapiao: function () {
                $scope.eventService.cancelFapiao(true);
            },
            showDetail: function (rowData) {
                $scope.gdVinDetailVariables.selectedGDInvoice = rowData;
                $scope.$broadcast("openGDDetailDialog");
            },
            redLetterCheck: function () {
                var pass = true;
                var message = "";
                //已经red letter的不能操作
                var limitedRecords = _.where($scope.gdVinDetailVariables.selectedTableRows, { gdBdStatus: enums.GDBDStatusEnum.redLettered });
                if (limitedRecords && limitedRecords.length > 0) {
                    pass = false;
                    message += $translate.instant('HasRedVehicleWarrning');
                }
                limitedRecords = _.where($scope.gdVinDetailVariables.selectedTableRows, { isRedInvoice: true });
                if (limitedRecords && limitedRecords.length > 0) {
                    pass = false;
                    message += $translate.instant('RedInvoiceWarrning');
                }
                limitedRecords = _.where($scope.gdVinDetailVariables.selectedTableRows, { gdStatus: enums.GDInvoiceStatusEnum.redLettered });
                if (limitedRecords && limitedRecords.length > 0) {
                    pass = false;
                    message += $translate.instant('HasRedInvoiceWarrning');
                }
                limitedRecords = _.where($scope.gdVinDetailVariables.selectedTableRows, { gdStatus: enums.GDInvoiceStatusEnum.cancelled });
                if (limitedRecords && limitedRecords.length > 0) {
                    pass = false;
                    message += $translate.instant('HasCancelInvoiceWarrning');
                }

                //红冲-除去当月往前退180，如果开票日期在这里面的就可以红冲
                var currentDate = new Date();
                var currentMonth = currentDate.getMonth();
                var endDate = new Date(currentDate.getFullYear(), currentMonth, 1);
                var one_day = 1000 * 60 * 60 * 24;
                var startDate = new Date(endDate.getTime() - one_day * 180);
               
                limitedRecords = _.filter($scope.gdVinDetailVariables.selectedTableRows, function (item) {
                    var iDate = new Date(item.gdIssuedDate);
                    return iDate < startDate || iDate > endDate
                });
                if (limitedRecords && limitedRecords.length > 0) {
                    pass = false;
                    message += $translate.instant('HasUnmatchRedTimeLimit');
                }
                return {
                    pass: pass,
                    msg: message
                }
            },
            confirmRedLetter: function () {
                if (!$scope.gdVinDetailVariables.selectedTableRows || $scope.gdVinDetailVariables.selectedTableRows.length < 1) {
                    SweetAlert.warning($translate.instant('SelectBdInvoiceCheck'));
                    return;
                }
                var result = $scope.eventService.redLetterCheck();
                if (result.pass)
                {
                    SweetAlert.swal({
                        title: $translate.instant('RedLetterConfirmTitle'),
                        text: $translate.instant('RedLetterConfirmText'),
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        confirmButtonText: $translate.instant('Confirm'),
                        cancelButtonText: $translate.instant('ENCancel'),
                        closeOnConfirm: true,
                        closeOnCancel: true
                    },
                    function (isConfirm) {
                        if (isConfirm) {
                            $scope.eventService.toRedLetter();
                        }
                    });
                }
                else
                {
                    SweetAlert.warning('', result.msg);
                }

            },
            toRedLetter: function () {
                //只用了detail id
                var detailIDs = _.pluck($scope.gdVinDetailVariables.selectedTableRows, 'detialID');
                //to connect baiwang interface and update the printed ID GB-BD status
                vatOutputInvoiceManageService.gdMultipleRedLetter(detailIDs).success(function (response) {
                    if (response.result) {
                        //refresh table
                        $scope.eventService.refreshInvoiceDataGrid();
                    } else {
                        SweetAlert.error('', $translate.instant(response.resultMsg));
                    }

                }).error(function () {
                    SweetAlert.error('', $translate.instant('CommonFail'));
                });
            },
            getQueryBasic: function () {
                vatOutputInvoiceManageService.getModelSeries().success(function (response) {
                    if (response && response.length > 0) {
                        $scope.vehicleModelSource = _.map(response, function (item) {
                            return { id: item, name: item };
                        });
                    }
                }).error(function (err) {
                    SweetAlert.error('', $translate.instant('CommonFail'));
                });
            }
        };

        (function () {
            $scope.eventService.getQueryBasic();
            $scope.eventService.refreshInvoiceDataGrid();
            $scope.hasShowMoreSearchBox = false;
            //设置表格高度
            $timeout(function () {
                $scope.setInvoiceGridHeight();
            }, 500);
           
        })();


    }]);