﻿/// <reference path="output-invoice-imported.ctrl.js" />
invoiceModule.controller('outputInvoiceImportedController', ['$scope', '$log', '$document', '$uibModal', 'SweetAlert', '$translate', '$q',
    'apiInterceptor', '$interval', 'region', '$timeout', '$location', '$state', 'InvoiceManageService', 'vatOutputInvoiceManageService',
    'loginContext', 'orgService', 'messagebox','Upload',
    function($scope, $log, $document, $uibModal, SweetAlert, $translate, $q, apiInterceptor, $interval, region, $timeout, $location, $state,
        InvoiceManageService, vatOutputInvoiceManageService, loginContext, orgService, messagebox, Upload) {
        'use strict';

        var parentSelector = '.invoice-manage-main';
        var issuedStatus = [
            { displayName: 'Normal', value: 1 },
            { displayName: 'Occupied', value: 2 },
            { displayName: 'Duplicated', value: 3 },
            { displayName: 'Prohibit', value: 4 },
            { displayName: 'On Hold', value: 5 }
        ];
        $scope.pleaseSelect = $translate.instant("ChoosePlaceholder");
        $scope.pleaseInput = $translate.instant('InputPlaceholder');
        $scope.currentVRL = '';

        //分页的设置
        $scope.pagingOptions = {
            pageIndex: 1, //当前页码
            totalItems: 0, //总数据
            pageSize: constant.page.pageSizeArrary[1], //每页多少条数据 
        };

        $scope.searchEntity = {};
        $scope.datagrid = {};
        $scope.hasShowMoreSearchBox = false;

        var uploadIndexPageUrl = "/invoiceManagement/main/uploadIndex";

        $scope.translated = {
            NoData: $translate.instant('NoDataText'),
            pleaseSelect: $translate.instant("ChoosePlaceholder"),
            pleaseInput: $translate.instant('InputPlaceholder'),
        };

        //显示手工导入数据历史记录
        $scope.openTriggerSyncHistory = function(event) {
            var mouseX = event.clientX;
            var mouseY = event.clientY;
            if (mouseX && mouseY) {
                $('#history-pop-container').css({ 'top': mouseY - 32 + 'px', 'left': mouseX - 180 + 'px' }).show(500);
            }
        };

        //关闭手工导入数据历史记录
        $scope.closeTriggerSyncHistory = function() {
            $('#history-pop-container').hide(500);
        };

        //toggle手工导入数据历史记录
        $scope.toggleTriggerSyncHistory = function() {
            var mouseX = event.clientX;
            var mouseY = event.clientY;
            if (mouseX && mouseY) {
                $('#history-pop-container').css({ 'top': mouseY - 32 + 'px', 'left': mouseX - 180 + 'px' }).toggle(500);
            }
        };

        $scope.toggleSearchContent = function() {
            if ($("#toggle-search-tr").css("display") == "none") {
                $(".hide-search-btn").addClass("fa-angle-up").html('&nbsp;&nbsp;Collapse');
                $(".hide-search-btn").removeClass("fa-angle-down");
            } else {
                $(".hide-search-btn").addClass("fa-angle-down").html('&nbsp;&nbsp;Expand');
                $(".hide-search-btn").removeClass("fa-angle-up");
            }
            $("#toggle-search-tr").toggle(200);
            $timeout(function() {
                $scope.setInvoiceGridHeight();
            }, 300);
        };

        //获取手工导入数据历史记录
        var getSyncHistory = function() {
            vatOutputInvoiceManageService.getSyncHistory().success(function(result) {
                if (result && result.length > 0) {
                    _.each(result, function(item) {
                        item.createTime = (new Date(item.createTime)).dateTimeToString('yyyyMMdd hh:mm');
                    });
                    $scope.syncHistoryList = result;
                }
            });
        };

        //模态框
        var modalService = {
            modalInstance: null,
            open: function() {
                var parentElem = parentSelector ? angular.element($document[0].querySelector(parentSelector)) : undefined;

                var modalInstance = $uibModal.open({
                    animation: true,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'template.html', //模板
                    windowClass: 'pupupModal', //弹框页面的css
                    scope: $scope,
                    appendTo: parentElem,
                });

                thisModalService.modalInstance = modalInstance;
            },
            close: function(result) {
                if (thisModalService.modalInstance) {
                    thisModalService.modalInstance.close(result);
                }
            },
            cancel: function() {
                if (thisModalService.modalInstance) {
                    thisModalService.modalInstance.dismiss('cancel');
                }
            }
        };


        //获取数据服务
        var getService = {
            //查询的数据源准备
            //getInvoiceFilterBasicData: function () {
            //    var deferred = $q.defer();
            //    InvoiceManageService.getInvoiceFilterBasicData().success(function (data) {
            //        if (data) {
            //            if (!$scope.searchFilterOptions) {
            //                $scope.searchFilterOptions = {};
            //            }
            //            // console.log('data' + JSON.stringify(data));
            //            $scope.searchFilterOptions = {
            //                invoiceStatusList: memoryService.translateEnumValue(data.invoiceStatusList),
            //                invoiceEntityList: memoryService.translateEnumValue(data.invoiceEntityList),
            //                invoiceTypeList: memoryService.translateEnumValue(data.invoiceTypeList),
            //                invoiceSourceList: memoryService.translateEnumValue(data.invoiceSourceList),
            //                invoiceUploadTypeList: memoryService.translateEnumValue(data.invoiceUploadTypeList),
            //            };

            //            deferred.resolve(data);
            //        }
            //    });
            //    return deferred.promise;
            //},

            //筛选invoice list
            getInputInvoiceList: function() {
                var deferred = $q.defer();

                var importedParams = {
                    QueryParam: $scope.searchEntity,
                    PagingParam: $scope.pagingOptions,
                };

                var HoldedStatus = $translate.instant('HoldedStatus');

                vatOutputInvoiceManageService.getOutputImportedList(importedParams).success(function(data) {
                    if (data) {
                        $scope.pagingOptions.totalItems = data.pageInfo && data.pageInfo.totalCount;
                        var dataList = data.list;
                        angular.forEach(dataList, function(item, index) {
                            if (item.lastModifiedBy) {
                                var d = window.PWC.parseFromLocalTimeString(item.lastModifiedBy);
                                item.lastModifiedBy = d.formatDateTime('yyyy-MM-dd');
                            }

                            if (item.statusName === 'Holded') {
                                item.statusName = HoldedStatus;
                            }

                            if (index === 0) {
                                $scope.currentVRL = item.vehicleroutinglocation;
                            }
                        });
                        //if ($scope.hideValidation) {
                        //    dataList = _.filter(dataList, function (item) {
                        //        return item.validationInforamtion.length<1;
                        //    });
                        //}
                        $scope.importedGridDataSource = dataList;

                        deferred.resolve(data);
                    };
                });
                return deferred.promise;
            },

        };

        //更新数据服务
        var updateService = {
            //发票识别,手动识别
            invoiceManualRecognize: function(invoiceIDList) {
                var deferred = $q.defer();
                InvoiceManageService.invoiceManualRecognize(invoiceIDList).success(function(data) {
                    if (data) {
                        deferred.resolve(data);
                    }
                });
                return deferred.promise;
            },
            //发票验真
            invoiceExamination: function(invoiceIDList) {
                var deferred = $q.defer();
                InvoiceManageService.invoiceExamination(invoiceIDList).success(function(data) {
                    if (data) {
                        deferred.resolve(data);
                    }
                });
                return deferred.promise;
            },
            //变更发票状态
            updateInvoiceStatus: function(invoiceIDList, invoiceStatusID) {
                var deferred = $q.defer();
                InvoiceManageService.updateInvoiceStatus(invoiceIDList, invoiceStatusID).success(function(data) {
                    if (data) {
                        deferred.resolve(data);
                    }
                });
                return deferred.promise;
            },
        };

        //内部处理
        var memoryService = {
            repaintInvoiceGrid: function() {
                $scope.setInvoiceGridHeight();
            },
            //翻译查询的数据源
            translateEnumValue: function(data) {
                if (!data || data.length == 0) return null;

                data.forEach(function(item) {
                    item.value = $translate.instant(item.value);
                });
                return data;
            },
            //分页下拉
            populatePagingSelection: function() {
                var pagingSelection = [];
                var pageArray = constant.page.pageSizeArrary;
                for (var i = 0; i < pageArray.length; i++) {
                    var selection = { id: pageArray[i], value: pageArray[i] };
                    pagingSelection.push(selection);
                }
                $scope.pagingOptions.pagingSelection = pagingSelection;
            }
        };

        //button的事件
        $scope.eventService = {
            //显示Mapping 界面
            showMapping: function() {
                $scope.isOpenMapping = true;
            },
            // 挂起
            holdVechicle: function() {

                var list = $scope.datagrid.selectedItems;
                if (!list || list.length === 0) {
                    SweetAlert.warning($translate.instant('SelectBdInvoiceCheck'));
                    return;
                };

                var msg = $translate.instant('Confirm') + ' ' + $translate.instant('HoldVechicle') + '?';

                messagebox.confirm(msg, '', constant.teslaConfirmClassName).then(function(isConfirm) {
                    if (isConfirm) {
                        var list = $scope.datagrid.selectedItems;
                        vatOutputInvoiceManageService.holdRecordList(list).success(function(ret) {
                            if (ret.result) {
                                SweetAlert.success($translate.instant('SaveSuccess'));
                                loadGridData();
                            } else {
                                swal($translate.instant('SaveFail'), $translate.instant('SaveFail'), 'warning');
                            }
                        });
                    }
                });

                //SweetAlert.swal({
                //    title: $translate.instant('Confirm') + ' ' + $translate.instant('HoldVechicle') + '?',
                //    text: $translate.instant('Confirm') + ' ' + $translate.instant('HoldVechicle'),
                //    type: "warning",
                //    showCancelButton: true,
                //    confirmButtonColor: '#B4122A',
                //    confirmButtonText: $translate.instant('Confirm'),
                //    cancelButtonText: $translate.instant('Cancel'),
                //    closeOnConfirm: false,
                //    closeOnCancel: true
                //},
                //    function (isConfirm) {
                //        if (isConfirm) {
                //            var list = $scope.datagrid.selectedItems;


                //            vatOutputInvoiceManageService.holdRecordList(list).success(function (ret) {
                //                if (ret.result) {
                //                    SweetAlert.success($translate.instant('SaveSuccess'));
                //                    loadGridData();
                //                } else {
                //                    swal($translate.instant('SaveFail'), $translate.instant('SaveFail'), 'warning');
                //                }
                //            });
                //        }

                //    });

            },

            //Trigger Issuance (Preview) 进入待开票状态
            triggerIssuance: function() {
                var list = $scope.datagrid.selectedItems;

                if (!list || list.length === 0) {
                    SweetAlert.warning("", $translate.instant('SelectBdInvoiceCheck'));

                    return;
                };
                //task12471 基于salesforce的验证没有通过的数据不能完成具体的发票开具
                var notValidDatas = _.filter(list, function(record) {
                    return record.validationInforamtion !== null && record.validationInforamtion.length > 0
                });
                if (notValidDatas && notValidDatas.length > 0) {
                    //include validation fail record
                    SweetAlert.warning("", $translate.instant('ValidationFailToPrint'));
                    return;
                }
                //fix bug 13216,on hold 状态不能开票
                notValidDatas = _.where(list, { recordStatus: issuedStatus[4].value });
                if (notValidDatas && notValidDatas.length > 0) {
                    //include validation fail record
                    SweetAlert.warning("", $translate.instant('NotTriggerIssurance'));
                    return;
                }
                //当需要开票的车辆为Prohibit状态时，需要发送红冲提示邮件
                //_.each(list, function(data) {
                //    if (data.statusName === "Prohibit") {
                //        vatOutputInvoiceManageService.sendEmail(data.vin,data.id);
                //        vatOutputInvoiceManageService.pendingForApprovalGdBdInvoice(data.vin);
                //    }
                //});

                vatOutputInvoiceManageService.triggerIssuanceList(list).success(function(ret) {
                    if (ret.result) {
                        SweetAlert.success($translate.instant('SaveSuccess'));
                        //loadGridData();
                        $state.go('outputInvoiceManage.outputInvoiceEdit');
                    } else if (ret.resultMsg) {
                        var baseMsg = 'AddModelMappingFirst';
                        var idx = ret.resultMsg.indexOf(baseMsg + ':');
                        if (idx >= 0) {
                            var msg = ret.resultMsg.substring(idx + baseMsg.length + 1);
                            ret.resultMsg = $translate.instant(baseMsg).replace('{0}', msg);
                        } else {
                            ret.resultMsg = $translate.instant(ret.resultMsg);
                        }

                        swal(ret.resultMsg, '', 'warning');
                    } else {
                        swal($translate.instant('SaveFail'), $translate.instant('SaveFail'), 'warning');
                    }
                });
            },

            fapiaoByManual: function() {
                $scope.invoiceOperateType = constant.Operation.Add;
                $scope.invoiceModel = {};
            },

            // 解挂
            unholdVechicle: function() {

                var list = $scope.datagrid.selectedItems;

                var myList = list;
                if (list && list.length > 0) {
                    myList = _.filter(list, function(row) {
                        return row.updateBy && row.updateBy.toLowerCase() === thisConstant.userId;
                    });
                }

                if (!myList || myList.length === 0) {
                    swal($translate.instant('SaveFail'), $translate.instant('OnlyUnholdMySelf'), 'warning');
                }

                vatOutputInvoiceManageService.unHoldRecordByList(myList).success(function(ret) {
                    if (ret.result) {
                        SweetAlert.success($translate.instant('SaveSuccess'));
                        loadGridData();
                    } else {
                        swal($translate.instant('SaveFail'), $translate.instant('SaveFail'), 'warning');
                    }
                });
            },

            showReassignModal: function() {
                showReassignModal();
            }

        };

        $scope.issuedPrompt = {
            instance: null,
            open: function() {
                var modalInstance = $uibModal.open({
                    animation: true,
                    backdrop: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'issuedStatus-prompt.html',
                    windowClass: 'to-be-issued-prompt',
                    scope: $scope,
                    appendTo: $('.output-invoice-imported')
                });
                $scope.issuedPrompt.instance = modalInstance;

            },
            cancel: function() {
                $scope.issuedPrompt.instance.dismiss('cancel');
            }
        };

        var showReassignModal = function() {
            $scope.reassignItems = $scope.datagrid.selectedItems;
            if (!$scope.reassignItems || $scope.reassignItems.length === 0) {

                SweetAlert.warning($translate.instant('SelectBdInvoiceCheck'));
                // swal($translate.instant('SelectWarning'), $translate.instant('AtleastOne'), 'warning');
                return;
            }
           var notValidDatas = _.where($scope.reassignItems, { recordStatus: issuedStatus[4].value });
            if (notValidDatas && notValidDatas.length > 0) {
                //include validation fail record
                SweetAlert.warning("", $translate.instant('OnHoldToPrint'));
                return;
            }
            //Controller
            var reassignMappingController = function($scope) {
                $log.debug($scope);

                orgService.getBdList().success(function(data) {
                    var allBDVRL = _.filter(_.uniq(_.pluck(data, 'vehicleroutinglocation')),
                        function(item) { return item !== null && item !== $scope.currentVRL });

                    $scope.BDListOptions = {
                        items: allBDVRL,
                        searchEnabled: false,
                        bindingOptions: {
                            value: 'newVRL',
                        },
                        placeholder: $scope.pleaseSelect
                    };

                });

                //保存新分配数据VRL
                $scope.saveReassignWindow = function() {
                    //$log.log($scope.reassignItems);


                    var reasonIdList = [];
                   
                    if (!$scope.newVRL || !$scope.reasonList || !$scope.reassignItems) {
                        swal($translate.instant('SelectWarning'), $translate.instant('ReAssignWarning'), 'warning');
                        return;
                    }
                    //排除false
                    var selectReason = _.filter($scope.reasonList, function (item) { return item });
                    if (!selectReason || selectReason.length < 1) {
                        swal($translate.instant('SelectWarning'), $translate.instant('ReAssignWarning'), 'warning');
                        return;
                    }
                    for (var obj in $scope.reasonList) {
                        reasonIdList.push(parseInt(obj));
                    }
                    if (reasonIdList.length === 0) {
                        swal($translate.instant('SelectWarning'), $translate.instant('AtleastOneReason'), 'warning');
                        return;
                    }

                    var param = { selectedCaseList: $scope.reassignItems, newVRLName: $scope.newVRL, reasonList: reasonIdList };

                    vatOutputInvoiceManageService.reassignCase(param).success(function(data) {
                        loadGridData();
                        $scope.$dismiss({ $value: 'cancel' });
                    });
                };

                //关闭弹窗口
                $scope.hidePopPanel = function() {
                    $scope.$dismiss({ $value: 'cancel' });
                };

            };

            var reassignModalInstance = $uibModal.open({
                ariaLabelledBy: 'modal-title',
                ariaDescribedBy: 'modal-body',
                backdrop: 'static',
                templateUrl: 'reassign-modal-template.html',
                controller: reassignMappingController,
                windowClass: 'data-table',
                appendTo: angular.element($document[0].querySelector('#reassign-modal-template')),
                scope: $scope,

            });
        };

        //搜索框的处理
        $scope.buttonService = {
            //查询数据
            searchByFilter: function() {
                loadGridData();
            },
            //手工拉取数据
            manualUpdateSFData: function() {
                var deferred = $q.defer();
                //添加手工拉取数据的历史记录，并刷新历史记录
                var data = {
                    createBy: loginContext.userName
                };
                vatOutputInvoiceManageService.saveSyncHistory(data).then(function() {
                    getSyncHistory();
                });

                vatOutputInvoiceManageService.manualUpdateSFData().success(function(data) {
                    deferred.resolve({ data: data });
                }).error(function() {
                    deferred.reject("Data Loading Error");
                });
                return deferred.promise;
            }
        }

        //分页里面的处理
        $scope.pagingSercice = {
            setPage: function(pageNo) {

                //$scope.currentPage = pageNo;
            },
            //分页的时候改变数字
            pageIndexChanging: function() {
                if ($scope.pagingOptions.pageIndex > $scope.pagingOptions.totalPages) {
                    $scope.pagingOptions.pageIndex = $scope.pagingOptions.totalPages;
                }

                $log.log('Page changed to: ' + $scope.pagingOptions.pageIndex);
                getService.getInputInvoiceList();
            },

            //每页显示的数据下拉改变
            pageSizeSelectionChanged: function() {
                $scope.pagingOptions.pageSize = parseInt($scope.pagingOptions.pageSizeString);
                getService.getInputInvoiceList();
            },
        };

        var loadGridData = function() {
            getService.getInputInvoiceList($scope.searchEntity);
            $timeout(function() {
                memoryService.repaintInvoiceGrid();
            }, 50);
        }

        $scope.$watch('importedGridDataSource', function () {
            $timeout(function () {
                if ($scope.uploadVins && $scope.importedGridDataSource) {
                    var gridInstance = $('#invoiceGridContainer').dxDataGrid('instance');//$('#invoiceGridContainer').dxDataGrid('instance');
                    var selectedInvoices = _.filter($scope.importedGridDataSource, function (item) {
                        return $scope.uploadVins.indexOf(item.vin) >= 0;
                    });
                    var selectedKeys = _.pluck(selectedInvoices, 'id');
                    gridInstance.selectRows(selectedKeys, true);
                }
            }, 200);

        });

        //初始化invoice datagrid 树
        var InitInvoiceGrid = function() {

            var setHoldStatus = function(data) {
                // 没有选的时候默认值
                $scope.showUnHoldBtn = false;
                $scope.showHoldBtn = true;
                if (data.selectedRowsData && data.selectedRowsData.length > 0) {
                    var list = _.uniq(_.pluck(data.selectedRowsData, 'recordStatus'));

                    var dataList = data.selectedRowsData;

                    var holdList = _.filter(dataList, function(row) {
                        // body...
                        return row.updateBy && row.updateBy.toLowerCase() === thisConstant.userId && row.recordStatus === constant.CaseImportedStatusEnum.Holded;
                    });

                    var unholdList = _.filter(dataList, function(row) {
                        // body...
                        return  row.recordStatus != constant.CaseImportedStatusEnum.Holded;
                    });

                    if (holdList.length === dataList.length ){
                        // 纯挂起的，则可以解挂
                        $scope.showUnHoldBtn = true;
                        $scope.showHoldBtn = false;
                    } else if (unholdList.length === dataList.length) {

                        // 纯解挂的，可以挂起
                         $scope.showUnHoldBtn = false;
                        $scope.showHoldBtn = true;
                    } else{
                        // 其他情况，不可以挂起也不可以解挂
                        $scope.showUnHoldBtn = false;
                        $scope.showHoldBtn = false;
                    }
                }

               
            };
            var validationMessage = function(validation) {
                var message = '';
                _.each(validation, function(item) {
                    //first split 换行符
                    var rowArray = item.validMessage.split("\n");
                    _.each(rowArray, function(row) {
                        if (row) {
                            var mArray = row.split(constant.splitValidation);
                            _.each(mArray, function(item) {
                                message += $translate.instant(item) + ' ';
                            });
                            message += ","
                        }
                    });

                });
                return message.substring(0, message.length - 1);
            };
            var valiationDisplay = function(cellInfo, field) {
                var val = cellInfo.value == null || cellInfo.value == '' ? '&nbsp;' : cellInfo.value;
                var htmlStr = ' <div><span>' + val + '</span></div>';
                if (cellInfo.data.validationInforamtion) {
                    var validation = _.where(cellInfo.data.validationInforamtion, { fieldName: field });
                    if (validation && validation.length > 0) {
                        var msg = validationMessage(validation);
                        htmlStr = '<div class="noteTips" title="' + msg + '"><span>' + val + '</span></div>';
                    }
                }
                return htmlStr;
            };
            $scope.invoiceGridOptions = {
                bindingOptions: {
                    dataSource: 'importedGridDataSource',
                    height: 'dataGridHeight'
                },
                // keyExpr: "ID",
                selection: {
                    mode: "multiple",
                    showCheckBoxesMode: 'always'
                },
                loadPanel: {
                    enabled: false,
                },
                paging: {
                    enabled: false,
                },
                keyExpr: 'id',
                allowColumnResizing: true,
                columnAutoWidth: true,
                showRowLines: true,
                showColumnLines: true,
                // rowAlternationEnabled: true,
                showBorders: true,
                allowColumnReordering: true,
                columnChooser: {
                    enabled: true,
                    emptyPanelText: $translate.instant('DragInformation'),

                },
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                onContentReady: function (e) {
                    $scope.invoiceGridInstance = e.component;
                },
                onCellPrepared: function(e) {
                    //已退票,已失效不显示checkbox
                    if (e.rowType === "data" & e.column.command === 'select' &&
                        (e.data.status === constant.inputInvoice.statusType.InvoiceHasRefund.id ||
                            e.data.status === constant.inputInvoice.statusType.InvoiceHasExpired.id)) {
                        e.cellElement.find('.dx-select-checkbox').hide();
                        //e.cellElement.find('.dx-select-checkbox').addClass('dx-state-disabled');
                        e.cellElement.off();
                    }

                    if (e.rowType === "data") {
                        var data = e.data;

                        if (data.recordStatus === constant.CaseImportedStatusEnum.Holded) {
                            // 挂起状态， 设置为灰色的行, 不可选
                            e.cellElement.css('background-color', '#F2F2F2');
                            // e.cellElement.find('.dx-select-checkbox').hide();
                            // e.cellElement.off();
                        }
                    }
                },
                onSelectionChanged: function(data) {
                    $scope.datagrid.selectedItems = data.selectedRowsData;
                    setHoldStatus(data);
                    //$scope.selectedItemIDs = _.pluck(data.selectedRowsData, 'id');
                    //$scope.selectedPlaceholder = data.selectedRowsData.length;
                    //$scope.disabled = !$scope.selectedItemIDs.length;
                },
                columns: [
                    { dataField: 'vehicleroutinglocation', caption: $translate.instant('VRL'), fixed: true },
                    {
                        dataField: 'vin',
                        caption: $translate.instant('VinNumber'),
                        cellTemplate: function(cellElement, cellInfo) {
                            var htmlStr = valiationDisplay(cellInfo, 'VIN');
                            cellElement.append(htmlStr);
                        }
                    },
                    {
                        dataField: 'caseNumber',
                        caption: $translate.instant('CaseNumber'),
                        cellTemplate: function(cellElement, cellInfo) {
                            var htmlStr = valiationDisplay(cellInfo, 'CaseNumber');
                            cellElement.append(htmlStr);
                        }
                    },
                    { dataField: 'modelSeries', caption: $translate.instant('ModelSeries') },
                    { dataField: 'cabinConfiguration', caption: $translate.instant('CabinConfig'), visible: false }, //发票来源
                    // make and model
                    { dataField: 'updateByUserName', caption: $translate.instant('LastModifiedBy'), visible: false },
                    { dataField: 'lastModifiedBy', caption: $translate.instant('LastModifiedDate'), visible: false },
                    {
                        dataField: 'subtotalforFinalPayment',
                        caption: $translate.instant('SubtotalForFinalPayment'),
                        cellTemplate: function(container, options) {
                            try {
                                var data = options.data;
                                var divEle = $('<div/>');
                                var spanEle = $('<span/>');

                                if (data.isRelatedBD && data.bdSubtotalforFinalPayment === null) {
                                    spanEle.addClass('span-is-related-bd cursor-pointer')
                                        .text(data.subtotalforFinalPayment.formatAmount(2))
                                        .on('click', function() {
                                            // 变价
                                            $scope.updateIsRelatedBDPrice(data);
                                        });

                                } else {
                                    spanEle.text(data.subtotalforFinalPayment.formatAmount(2));
                                }

                                if (data.validationInforamtion) {
                                    var validation = _.findWhere(data.validationInforamtion, { fieldName: 'SubtotalforFinalPayment' });
                                    if (validation && validation.length > 0) {
                                        var msg = validationMessage(validation);
                                        divEle.addClass('noteTips').attr('title', msg);
                                    }
                                }
                                spanEle.appendTo(divEle);
                                divEle.appendTo(container);
                            } catch (e) {
                                $log.error(e);
                            }
                        }
                    },
                    {
                        dataField: 'registrationLocalName',
                        caption: $translate.instant('RegistrationLocalName'),
                        visible: true,
                        cellTemplate: function(cellElement, cellInfo) {
                            var htmlStr = valiationDisplay(cellInfo, 'RegistrationLocalName');
                            cellElement.append(htmlStr);
                        }
                    },
                    {
                        dataField: 'driverLicense',
                        caption: $translate.instant('DriverLicense'),
                        cellTemplate: function(cellElement, cellInfo) {
                            var htmlStr = valiationDisplay(cellInfo, 'DriverLicense');
                            cellElement.append(htmlStr);
                        }
                    }, //税额合计小写
                    {
                        dataField: 'organizationCode',
                        caption: $translate.instant('OrganizationCode'),
                        visible: false,
                        cellTemplate: function(cellElement, cellInfo) {
                            var htmlStr = valiationDisplay(cellInfo, 'OrganizationCode');
                            cellElement.append(htmlStr);
                        }
                    },
                    {
                        dataField: 'companyVATIDTaxID',
                        caption: $translate.instant('CompanyTaxID'),
                        cellTemplate: function(cellElement, cellInfo) {
                            var htmlStr = valiationDisplay(cellInfo, 'CompanyVATIDTaxID');
                            cellElement.append(htmlStr);
                        }
                    }, //税额
                    {
                        dataField: 'importCertificateNumber',
                        caption: $translate.instant('ImportCertificate'),
                        visible: false,
                        cellTemplate: function(cellElement, cellInfo) {
                            var htmlStr = valiationDisplay(cellInfo, 'ImportCertificateNumber');
                            cellElement.append(htmlStr);
                        }
                    }, //开票日期
                    { dataField: 'motorNumber', caption: $translate.instant('MotorNumber'), visible: false },
                    {
                        dataField: 'ciqNumber',
                        caption: $translate.instant('CIQNumber'),
                        visible: false,
                        cellTemplate: function(cellElement, cellInfo) {
                            var htmlStr = valiationDisplay(cellInfo, 'CIQNumber');
                            cellElement.append(htmlStr);
                        }

                    },
                    { dataField: 'deliveryStatus', caption: $translate.instant('DeliveryStatus'), visible: false },
                    {
                        dataField: 'statusName',
                        caption: $translate.instant('toBeIssuedStatus'),
                        cellTemplate: function(container, options) {
                            try {
                                var data = options.data;
                                //Prohibit
                                if (data.statusName === "Prohibit") {
                                    $("<span class='glyphicon glyphicon-remove cursor-pointer' />").appendTo(container);
                                    $("<span class='cursor-pointer' />")
                                        .text(data.statusName)
                                        .on('click', function() {
                                            $scope.issusedStatus = {
                                                selectedVIN: data.vin,
                                                icon: '<i  class="glyphicon glyphicon-remove" ></i>',
                                                status: data.statusName,
                                                information: $translate.instant('ProhibitInformation'),
                                                BDInformation: $translate.instant('BDColon') + " " + data.otherBDs
                                            };
                                            $scope.issuedPrompt.open();
                                        })
                                        .appendTo(container);
                                    //Opccupied
                                } else if (data.statusName === "Occupied") {
                                    $("<span class='glyphicon glyphicon-alert cursor-pointer' />").appendTo(container);
                                    $("<span class='cursor-pointer' />")
                                        .text(data.statusName)
                                        .on('click', function() {
                                            // $scope.updateIsRelatedBDPrice(data);
                                            $scope.issusedStatus = {
                                                selectedVIN: data.vin,
                                                icon: '<i  class="glyphicon glyphicon-alert" ></i>',
                                                status: data.statusName,
                                                information: $translate.instant('OccupiedInformation'),
                                                BDInformation: $translate.instant('OtherBDColon') + " " + data.otherBDs
                                            };
                                            $scope.issuedPrompt.open();
                                        })
                                        .appendTo(container);
                                    //Duplicated
                                } else if (data.statusName === "Duplicated") {
                                    $("<span class='glyphicon glyphicon-ban-circle cursor-pointer' />").appendTo(container);
                                    $("<span class='cursor-pointer'/>")
                                        .text(data.statusName)
                                        .on('click', function() {
                                            //  $scope.updateIsRelatedBDPrice(data);
                                            $scope.issusedStatus = {
                                                selectedVIN: data.vin,
                                                icon: '<i  class="glyphicon glyphicon-ban-circle" ></i>',
                                                status: data.statusName,
                                                information: $translate.instant('DuplicatedInformation'),
                                                BDInformation: $translate.instant('BDColon') + " " + data.otherBDs
                                            };
                                            $scope.issuedPrompt.open();
                                        })
                                        .appendTo(container);
                                } else {
                                    $("<span class='glyphicon glyphicon-ban-circle cursor-pointer visibility-hidden-before' />").appendTo(container);
                                    $("<span class='cursor-pointer'/>")
                                        .text('' + data.statusName)
                                        .appendTo(container);
                                }
                            } catch (e) {
                                $log.error(e);
                            }
                        }
                    },
                    { dataField: 'otherItem1', caption: $translate.instant('otherItem1'), visible: false },
                    { dataField: 'otherItem1Amount', caption: $translate.instant('otherItem1Amount'), visible: false },
                    { dataField: 'otherItem2', caption: $translate.instant('otherItem2'), visible: false },
                    { dataField: 'otherItem2Amount', caption: $translate.instant('otherItem2Amount'), visible: false },
                    { dataField: 'otherItem3', caption: $translate.instant('otherItem3'), visible: false },
                    { dataField: 'otherItem3Amount', caption: $translate.instant('otherItem3Amount'), visible: false },
                    /*
                    {
                        dataField: 'id', caption: $translate.instant('Action'),
                        cellTemplate: function (container, options) {
                            try {
                                var data = options.data;
                                $('<a href="javascript:void(0)" />')
                                    .text('Re-assign')
                                    .on('click', function () {
                                    //  $scope.updateIsRelatedBDPrice(data);
                                    showReassignModal(data.id);
                                    })
                                    .appendTo(container);
                            } catch (e) {
                                $log.error(e);
                            }
                        }
                    },      
                    */
                    { dataField: 'commissionableStore', caption: $translate.instant('CommissionableStore'), visible: false },
                    { dataField: 'financePartner', caption: $translate.instant('FinancePartner'), visible: false },

                ],
                masterDetail: {
                    enabled: true,
                    template: "paymentDetail"
                },
                paymentDetailOptions: function(payments) {
                    return {
                        dataSource: payments,
                        columnAutoWidth: true,
                        showBorders: true,
                        width: '92%',
                        height: '95%',
                        noDataText: $translate.instant('NoDataText'),
                        columns: [{
                                dataField: 'paymentAmount',
                                caption: $translate.instant('PaymentAmount'),
                                format: { type: 'fixedPoint', precision: 2 }
                            },
                            {
                                dataField: 'paymentDate',
                                caption: $translate.instant('PaymentDate'),
                                dataType: 'date',
                                format: 'yyyy-MM-dd'
                            },
                            { dataField: 'payorName', caption: $translate.instant('PayorName') }
                            /*
                            {
                                dataField: 'UpdateTime',
                                dataType: 'date',
                                format: 'yyyy-MM-dd',
                                caption: $translate.instant('UpdateTime')
                            }
                            */
                        ]
                    }
                }
            };
        };

        var initDatePicker = function() {
            $('#lastModifiedDateDatePicker').datepicker({
                language: region
            });
        };

        //搜索框初始化
        var initSearchBoxContorls = function() {

            var valueExpr = "id";
            var displayExpr = "value";

            var isShowClearButton = true;

            $scope.searchEntityOptions = {
                //1. VIN
                txtVINBoxOptions: {
                    bindingOptions: {
                        value: 'searchEntity.VIN',
                    },
                    placeholder: $scope.pleaseInput,
                    showClearButton: isShowClearButton,
                    //onValueChanged: function (data) {
                    //$log.debug(data);
                    //loadGridData();
                    //}
                },

                //2. Last Modified Date
                dateLastModifiedDataOptions: {
                    type: 'date',
                    width: 230,
                    bindingOptions: {
                        value: 'searchEntity.LastModifiedData',
                    },
                    placeholder: $scope.pleaseSelect,
                    showClearButton: isShowClearButton,
                    displayFormat: 'yyyy-MM-dd',
                    //onValueChanged: function (data) {
                    //$log.debug(data);
                    //loadGridData();
                    //}
                },

                //3. txtCommissionableStoreBoxOptions
                txtCommissionableStoreBoxOptions: {
                    bindingOptions: {
                        value: 'searchEntity.commissionableStore',
                    },
                    placeholder: $scope.pleaseInput,
                    showClearButton: isShowClearButton,
                    //onValueChanged: function (data) {
                    //$log.debug(data);
                    //loadGridData();
                    //}
                },

                //4. txtFinancePartnerOptions
                txtFinancePartnerOptions: {
                    bindingOptions: {
                        value: 'searchEntity.financePartner',
                    },
                    placeholder: $scope.pleaseInput,
                    showClearButton: isShowClearButton,
                    //onValueChanged: function (data) {
                    //$log.debug(data);
                    //loadGridData();
                    //}
                },

                //5. txtCaseNumberBoxOptions
                txtCaseNumberBoxOptions: {
                    bindingOptions: {
                        value: 'searchEntity.caseNumber',
                    },
                    placeholder: $scope.pleaseInput,
                    showClearButton: isShowClearButton,
                    //onValueChanged: function (data) {
                    //$log.debug(data);
                    //loadGridData();
                    //}
                },

                //5. issuedStatus
                selectIssuedStatusOptions: {
                    placeholder: $scope.pleaseSelect,
                    showClearButton: isShowClearButton,
                    showDropButton: true,
                    multiline: false,
                    showSelectionControls: true,
                    applyValueMode: "useButtons",
                    displayExpr: 'displayName',
                    valueExpr: 'value',
                    width: "100%",
                    bindingOptions: {
                        value: 'searchEntity.issuedStatus'
                    },
                    items: issuedStatus
                },

            };
        };

        //初始化控件
        var initControls = function() {
            initDatePicker();
            initSearchBoxContorls();
            InitInvoiceGrid();
        };

        //初始化数据
        var initData = function() {
            $scope.searchFilterOptions = {};
            memoryService.populatePagingSelection();
            loadGridData();
            // getService.getInvoiceFilterBasicData();
        };

        // 修改变价
        $scope.updateIsRelatedBDPrice = function(data) {
            $scope.invoicePriceOperateType = constant.Operation.Edit;
            $scope.invoicePriceModel = {
                subtotalforFinalPayment: data.subtotalforFinalPayment,
                bdSubtotalforFinalPayment: '',
                id: data.id
            };
        };

        // 价格变动后，重新刷新数据
        $scope.closePriceModal = function(param) {
            $scope.buttonService.searchByFilter();
        };


        $scope.closeInvoiceModal = function(param) {
            $scope.buttonService.searchByFilter();
        };

        $scope.displayOrShowValidation = function() {
            //if ($scope.searchEntity.hideValidation) {
            //    $scope.importedGridDataSource = _.filter($scope.importedGridDataSource, function (item) {
            //        return item.validationInforamtion.length<1;
            //    });
            //}
            getService.getInputInvoiceList();

        };
        // 本页面的常量
        var thisConstant = {
            userId: null,
        };

        //Upload Vin file define -->start
        var resumable = true;
        $scope.chunkSize = 500 * 1024;
        $scope.uploadOption = {};
        $scope.uploadOption.uploadFiles = [];
        $scope.uploadVins = "";
        $scope.$watch('uploadOption.uploadFiles', function (newValue, oldValue) {
            if (newValue && newValue !== oldValue) {
                uploadfile($scope.uploadOption.uploadFiles);
            }
        });

        //执行上传文件操作。
        var uploadfile = function (file) {
            $("#busy-indicator-container").show();
            if (file) {
                var uploadSuccessCallBack = function (data) {
                    var result = data;
                };

                var uploadSuccess = function (result) {
                    //根据上传的vin勾选发票
                    if (result) {
                        SweetAlert.success($translate.instant('UploadVinSuccess'));
                        $scope.uploadVins = result.data;
                        $scope.searchEntity.uploadVins = result.data;
                        var gridInstance = $('#invoiceGridContainer').dxDataGrid('instance');
                        var selectedInvoices = _.filter($scope.importedGridDataSource, function (item) {
                            return result.data.indexOf(item.vin) >= 0;
                        });
                        var selectedKeys = _.pluck(selectedInvoices, 'id');
                        gridInstance.selectRows(selectedKeys, true);
                    }
                    $("#busy-indicator-container").hide();
                };

                if (!file.$error) {
                    var tempFileName = PWC.newGuid() + '.dat';
                    var token = $('input[name="__RequestVerificationToken"]').val();
                    Upload.upload({
                        url: apiInterceptor.webApiHostUrl + '/outputInvoicePrinted/uploadVinFile',
                        data: {
                            cancel: false,
                            filename: file.name,
                            tempFileName: tempFileName,
                            file: file,
                            period: $scope.period
                        },
                        resumeChunkSize: resumable ? $scope.chunkSize : null,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken()
                        },
                        __RequestVerificationToken: token,
                        withCredentials: true
                    }).then(uploadSuccess, uploadSuccessCallBack);
                }
            }
        };//Upload Vin file define -->end


        (function initialize() {
            $log.debug('invoiceManageMainController.ctor()...');

            thisConstant.userId = loginContext.userId.toLowerCase();
            $scope.showUnHoldBtn = false;
            $scope.showHoldBtn = true;
            $scope.isOpenMapping = false;
            $scope.hideValidation = false;
            initControls();
            initData();
            getSyncHistory();
        })();
    }
]);