﻿vatModule.controller('VatPreviewInvoiceDataController', ['$rootScope','$scope', '$log','$filter', '$translate', '$timeout', 'SweetAlert', '$q', 'uiGridConstants', '$interval', 'vatPreviewService', 'browserService', 'vatSessionService', 'region', 'enums', 'vatExportService',
    function ($rootScope,$scope, $log,$filter, $translate, $timeout, SweetAlert, $q, uiGridConstants, $interval, vatPreviewService, browserService, vatSessionService, region, enums, vatExportService) {
        'use strict';

        $scope.startDate = new Date(vatSessionService.project.year, 0, 1);
        $scope.endDate = new Date(vatSessionService.project.year, 11, 31);
        $scope.dateFormat = $translate.instant('dateFormat4YearMonthDay');
        $scope.startMonth = vatSessionService.month;
        $scope.endMonth = vatSessionService.month;
        $scope.totalMoneyAmount = 0;
        $scope.totalTaxAmount = 0;
        $scope.pageSize = constant.vatPagesize;

        var minDate = [1, vatSessionService.project.year];
        // var minDate = moment().startOf('month').subtract(0, 'months');
        var maxDate = [12, vatSessionService.project.year];
        var setDate = [
            [vatSessionService.month, vatSessionService.project.year],
            [vatSessionService.month, vatSessionService.project.year]];

        $scope.monthList = [$translate.instant('Month01'),
                            $translate.instant('Month02'),
                            $translate.instant('Month03'),
                            $translate.instant('Month04'),
                            $translate.instant('Month05'),
                            $translate.instant('Month06'),
                            $translate.instant('Month07'),
                            $translate.instant('Month08'),
                            $translate.instant('Month09'),
                            $translate.instant('Month10'),
                            $translate.instant('Month11'),
                            $translate.instant('Month12')
        ];

        //初始化期间
        var initPeriods = function () {
            var curMonth = new Date().getMonth() + 1;


            $scope.queryParams = {
                pageInfo: {},
                periodStart: '',
                periodEnd: '',
                certificationDateStart: null,
                certificationDateEnd: null,
                invoiceCode: '',
                invoiceNumber: '',
                sellerTaxNumber: '',
                amountStart: null,
                amountEnd: null,
                invoiceType: null,
                taxAmountStart: null,
                taxAmountEnd: null,
                certificationStatus: null
            };
        };

        /*var countTotal = function(){
            $scope.queryParams.pageInfo = {
                totalCount: -1,
                pageIndex: 1,
                pageSize: -1,
                totalPage: 0,
            };
            vatPreviewService.queryInputInvoiceAllList($scope.queryParams).success(function (data) {
                if (data) {
                    var totalMoneyAmount = 0;
                    var totalTaxAmount = 0;
                    _.each(data, function (x) {
                        totalMoneyAmount = totalMoneyAmount + parseFloat(x.hjje.replace(/,/g, ""));
                        totalTaxAmount = totalTaxAmount + parseFloat(x.hjse.replace(/,/g, ""));
                    })
                    $scope.totalMoneyAmount = totalMoneyAmount.toLocaleString();
                    $scope.totalTaxAmount = totalTaxAmount.toLocaleString();
                }
            });
        };*/

        //从数据库中load数据
        var loadInvoiceDataItemDataFromDB = function (pageIndex) {
            initInvoiceDataItemPagination();

            $scope.curInvoiceDataItemPage = pageIndex;

            //初始化查询信息
            $scope.queryParams.pageInfo = {
                totalCount: $scope.queryInvoiceDataResult.pageInfo.totalCount,
                pageIndex: pageIndex,
                pageSize: $scope.queryInvoiceDataResult.pageInfo.pageSize,
                totalPage: 0
            };
            $scope.queryParams.orgId = vatSessionService.project.organizationID;
            $scope.getDataFromDatabase($scope.queryParams);
        };

        $scope.getDataFromDatabase = function (queryParams){
            vatPreviewService.getIDDataForDisplay(queryParams).success(function (data) {
                if (data) {
                    // minDate = data.
                    var index = 1;
                    data.list.forEach(function (v) {
                        v.index = index++;
                    });
                    $scope.gridOptions.data = data.list;
                    $scope.queryInvoiceDataResult.pageInfo = data;
                    computeInvoiceDataItemPage();
                    /*$scope.ledgerName = data.list[0].ledgerName;
                    $scope.currencyCode = data.list[0].ledgerCurrencyCode;
                    $scope.status = data.list[0].status;
                    $scope.importDate = $filter('date')(data.list[0].date, "yyyy-MM-dd hh:mm:ss");*/
                }
            });
        };

        //点击任意一页加载数据事件
        var loadInvoiceDataDataByPage = function (pageIndex) {
            loadInvoiceDataItemDataFromDB(pageIndex);
        };

        //计算页数，创建分页栏
        var computeInvoiceDataItemPage = function () {

            if ($scope.queryInvoiceDataResult.pageInfo && $scope.queryInvoiceDataResult.pageInfo.total > 0) {

                var totalPage = parseInt($scope.queryInvoiceDataResult.pageInfo.total / $scope.pageSize);
                totalPage = $scope.queryInvoiceDataResult.pageInfo.totalCount % $scope.pageSize == 0 ? totalPage : totalPage + 1;

                //计算本页记录数
                if ($scope.queryInvoiceDataResult.pageInfo.pageNum === totalPage) {
                    $scope.curPageItemCount = $scope.queryInvoiceDataResult.pageInfo.total % $scope.pageSize;
                }
                else {
                    $scope.curPageItemCount = $scope.pageSize;
                }

                $scope.queryInvoiceDataResult.pageInfo.totalPage = totalPage;

                var createPage = $("#totalInvoicePage").createPage({
                    pageCount: totalPage,
                    current: $scope.curInvoiceDataItemPage,
                    backFn: function (p) {
                        //单击回调方法，p是当前页码
                        loadInvoiceDataDataByPage(p);
                    }
                });

                $('#totalInvoicePage').css('display', 'inline-block');
            } else {
                //如果查询结果为0，则直接设置本页记录数为0
                $scope.curPageItemCount = 0;
                var createPage = $("#totalInvoicePage").createPage({
                    pageCount: 0,
                    current: $scope.curInvoiceDataItemPage,
                    backFn: function (p) {
                        //单击回调方法，p是当前页码
                        loadInvoiceDataDataByPage(p);
                    }
                });

                $('#totalInvoicePage').css('display', 'inline-block');
            }
        };

        //初始化分页信息
        var initInvoiceDataItemPagination = function () {
            $scope.queryInvoiceDataResult = {
                list: [],
                pageInfo: {
                    totalCount: -1,
                    pageIndex: 1,
                    pageSize: constant.pagesize,
                    totalPage: 0
                }
            };

            $scope.curInvoiceDataItemPage = 1;
        };

        //去掉所有的查询条件，重新load数据
        var doDataFilterReset = function () {
            $scope.queryParams = {
                pageInfo: {},
                periodStart: '',
                periodEnd: '',
                certificationDateStart: null,
                certificationDateEnd: null,
                invoiceCode: '',
                invoiceNumber: '',
                sellerTaxNumber: '',
                amountStart: null,
                amountEnd: null,
                invoiceType: null,
                taxAmountStart: null,
                taxAmountEnd: null,
                certificationStatus: null
            };
            $scope.criteriaList = [];
            $scope.queryParams.periodStart = $scope.startMonth;
            $scope.queryParams.periodEnd = $scope.endMonth;
            // countTotal();
            loadInvoiceDataItemDataFromDB(1);
            $('.filter-button').popover("hide");
        };

        //在popover打开时执行事件
        var showPopover = function () {
            $timeout(function () {
                initDatePickers();
            }, 500);
        };

        //初始化时间控件
        var initDatePickers = function () {
            //认证开始时间
            var ele1 = $("#certificationDateStart");
            ele1.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                language: region,
                autoclose: true,//选中之后自动隐藏日期选择框
                clearBtn: true,//清除按钮
                todayBtn: false,//今日按钮
                format: $scope.dateFormat//日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            });
            ele1.datepicker("setDate", $scope.queryParams.certificationDateStart);
            //认证结束时间
            var ele2 = $("#certificationDateEnd");
            ele2.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                language: region,
                autoclose: true,//选中之后自动隐藏日期选择框
                clearBtn: true,//清除按钮
                todayBtn: false,//今日按钮
                format: $scope.dateFormat//日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            })
            ele2.datepicker("setDate", $scope.queryParams.certificationDateEnd);


            //初始化已选择的发票类型和认证结果
            $scope.InvoiceType.selected = _.find($scope.invoiceTypeList, function (v) {
                return v.id == $scope.queryParams.invoiceType;
            })

            $scope.CertificationStatus.selected = _.find($scope.cetificationResultList, function (v) {
                return v.id == $scope.queryParams.certificationStatus;
            })
        };

        (function initialize() {
            $log.debug('VatPreviewInputInvoiceController.ctor()...');
            $('#input-invoice-period-picker').focus(function () {
                $('.filter-button').popover("hide");
            });
            //初始化month-picker
            $('#input-invoice-period-picker').rangePicker({
                minDate: minDate,
                maxDate: maxDate,
                setDate: setDate,
                months: $scope.monthList,//['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
                ConfirmBtnText: $translate.instant('Confirm'),
                CancelBtnText: $translate.instant('ButtonCancel')
            })
             .on('datePicker.done', function (e, result) {
                 //开始月份
                 var startMonth = result[0][0];
                 //结束月份
                 var endMonth = result[1][0];
                 $scope.startMonth = startMonth;
                 $scope.endMonth = endMonth;

                 $scope.queryParams.periodStart = startMonth;
                 $scope.queryParams.periodEnd = endMonth;
                 $scope.queryParams.orgId = vatSessionService.project.organizationID;
                 // countTotal();
                 loadInvoiceDataItemDataFromDB(1);
             });

            var downloadID = function () {
                var localDate=$filter('date')(new  Date(), 'yyyyMMddHHmmss');
                var fileName= constant.exportExcelFileName.invoiceData + localDate;
                vatPreviewService.initExportIDData($scope.queryParams,fileName).then(function (data) {
                });
            };

            $scope.gridOptions = {
                rowHeight: constant.UIGrid.rowHeight,
                selectionRowHeaderWidth: constant.UIGrid.rowHeight,
                virtualizationThreshold: 50,//默认加载50条数据，避免在数据展示时，只显示前面4条
                enableSorting: false,
                enableColumnMenus: false,
                columnDefs: [
                 { name: $translate.instant('ProjectName'),  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.projectName}}<span></div>' },
                 // { name: $translate.instant('InvoiceQJ'), width: '8%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.periodID}}<span></div>' },
                 { name: $translate.instant('IDTotalAmount'),   cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.totalAmount }}<span></div>' },
                 { name: $translate.instant('Amount1'),   cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.amount1}}</span></div>' },
                 { name: $translate.instant('Amount2'),   cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.amount2}}</span></div>' },
                 { name: $translate.instant('Amount3'),   cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.amount3}}</span></div>' },
                 { name: $translate.instant('Amount4'),   cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.amount4}}</span></div>' },
                 { name: $translate.instant('Amount5'),  cellTemplate: '<div class="ui-grid-cell-contents "><span>{{row.entity.amount5}}</span></div>' },
                 { name: $translate.instant('Amount6'),  cellTemplate: '<div class="ui-grid-cell-contents "><span>{{row.entity.amount6}}</span></div>' },
                 { name: $translate.instant('Amount7'),   cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.amount7 }}</span></div>' },
                 { name: $translate.instant('OtherAmount'),  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.otherAmount}}</span></div>' }
                 ]
            };

            $scope.doDataFilterReset = doDataFilterReset;
            $scope.showPopover = showPopover;
            $scope.downloadID = downloadID;

            initPeriods();
            initInvoiceDataItemPagination();
            //初始化查询条件-期间范围
            $scope.queryParams.periodStart = vatSessionService.year * 100 + vatSessionService.month;
            $scope.queryParams.periodEnd = vatSessionService.year * 100 + vatSessionService.month;
            $scope.queryParams.orgId = vatSessionService.project.organizationID;
            if($rootScope.currentLanguage === 'en-us'){
                $('.periodInput')[0].style.left = "250px";
            }else{
                $('.periodInput')[0].style.left = "130px";
            }
            loadInvoiceDataItemDataFromDB(1);

        })();
    }
]);




