/*
Navicat MySQL Data Transfer

Source Server         : atms_mysql_didi_bak
Source Server Version : 50725
Source Host           : 10.158.230.16:3306
Source Database       : tax_admin_didi

Target Server Type    : MYSQL
Target Server Version : 50725
File Encoding         : 65001

Date: 2019-02-27 13:58:54
*/

SET FOREIGN_KEY_CHECKS=0;

-- ----------------------------
-- Table structure for account_mapping
-- ----------------------------
DROP TABLE IF EXISTS `account_mapping`;
CREATE TABLE `account_mapping` (
  `id` varchar(128) NOT NULL,
  `enterprise_account_code` varchar(50) NOT NULL DEFAULT '',
  `standard_account_code` varchar(50) NOT NULL DEFAULT '',
  `enterprise_account_set_id` varchar(128) NOT NULL DEFAULT '',
  `organization_id` varchar(128) NOT NULL DEFAULT '',
  `industry_id` varchar(128) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `account_mapping_organization_id_IDX` (`organization_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for account_mapping_keyword
-- ----------------------------
DROP TABLE IF EXISTS `account_mapping_keyword`;
CREATE TABLE `account_mapping_keyword` (
  `id` varchar(128) NOT NULL,
  `standard_code` varchar(50) NOT NULL DEFAULT '',
  `full_name` varchar(200) NOT NULL DEFAULT '',
  `rule_type` int(11) NOT NULL DEFAULT '0',
  `industry_id` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime DEFAULT NULL,
  `update_time` datetime DEFAULT NULL,
  `is_active` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for account_mapping_manual
-- ----------------------------
DROP TABLE IF EXISTS `account_mapping_manual`;
CREATE TABLE `account_mapping_manual` (
  `id` varchar(128) NOT NULL,
  `standard_code` varchar(50) NOT NULL DEFAULT '',
  `full_name` varchar(200) NOT NULL DEFAULT '',
  `enterprise_account_set_id` varchar(128) NOT NULL DEFAULT '',
  `organization_id` varchar(128) NOT NULL DEFAULT '',
  `industry_id` varchar(128) NOT NULL DEFAULT '',
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_by` varchar(128) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `account_mapping_manual_organization_id_IDX` (`organization_id`,`enterprise_account_set_id`,`industry_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for ACT_EVT_LOG
-- ----------------------------
DROP TABLE IF EXISTS `ACT_EVT_LOG`;
CREATE TABLE `ACT_EVT_LOG` (
  `LOG_NR_` bigint(20) NOT NULL AUTO_INCREMENT,
  `TYPE_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `PROC_DEF_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `PROC_INST_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `EXECUTION_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `TASK_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `TIME_STAMP_` timestamp(3) NOT NULL DEFAULT CURRENT_TIMESTAMP(3) ON UPDATE CURRENT_TIMESTAMP(3),
  `USER_ID_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `DATA_` longblob,
  `LOCK_OWNER_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `LOCK_TIME_` timestamp(3) NULL DEFAULT NULL,
  `IS_PROCESSED_` tinyint(4) DEFAULT '0',
  PRIMARY KEY (`LOG_NR_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_GE_BYTEARRAY
-- ----------------------------
DROP TABLE IF EXISTS `ACT_GE_BYTEARRAY`;
CREATE TABLE `ACT_GE_BYTEARRAY` (
  `ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `REV_` int(11) DEFAULT NULL,
  `NAME_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `DEPLOYMENT_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `BYTES_` longblob,
  `GENERATED_` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`ID_`),
  KEY `ACT_FK_BYTEARR_DEPL` (`DEPLOYMENT_ID_`),
  CONSTRAINT `ACT_FK_BYTEARR_DEPL` FOREIGN KEY (`DEPLOYMENT_ID_`) REFERENCES `ACT_RE_DEPLOYMENT` (`ID_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_GE_PROPERTY
-- ----------------------------
DROP TABLE IF EXISTS `ACT_GE_PROPERTY`;
CREATE TABLE `ACT_GE_PROPERTY` (
  `NAME_` varchar(64) COLLATE utf8_bin NOT NULL,
  `VALUE_` varchar(300) COLLATE utf8_bin DEFAULT NULL,
  `REV_` int(11) DEFAULT NULL,
  PRIMARY KEY (`NAME_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_HI_ACTINST
-- ----------------------------
DROP TABLE IF EXISTS `ACT_HI_ACTINST`;
CREATE TABLE `ACT_HI_ACTINST` (
  `ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `PROC_DEF_ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `PROC_INST_ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `EXECUTION_ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `ACT_ID_` varchar(255) COLLATE utf8_bin NOT NULL,
  `TASK_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `CALL_PROC_INST_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `ACT_NAME_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `ACT_TYPE_` varchar(255) COLLATE utf8_bin NOT NULL,
  `ASSIGNEE_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `START_TIME_` datetime(3) NOT NULL,
  `END_TIME_` datetime(3) DEFAULT NULL,
  `DURATION_` bigint(20) DEFAULT NULL,
  `TENANT_ID_` varchar(255) COLLATE utf8_bin DEFAULT '',
  PRIMARY KEY (`ID_`),
  KEY `ACT_IDX_HI_ACT_INST_START` (`START_TIME_`),
  KEY `ACT_IDX_HI_ACT_INST_END` (`END_TIME_`),
  KEY `ACT_IDX_HI_ACT_INST_PROCINST` (`PROC_INST_ID_`,`ACT_ID_`),
  KEY `ACT_IDX_HI_ACT_INST_EXEC` (`EXECUTION_ID_`,`ACT_ID_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_HI_ATTACHMENT
-- ----------------------------
DROP TABLE IF EXISTS `ACT_HI_ATTACHMENT`;
CREATE TABLE `ACT_HI_ATTACHMENT` (
  `ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `REV_` int(11) DEFAULT NULL,
  `USER_ID_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `NAME_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `DESCRIPTION_` varchar(4000) COLLATE utf8_bin DEFAULT NULL,
  `TYPE_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `TASK_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `PROC_INST_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `URL_` varchar(4000) COLLATE utf8_bin DEFAULT NULL,
  `CONTENT_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `TIME_` datetime(3) DEFAULT NULL,
  PRIMARY KEY (`ID_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_HI_COMMENT
-- ----------------------------
DROP TABLE IF EXISTS `ACT_HI_COMMENT`;
CREATE TABLE `ACT_HI_COMMENT` (
  `ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `TYPE_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `TIME_` datetime(3) NOT NULL,
  `USER_ID_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `TASK_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `PROC_INST_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `ACTION_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `MESSAGE_` varchar(4000) COLLATE utf8_bin DEFAULT NULL,
  `FULL_MSG_` longblob,
  PRIMARY KEY (`ID_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_HI_DETAIL
-- ----------------------------
DROP TABLE IF EXISTS `ACT_HI_DETAIL`;
CREATE TABLE `ACT_HI_DETAIL` (
  `ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `TYPE_` varchar(255) COLLATE utf8_bin NOT NULL,
  `PROC_INST_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `EXECUTION_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `TASK_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `ACT_INST_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `NAME_` varchar(255) COLLATE utf8_bin NOT NULL,
  `VAR_TYPE_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `REV_` int(11) DEFAULT NULL,
  `TIME_` datetime(3) NOT NULL,
  `BYTEARRAY_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `DOUBLE_` double DEFAULT NULL,
  `LONG_` bigint(20) DEFAULT NULL,
  `TEXT_` varchar(4000) COLLATE utf8_bin DEFAULT NULL,
  `TEXT2_` varchar(4000) COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`ID_`),
  KEY `ACT_IDX_HI_DETAIL_PROC_INST` (`PROC_INST_ID_`),
  KEY `ACT_IDX_HI_DETAIL_ACT_INST` (`ACT_INST_ID_`),
  KEY `ACT_IDX_HI_DETAIL_TIME` (`TIME_`),
  KEY `ACT_IDX_HI_DETAIL_NAME` (`NAME_`),
  KEY `ACT_IDX_HI_DETAIL_TASK_ID` (`TASK_ID_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_HI_IDENTITYLINK
-- ----------------------------
DROP TABLE IF EXISTS `ACT_HI_IDENTITYLINK`;
CREATE TABLE `ACT_HI_IDENTITYLINK` (
  `ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `GROUP_ID_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `TYPE_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `USER_ID_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `TASK_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `PROC_INST_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`ID_`),
  KEY `ACT_IDX_HI_IDENT_LNK_USER` (`USER_ID_`),
  KEY `ACT_IDX_HI_IDENT_LNK_TASK` (`TASK_ID_`),
  KEY `ACT_IDX_HI_IDENT_LNK_PROCINST` (`PROC_INST_ID_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_HI_PROCINST
-- ----------------------------
DROP TABLE IF EXISTS `ACT_HI_PROCINST`;
CREATE TABLE `ACT_HI_PROCINST` (
  `ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `PROC_INST_ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `BUSINESS_KEY_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `PROC_DEF_ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `START_TIME_` datetime(3) NOT NULL,
  `END_TIME_` datetime(3) DEFAULT NULL,
  `DURATION_` bigint(20) DEFAULT NULL,
  `START_USER_ID_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `START_ACT_ID_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `END_ACT_ID_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `SUPER_PROCESS_INSTANCE_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `DELETE_REASON_` varchar(4000) COLLATE utf8_bin DEFAULT NULL,
  `TENANT_ID_` varchar(255) COLLATE utf8_bin DEFAULT '',
  `NAME_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`ID_`),
  UNIQUE KEY `PROC_INST_ID_` (`PROC_INST_ID_`),
  KEY `ACT_IDX_HI_PRO_INST_END` (`END_TIME_`),
  KEY `ACT_IDX_HI_PRO_I_BUSKEY` (`BUSINESS_KEY_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_HI_TASKINST
-- ----------------------------
DROP TABLE IF EXISTS `ACT_HI_TASKINST`;
CREATE TABLE `ACT_HI_TASKINST` (
  `ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `PROC_DEF_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `TASK_DEF_KEY_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `PROC_INST_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `EXECUTION_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `NAME_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `PARENT_TASK_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `DESCRIPTION_` varchar(4000) COLLATE utf8_bin DEFAULT NULL,
  `OWNER_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `ASSIGNEE_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `START_TIME_` datetime(3) NOT NULL,
  `CLAIM_TIME_` datetime(3) DEFAULT NULL,
  `END_TIME_` datetime(3) DEFAULT NULL,
  `DURATION_` bigint(20) DEFAULT NULL,
  `DELETE_REASON_` varchar(4000) COLLATE utf8_bin DEFAULT NULL,
  `PRIORITY_` int(11) DEFAULT NULL,
  `DUE_DATE_` datetime(3) DEFAULT NULL,
  `FORM_KEY_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `CATEGORY_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `TENANT_ID_` varchar(255) COLLATE utf8_bin DEFAULT '',
  PRIMARY KEY (`ID_`),
  KEY `ACT_IDX_HI_TASK_INST_PROCINST` (`PROC_INST_ID_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_HI_VARINST
-- ----------------------------
DROP TABLE IF EXISTS `ACT_HI_VARINST`;
CREATE TABLE `ACT_HI_VARINST` (
  `ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `PROC_INST_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `EXECUTION_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `TASK_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `NAME_` varchar(255) COLLATE utf8_bin NOT NULL,
  `VAR_TYPE_` varchar(100) COLLATE utf8_bin DEFAULT NULL,
  `REV_` int(11) DEFAULT NULL,
  `BYTEARRAY_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `DOUBLE_` double DEFAULT NULL,
  `LONG_` bigint(20) DEFAULT NULL,
  `TEXT_` varchar(4000) COLLATE utf8_bin DEFAULT NULL,
  `TEXT2_` varchar(4000) COLLATE utf8_bin DEFAULT NULL,
  `CREATE_TIME_` datetime(3) DEFAULT NULL,
  `LAST_UPDATED_TIME_` datetime(3) DEFAULT NULL,
  PRIMARY KEY (`ID_`),
  KEY `ACT_IDX_HI_PROCVAR_PROC_INST` (`PROC_INST_ID_`),
  KEY `ACT_IDX_HI_PROCVAR_NAME_TYPE` (`NAME_`,`VAR_TYPE_`),
  KEY `ACT_IDX_HI_PROCVAR_TASK_ID` (`TASK_ID_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_ID_GROUP
-- ----------------------------
DROP TABLE IF EXISTS `ACT_ID_GROUP`;
CREATE TABLE `ACT_ID_GROUP` (
  `ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `REV_` int(11) DEFAULT NULL,
  `NAME_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `TYPE_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`ID_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_ID_INFO
-- ----------------------------
DROP TABLE IF EXISTS `ACT_ID_INFO`;
CREATE TABLE `ACT_ID_INFO` (
  `ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `REV_` int(11) DEFAULT NULL,
  `USER_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `TYPE_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `KEY_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `VALUE_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `PASSWORD_` longblob,
  `PARENT_ID_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`ID_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_ID_MEMBERSHIP
-- ----------------------------
DROP TABLE IF EXISTS `ACT_ID_MEMBERSHIP`;
CREATE TABLE `ACT_ID_MEMBERSHIP` (
  `USER_ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `GROUP_ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  PRIMARY KEY (`USER_ID_`,`GROUP_ID_`),
  KEY `ACT_FK_MEMB_GROUP` (`GROUP_ID_`),
  CONSTRAINT `ACT_FK_MEMB_GROUP` FOREIGN KEY (`GROUP_ID_`) REFERENCES `ACT_ID_GROUP` (`ID_`),
  CONSTRAINT `ACT_FK_MEMB_USER` FOREIGN KEY (`USER_ID_`) REFERENCES `ACT_ID_USER` (`ID_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_ID_USER
-- ----------------------------
DROP TABLE IF EXISTS `ACT_ID_USER`;
CREATE TABLE `ACT_ID_USER` (
  `ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `REV_` int(11) DEFAULT NULL,
  `FIRST_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `LAST_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `EMAIL_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `PWD_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `PICTURE_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`ID_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_PROCDEF_INFO
-- ----------------------------
DROP TABLE IF EXISTS `ACT_PROCDEF_INFO`;
CREATE TABLE `ACT_PROCDEF_INFO` (
  `ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `PROC_DEF_ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `REV_` int(11) DEFAULT NULL,
  `INFO_JSON_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`ID_`),
  UNIQUE KEY `ACT_UNIQ_INFO_PROCDEF` (`PROC_DEF_ID_`),
  KEY `ACT_IDX_INFO_PROCDEF` (`PROC_DEF_ID_`),
  KEY `ACT_FK_INFO_JSON_BA` (`INFO_JSON_ID_`),
  CONSTRAINT `ACT_FK_INFO_JSON_BA` FOREIGN KEY (`INFO_JSON_ID_`) REFERENCES `ACT_GE_BYTEARRAY` (`ID_`),
  CONSTRAINT `ACT_FK_INFO_PROCDEF` FOREIGN KEY (`PROC_DEF_ID_`) REFERENCES `ACT_RE_PROCDEF` (`ID_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_RE_DEPLOYMENT
-- ----------------------------
DROP TABLE IF EXISTS `ACT_RE_DEPLOYMENT`;
CREATE TABLE `ACT_RE_DEPLOYMENT` (
  `ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `NAME_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `CATEGORY_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `TENANT_ID_` varchar(255) COLLATE utf8_bin DEFAULT '',
  `DEPLOY_TIME_` timestamp(3) NULL DEFAULT NULL,
  PRIMARY KEY (`ID_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_RE_MODEL
-- ----------------------------
DROP TABLE IF EXISTS `ACT_RE_MODEL`;
CREATE TABLE `ACT_RE_MODEL` (
  `ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `REV_` int(11) DEFAULT NULL,
  `NAME_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `KEY_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `CATEGORY_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `CREATE_TIME_` timestamp(3) NULL DEFAULT NULL,
  `LAST_UPDATE_TIME_` timestamp(3) NULL DEFAULT NULL,
  `VERSION_` int(11) DEFAULT NULL,
  `META_INFO_` varchar(4000) COLLATE utf8_bin DEFAULT NULL,
  `DEPLOYMENT_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `EDITOR_SOURCE_VALUE_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `EDITOR_SOURCE_EXTRA_VALUE_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `TENANT_ID_` varchar(255) COLLATE utf8_bin DEFAULT '',
  PRIMARY KEY (`ID_`),
  KEY `ACT_FK_MODEL_SOURCE` (`EDITOR_SOURCE_VALUE_ID_`),
  KEY `ACT_FK_MODEL_SOURCE_EXTRA` (`EDITOR_SOURCE_EXTRA_VALUE_ID_`),
  KEY `ACT_FK_MODEL_DEPLOYMENT` (`DEPLOYMENT_ID_`),
  CONSTRAINT `ACT_FK_MODEL_DEPLOYMENT` FOREIGN KEY (`DEPLOYMENT_ID_`) REFERENCES `ACT_RE_DEPLOYMENT` (`ID_`),
  CONSTRAINT `ACT_FK_MODEL_SOURCE` FOREIGN KEY (`EDITOR_SOURCE_VALUE_ID_`) REFERENCES `ACT_GE_BYTEARRAY` (`ID_`),
  CONSTRAINT `ACT_FK_MODEL_SOURCE_EXTRA` FOREIGN KEY (`EDITOR_SOURCE_EXTRA_VALUE_ID_`) REFERENCES `ACT_GE_BYTEARRAY` (`ID_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_RE_PROCDEF
-- ----------------------------
DROP TABLE IF EXISTS `ACT_RE_PROCDEF`;
CREATE TABLE `ACT_RE_PROCDEF` (
  `ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `REV_` int(11) DEFAULT NULL,
  `CATEGORY_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `NAME_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `KEY_` varchar(255) COLLATE utf8_bin NOT NULL,
  `VERSION_` int(11) NOT NULL,
  `DEPLOYMENT_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `RESOURCE_NAME_` varchar(4000) COLLATE utf8_bin DEFAULT NULL,
  `DGRM_RESOURCE_NAME_` varchar(4000) COLLATE utf8_bin DEFAULT NULL,
  `DESCRIPTION_` varchar(4000) COLLATE utf8_bin DEFAULT NULL,
  `HAS_START_FORM_KEY_` tinyint(4) DEFAULT NULL,
  `HAS_GRAPHICAL_NOTATION_` tinyint(4) DEFAULT NULL,
  `SUSPENSION_STATE_` int(11) DEFAULT NULL,
  `TENANT_ID_` varchar(255) COLLATE utf8_bin DEFAULT '',
  PRIMARY KEY (`ID_`),
  UNIQUE KEY `ACT_UNIQ_PROCDEF` (`KEY_`,`VERSION_`,`TENANT_ID_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_RU_EVENT_SUBSCR
-- ----------------------------
DROP TABLE IF EXISTS `ACT_RU_EVENT_SUBSCR`;
CREATE TABLE `ACT_RU_EVENT_SUBSCR` (
  `ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `REV_` int(11) DEFAULT NULL,
  `EVENT_TYPE_` varchar(255) COLLATE utf8_bin NOT NULL,
  `EVENT_NAME_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `EXECUTION_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `PROC_INST_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `ACTIVITY_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `CONFIGURATION_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `CREATED_` timestamp(3) NOT NULL DEFAULT CURRENT_TIMESTAMP(3),
  `PROC_DEF_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `TENANT_ID_` varchar(255) COLLATE utf8_bin DEFAULT '',
  PRIMARY KEY (`ID_`),
  KEY `ACT_IDX_EVENT_SUBSCR_CONFIG_` (`CONFIGURATION_`),
  KEY `ACT_FK_EVENT_EXEC` (`EXECUTION_ID_`),
  CONSTRAINT `ACT_FK_EVENT_EXEC` FOREIGN KEY (`EXECUTION_ID_`) REFERENCES `ACT_RU_EXECUTION` (`ID_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_RU_EXECUTION
-- ----------------------------
DROP TABLE IF EXISTS `ACT_RU_EXECUTION`;
CREATE TABLE `ACT_RU_EXECUTION` (
  `ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `REV_` int(11) DEFAULT NULL,
  `PROC_INST_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `BUSINESS_KEY_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `PARENT_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `PROC_DEF_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `SUPER_EXEC_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `ACT_ID_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `IS_ACTIVE_` tinyint(4) DEFAULT NULL,
  `IS_CONCURRENT_` tinyint(4) DEFAULT NULL,
  `IS_SCOPE_` tinyint(4) DEFAULT NULL,
  `IS_EVENT_SCOPE_` tinyint(4) DEFAULT NULL,
  `SUSPENSION_STATE_` int(11) DEFAULT NULL,
  `CACHED_ENT_STATE_` int(11) DEFAULT NULL,
  `TENANT_ID_` varchar(255) COLLATE utf8_bin DEFAULT '',
  `NAME_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `LOCK_TIME_` timestamp(3) NULL DEFAULT NULL,
  PRIMARY KEY (`ID_`),
  KEY `ACT_IDX_EXEC_BUSKEY` (`BUSINESS_KEY_`),
  KEY `ACT_FK_EXE_PROCINST` (`PROC_INST_ID_`),
  KEY `ACT_FK_EXE_PARENT` (`PARENT_ID_`),
  KEY `ACT_FK_EXE_SUPER` (`SUPER_EXEC_`),
  KEY `ACT_FK_EXE_PROCDEF` (`PROC_DEF_ID_`),
  CONSTRAINT `ACT_FK_EXE_PARENT` FOREIGN KEY (`PARENT_ID_`) REFERENCES `ACT_RU_EXECUTION` (`ID_`),
  CONSTRAINT `ACT_FK_EXE_PROCDEF` FOREIGN KEY (`PROC_DEF_ID_`) REFERENCES `ACT_RE_PROCDEF` (`ID_`),
  CONSTRAINT `ACT_FK_EXE_PROCINST` FOREIGN KEY (`PROC_INST_ID_`) REFERENCES `ACT_RU_EXECUTION` (`ID_`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `ACT_FK_EXE_SUPER` FOREIGN KEY (`SUPER_EXEC_`) REFERENCES `ACT_RU_EXECUTION` (`ID_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_RU_IDENTITYLINK
-- ----------------------------
DROP TABLE IF EXISTS `ACT_RU_IDENTITYLINK`;
CREATE TABLE `ACT_RU_IDENTITYLINK` (
  `ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `REV_` int(11) DEFAULT NULL,
  `GROUP_ID_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `TYPE_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `USER_ID_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `TASK_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `PROC_INST_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `PROC_DEF_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`ID_`),
  KEY `ACT_IDX_IDENT_LNK_USER` (`USER_ID_`),
  KEY `ACT_IDX_IDENT_LNK_GROUP` (`GROUP_ID_`),
  KEY `ACT_IDX_ATHRZ_PROCEDEF` (`PROC_DEF_ID_`),
  KEY `ACT_FK_TSKASS_TASK` (`TASK_ID_`),
  KEY `ACT_FK_IDL_PROCINST` (`PROC_INST_ID_`),
  CONSTRAINT `ACT_FK_ATHRZ_PROCEDEF` FOREIGN KEY (`PROC_DEF_ID_`) REFERENCES `ACT_RE_PROCDEF` (`ID_`),
  CONSTRAINT `ACT_FK_IDL_PROCINST` FOREIGN KEY (`PROC_INST_ID_`) REFERENCES `ACT_RU_EXECUTION` (`ID_`),
  CONSTRAINT `ACT_FK_TSKASS_TASK` FOREIGN KEY (`TASK_ID_`) REFERENCES `ACT_RU_TASK` (`ID_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_RU_JOB
-- ----------------------------
DROP TABLE IF EXISTS `ACT_RU_JOB`;
CREATE TABLE `ACT_RU_JOB` (
  `ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `REV_` int(11) DEFAULT NULL,
  `TYPE_` varchar(255) COLLATE utf8_bin NOT NULL,
  `LOCK_EXP_TIME_` timestamp(3) NULL DEFAULT NULL,
  `LOCK_OWNER_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `EXCLUSIVE_` tinyint(1) DEFAULT NULL,
  `EXECUTION_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `PROCESS_INSTANCE_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `PROC_DEF_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `RETRIES_` int(11) DEFAULT NULL,
  `EXCEPTION_STACK_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `EXCEPTION_MSG_` varchar(4000) COLLATE utf8_bin DEFAULT NULL,
  `DUEDATE_` timestamp(3) NULL DEFAULT NULL,
  `REPEAT_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `HANDLER_TYPE_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `HANDLER_CFG_` varchar(4000) COLLATE utf8_bin DEFAULT NULL,
  `TENANT_ID_` varchar(255) COLLATE utf8_bin DEFAULT '',
  PRIMARY KEY (`ID_`),
  KEY `ACT_FK_JOB_EXCEPTION` (`EXCEPTION_STACK_ID_`),
  CONSTRAINT `ACT_FK_JOB_EXCEPTION` FOREIGN KEY (`EXCEPTION_STACK_ID_`) REFERENCES `ACT_GE_BYTEARRAY` (`ID_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_RU_TASK
-- ----------------------------
DROP TABLE IF EXISTS `ACT_RU_TASK`;
CREATE TABLE `ACT_RU_TASK` (
  `ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `REV_` int(11) DEFAULT NULL,
  `EXECUTION_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `PROC_INST_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `PROC_DEF_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `NAME_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `PARENT_TASK_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `DESCRIPTION_` varchar(4000) COLLATE utf8_bin DEFAULT NULL,
  `TASK_DEF_KEY_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `OWNER_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `ASSIGNEE_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `DELEGATION_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `PRIORITY_` int(11) DEFAULT NULL,
  `CREATE_TIME_` timestamp(3) NULL DEFAULT NULL,
  `DUE_DATE_` datetime(3) DEFAULT NULL,
  `CATEGORY_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  `SUSPENSION_STATE_` int(11) DEFAULT NULL,
  `TENANT_ID_` varchar(255) COLLATE utf8_bin DEFAULT '',
  `FORM_KEY_` varchar(255) COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`ID_`),
  KEY `ACT_IDX_TASK_CREATE` (`CREATE_TIME_`),
  KEY `ACT_FK_TASK_EXE` (`EXECUTION_ID_`),
  KEY `ACT_FK_TASK_PROCINST` (`PROC_INST_ID_`),
  KEY `ACT_FK_TASK_PROCDEF` (`PROC_DEF_ID_`),
  CONSTRAINT `ACT_FK_TASK_EXE` FOREIGN KEY (`EXECUTION_ID_`) REFERENCES `ACT_RU_EXECUTION` (`ID_`),
  CONSTRAINT `ACT_FK_TASK_PROCDEF` FOREIGN KEY (`PROC_DEF_ID_`) REFERENCES `ACT_RE_PROCDEF` (`ID_`),
  CONSTRAINT `ACT_FK_TASK_PROCINST` FOREIGN KEY (`PROC_INST_ID_`) REFERENCES `ACT_RU_EXECUTION` (`ID_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for ACT_RU_VARIABLE
-- ----------------------------
DROP TABLE IF EXISTS `ACT_RU_VARIABLE`;
CREATE TABLE `ACT_RU_VARIABLE` (
  `ID_` varchar(64) COLLATE utf8_bin NOT NULL,
  `REV_` int(11) DEFAULT NULL,
  `TYPE_` varchar(255) COLLATE utf8_bin NOT NULL,
  `NAME_` varchar(255) COLLATE utf8_bin NOT NULL,
  `EXECUTION_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `PROC_INST_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `TASK_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `BYTEARRAY_ID_` varchar(64) COLLATE utf8_bin DEFAULT NULL,
  `DOUBLE_` double DEFAULT NULL,
  `LONG_` bigint(20) DEFAULT NULL,
  `TEXT_` varchar(4000) COLLATE utf8_bin DEFAULT NULL,
  `TEXT2_` varchar(4000) COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`ID_`),
  KEY `ACT_IDX_VARIABLE_TASK_ID` (`TASK_ID_`),
  KEY `ACT_FK_VAR_EXE` (`EXECUTION_ID_`),
  KEY `ACT_FK_VAR_PROCINST` (`PROC_INST_ID_`),
  KEY `ACT_FK_VAR_BYTEARRAY` (`BYTEARRAY_ID_`),
  CONSTRAINT `ACT_FK_VAR_BYTEARRAY` FOREIGN KEY (`BYTEARRAY_ID_`) REFERENCES `ACT_GE_BYTEARRAY` (`ID_`),
  CONSTRAINT `ACT_FK_VAR_EXE` FOREIGN KEY (`EXECUTION_ID_`) REFERENCES `ACT_RU_EXECUTION` (`ID_`),
  CONSTRAINT `ACT_FK_VAR_PROCINST` FOREIGN KEY (`PROC_INST_ID_`) REFERENCES `ACT_RU_EXECUTION` (`ID_`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- ----------------------------
-- Table structure for adjustment_table
-- ----------------------------
DROP TABLE IF EXISTS `adjustment_table`;
CREATE TABLE `adjustment_table` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL COMMENT '机构编号',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '项目ID',
  `period` int(11) NOT NULL DEFAULT '0' COMMENT '期间',
  `segment1` varchar(300) NOT NULL DEFAULT '' COMMENT '主体',
  `segment2` varchar(300) NOT NULL DEFAULT '' COMMENT '成本中心',
  `segment3` varchar(300) NOT NULL DEFAULT '' COMMENT '科目',
  `segment4` varchar(300) NOT NULL DEFAULT '' COMMENT '辅助科目',
  `segment5` varchar(300) NOT NULL DEFAULT '' COMMENT '利润中心',
  `segment6` varchar(300) NOT NULL DEFAULT '' COMMENT '产品',
  `segment7` varchar(300) NOT NULL DEFAULT '' COMMENT '项目',
  `segment8` varchar(300) NOT NULL DEFAULT '' COMMENT '公司间',
  `segment9` varchar(300) NOT NULL DEFAULT '' COMMENT '备用1',
  `segment10` varchar(300) NOT NULL DEFAULT '' COMMENT '备用2',
  `segment1_name` varchar(300) NOT NULL DEFAULT '' COMMENT '主体说明',
  `segment2_name` varchar(300) NOT NULL DEFAULT '' COMMENT '成本中心说明',
  `segment3_name` varchar(300) NOT NULL DEFAULT '' COMMENT '科目说明',
  `segment4_name` varchar(300) NOT NULL DEFAULT '' COMMENT '辅助科目说明',
  `segment5_name` varchar(300) NOT NULL DEFAULT '' COMMENT '利润中心说明',
  `segment6_name` varchar(300) NOT NULL DEFAULT '' COMMENT '产品说明',
  `segment7_name` varchar(300) NOT NULL DEFAULT '' COMMENT '项目说明',
  `segment8_name` varchar(300) NOT NULL DEFAULT '' COMMENT '公司间说明',
  `segment9_name` varchar(300) NOT NULL DEFAULT '' COMMENT '备用1说明',
  `segment10_name` varchar(300) NOT NULL DEFAULT '' COMMENT '备用2说明',
  `period_dr_beq` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本位币本期借方发生额',
  `period_cr_beq` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本位币本期贷方发生额',
  `end_bal_beq` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本位币期末余额',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='调整表';

-- ----------------------------
-- Table structure for area
-- ----------------------------
DROP TABLE IF EXISTS `area`;
CREATE TABLE `area` (
  `id` varchar(128) NOT NULL,
  `parent_id` varchar(128) DEFAULT '',
  `name` varchar(200) NOT NULL DEFAULT '',
  `is_active` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `area_name_IDX` (`name`) USING BTREE,
  KEY `area_parent_id_IDX` (`parent_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for area_region
-- ----------------------------
DROP TABLE IF EXISTS `area_region`;
CREATE TABLE `area_region` (
  `id` varchar(128) NOT NULL,
  `area_id` varchar(128) NOT NULL DEFAULT '',
  `region_id` varchar(128) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `area_region_area_id_IDX` (`area_id`,`region_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for asset_detail_group
-- ----------------------------
DROP TABLE IF EXISTS `asset_detail_group`;
CREATE TABLE `asset_detail_group` (
  `id` bigint(18) NOT NULL DEFAULT '0',
  `asset_group_id` bigint(18) NOT NULL DEFAULT '0' COMMENT '表asset_group的主键',
  `detail_group_name` varchar(200) NOT NULL DEFAULT '' COMMENT '资产分类二级分类名称',
  `asset_group_type` int(10) NOT NULL DEFAULT '0' COMMENT '隶属的资产一级分类的类型代码',
  `group_year` int(10) NOT NULL DEFAULT '0',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `detail_group_type` int(10) NOT NULL DEFAULT '0' COMMENT '二级分类的类型代码',
  `key_values` varchar(500) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `asset_detail_group_asset_group_type_IDX` (`asset_group_type`,`detail_group_type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='资产分类二级分类';

-- ----------------------------
-- Table structure for asset_group
-- ----------------------------
DROP TABLE IF EXISTS `asset_group`;
CREATE TABLE `asset_group` (
  `id` bigint(18) NOT NULL DEFAULT '0',
  `asset_group_name` varchar(200) NOT NULL DEFAULT '' COMMENT '资产分类一级分类名称',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `asset_group_type` int(10) NOT NULL DEFAULT '0' COMMENT '资产一级分类的类型代码',
  PRIMARY KEY (`id`),
  UNIQUE KEY `asset_group_asset_group_name_IDX` (`asset_group_name`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='资产分类一级分类';

-- ----------------------------
-- Table structure for asset_group_result
-- ----------------------------
DROP TABLE IF EXISTS `asset_group_result`;
CREATE TABLE `asset_group_result` (
  `id` bigint(18) NOT NULL DEFAULT '0',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '表project主键',
  `period` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '期间',
  `asset_name` varchar(400) NOT NULL DEFAULT '' COMMENT '资产类别-资产清单中资产分类弹框中的资产类别，包含资产清单Grid中的所有资产类别',
  `asset_group_id` bigint(18) NOT NULL DEFAULT '0' COMMENT '资产一级分类主键',
  `asset_detail_group_id` bigint(18) NOT NULL DEFAULT '0' COMMENT '资产二级分类主键',
  `tax_depreciation_period` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '税务折旧期限',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '修改时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='资产分类（资产类别与资产二级分类对应的对应关系，资产清单页面中的资产分类弹框用到此表）';

-- ----------------------------
-- Table structure for assets_list
-- ----------------------------
DROP TABLE IF EXISTS `assets_list`;
CREATE TABLE `assets_list` (
  `id` bigint(18) NOT NULL DEFAULT '0',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '表project主键',
  `period` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '期间',
  `asset_number` varchar(100) NOT NULL DEFAULT '' COMMENT '资产编号',
  `asset_group_name` varchar(400) NOT NULL DEFAULT '' COMMENT '资产类别-页面',
  `asset_detail_group_id` bigint(18) NOT NULL DEFAULT '0' COMMENT '资产二级分类主键',
  `asset_description` varchar(1000) NOT NULL DEFAULT '' COMMENT '资产说明',
  `buy_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '购入日期',
  `depreciation_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '开始折旧日期',
  `depreciation_period` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '折旧期限',
  `acquisition_value` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT '原值',
  `adjustment_value` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT '调整值',
  `disposed_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '报废日期',
  `residual_rate` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT '残值率',
  `year_depreciation_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT '本年折旧额',
  `year_adjustment_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT '本年调整额',
  `year_end_value` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT '年终剩余价值',
  `status` int(1) unsigned NOT NULL DEFAULT '0' COMMENT '状态',
  `account_acquisition_value` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT '财务原值（按照文档所说：该值就是上面的原值加上调整值么）',
  `account_month_depreciation_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT '财务每月折旧额',
  `account_year_depreciation_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT '财务本年折旧额（上方的本年折旧额 + 本年折旧调整额）',
  `account_total_depreciation_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT '财务累计折旧额',
  `tax_depreciation_period` int(10) NOT NULL DEFAULT '0' COMMENT '税务折旧期限',
  `tax_to_last_year_depreciation_period` int(10) NOT NULL DEFAULT '0' COMMENT '截止去年累计折旧期间',
  `tax_to_current_year_depreciation_period` int(10) NOT NULL DEFAULT '0' COMMENT '截止本年累计折旧期间',
  `tax_year_depreciation_period` int(10) NOT NULL DEFAULT '0' COMMENT '本年折旧期间',
  `tax_month_depreciation_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT '税务每月折旧额',
  `tax_to_current_year_depreciation_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT '税务累计折旧额',
  `tax_current_year_depreciation_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT '税务本年折旧额',
  `total_difference_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT '累计差异',
  `year_difference_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT '当年差异',
  `is_retain` int(1) unsigned NOT NULL DEFAULT '0' COMMENT '保留差异',
  `asset_type` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '资产一级分类（固定资产、长期分摊、无形资产）',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '修改时间',
  `tax_account_compare` int(1) unsigned NOT NULL DEFAULT '0' COMMENT '税会折旧大小比较结果；1表示税大，2表示会大',
  `tax_group_name` varchar(200) NOT NULL DEFAULT '' COMMENT '税法分类，也是资产二级分类（asset_detail_group表中的detailGroupName）',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='资产清单';

-- ----------------------------
-- Table structure for balance_sheet
-- ----------------------------
DROP TABLE IF EXISTS `balance_sheet`;
CREATE TABLE `balance_sheet` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL COMMENT '机构编号',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '项目ID',
  `date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '数据日期',
  `source` varchar(20) NOT NULL DEFAULT '' COMMENT '来源 GL',
  `tms_period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '税务系统期间yyyymm',
  `period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '期间 yyyymm',
  `status` varchar(10) NOT NULL DEFAULT '' COMMENT '关账标识 Y/N',
  `ledger_id` varchar(128) NOT NULL DEFAULT '' COMMENT '账套ID',
  `ledger_name` varchar(300) NOT NULL DEFAULT '' COMMENT '账套名称',
  `ledger_currency_code` varchar(20) NOT NULL DEFAULT '' COMMENT '账套币种',
  `entity_code` varchar(300) NOT NULL DEFAULT '' COMMENT '机构编码',
  `entity_name` varchar(300) NOT NULL DEFAULT '' COMMENT '机构名称',
  `category` varchar(300) NOT NULL DEFAULT '' COMMENT '主体性质 单体/合并',
  `frequency` varchar(300) NOT NULL DEFAULT '' COMMENT '频度 固定值M，仅期间(月度含13期)报表数据',
  `item_name` varchar(300) NOT NULL DEFAULT '' COMMENT '项目名称',
  `end_bal` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '期末余额',
  `beg_bal` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '年初余额',
  `prc_flag` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否为国外 0-国内，1-国外',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='资产负债表。月度，次月传送上月，全部主体，只传送账套币种即折算后本位币币种金额';

-- ----------------------------
-- Table structure for balance_sheet_final
-- ----------------------------
DROP TABLE IF EXISTS `balance_sheet_final`;
CREATE TABLE `balance_sheet_final` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL COMMENT '机构编号',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '项目ID',
  `date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '数据日期',
  `source` varchar(20) NOT NULL DEFAULT '' COMMENT '来源 GL',
  `tms_period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '税务系统期间yyyymm',
  `period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '期间 yyyymm',
  `status` varchar(10) NOT NULL DEFAULT '' COMMENT '关账标识 Y/N',
  `ledger_id` varchar(128) NOT NULL DEFAULT '' COMMENT '账套ID',
  `ledger_name` varchar(300) NOT NULL DEFAULT '' COMMENT '账套名称',
  `ledger_currency_code` varchar(20) NOT NULL DEFAULT '' COMMENT '账套币种',
  `entity_code` varchar(300) NOT NULL DEFAULT '' COMMENT '机构编码',
  `entity_name` varchar(300) NOT NULL DEFAULT '' COMMENT '机构名称',
  `category` varchar(300) NOT NULL DEFAULT '' COMMENT '主体性质 单体/合并',
  `frequency` varchar(300) NOT NULL DEFAULT '' COMMENT '频度 固定值M，仅期间(月度含13期)报表数据',
  `item_name` varchar(300) NOT NULL DEFAULT '' COMMENT '项目名称',
  `end_bal` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '期末余额',
  `beg_bal` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '年初余额',
  `prc_flag` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否为国外 0-国内，1-国外',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='资产负债表。最新版本，与接口导入、excel导入中最新版本一致';

-- ----------------------------
-- Table structure for balance_sheet_manual
-- ----------------------------
DROP TABLE IF EXISTS `balance_sheet_manual`;
CREATE TABLE `balance_sheet_manual` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL COMMENT '机构编号',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '项目ID',
  `date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '数据日期',
  `source` varchar(20) NOT NULL DEFAULT '' COMMENT '来源 GL',
  `tms_period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '税务系统期间yyyymm',
  `period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '期间 yyyymm',
  `status` varchar(10) NOT NULL DEFAULT '' COMMENT '关账标识 Y/N',
  `ledger_id` varchar(128) NOT NULL DEFAULT '' COMMENT '账套ID',
  `ledger_name` varchar(300) NOT NULL DEFAULT '' COMMENT '账套名称',
  `ledger_currency_code` varchar(20) NOT NULL DEFAULT '' COMMENT '账套币种',
  `entity_code` varchar(300) NOT NULL DEFAULT '' COMMENT '机构编码',
  `entity_name` varchar(300) NOT NULL DEFAULT '' COMMENT '机构名称',
  `category` varchar(300) NOT NULL DEFAULT '' COMMENT '主体性质 单体/合并',
  `frequency` varchar(300) NOT NULL DEFAULT '' COMMENT '频度 固定值M，仅期间(月度含13期)报表数据',
  `item_name` varchar(300) NOT NULL DEFAULT '' COMMENT '项目名称',
  `end_bal` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '期末余额',
  `beg_bal` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '年初余额',
  `prc_flag` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否为国外 0-国内，1-国外',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='资产负债表。人工调整，excel导入';

-- ----------------------------
-- Table structure for business_unit
-- ----------------------------
DROP TABLE IF EXISTS `business_unit`;
CREATE TABLE `business_unit` (
  `id` varchar(128) NOT NULL,
  `name` varchar(100) NOT NULL DEFAULT '',
  `is_active` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `business_unit_name_IDX` (`name`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for cache
-- ----------------------------
DROP TABLE IF EXISTS `cache`;
CREATE TABLE `cache` (
  `id` varchar(128) NOT NULL,
  `cache_key` varchar(255) NOT NULL DEFAULT '',
  `last_modify_time` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for cash_flow
-- ----------------------------
DROP TABLE IF EXISTS `cash_flow`;
CREATE TABLE `cash_flow` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号 系统唯一编号',
  `organization_id` varchar(128) NOT NULL DEFAULT '' COMMENT '机构id',
  `date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '数据日期',
  `source` varchar(128) NOT NULL DEFAULT '' COMMENT '数据来源GL',
  `tms_period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '税务系统期间 yyyyMM',
  `period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '期间 YYYY-MM',
  `status` varchar(10) NOT NULL DEFAULT '' COMMENT '关账标识 Y/N',
  `ledger_id` varchar(128) NOT NULL DEFAULT '' COMMENT '账套ID',
  `ledger_name` varchar(300) NOT NULL DEFAULT '' COMMENT '账套名称',
  `ledger_currency_code` varchar(128) NOT NULL DEFAULT '' COMMENT '账套币种',
  `entity_code` varchar(128) NOT NULL DEFAULT '' COMMENT '机构编码',
  `entity_name` varchar(300) NOT NULL DEFAULT '' COMMENT '机构名称',
  `category` varchar(300) NOT NULL DEFAULT '' COMMENT '主体性质（单体/合并）',
  `frequency` varchar(300) NOT NULL DEFAULT '' COMMENT '频度（固定值M，\n仅期间(月度含13期)报表数据）',
  `item_name` varchar(300) NOT NULL DEFAULT '' COMMENT '项目中文名称',
  `item_name2` varchar(300) NOT NULL DEFAULT '' COMMENT '项目英文名称',
  `period_amt` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本期发生',
  `ytd_amt` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本年累计',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='月度，次月传送上月，全部主体，只传送账套币种即折算后本位币币种金额';

-- ----------------------------
-- Table structure for cell_data_source
-- ----------------------------
DROP TABLE IF EXISTS `cell_data_source`;
CREATE TABLE `cell_data_source` (
  `id` bigint(19) NOT NULL DEFAULT '0',
  `cell_template_id` bigint(19) NOT NULL DEFAULT '0',
  `cell_data_id` bigint(19) NOT NULL DEFAULT '0',
  `data_source_id` bigint(19) NOT NULL DEFAULT '0',
  `operation_type` int(10) NOT NULL DEFAULT '0',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `project_id` varchar(128) NOT NULL DEFAULT '',
  `period` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `cell_data_source_cell_data_id_IDX` (`cell_data_id`,`data_source_id`,`project_id`,`period`) USING BTREE,
  KEY `cell_data_source_cell_template_id_IDX` (`cell_template_id`,`cell_data_id`,`data_source_id`,`project_id`,`period`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for cell_template
-- ----------------------------
DROP TABLE IF EXISTS `cell_template`;
CREATE TABLE `cell_template` (
  `id` bigint(19) NOT NULL,
  `report_template_id` bigint(19) NOT NULL DEFAULT '0',
  `row_index` int(10) NOT NULL DEFAULT '0',
  `row_name` varchar(1000) DEFAULT '',
  `column_index` int(10) NOT NULL DEFAULT '0',
  `column_name` varchar(1000) DEFAULT '',
  `comment` varchar(3000) DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `copy_from_id` bigint(19) NOT NULL DEFAULT '0',
  `data_type` int(10) NOT NULL DEFAULT '0',
  `is_read_only` tinyint(1) NOT NULL DEFAULT '0',
  `create_by` varchar(128) DEFAULT '',
  `update_by` varchar(128) DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `cell_template_report_template_id_IDX` (`report_template_id`,`row_index`,`column_index`,`copy_from_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for cell_template_config
-- ----------------------------
DROP TABLE IF EXISTS `cell_template_config`;
CREATE TABLE `cell_template_config` (
  `id` bigint(19) NOT NULL,
  `cell_template_id` bigint(19) NOT NULL DEFAULT '0',
  `report_template_id` bigint(19) NOT NULL DEFAULT '0',
  `data_source_type` int(4) NOT NULL DEFAULT '0',
  `formula` varchar(1000) DEFAULT '',
  `formula_description` varchar(1000) DEFAULT '',
  `account_codes` varchar(1000) DEFAULT '',
  `invoice_type` int(10) NOT NULL DEFAULT '0',
  `tax_rate` varchar(50) DEFAULT '',
  `invoice_amount_type` int(10) NOT NULL DEFAULT '0',
  `model_ids` varchar(1000) DEFAULT '',
  `create_by` varchar(128) DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_by` varchar(128) DEFAULT '',
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `invoice_category` varchar(50) DEFAULT '',
  `formula_data_source` varchar(1000) DEFAULT '',
  `validation` varchar(1000) DEFAULT '',
  `validation_description` varchar(1000) DEFAULT '',
  `voucher_keyword` varchar(1000) DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `cell_template_config_cell_template_id_IDX` (`cell_template_id`) USING BTREE,
  KEY `cell_template_config_report_template_id_IDX` (`report_template_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for certified_invoices_list
-- ----------------------------
DROP TABLE IF EXISTS `certified_invoices_list`;
CREATE TABLE `certified_invoices_list` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL COMMENT '机构编号',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '项目ID',
  `tms_period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '税务系统期间',
  `period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '期间',
  `taxpayer_id_num` varchar(300) NOT NULL DEFAULT '' COMMENT '纳税人识别号 ',
  `certified_month` int(11) NOT NULL DEFAULT '0' COMMENT '认证月份',
  `unit` varchar(20) NOT NULL DEFAULT '' COMMENT '单位：元',
  `seq_no` int(8) unsigned NOT NULL DEFAULT '0' COMMENT '序号',
  `invoice_code` varchar(50) NOT NULL DEFAULT '' COMMENT '发票代码',
  `invoice_num` varchar(50) NOT NULL DEFAULT '' COMMENT '发票号码',
  `billing_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '开票日期',
  `sales_tax_num` varchar(50) NOT NULL DEFAULT '' COMMENT '销方税号',
  `salesperson_name` varchar(50) NOT NULL DEFAULT '' COMMENT '销方名称',
  `amount` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '金额',
  `tax_amount` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '税额',
  `verification_method` varchar(50) NOT NULL DEFAULT '' COMMENT '认证方式',
  `certified_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '确认/认证日期',
  `invoice_type` varchar(50) NOT NULL DEFAULT '' COMMENT '发票类型',
  `invoice_status` varchar(50) NOT NULL DEFAULT '' COMMENT '发票状态',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='已认证发票清单';

-- ----------------------------
-- Table structure for cit_balance_sheet_prc_adjust
-- ----------------------------
DROP TABLE IF EXISTS `cit_balance_sheet_prc_adjust`;
CREATE TABLE `cit_balance_sheet_prc_adjust` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL COMMENT '机构编号',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '项目ID',
  `period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '期间 yyyymm',
  `date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '数据日期',
  `source` varchar(20) NOT NULL DEFAULT '' COMMENT '来源 GL',
  `tms_period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '税务系统期间yyyymm',
  `item_name` varchar(300) NOT NULL DEFAULT '' COMMENT '项目名称',
  `end_bal` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '期末余额',
  `beg_bal` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '年初余额',
  `create_by` varchar(100) NOT NULL DEFAULT '' COMMENT '创建人',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='资产负债表（单家PRC）调整';

-- ----------------------------
-- Table structure for cit_data_import_log
-- ----------------------------
DROP TABLE IF EXISTS `cit_data_import_log`;
CREATE TABLE `cit_data_import_log` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL DEFAULT '' COMMENT '机构编号',
  `taxpayer_id_num` varchar(128) NOT NULL DEFAULT '' COMMENT '纳税人识别号',
  `type` tinyint(2) unsigned DEFAULT '0' COMMENT '导入类型（随着类型的增加增加数字即可）。0-未定义，1-日记账调整，2-资产负债表，3-',
  `company_code` varchar(300) NOT NULL DEFAULT '' COMMENT '公司代码',
  `company_name` varchar(300) NOT NULL DEFAULT '' COMMENT '公司名称',
  `file_type` varchar(20) NOT NULL DEFAULT '' COMMENT '文件类型',
  `period_year` int(4) unsigned NOT NULL DEFAULT '0' COMMENT '年度',
  `tms_period_month` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '税务系统期间',
  `period_month` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '期间',
  `period_status` varchar(20) NOT NULL DEFAULT '' COMMENT 'Oracle期间状态',
  `operator` varchar(50) NOT NULL DEFAULT '' COMMENT '操作人',
  `operate_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '操作时间',
  `import_result` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '导入结果',
  `error_msg` varchar(300) NOT NULL DEFAULT '导入成功' COMMENT '校验问题',
  `record_size` int(8) unsigned NOT NULL DEFAULT '0' COMMENT '记录条数',
  `display` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '是否为最新导入记录。0-不是，1-是 。写入新提交记录时更新旧的为0',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='CIT数据导入记录。';

-- ----------------------------
-- Table structure for cit_draft_account_mapping
-- ----------------------------
DROP TABLE IF EXISTS `cit_draft_account_mapping`;
CREATE TABLE `cit_draft_account_mapping` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号 系统唯一编号',
  `organization_id` varchar(128) NOT NULL DEFAULT '' COMMENT '机构编号 对应机构编号',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '项目ID ',
  `period` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '期间',
  `source` varchar(20) NOT NULL DEFAULT '' COMMENT '来源 GL',
  `acct_code` varchar(128) NOT NULL DEFAULT '' COMMENT '科目代码',
  `account_name` varchar(400) NOT NULL DEFAULT '' COMMENT '科目名称 ',
  `attribute` varchar(128) NOT NULL DEFAULT '' COMMENT '小类 ',
  `created_by` varchar(300) NOT NULL DEFAULT '' COMMENT '创建人 ',
  `updated_by` varchar(300) NOT NULL DEFAULT '' COMMENT '最后更新人 ',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间 ',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间 ',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='底稿&科目Mapping表';

-- ----------------------------
-- Table structure for cit_eam_assets_disposal
-- ----------------------------
DROP TABLE IF EXISTS `cit_eam_assets_disposal`;
CREATE TABLE `cit_eam_assets_disposal` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号 系统唯一编号',
  `organization_id` varchar(128) NOT NULL DEFAULT '' COMMENT '机构编号 对应机构编号',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '项目ID ',
  `period` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '期间',
  `source` varchar(20) NOT NULL DEFAULT '' COMMENT '来源 GL',
  `occur_period` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '发生期间',
  `asset_label_number` varchar(128) NOT NULL DEFAULT '' COMMENT '资产标签号',
  `compensation_sale_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT '赔偿/变卖金额',
  `created_by` varchar(300) NOT NULL DEFAULT '' COMMENT '创建人 ',
  `updated_by` varchar(300) NOT NULL DEFAULT '' COMMENT '最后更新人 ',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间 ',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间 ',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='EAM资产处置金额记录表';

-- ----------------------------
-- Table structure for cit_journal_entry_adjust
-- ----------------------------
DROP TABLE IF EXISTS `cit_journal_entry_adjust`;
CREATE TABLE `cit_journal_entry_adjust` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号 系统唯一编号',
  `organization_id` varchar(128) NOT NULL DEFAULT '' COMMENT '机构编号 对应机构编号',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '项目ID ',
  `period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '期间',
  `date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '数据日期 ',
  `source` varchar(20) NOT NULL DEFAULT '' COMMENT '来源 GL',
  `ledger_id` varchar(128) NOT NULL DEFAULT '' COMMENT '账套ID ',
  `ledger_name` varchar(300) NOT NULL DEFAULT '' COMMENT '账套名称 ',
  `currency_code` varchar(20) NOT NULL DEFAULT '' COMMENT '账套币种 ',
  `status` varchar(10) NOT NULL DEFAULT '' COMMENT '关账标识 Y/N',
  `header_id` varchar(128) NOT NULL DEFAULT '' COMMENT '日记账头ID ',
  `line_num` varchar(300) NOT NULL DEFAULT '' COMMENT '日记账行号 ',
  `approval_status` varchar(20) NOT NULL DEFAULT '' COMMENT '审批状态 ',
  `posted_status` varchar(20) NOT NULL DEFAULT '' COMMENT '过账 ',
  `account_period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '会计期间 yyyymm',
  `accounting_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '凭证日期 ',
  `journal_source` varchar(20) NOT NULL DEFAULT '' COMMENT '日记账来源 ',
  `category` varchar(50) NOT NULL DEFAULT '' COMMENT '日记账类别 ',
  `name` varchar(300) NOT NULL DEFAULT '' COMMENT '日记账名称 ',
  `voucher_num` varchar(128) NOT NULL DEFAULT '' COMMENT '凭证编号 ',
  `description` varchar(500) NOT NULL DEFAULT '' COMMENT '摘要 ',
  `org_code` varchar(300) NOT NULL DEFAULT '' COMMENT '主体代码 ',
  `subject_code` varchar(300) NOT NULL DEFAULT '' COMMENT '科目代码 ',
  `org_name` varchar(300) NOT NULL DEFAULT '' COMMENT '主体说明 ',
  `subject_name` varchar(300) NOT NULL DEFAULT '' COMMENT '科目说明 ',
  `accounted_dr` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '借方金额 ',
  `accounted_cr` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '贷方金额 ',
  `created_by` varchar(300) NOT NULL DEFAULT '' COMMENT '创建人 ',
  `created_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建日期 ',
  `late_updated_by` varchar(300) NOT NULL DEFAULT '' COMMENT '最后更新人 ',
  `late_updated_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '最后更新日期 ',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间 ',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间 ',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='CIT日记账调整版';

-- ----------------------------
-- Table structure for cit_profit_prc_adjust
-- ----------------------------
DROP TABLE IF EXISTS `cit_profit_prc_adjust`;
CREATE TABLE `cit_profit_prc_adjust` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL COMMENT '机构编号',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '项目ID',
  `period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '期间 yyyymm',
  `date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '数据日期',
  `source` varchar(20) NOT NULL DEFAULT '' COMMENT '来源',
  `tms_period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '税务系统期间yyyymm',
  `item_name` varchar(300) NOT NULL DEFAULT '' COMMENT '项目名称',
  `period_amt` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本期发生额',
  `ytd_amt` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本年累计',
  `create_by` varchar(100) NOT NULL DEFAULT '' COMMENT '创建人',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='利润表表（单家PRC）调整';

-- ----------------------------
-- Table structure for cit_salary_advance
-- ----------------------------
DROP TABLE IF EXISTS `cit_salary_advance`;
CREATE TABLE `cit_salary_advance` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号 系统唯一编号',
  `organization_id` varchar(128) NOT NULL DEFAULT '' COMMENT '机构编号 对应机构编号',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '项目ID ',
  `period` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '期间',
  `source` varchar(20) NOT NULL DEFAULT '' COMMENT '来源 GL',
  `po_no` varchar(22) NOT NULL DEFAULT '0' COMMENT 'PO号',
  `po_subject_code` varchar(128) NOT NULL DEFAULT '' COMMENT 'PO主体CODE',
  `po_subject_name` varchar(300) NOT NULL DEFAULT '' COMMENT 'PO主体名称',
  `advance` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT '预提',
  `approved_standard_invoice_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT '已批准标准发票金额',
  `created_by` varchar(300) NOT NULL DEFAULT '' COMMENT '创建人 ',
  `updated_by` varchar(300) NOT NULL DEFAULT '' COMMENT '最后更新人 ',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间 ',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间 ',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='预提重分类数据源（工资薪金预提）';

-- ----------------------------
-- Table structure for cit_trial_balance
-- ----------------------------
DROP TABLE IF EXISTS `cit_trial_balance`;
CREATE TABLE `cit_trial_balance` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL COMMENT '机构编号',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '项目ID',
  `date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '数据日期',
  `source` varchar(20) NOT NULL DEFAULT '' COMMENT '来源',
  `period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '期间 yyyymm',
  `account_code` varchar(300) NOT NULL DEFAULT '' COMMENT '科目代码',
  `account_description` varchar(300) NOT NULL DEFAULT '' COMMENT '科目说明',
  `account_period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '期间 yyyymm',
  `beginning_balance` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT '期初余额',
  `ending_balance` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT '期末余额',
  `create_by` varchar(100) NOT NULL DEFAULT '',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='CIT试算平衡表';

-- ----------------------------
-- Table structure for coupa_purchasing_report
-- ----------------------------
DROP TABLE IF EXISTS `coupa_purchasing_report`;
CREATE TABLE `coupa_purchasing_report` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL COMMENT '机构编号',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '项目ID',
  `tms_period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '税务系统期间',
  `period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '期间',
  `bill_num` varchar(300) NOT NULL DEFAULT '' COMMENT '账单',
  `company_code` varchar(300) NOT NULL DEFAULT '' COMMENT '机构代码',
  `billing_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '记账日期',
  `invoice_num` varchar(50) NOT NULL DEFAULT '' COMMENT '发票编号',
  `line_num` int(8) unsigned NOT NULL DEFAULT '0' COMMENT '行号',
  `head_up_status` varchar(20) NOT NULL DEFAULT '' COMMENT '抬头状态',
  `invoice_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '发票日期',
  `invoice_receipt_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '发票接收日期',
  `pay_expiration` varchar(20) NOT NULL DEFAULT '' COMMENT '付款期限',
  `purchase_order_num` varchar(300) NOT NULL DEFAULT '' COMMENT '采购订单号',
  `purchase_order_line_num` int(8) unsigned NOT NULL DEFAULT '0' COMMENT '采购订单行号',
  `description` varchar(300) NOT NULL DEFAULT '' COMMENT '说明',
  `supplier_num` varchar(20) NOT NULL DEFAULT '' COMMENT '供应商号',
  `supplier` varchar(300) NOT NULL DEFAULT '' COMMENT '供应商',
  `total_amount` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '总计',
  `currency` varchar(20) NOT NULL DEFAULT '' COMMENT '货币',
  `paid` tinyint(1) NOT NULL DEFAULT '0' COMMENT '已付款',
  `amortization` tinyint(1) NOT NULL DEFAULT '0' COMMENT '摊销',
  `prepayments` tinyint(1) NOT NULL DEFAULT '0' COMMENT '预付款',
  `review_reason` varchar(300) NOT NULL DEFAULT '' COMMENT '审核原因',
  `commodity` varchar(300) NOT NULL DEFAULT '' COMMENT '商品',
  `commodity_code` varchar(50) NOT NULL DEFAULT '' COMMENT 'Commodity Code',
  `founder` varchar(50) NOT NULL DEFAULT '' COMMENT '创建人',
  `create_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建日期',
  `current_approver` varchar(50) NOT NULL DEFAULT '' COMMENT '当前批准人',
  `last_updated_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '上次更新日期',
  `last_updated_person` varchar(50) NOT NULL DEFAULT '' COMMENT '上次更新人',
  `total_tax_amount` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '总税额',
  `total_tax_amount_header` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '总计税额（抬头）',
  `billing_note` varchar(300) NOT NULL DEFAULT '' COMMENT 'Billing Note',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='coupa发票报告';

-- ----------------------------
-- Table structure for customer
-- ----------------------------
DROP TABLE IF EXISTS `customer`;
CREATE TABLE `customer` (
  `id` varchar(128) NOT NULL,
  `code` varchar(50) NOT NULL DEFAULT '',
  `name` varchar(100) NOT NULL DEFAULT '',
  `enter_prise_account_id` varchar(128) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `customer_code_IDX` (`code`,`enter_prise_account_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for data_import_log
-- ----------------------------
DROP TABLE IF EXISTS `data_import_log`;
CREATE TABLE `data_import_log` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL DEFAULT '' COMMENT '机构编号',
  `taxpayer_id_num` varchar(128) NOT NULL DEFAULT '' COMMENT '纳税人识别号',
  `type` tinyint(2) unsigned DEFAULT '0' COMMENT '导入类型。0-未定义，1-利润表，2-资产负债表',
  `company_code` varchar(300) NOT NULL DEFAULT '' COMMENT '公司代码',
  `company_name` varchar(300) NOT NULL DEFAULT '' COMMENT '公司名称',
  `file_type` varchar(20) NOT NULL DEFAULT '' COMMENT '文件类型',
  `period_year` int(4) unsigned NOT NULL DEFAULT '0' COMMENT '年度',
  `tms_period_month` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '税务系统期间',
  `period_month` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '期间',
  `period_status` varchar(20) NOT NULL DEFAULT '' COMMENT 'Oracle期间状态',
  `operator` varchar(50) NOT NULL DEFAULT '' COMMENT '操作人',
  `operate_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '操作时间',
  `import_result` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '导入结果',
  `error_msg` varchar(300) NOT NULL DEFAULT '导入成功' COMMENT '校验问题',
  `record_size` int(8) unsigned NOT NULL DEFAULT '0' COMMENT '记录条数',
  `display` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '是否为最新导入记录。0-不是，1-是 。写入新提交记录时更新旧的为0',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='数据校验日志记录。';

-- ----------------------------
-- Table structure for data_validate_log
-- ----------------------------
DROP TABLE IF EXISTS `data_validate_log`;
CREATE TABLE `data_validate_log` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '项目编号',
  `result` varchar(128) DEFAULT NULL COMMENT '结果信息',
  `period` varchar(128) NOT NULL DEFAULT '' COMMENT '期间',
  `validate_result` varchar(300) DEFAULT '' COMMENT '校验结果(end  or error )',
  `validate_user` varchar(300) NOT NULL DEFAULT '' COMMENT '校验人',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='数据校验日志记录。';

-- ----------------------------
-- Table structure for dictionary
-- ----------------------------
DROP TABLE IF EXISTS `dictionary`;
CREATE TABLE `dictionary` (
  `id` varchar(128) NOT NULL,
  `code` varchar(200) NOT NULL DEFAULT '',
  `dict_key` varchar(200) NOT NULL DEFAULT '',
  `dict_value` varchar(500) NOT NULL DEFAULT '',
  `parent_code` varchar(200) DEFAULT '',
  `order_index` int(10) NOT NULL DEFAULT '0',
  `is_active` tinyint(1) NOT NULL DEFAULT '0',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `remark` varchar(500) DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for dimension
-- ----------------------------
DROP TABLE IF EXISTS `dimension`;
CREATE TABLE `dimension` (
  `id` varchar(128) NOT NULL,
  `name` varchar(200) NOT NULL DEFAULT '',
  `attribute_id` varchar(128) DEFAULT '',
  `order_index` int(5) NOT NULL DEFAULT '0',
  `is_mandatory` tinyint(1) NOT NULL DEFAULT '0',
  `is_active` tinyint(1) NOT NULL DEFAULT '0',
  `is_system_dimension` tinyint(1) NOT NULL DEFAULT '0',
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `update_by` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `dimension_attribute_id_IDX` (`attribute_id`,`is_active`,`is_system_dimension`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for dimension_value
-- ----------------------------
DROP TABLE IF EXISTS `dimension_value`;
CREATE TABLE `dimension_value` (
  `id` varchar(128) NOT NULL,
  `name` varchar(100) NOT NULL DEFAULT '',
  `is_active` tinyint(1) NOT NULL DEFAULT '0',
  `dimension_id` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `update_by` varchar(128) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `dimension_value_name_IDX` (`name`,`is_active`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for dimension_value_org
-- ----------------------------
DROP TABLE IF EXISTS `dimension_value_org`;
CREATE TABLE `dimension_value_org` (
  `id` varchar(128) NOT NULL,
  `dimension_value_id` varchar(128) NOT NULL DEFAULT '',
  `organization_id` varchar(128) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `dimension_value_org_dimension_value_id_IDX` (`dimension_value_id`,`organization_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for enterprise_account
-- ----------------------------
DROP TABLE IF EXISTS `enterprise_account`;
CREATE TABLE `enterprise_account` (
  `id` varchar(128) NOT NULL,
  `code` varchar(50) NOT NULL DEFAULT '',
  `name` varchar(200) NOT NULL DEFAULT '',
  `parent_code` varchar(50) DEFAULT '',
  `full_name` varchar(200) DEFAULT '',
  `acct_prop` int(10) DEFAULT '0',
  `sub_prop` int(10) DEFAULT '0',
  `acct_level` int(10) DEFAULT '0',
  `direction` int(10) NOT NULL DEFAULT '0',
  `is_leaf` tinyint(1) NOT NULL DEFAULT '0',
  `rule_type` int(10) NOT NULL DEFAULT '0',
  `is_active` tinyint(1) NOT NULL DEFAULT '0',
  `english_name` varchar(200) DEFAULT '',
  `std_code` varchar(50) DEFAULT '',
  `enterprise_account_set_id` varchar(128) NOT NULL DEFAULT '',
  `creator_id` varchar(128) NOT NULL DEFAULT '',
  `updator_id` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `enterprise_account_acct_level_IDX` (`acct_level`,`enterprise_account_set_id`) USING BTREE,
  KEY `enterprise_account_code_IDX` (`code`) USING BTREE,
  KEY `enterprise_account_parent_code_IDX` (`parent_code`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for enterprise_account_set
-- ----------------------------
DROP TABLE IF EXISTS `enterprise_account_set`;
CREATE TABLE `enterprise_account_set` (
  `id` varchar(128) NOT NULL,
  `code` varchar(50) NOT NULL DEFAULT '',
  `name` varchar(500) NOT NULL DEFAULT '',
  `is_active` tinyint(1) NOT NULL DEFAULT '0',
  `creator_id` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  UNIQUE KEY `enterprise_account_set_name_IDX` (`name`) USING BTREE,
  KEY `enterprise_account_set_code_IDX` (`code`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for enterprise_account_set_org
-- ----------------------------
DROP TABLE IF EXISTS `enterprise_account_set_org`;
CREATE TABLE `enterprise_account_set_org` (
  `id` varchar(128) NOT NULL,
  `enterprise_account_set_id` varchar(128) NOT NULL DEFAULT '',
  `organization_id` varchar(128) NOT NULL DEFAULT '',
  `effective_date` datetime DEFAULT CURRENT_TIMESTAMP,
  `expired_date` datetime DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  UNIQUE KEY `enterprise_account_set_org_enterprise_account_set_id_IDX` (`enterprise_account_set_id`,`organization_id`,`effective_date`,`expired_date`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for equity_information
-- ----------------------------
DROP TABLE IF EXISTS `equity_information`;
CREATE TABLE `equity_information` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号',
  `e_num` int(4) NOT NULL COMMENT '股权信息序号。从1开始',
  `organization_id` varchar(128) NOT NULL DEFAULT '' COMMENT '对应机构编号',
  `investor_name` varchar(200) DEFAULT '' COMMENT '投资方名称。表格里的文本框',
  `investor_economic_nature` varchar(500) DEFAULT '' COMMENT '投资方经济性质',
  `certificate_type` varchar(20) DEFAULT '' COMMENT '证件类型',
  `id_num` varchar(30) DEFAULT '' COMMENT '证件号码.',
  `investment_amount` bigint(22) DEFAULT '0' COMMENT '投资金额.',
  `investment_currency` varchar(10) DEFAULT '' COMMENT '投资金额币种.',
  `investment_radio` float DEFAULT '0' COMMENT '投资比例',
  `payable_shareholder_name` varchar(200) DEFAULT '' COMMENT '实缴股东名称.',
  `payable_shareholder_id_num` varchar(100) DEFAULT '' COMMENT '实缴股东证件编号',
  `payable_capital_contribution_amount` bigint(22) DEFAULT '0' COMMENT '实缴出资金额',
  `payable_capital_contribution_currency` varchar(10) DEFAULT '' COMMENT '实缴出资币种',
  `payable_contribution_proportion` float DEFAULT '0' COMMENT '实缴出资比例。百分比，多个股东合计为100%',
  `create_time` datetime DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` datetime DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`,`e_num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='股权信息表';

-- ----------------------------
-- Table structure for equity_information_history
-- ----------------------------
DROP TABLE IF EXISTS `equity_information_history`;
CREATE TABLE `equity_information_history` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号',
  `e_num` int(4) NOT NULL COMMENT '股权信息序号。从1开始',
  `organization_id` varchar(128) NOT NULL DEFAULT '' COMMENT '对应机构编号',
  `investor_name` varchar(200) DEFAULT '' COMMENT '投资方名称。表格里的文本框',
  `investor_economic_nature` varchar(500) DEFAULT '' COMMENT '投资方经济性质',
  `certificate_type` varchar(20) DEFAULT '' COMMENT '证件类型',
  `id_num` varchar(30) DEFAULT '' COMMENT '证件号码.',
  `investment_amount` bigint(22) DEFAULT '0' COMMENT '投资金额.',
  `investment_currency` varchar(10) DEFAULT '' COMMENT '投资金额币种.',
  `investment_radio` float DEFAULT '0' COMMENT '投资比例',
  `payable_shareholder_name` varchar(200) DEFAULT '' COMMENT '实缴股东名称.',
  `payable_shareholder_id_num` varchar(100) DEFAULT '' COMMENT '实缴股东证件编号',
  `payable_capital_contribution_amount` bigint(22) DEFAULT '0' COMMENT '实缴出资金额',
  `payable_capital_contribution_currency` varchar(10) DEFAULT '' COMMENT '实缴出资币种',
  `payable_contribution_proportion` float DEFAULT '0' COMMENT '实缴出资比例。百分比，多个股东合计为100%',
  `create_time` datetime DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` datetime DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`,`e_num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='股权信息表-历史表';

-- ----------------------------
-- Table structure for formula_config
-- ----------------------------
DROP TABLE IF EXISTS `formula_config`;
CREATE TABLE `formula_config` (
  `id` varchar(128) NOT NULL,
  `formula_name` varchar(500) NOT NULL DEFAULT '',
  `description` varchar(500) NOT NULL DEFAULT '',
  `calculate_status` int(10) NOT NULL DEFAULT '0',
  `data_source_type` int(10) DEFAULT '0',
  `data_source_name` varchar(500) DEFAULT '',
  `chinese_name` varchar(500) DEFAULT '',
  `english_name` varchar(500) DEFAULT '',
  `service_type` varchar(128) DEFAULT '',
  `industry` varchar(128) DEFAULT '',
  `required_param_num` int(10) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `formula_config_formula_name_IDX` (`formula_name`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for formula_param_config
-- ----------------------------
DROP TABLE IF EXISTS `formula_param_config`;
CREATE TABLE `formula_param_config` (
  `id` varchar(128) NOT NULL,
  `name` varchar(500) NOT NULL DEFAULT '',
  `display_format` varchar(500) DEFAULT '',
  `param_type` int(10) NOT NULL DEFAULT '0',
  `param_data_type` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `formula_param_config_name_IDX` (`name`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for formula_param_mapping
-- ----------------------------
DROP TABLE IF EXISTS `formula_param_mapping`;
CREATE TABLE `formula_param_mapping` (
  `id` varchar(128) NOT NULL,
  `formula_id` varchar(128) NOT NULL DEFAULT '',
  `formula_param_id` varchar(128) NOT NULL DEFAULT '',
  `param_index` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `formula_param_mapping_formula_id_UIDX` (`formula_id`,`formula_param_id`,`param_index`) USING BTREE,
  UNIQUE KEY `formula_param_mapping_formula_id_IDX` (`formula_id`,`formula_param_id`,`param_index`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for formula_param_option
-- ----------------------------
DROP TABLE IF EXISTS `formula_param_option`;
CREATE TABLE `formula_param_option` (
  `id` varchar(128) NOT NULL,
  `formula_param_id` varchar(128) NOT NULL DEFAULT '',
  `value` varchar(500) NOT NULL DEFAULT '',
  `name` varchar(500) NOT NULL DEFAULT '',
  `short_name` varchar(500) NOT NULL DEFAULT '',
  `option_index` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for gl_balance
-- ----------------------------
DROP TABLE IF EXISTS `gl_balance`;
CREATE TABLE `gl_balance` (
  `id` bigint(22) DEFAULT NULL,
  `code_combination_id` bigint(22) DEFAULT NULL,
  `code_combination_code` varchar(300) DEFAULT NULL,
  `code_combination_description` varchar(300) DEFAULT NULL,
  `attribute12` varchar(300) DEFAULT NULL,
  `segment1` varchar(300) DEFAULT NULL,
  `segment2` varchar(300) DEFAULT NULL,
  `segment3` varchar(300) DEFAULT NULL,
  `segment4` varchar(300) DEFAULT NULL,
  `segment5` varchar(300) DEFAULT NULL,
  `segment6` varchar(300) DEFAULT NULL,
  `segment7` varchar(300) DEFAULT NULL,
  `period_name` varchar(10) DEFAULT NULL,
  `begin_dr_balance` bigint(22) DEFAULT NULL,
  `begin_cr_balance` bigint(22) DEFAULT NULL,
  `ptd_dr` bigint(22) DEFAULT NULL,
  `ptd_cr` bigint(22) DEFAULT NULL,
  `ytd_dr` bigint(22) DEFAULT NULL,
  `ytd_cr` bigint(22) DEFAULT NULL,
  `end_dr_balance` bigint(22) DEFAULT NULL,
  `end_cr_balance` bigint(22) DEFAULT NULL,
  `attr1` varchar(300) DEFAULT NULL,
  `attr2` varchar(300) DEFAULT NULL,
  `attr3` varchar(300) DEFAULT NULL,
  `attr4` varchar(300) DEFAULT NULL,
  `attr5` varchar(300) DEFAULT NULL,
  UNIQUE KEY `gl_balance_id_IDX` (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for industry
-- ----------------------------
DROP TABLE IF EXISTS `industry`;
CREATE TABLE `industry` (
  `id` varchar(128) NOT NULL,
  `name` varchar(100) NOT NULL DEFAULT '',
  `is_active` tinyint(1) NOT NULL DEFAULT '0',
  `english_name` varchar(100) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for input_ap_invoice
-- ----------------------------
DROP TABLE IF EXISTS `input_ap_invoice`;
CREATE TABLE `input_ap_invoice` (
  `id` bigint(18) NOT NULL,
  `operation_unit_id` int(11) NOT NULL DEFAULT '0',
  `operation_name` varchar(240) NOT NULL DEFAULT '',
  `invoice_type_lookup_code` varchar(240) NOT NULL DEFAULT '',
  `invoice_id` int(11) NOT NULL DEFAULT '0',
  `invoice_num` varchar(50) NOT NULL DEFAULT '',
  `vendor_id` int(11) NOT NULL DEFAULT '0',
  `vendor_number` varchar(30) NOT NULL DEFAULT '',
  `vendor_name` varchar(240) NOT NULL DEFAULT '',
  `vendor_site_id` int(11) NOT NULL DEFAULT '0',
  `vendor_site_code` varchar(15) NOT NULL DEFAULT '',
  `invoice_date` varchar(10) NOT NULL DEFAULT '',
  `invoice_currency_code` varchar(15) NOT NULL DEFAULT '',
  `invoice_amount` decimal(18,4) NOT NULL DEFAULT '0.0000',
  `total_tax_amount` decimal(18,4) NOT NULL DEFAULT '0.0000',
  `gl_date` varchar(10) NOT NULL DEFAULT '',
  `payment_currency_code` varchar(15) NOT NULL DEFAULT '',
  `payment_cross_rate_date` varchar(10) NOT NULL DEFAULT '',
  `exchange_rate_yype` varchar(30) NOT NULL DEFAULT '',
  `exchange_date` varchar(10) NOT NULL DEFAULT '',
  `exchange_rate` decimal(18,4) NOT NULL DEFAULT '0.0000',
  `description` varchar(240) NOT NULL DEFAULT '',
  `terms_name` varchar(50) NOT NULL DEFAULT '',
  `terms_date` varchar(10) NOT NULL DEFAULT '',
  `payment_method_code` varchar(30) NOT NULL DEFAULT '',
  `taxation_country` varchar(30) NOT NULL DEFAULT '',
  `tax_business_category` varchar(240) NOT NULL DEFAULT '',
  `invoice_status` varchar(240) NOT NULL DEFAULT '',
  `source` varchar(25) NOT NULL DEFAULT '',
  `created_by_name` varchar(240) NOT NULL DEFAULT '',
  `attribute1` varchar(240) NOT NULL DEFAULT '',
  `attribute2` varchar(240) NOT NULL DEFAULT '',
  `attribute3` varchar(240) NOT NULL DEFAULT '',
  `attribute4` varchar(240) NOT NULL DEFAULT '',
  `attribute5` varchar(240) NOT NULL DEFAULT '',
  `attribute6` varchar(240) NOT NULL DEFAULT '',
  `attribute7` varchar(240) NOT NULL DEFAULT '',
  `attribute8` varchar(240) NOT NULL DEFAULT '',
  `attribute9` varchar(240) NOT NULL DEFAULT '',
  `attribute10` varchar(240) NOT NULL DEFAULT '',
  `attribute11` varchar(240) NOT NULL DEFAULT '',
  `attribute12` varchar(240) NOT NULL DEFAULT '',
  `attribute13` varchar(240) NOT NULL DEFAULT '',
  `attribute14` varchar(240) NOT NULL DEFAULT '',
  `attribute15` varchar(240) NOT NULL DEFAULT '',
  `attr1` varchar(240) NOT NULL DEFAULT '',
  `attr2` varchar(240) NOT NULL DEFAULT '',
  `attr3` varchar(240) NOT NULL DEFAULT '',
  `attr4` varchar(240) NOT NULL DEFAULT '',
  `attr5` varchar(240) NOT NULL DEFAULT '',
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `update_by` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for input_invoice
-- ----------------------------
DROP TABLE IF EXISTS `input_invoice`;
CREATE TABLE `input_invoice` (
  `ID` varchar(255) NOT NULL,
  `BLYY` varchar(255) DEFAULT NULL,
  `BZ` varchar(255) DEFAULT NULL,
  `CJSJ` varchar(255) DEFAULT NULL,
  `COMPANYID` varchar(255) DEFAULT NULL,
  `CYZT` varchar(255) DEFAULT NULL,
  `DZDH` varchar(255) DEFAULT NULL,
  `FHR` varchar(255) DEFAULT NULL,
  `FPDM` varchar(255) DEFAULT NULL,
  `FPHM` varchar(255) DEFAULT NULL,
  `FPLC` varchar(255) DEFAULT NULL,
  `FPLX` varchar(255) DEFAULT NULL,
  `FPYX` varchar(255) DEFAULT NULL,
  `FPZT` varchar(255) DEFAULT NULL,
  `GFDZDH` varchar(255) DEFAULT NULL,
  `GFMC` varchar(255) DEFAULT NULL,
  `GFSH` varchar(255) DEFAULT NULL,
  `GFYHZH` varchar(255) DEFAULT NULL,
  `HJJE` varchar(255) DEFAULT NULL,
  `HJSE` varchar(255) DEFAULT NULL,
  `JQBH` varchar(255) DEFAULT NULL,
  `JSHJ` varchar(255) DEFAULT NULL,
  `JYM` varchar(255) DEFAULT NULL,
  `KPR` varchar(255) DEFAULT NULL,
  `KPRQ` varchar(255) DEFAULT NULL,
  `LCBH` varchar(255) DEFAULT NULL,
  `LRRQ` varchar(255) DEFAULT NULL,
  `MWQ` varchar(255) DEFAULT NULL,
  `PZH` varchar(255) DEFAULT NULL,
  `RZJG` varchar(255) DEFAULT NULL,
  `RZJGMS` varchar(255) DEFAULT NULL,
  `RZSJ` varchar(255) DEFAULT NULL,
  `RZSQ` varchar(255) DEFAULT NULL,
  `RZZT` varchar(255) DEFAULT NULL,
  `SKR` varchar(255) DEFAULT NULL,
  `XFDZDH` varchar(255) DEFAULT NULL,
  `XFMC` varchar(255) DEFAULT NULL,
  `XFSH` varchar(255) DEFAULT NULL,
  `XFYHZH` varchar(255) DEFAULT NULL,
  `XTLY` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for input_material_item
-- ----------------------------
DROP TABLE IF EXISTS `input_material_item`;
CREATE TABLE `input_material_item` (
  `id` bigint(18) NOT NULL,
  `org_code` varchar(10) NOT NULL DEFAULT '',
  `item_number` varchar(40) NOT NULL DEFAULT '',
  `item_desc_zhs` varchar(240) NOT NULL DEFAULT '',
  `item_desc_us` varchar(240) NOT NULL DEFAULT '',
  `item_long_desc_zhs` varchar(4000) NOT NULL DEFAULT '',
  `item_long_desc_us` varchar(4000) NOT NULL DEFAULT '',
  `primary_unit_of_measure` varchar(10) NOT NULL DEFAULT '',
  `unit_of_measure` varchar(10) NOT NULL DEFAULT '',
  `lot_control` varchar(5) NOT NULL DEFAULT '',
  `shelflife_days` int(11) NOT NULL DEFAULT '0',
  `item_status` varchar(10) NOT NULL DEFAULT '',
  `stock_enable_flag` varchar(5) NOT NULL DEFAULT '',
  `purchasing_enable_flag` varchar(5) NOT NULL DEFAULT '',
  `must_approve_vendor` varchar(5) NOT NULL DEFAULT '',
  `default_buyer_num` varchar(30) NOT NULL DEFAULT '',
  `default_buyer` varchar(100) NOT NULL DEFAULT '',
  `bom_enabled_flag` varchar(5) NOT NULL DEFAULT '',
  `build_in_wip_flag` varchar(5) NOT NULL DEFAULT '',
  `custmoer_order_flag` varchar(5) NOT NULL DEFAULT '',
  `internal_order_flag` varchar(5) NOT NULL DEFAULT '',
  `invoiced_enable_flag` varchar(5) NOT NULL DEFAULT '',
  `transaction_enable_flag` varchar(5) NOT NULL DEFAULT '',
  `receive_routing_id` varchar(5) NOT NULL DEFAULT '',
  `extend_attributes` varchar(4000) NOT NULL DEFAULT '',
  `attr1` varchar(240) NOT NULL DEFAULT '',
  `attr2` varchar(240) NOT NULL DEFAULT '',
  `attr3` varchar(240) NOT NULL DEFAULT '',
  `attr4` varchar(240) NOT NULL DEFAULT '',
  `attr5` varchar(240) NOT NULL DEFAULT '',
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `update_by` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `item_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for input_material_item_category
-- ----------------------------
DROP TABLE IF EXISTS `input_material_item_category`;
CREATE TABLE `input_material_item_category` (
  `id` bigint(18) NOT NULL,
  `material_item_id` bigint(18) NOT NULL DEFAULT '0',
  `category_set_code` varchar(30) NOT NULL DEFAULT '',
  `category_set_name_zhs` varchar(240) NOT NULL DEFAULT '',
  `category_set_name_us` varchar(240) NOT NULL DEFAULT '',
  `set_value` varchar(80) NOT NULL DEFAULT '',
  `set_value_desc_zhs` varchar(800) NOT NULL DEFAULT '',
  `set_value_desc_us` varchar(800) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `update_by` varchar(128) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for input_vendor
-- ----------------------------
DROP TABLE IF EXISTS `input_vendor`;
CREATE TABLE `input_vendor` (
  `id` bigint(18) NOT NULL,
  `vendor_id` varchar(60) NOT NULL DEFAULT '',
  `vendor_class` varchar(60) NOT NULL DEFAULT '',
  `vendor_code` varchar(40) NOT NULL DEFAULT '',
  `vendor_name` varchar(240) NOT NULL DEFAULT '',
  `vendor_alt_name` varchar(320) NOT NULL DEFAULT '',
  `vendor_address` varchar(240) NOT NULL DEFAULT '',
  `law_person` varchar(100) NOT NULL DEFAULT '',
  `pay_tax_num` varchar(40) NOT NULL DEFAULT '',
  `payment_term` varchar(80) NOT NULL DEFAULT '',
  `payment_method` varchar(80) NOT NULL DEFAULT '',
  `enable_flag` varchar(10) NOT NULL DEFAULT '',
  `internal_comm_com_code` varchar(60) NOT NULL DEFAULT '',
  `internalc_omm_company` varchar(240) NOT NULL DEFAULT '',
  `origin_vendor_code` varchar(60) NOT NULL DEFAULT '',
  `origin_vendo_name` varchar(240) NOT NULL DEFAULT '',
  `attr1` varchar(240) NOT NULL DEFAULT '',
  `attr2` varchar(240) NOT NULL DEFAULT '',
  `attr3` varchar(240) NOT NULL DEFAULT '',
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `update_by` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `internal_com_tax_ref` varchar(40) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for input_vendor_address
-- ----------------------------
DROP TABLE IF EXISTS `input_vendor_address`;
CREATE TABLE `input_vendor_address` (
  `id` bigint(18) NOT NULL,
  `vendor_id` bigint(18) NOT NULL DEFAULT '0',
  `party_site_id` varchar(60) NOT NULL DEFAULT '',
  `address_name` varchar(40) NOT NULL DEFAULT '',
  `country` varchar(10) NOT NULL DEFAULT '',
  `province` varchar(30) NOT NULL DEFAULT '',
  `city` varchar(80) NOT NULL DEFAULT '',
  `county` varchar(100) NOT NULL DEFAULT '',
  `detail_address` varchar(320) NOT NULL DEFAULT '',
  `purchase_flag` varchar(5) NOT NULL DEFAULT '',
  `payment_flag` varchar(5) NOT NULL DEFAULT '',
  `rfq_only_flag` varchar(5) NOT NULL DEFAULT '',
  `enabled_flag` varchar(10) NOT NULL DEFAULT '',
  `attr1` varchar(240) NOT NULL DEFAULT '',
  `attr2` varchar(240) NOT NULL DEFAULT '',
  `attr3` varchar(240) NOT NULL DEFAULT '',
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `update_by` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for input_vendor_bank_account
-- ----------------------------
DROP TABLE IF EXISTS `input_vendor_bank_account`;
CREATE TABLE `input_vendor_bank_account` (
  `id` bigint(18) NOT NULL,
  `vendor_id` bigint(18) NOT NULL DEFAULT '0',
  `bank_code` varchar(40) NOT NULL DEFAULT '',
  `bank_name` varchar(240) NOT NULL DEFAULT '',
  `branch_bank_code` varchar(40) NOT NULL DEFAULT '',
  `branch_bank_name` varchar(240) NOT NULL DEFAULT '',
  `bank_account_name` varchar(120) NOT NULL DEFAULT '',
  `bank_account_number` varchar(40) NOT NULL DEFAULT '',
  `currency_code` varchar(10) NOT NULL DEFAULT '',
  `primary_bank_account` varchar(10) NOT NULL DEFAULT '',
  `enabled_flag` varchar(10) NOT NULL DEFAULT '',
  `attr1` varchar(240) NOT NULL DEFAULT '',
  `attr2` varchar(240) NOT NULL DEFAULT '',
  `attr3` varchar(240) NOT NULL DEFAULT '',
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `update_by` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for input_vendor_contactor
-- ----------------------------
DROP TABLE IF EXISTS `input_vendor_contactor`;
CREATE TABLE `input_vendor_contactor` (
  `id` bigint(18) NOT NULL,
  `vendor_id` bigint(18) NOT NULL DEFAULT '0',
  `contact_party_id` varchar(60) NOT NULL DEFAULT '',
  `contractor_name` varchar(100) NOT NULL DEFAULT '',
  `phon_number` varchar(30) NOT NULL DEFAULT '',
  `email_address` varchar(40) NOT NULL DEFAULT '',
  `disable_date` varchar(30) NOT NULL DEFAULT '',
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `update_by` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for input_vendor_site
-- ----------------------------
DROP TABLE IF EXISTS `input_vendor_site`;
CREATE TABLE `input_vendor_site` (
  `id` bigint(18) NOT NULL,
  `vendor_id` bigint(18) NOT NULL DEFAULT '0',
  `vendor_site_id` varchar(60) NOT NULL DEFAULT '',
  `address_name` varchar(60) NOT NULL DEFAULT '',
  `operate_unit` varchar(30) NOT NULL DEFAULT '',
  `operate_unit_name` varchar(120) NOT NULL DEFAULT '',
  `ship_to_location` varchar(80) NOT NULL DEFAULT '',
  `bill_to_location` varchar(80) NOT NULL DEFAULT '',
  `ship_method` varchar(60) NOT NULL DEFAULT '',
  `payment_method` varchar(60) NOT NULL DEFAULT '',
  `invoice_match_option` varchar(60) NOT NULL DEFAULT '',
  `payment_currency` varchar(10) NOT NULL DEFAULT '',
  `liability_accounts` varchar(80) NOT NULL DEFAULT '',
  `advance_account` varchar(80) NOT NULL DEFAULT '',
  `bill_account` varchar(80) NOT NULL DEFAULT '',
  `disable_date` varchar(30) NOT NULL DEFAULT '',
  `attr1` varchar(240) NOT NULL DEFAULT '',
  `attr2` varchar(240) NOT NULL DEFAULT '',
  `attr3` varchar(240) NOT NULL DEFAULT '',
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `update_by` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for invoice_data
-- ----------------------------
DROP TABLE IF EXISTS `invoice_data`;
CREATE TABLE `invoice_data` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL COMMENT '机构编号',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '项目ID',
  `company_code` varchar(300) NOT NULL DEFAULT '' COMMENT '机构代码',
  `company_name` varchar(300) NOT NULL DEFAULT '' COMMENT '机构名称',
  `tms_period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '税务系统期间',
  `period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '期间',
  `count_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '计数类型',
  `special_invoice_amount1` bigint(8) unsigned NOT NULL DEFAULT '0' COMMENT '专票正数发票份数',
  `special_invoice_amount2` bigint(8) unsigned NOT NULL DEFAULT '0' COMMENT '专票负数发票份数',
  `special_invoice_amount3` bigint(8) unsigned NOT NULL DEFAULT '0' COMMENT '专票正数废票份数',
  `special_invoice_amount4` bigint(8) unsigned NOT NULL DEFAULT '0' COMMENT '专票负数废票份数',
  `special_invoice_sales_amount1` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '专票销项正废金额',
  `special_invoice_sales_amount2` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '专票销项正数金额',
  `special_invoice_sales_amount3` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '专票销项负废金额',
  `special_invoice_sales_amount4` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '专票销项负数金额',
  `special_invoice_sales_amount5` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '专票实际销项金额',
  `special_invoice_tax_amount1` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '专票销项正废税额',
  `special_invoice_tax_amount2` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '专票销项正数税额',
  `special_invoice_tax_amount3` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '专票销项负废税额',
  `special_invoice_tax_amount4` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '专票销项负数税额',
  `special_invoice_tax_amount5` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '专票实际销项税额',
  `invoice_amount1` bigint(8) unsigned NOT NULL DEFAULT '0' COMMENT '普票正数发票份数',
  `invoice_amount2` bigint(8) unsigned NOT NULL DEFAULT '0' COMMENT '普票负数发票份数',
  `invoice_amount3` bigint(8) unsigned NOT NULL DEFAULT '0' COMMENT '普票正数废票份数',
  `invoice_amount4` bigint(8) unsigned NOT NULL DEFAULT '0' COMMENT '普票负数废票份数',
  `invoice_sales_amount1` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '普票销项正废金额',
  `invoice_sales_amount2` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '普票销项正数金额',
  `invoice_sales_amount3` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '普票销项负废金额',
  `invoice_sales_amount4` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '普票销项负数金额',
  `invoice_sales_amount5` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '普票实际销项金额',
  `invoice_tax_amount1` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '普票销项正废税额',
  `invoice_tax_amount2` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '普票销项正数税额',
  `invoice_tax_amount3` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '普票销项负废税额',
  `invoice_tax_amount4` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '普票销项负数税额',
  `invoice_tax_amount5` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '普票实际销项税额',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='发票资料';

-- ----------------------------
-- Table structure for invoice_record
-- ----------------------------
DROP TABLE IF EXISTS `invoice_record`;
CREATE TABLE `invoice_record` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL COMMENT '机构编号',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '项目ID',
  `tms_period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '税务系统期间',
  `period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '期间',
  `seq_no` int(8) unsigned NOT NULL DEFAULT '0' COMMENT '序号',
  `source` varchar(20) NOT NULL DEFAULT '' COMMENT '来源',
  `billing_body` varchar(128) NOT NULL DEFAULT '' COMMENT '开票主体',
  `customer_company_name` varchar(128) NOT NULL DEFAULT '' COMMENT '客户公司名称',
  `invoice_type` varchar(128) NOT NULL DEFAULT '' COMMENT '发票类型',
  `billing_content` varchar(128) NOT NULL DEFAULT '' COMMENT '开票内容',
  `invoice_amount` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '开票金额',
  `applicant` varchar(128) NOT NULL DEFAULT '' COMMENT '申请人',
  `oa_application_num` varchar(128) NOT NULL DEFAULT '' COMMENT 'OA申请单号',
  `contract_no` varchar(128) NOT NULL DEFAULT '' COMMENT '合同编号',
  `contract_amount` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '合同金额',
  `department` varchar(128) NOT NULL DEFAULT '' COMMENT '所属部门',
  `application_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '申请日期',
  `billing_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '开票日期',
  `billing_month` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '开票月份',
  `invoice_code` varchar(128) NOT NULL DEFAULT '' COMMENT '发票代码',
  `invoice_num` varchar(128) NOT NULL DEFAULT '' COMMENT '发票号码',
  `invoices_amount` int(8) unsigned NOT NULL DEFAULT '0' COMMENT '发票张数',
  `customer_company_tax_num` varchar(300) NOT NULL DEFAULT '' COMMENT '客户公司税号',
  `contract_source_system` varchar(300) NOT NULL DEFAULT '' COMMENT '合同来源系统',
  `tax_rate` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '税率',
  `tax_amount` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '税额',
  `invoice_status` varchar(20) NOT NULL DEFAULT '' COMMENT '发票状态',
  `remarks` varchar(500) NOT NULL DEFAULT '' COMMENT '备注',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='已开增值税发票记录';

-- ----------------------------
-- Table structure for journal_entry
-- ----------------------------
DROP TABLE IF EXISTS `journal_entry`;
CREATE TABLE `journal_entry` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号 系统唯一编号',
  `organization_id` varchar(128) NOT NULL DEFAULT '' COMMENT '机构编号 对应机构编号',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '项目ID ',
  `date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '数据日期 ',
  `source` varchar(20) NOT NULL DEFAULT '' COMMENT '来源 GL',
  `ledger_id` varchar(128) NOT NULL DEFAULT '' COMMENT '账套ID ',
  `ledger_name` varchar(300) NOT NULL DEFAULT '' COMMENT '账套名称 ',
  `currency_code` varchar(20) NOT NULL DEFAULT '' COMMENT '账套币种 ',
  `status` varchar(10) NOT NULL DEFAULT '' COMMENT '关账标识 Y/N',
  `header_id` varchar(128) NOT NULL DEFAULT '' COMMENT '日记账头ID ',
  `line_num` varchar(300) NOT NULL DEFAULT '' COMMENT '日记账行号 ',
  `approval_status` varchar(20) NOT NULL DEFAULT '' COMMENT '审批状态 ',
  `posted_status` varchar(20) NOT NULL DEFAULT '' COMMENT '过账 ',
  `period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '会计期间 yyyymm',
  `accounting_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '凭证日期 ',
  `journal_source` varchar(20) NOT NULL DEFAULT '' COMMENT '日记账来源 ',
  `category` varchar(50) NOT NULL DEFAULT '' COMMENT '日记账类别 ',
  `name` varchar(300) NOT NULL DEFAULT '' COMMENT '日记账名称 ',
  `voucher_num` varchar(128) NOT NULL DEFAULT '' COMMENT '凭证编号 ',
  `description` varchar(500) NOT NULL DEFAULT '' COMMENT '摘要 ',
  `segment1` varchar(300) NOT NULL DEFAULT '' COMMENT '主体代码 ',
  `segment2` varchar(300) NOT NULL DEFAULT '' COMMENT '成本中心 ',
  `segment3` varchar(300) NOT NULL DEFAULT '' COMMENT '科目代码 ',
  `segment4` varchar(300) NOT NULL DEFAULT '' COMMENT '辅助科目 ',
  `segment5` varchar(300) NOT NULL DEFAULT '' COMMENT '利润中心 ',
  `segment6` varchar(300) NOT NULL DEFAULT '' COMMENT '产品 ',
  `segment7` varchar(300) NOT NULL DEFAULT '' COMMENT '项目 ',
  `segment8` varchar(300) NOT NULL DEFAULT '' COMMENT '公司间 ',
  `segment9` varchar(300) NOT NULL DEFAULT '' COMMENT '备用1 ',
  `segment10` varchar(300) NOT NULL DEFAULT '' COMMENT '备用2 ',
  `segment1_name` varchar(300) NOT NULL DEFAULT '' COMMENT '主体说明 ',
  `segment2_name` varchar(300) NOT NULL DEFAULT '' COMMENT '成本中心说明 ',
  `segment3_name` varchar(300) NOT NULL DEFAULT '' COMMENT '科目说明 ',
  `segment4_name` varchar(300) NOT NULL DEFAULT '' COMMENT '辅助科目说明 ',
  `segment5_name` varchar(300) NOT NULL DEFAULT '' COMMENT '利润中心说明 ',
  `segment6_name` varchar(300) NOT NULL DEFAULT '' COMMENT '产品说明 ',
  `segment7_name` varchar(300) NOT NULL DEFAULT '' COMMENT '项目说明 ',
  `segment8_name` varchar(300) NOT NULL DEFAULT '' COMMENT '公司间说明 ',
  `segment9_name` varchar(300) NOT NULL DEFAULT '' COMMENT '备用1说明 ',
  `segment10_name` varchar(300) NOT NULL DEFAULT '' COMMENT '备用2说明 ',
  `journal_currency_code` varchar(20) NOT NULL DEFAULT '' COMMENT '币种 ',
  `sob_currency_code` varchar(20) NOT NULL DEFAULT '' COMMENT '本位币币种 ',
  `accounted_dr` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '借方金额 ',
  `accounted_cr` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '贷方金额 ',
  `entered_dr` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本位币借方金额 ',
  `entered_cr` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本位币贷方金额 ',
  `cf_item` varchar(50) DEFAULT '' COMMENT '现金流量表项 ',
  `attribute1` varchar(300) DEFAULT '' COMMENT '城市 ',
  `attribute2` datetime DEFAULT CURRENT_TIMESTAMP COMMENT '交易日期 ',
  `attribute3` varchar(300) DEFAULT '' COMMENT '对方银行账号 ',
  `attribute4` varchar(300) DEFAULT '' COMMENT '银行流水号 ',
  `attribute5` varchar(300) DEFAULT '' COMMENT '供应商编号 ',
  `attribute6` varchar(300) DEFAULT '' COMMENT '交易单号 ',
  `attribute7` varchar(300) DEFAULT '' COMMENT '供应商名称 ',
  `attribute8` varchar(300) DEFAULT '' COMMENT '接收编码 ',
  `attribute9` varchar(300) DEFAULT '' COMMENT '制单人 ',
  `attribute10` varchar(300) DEFAULT '' COMMENT '审核人 ',
  `attribute11` varchar(300) DEFAULT '' COMMENT '成本中心部门描述1 ',
  `attribute12` varchar(300) DEFAULT '' COMMENT '成本中心部门描述2 ',
  `attribute13` varchar(300) DEFAULT '' COMMENT '成本中心部门描述3 ',
  `attribute14` varchar(300) DEFAULT '' COMMENT '成本中心部门描述4 ',
  `attribute15` varchar(300) DEFAULT '' COMMENT '成本中心部门描述5 ',
  `attribute16` varchar(300) DEFAULT '' COMMENT '成本中心部门描述6 ',
  `created_by` varchar(300) NOT NULL DEFAULT '' COMMENT '创建人 ',
  `created_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建日期 ',
  `late_updated_by` varchar(300) NOT NULL DEFAULT '' COMMENT '最后更新人 ',
  `late_updated_date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '最后更新日期 ',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间 ',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间 ',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='日记账。月度传送，次月传送上月一个期间数据，13期在关账时传送';

-- ----------------------------
-- Table structure for key_value_config
-- ----------------------------
DROP TABLE IF EXISTS `key_value_config`;
CREATE TABLE `key_value_config` (
  `id` varchar(128) NOT NULL,
  `key_code` varchar(500) NOT NULL DEFAULT '',
  `name` varchar(500) NOT NULL DEFAULT '',
  `key_value_type` int(10) NOT NULL DEFAULT '0',
  `formula` varchar(500) DEFAULT '',
  `is_constant` int(10) NOT NULL DEFAULT '0',
  `calculate_status` int(10) NOT NULL DEFAULT '0',
  `result_type` int(10) NOT NULL DEFAULT '0',
  `service_type_ids` varchar(200) NOT NULL DEFAULT '',
  `industry_ids` varchar(200) NOT NULL DEFAULT '',
  `description` varchar(500) DEFAULT '',
  `creator` varchar(128) DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `updator` varchar(128) DEFAULT '',
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `data_source` varchar(128) DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `key_value_config_key_code_IDX` (`key_code`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for key_value_reference
-- ----------------------------
DROP TABLE IF EXISTS `key_value_reference`;
CREATE TABLE `key_value_reference` (
  `id` varchar(128) NOT NULL,
  `key_value_config_id` varchar(128) NOT NULL DEFAULT '',
  `scope` int(10) NOT NULL DEFAULT '0',
  `cell_template_id` bigint(19) NOT NULL DEFAULT '0',
  `model_id` varchar(128) DEFAULT '',
  `organization_id` varchar(128) DEFAULT '',
  `industry_id` varchar(128) DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `key_value_reference_organization_id_IDX` (`organization_id`,`industry_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for menu
-- ----------------------------
DROP TABLE IF EXISTS `menu`;
CREATE TABLE `menu` (
  `id` varchar(128) NOT NULL,
  `name` varchar(50) NOT NULL DEFAULT '',
  `route_state_name` varchar(200) DEFAULT '',
  `navigation_url` varchar(500) DEFAULT '',
  `icon_class_name` varchar(500) DEFAULT '',
  `parent_id` varchar(128) DEFAULT '',
  `order_index` int(10) NOT NULL DEFAULT '0',
  `is_active` tinyint(1) NOT NULL DEFAULT '0',
  `is_visible` tinyint(1) NOT NULL DEFAULT '0',
  `service_type_id` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  UNIQUE KEY `menu_name_IDX` (`name`) USING BTREE,
  KEY `menu_parent_id_IDX` (`parent_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for model
-- ----------------------------
DROP TABLE IF EXISTS `model`;
CREATE TABLE `model` (
  `id` varchar(128) NOT NULL,
  `rule_type` int(10) NOT NULL DEFAULT '0',
  `code` varchar(20) NOT NULL DEFAULT '',
  `name` varchar(50) NOT NULL DEFAULT '',
  `type` int(10) NOT NULL DEFAULT '0',
  `is_status` int(10) NOT NULL DEFAULT '0',
  `description` varchar(500) DEFAULT '',
  `feature` int(10) NOT NULL DEFAULT '0',
  `is_filter` int(10) NOT NULL DEFAULT '0',
  `month_judge` varchar(200) DEFAULT '',
  `month_explain` varchar(200) DEFAULT '',
  `year_judge` varchar(200) DEFAULT '',
  `year_explain` varchar(200) DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for model_category
-- ----------------------------
DROP TABLE IF EXISTS `model_category`;
CREATE TABLE `model_category` (
  `id` varchar(128) NOT NULL,
  `client_code` varchar(50) NOT NULL DEFAULT '',
  `organization_id` varchar(128) NOT NULL DEFAULT '',
  `category` varchar(10) NOT NULL DEFAULT '',
  `parent_id` varchar(128) NOT NULL DEFAULT '',
  `sort` int(10) NOT NULL DEFAULT '0',
  `quantity` int(10) NOT NULL DEFAULT '0',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `industry_id` varchar(128) DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for model_config
-- ----------------------------
DROP TABLE IF EXISTS `model_config`;
CREATE TABLE `model_config` (
  `id` varchar(128) NOT NULL,
  `category_id` varchar(128) NOT NULL DEFAULT '',
  `model_id` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for model_service_config
-- ----------------------------
DROP TABLE IF EXISTS `model_service_config`;
CREATE TABLE `model_service_config` (
  `id` varchar(128) NOT NULL,
  `model_id` varchar(128) NOT NULL DEFAULT '',
  `service_type_id` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for operation_log
-- ----------------------------
DROP TABLE IF EXISTS `operation_log`;
CREATE TABLE `operation_log` (
  `id` varchar(128) DEFAULT NULL,
  `operation_object` varchar(50) DEFAULT NULL,
  `original_state` varchar(255) DEFAULT NULL,
  `update_state` varchar(255) DEFAULT NULL,
  `operation_description` varchar(255) DEFAULT NULL,
  `operation_by` varchar(128) DEFAULT NULL,
  `ip` varchar(50) DEFAULT NULL,
  `oid` varchar(100) DEFAULT NULL,
  `module_id` bigint(22) DEFAULT NULL,
  `comment` varchar(4000) DEFAULT NULL,
  `create_time` timestamp NULL DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for operation_log_basic_data
-- ----------------------------
DROP TABLE IF EXISTS `operation_log_basic_data`;
CREATE TABLE `operation_log_basic_data` (
  `id` varchar(128) NOT NULL,
  `operation_content` varchar(255) DEFAULT '',
  `module_name` varchar(255) NOT NULL DEFAULT '',
  `operation_object` varchar(100) NOT NULL DEFAULT '',
  `operation_action` varchar(100) NOT NULL DEFAULT '',
  `original_state` varchar(500) DEFAULT '',
  `update_state` varchar(500) DEFAULT '',
  `operation_user` varchar(50) NOT NULL DEFAULT '',
  `ip` varchar(50) NOT NULL DEFAULT '',
  `comment` varchar(500) DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for operation_log_enter_prise
-- ----------------------------
DROP TABLE IF EXISTS `operation_log_enter_prise`;
CREATE TABLE `operation_log_enter_prise` (
  `id` varchar(128) NOT NULL,
  `operation_content` varchar(255) NOT NULL DEFAULT '',
  `module_name` varchar(255) NOT NULL DEFAULT '',
  `operation_object` varchar(100) NOT NULL DEFAULT '',
  `operation_action` varchar(100) NOT NULL DEFAULT '',
  `original_state` varchar(500) DEFAULT '',
  `update_state` varchar(500) DEFAULT '',
  `operation_user` varchar(50) NOT NULL DEFAULT '',
  `ip` varchar(50) NOT NULL DEFAULT '',
  `comment` varchar(500) DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for operation_log_equity
-- ----------------------------
DROP TABLE IF EXISTS `operation_log_equity`;
CREATE TABLE `operation_log_equity` (
  `id` varchar(128) NOT NULL,
  `operation_content` varchar(255) NOT NULL DEFAULT '',
  `module_name` varchar(255) NOT NULL DEFAULT '',
  `operation_object` varchar(100) NOT NULL DEFAULT '',
  `operation_action` varchar(100) NOT NULL DEFAULT '',
  `original_state` varchar(500) DEFAULT '',
  `update_state` varchar(500) DEFAULT '',
  `operation_user` varchar(50) NOT NULL DEFAULT '',
  `ip` varchar(50) NOT NULL DEFAULT '',
  `comment` varchar(500) DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for operation_log_keyvalue
-- ----------------------------
DROP TABLE IF EXISTS `operation_log_keyvalue`;
CREATE TABLE `operation_log_keyvalue` (
  `id` varchar(128) NOT NULL,
  `operation_content` varchar(255) DEFAULT '',
  `module_name` varchar(255) DEFAULT '',
  `operation_object` varchar(100) DEFAULT '',
  `operation_action` varchar(100) DEFAULT '',
  `original_state` varchar(500) DEFAULT '',
  `update_state` varchar(500) DEFAULT '',
  `operation_user` varchar(50) DEFAULT '',
  `ip` varchar(50) DEFAULT '',
  `comment` varchar(500) DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for operation_log_organization
-- ----------------------------
DROP TABLE IF EXISTS `operation_log_organization`;
CREATE TABLE `operation_log_organization` (
  `id` varchar(128) NOT NULL,
  `operation_content` varchar(255) NOT NULL DEFAULT '' COMMENT '操作内容',
  `module_name` varchar(255) NOT NULL DEFAULT '' COMMENT '模块名',
  `operation_object` varchar(100) NOT NULL DEFAULT '' COMMENT '被操作对象',
  `operation_action` varchar(100) NOT NULL DEFAULT '' COMMENT '操作动作 eg:new, update',
  `original_state` varchar(500) DEFAULT '' COMMENT '原值',
  `update_state` varchar(500) DEFAULT '' COMMENT '修改的值',
  `operation_user` varchar(50) NOT NULL DEFAULT '' COMMENT '当前操作者',
  `ip` varchar(50) NOT NULL DEFAULT '',
  `comment` varchar(500) DEFAULT '' COMMENT '备注',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for operation_log_project
-- ----------------------------
DROP TABLE IF EXISTS `operation_log_project`;
CREATE TABLE `operation_log_project` (
  `id` varchar(128) DEFAULT NULL,
  `operation_content` varchar(2000) DEFAULT NULL,
  `module_name` varchar(255) DEFAULT NULL,
  `operation_object` varchar(100) DEFAULT NULL,
  `operation_action` varchar(100) DEFAULT NULL,
  `original_state` varchar(4000) DEFAULT NULL,
  `update_state` varchar(4000) DEFAULT NULL,
  `operation_user` varchar(50) DEFAULT NULL,
  `ip` varchar(50) DEFAULT NULL,
  `comment` varchar(4000) DEFAULT NULL,
  `create_time` timestamp NULL DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for operation_log_report
-- ----------------------------
DROP TABLE IF EXISTS `operation_log_report`;
CREATE TABLE `operation_log_report` (
  `id` varchar(128) DEFAULT NULL,
  `operation_content` varchar(255) DEFAULT NULL,
  `module_name` varchar(255) DEFAULT NULL,
  `operation_object` varchar(100) DEFAULT NULL,
  `operation_action` varchar(100) DEFAULT NULL,
  `original_state` varchar(4000) DEFAULT NULL,
  `update_state` varchar(4000) DEFAULT NULL,
  `operation_user` varchar(50) DEFAULT NULL,
  `ip` varchar(50) DEFAULT NULL,
  `comment` varchar(4000) DEFAULT NULL,
  `create_time` timestamp NULL DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for operation_log_role
-- ----------------------------
DROP TABLE IF EXISTS `operation_log_role`;
CREATE TABLE `operation_log_role` (
  `id` varchar(128) NOT NULL,
  `operation_content` varchar(255) DEFAULT '',
  `module_name` varchar(255) DEFAULT '',
  `operation_object` varchar(100) DEFAULT '',
  `operation_action` varchar(100) DEFAULT '',
  `original_state` varchar(500) DEFAULT '',
  `update_state` varchar(500) DEFAULT '',
  `operation_user` varchar(50) DEFAULT '',
  `ip` varchar(50) DEFAULT '',
  `comment` varchar(500) DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for operation_log_rule_engine
-- ----------------------------
DROP TABLE IF EXISTS `operation_log_rule_engine`;
CREATE TABLE `operation_log_rule_engine` (
  `id` varchar(128) DEFAULT NULL,
  `operation_content` varchar(255) DEFAULT NULL,
  `module_name` varchar(255) DEFAULT NULL,
  `operation_object` varchar(100) DEFAULT NULL,
  `operation_action` varchar(100) DEFAULT NULL,
  `original_state` varchar(4000) DEFAULT NULL,
  `update_state` varchar(4000) DEFAULT NULL,
  `operation_user` varchar(50) DEFAULT NULL,
  `ip` varchar(50) DEFAULT NULL,
  `comment` varchar(4000) DEFAULT NULL,
  `create_time` timestamp NULL DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for operation_log_subject
-- ----------------------------
DROP TABLE IF EXISTS `operation_log_subject`;
CREATE TABLE `operation_log_subject` (
  `id` varchar(128) DEFAULT NULL,
  `operation_content` varchar(255) DEFAULT NULL,
  `module_name` varchar(255) DEFAULT NULL,
  `operation_object` varchar(100) DEFAULT NULL,
  `operation_action` varchar(100) DEFAULT NULL,
  `original_state` varchar(4000) DEFAULT NULL,
  `update_state` varchar(4000) DEFAULT NULL,
  `operation_user` varchar(50) DEFAULT NULL,
  `ip` varchar(50) DEFAULT NULL,
  `comment` varchar(4000) DEFAULT NULL,
  `create_time` timestamp NULL DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for operation_log_user
-- ----------------------------
DROP TABLE IF EXISTS `operation_log_user`;
CREATE TABLE `operation_log_user` (
  `id` varchar(128) NOT NULL,
  `operation_content` varchar(255) NOT NULL DEFAULT '',
  `module_name` varchar(255) NOT NULL DEFAULT '',
  `operation_object` varchar(100) NOT NULL DEFAULT '',
  `operation_action` varchar(100) NOT NULL DEFAULT '',
  `original_state` varchar(500) DEFAULT '',
  `update_state` varchar(500) DEFAULT '',
  `operation_user` varchar(50) NOT NULL DEFAULT '',
  `ip` varchar(50) NOT NULL DEFAULT '',
  `comment` varchar(500) DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for organization
-- ----------------------------
DROP TABLE IF EXISTS `organization`;
CREATE TABLE `organization` (
  `id` varchar(128) NOT NULL,
  `client_code` varchar(50) NOT NULL DEFAULT '',
  `name` varchar(100) NOT NULL DEFAULT '',
  `code` varchar(50) NOT NULL DEFAULT '',
  `parent_id` varchar(128) DEFAULT '',
  `tax_payer_number` varchar(50) DEFAULT '',
  `region_id` varchar(128) DEFAULT '',
  `structure_id` varchar(128) NOT NULL DEFAULT '',
  `industry_id` varchar(128) DEFAULT '',
  `business_unit_id` varchar(128) DEFAULT '',
  `is_active` tinyint(1) NOT NULL DEFAULT '0',
  `p_level` int(10) NOT NULL DEFAULT '0',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `area_id` varchar(128) DEFAULT '',
  `english_name` varchar(500) DEFAULT '',
  `abbreviation` varchar(50) DEFAULT '',
  `invoice_type` varchar(255) DEFAULT '',
  `legal_person_name` varchar(200) DEFAULT '',
  `manufacture_address` varchar(500) DEFAULT '',
  `register_address` varchar(500) DEFAULT '',
  `bank_account_name` varchar(200) DEFAULT '',
  `bank_account_number` varchar(128) DEFAULT '',
  `phone_number` varchar(100) DEFAULT '',
  `registration_type` varchar(200) DEFAULT '',
  `remark` varchar(500) DEFAULT '',
  `vehicle_routing_location` varchar(255) DEFAULT '',
  `ratepayer` varchar(10) DEFAULT '',
  `address` varchar(500) DEFAULT '',
  `foundation_date` datetime DEFAULT CURRENT_TIMESTAMP,
  `registration_date` datetime DEFAULT CURRENT_TIMESTAMP,
  `registration_location` varchar(500) DEFAULT '',
  `registration_capital` varchar(500) DEFAULT '' COMMENT '注册资本',
  `business_allotted_time_from` datetime DEFAULT CURRENT_TIMESTAMP,
  `business_allotted_time_to` datetime DEFAULT CURRENT_TIMESTAMP,
  `legal_code` varchar(500) DEFAULT '',
  `vehicleroutinglocation` varchar(255) DEFAULT '',
  `business_scope` varchar(1000) DEFAULT '' COMMENT '经营范围',
  `architecture_type` varchar(20) DEFAULT '' COMMENT '架构类型',
  `num_of_branches` tinyint(3) DEFAULT NULL COMMENT '分公司数量。税务系统自动计算无法更改，从主数据通过相同的总公司名称抓子公司再count；只有在总公司的时候自动更新数量，分公司则无此字段',
  `api_update_flag` tinyint(1) DEFAULT NULL COMMENT '接口更新标识',
  `effec_time_of_general_taxpayers` datetime DEFAULT CURRENT_TIMESTAMP COMMENT '一般纳税人生效时间。2018年1月3日',
  `registration_location_en` varchar(500) DEFAULT '' COMMENT '注册地址（住所）英文',
  `paid_in_capital` varchar(500) DEFAULT '' COMMENT '实缴资本',
  `general_tax_payer_effective_time` datetime DEFAULT CURRENT_TIMESTAMP COMMENT '一般纳税人生效时间.2018年1月3日',
  `oversea` tinyint(1) DEFAULT NULL COMMENT '是否为境外企业。0-境内企业，1-境外企业',
  `reg_status` varchar(20) DEFAULT '' COMMENT '工商登记状态.存续/注销中/已注销',
  `national_economic_industry` varchar(10) DEFAULT '' COMMENT '所属国民经济行业（填写代码）',
  `engage_national_prohibit_industry` tinyint(1) DEFAULT NULL COMMENT '从事国家限制或禁止行业',
  `logout_time` datetime DEFAULT CURRENT_TIMESTAMP COMMENT '注销时间。',
  PRIMARY KEY (`id`),
  KEY `organization_client_code_IDX` (`client_code`,`code`,`parent_id`,`region_id`,`industry_id`,`business_unit_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for organization_accounting_rate
-- ----------------------------
DROP TABLE IF EXISTS `organization_accounting_rate`;
CREATE TABLE `organization_accounting_rate` (
  `id` bigint(22) NOT NULL DEFAULT '0' COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL DEFAULT '' COMMENT '机构编号',
  `period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '期间',
  `convertion_type` varchar(100) DEFAULT '' COMMENT '汇率类型',
  `currency_from` varchar(10) DEFAULT '' COMMENT '货币自',
  `currency_to` varchar(10) DEFAULT '' COMMENT '货币至',
  `start_date` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '期间始',
  `end_date` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '期间止.2015-05-02',
  `rate` float DEFAULT '0' COMMENT '入账汇率.6.66',
  `create_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for organization_approved_levy_info
-- ----------------------------
DROP TABLE IF EXISTS `organization_approved_levy_info`;
CREATE TABLE `organization_approved_levy_info` (
  `id` bigint(22) NOT NULL DEFAULT '0' COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL DEFAULT '' COMMENT '机构编号',
  `approved_levy_project` varchar(1000) DEFAULT '' COMMENT '核定征收项目',
  `approved_validity_period_start_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '核定有效期起',
  `approved_validity_period_end_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '核定有效期止',
  `approved_rate` tinyint(4) DEFAULT '0' COMMENT '核定税率',
  `approved_tax_period` varchar(10) DEFAULT '' COMMENT '核定纳税期限。月、季、年',
  `create_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for organization_employee
-- ----------------------------
DROP TABLE IF EXISTS `organization_employee`;
CREATE TABLE `organization_employee` (
  `id` bigint(22) NOT NULL DEFAULT '0' COMMENT '系统唯一编号',
  `organization_id` varchar(128) NOT NULL DEFAULT '',
  `employees_num_start` int(9) DEFAULT NULL COMMENT '期初雇员人数',
  `employees_num_end` int(9) DEFAULT NULL COMMENT '期末雇员人数',
  `statistical_month` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '统计月份.2019/2',
  `create_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='机构信息-雇员信息';

-- ----------------------------
-- Table structure for organization_extra
-- ----------------------------
DROP TABLE IF EXISTS `organization_extra`;
CREATE TABLE `organization_extra` (
  `id` bigint(22) NOT NULL COMMENT '系统唯一编号',
  `organization_id` varchar(128) NOT NULL COMMENT '机构编号.对应机构编号',
  `unified_social_credit_code` varchar(50) NOT NULL DEFAULT '' COMMENT '统一社会信用代码.例：XR23T345DFG4562。与纳税人识别号一致，页面用纳税人识别号描述',
  `reg_financial_accounting_type` tinyint(1) DEFAULT NULL COMMENT '登记方式。1-独立 0-非独立',
  `tax_reg_status` varchar(20) DEFAULT '' COMMENT '税务登记状态',
  `tax_credit_rating` varchar(20) DEFAULT '' COMMENT '纳税信用评级.ABCD等等',
  `applicable_accounting_rule` varchar(20) DEFAULT '' COMMENT '适用会计制度.企业会计制度/金融企业会计制度/小企业会计准则/企业会计准则',
  `low_value_consumables_amortization_method` varchar(20) DEFAULT '' COMMENT '低值易耗品摊销方法.一次摊销法/分期摊销法/五五摊销法 ',
  `depreciation_method` varchar(20) DEFAULT '' COMMENT '折旧方法.年限平均法（直线法）/工作量法/年数总和法/双倍余额递减法',
  `accounting_software` varchar(20) DEFAULT '' COMMENT '会计核算软件. Oracle 或其他',
  `complete_record_total_institutions` tinyint(1) DEFAULT NULL COMMENT '是否完成总分机构备案.1-是，0-否',
  `tax_client_person_name` varchar(20) DEFAULT '' COMMENT '办税人姓名',
  `tax_client_person_phone_num` varchar(20) DEFAULT '' COMMENT '办税人电话',
  `tax_client_person_id_num` varchar(20) DEFAULT '' COMMENT '办税人身份证号',
  `ticket_holder_name` varchar(20) DEFAULT '' COMMENT '购票人姓名',
  `ticket_holder_phone_num` varchar(20) DEFAULT '' COMMENT '购票人电话',
  `national_tax_hall_address` varchar(500) DEFAULT '' COMMENT '主管税局地址(原国税)',
  `national_tax_administrator_name` varchar(100) DEFAULT '' COMMENT '主管税局名称(原国税)',
  `national_tax_administrator_phone_num` varchar(100) DEFAULT '' COMMENT '主管税局电话(原国税)',
  `local_tax_hall_address` varchar(500) DEFAULT '' COMMENT '主管税局地址(原地税)',
  `local_tax_administrator_name` varchar(100) DEFAULT '' COMMENT '主管税局名称(原地税)',
  `local_tax_administrator_phone_num` varchar(100) DEFAULT '' COMMENT '主管税局电话(原地税)',
  `eta_website` varchar(500) DEFAULT '' COMMENT '电子税局网址',
  `sign_tripartite_agreement` tinyint(1) DEFAULT NULL COMMENT '三方协议是否签订.1-是，0-否',
  `reporting_currency` varchar(50) DEFAULT '' COMMENT '记账本位币',
  `consolidation_time` datetime DEFAULT CURRENT_TIMESTAMP COMMENT '并表期间',
  `fiscal_year_deadline` datetime DEFAULT CURRENT_TIMESTAMP COMMENT '财年截止日.(国际化特有字段)',
  `tax_agent` varchar(100) DEFAULT '' COMMENT '税务代理',
  `tax_agent_contact` varchar(20) DEFAULT '' COMMENT '税务代理联系方式',
  `other_facts` varchar(1000) DEFAULT '' COMMENT '其他情况说明.(国际化特有字段)',
  `tax_return_business_type` int(4) DEFAULT NULL COMMENT '纳税申报企业类型.100/210/220/230/311/312（填写代码）',
  `small_meager_profit` tinyint(1) DEFAULT NULL COMMENT '小型微利企业.1是/0否',
  `listed_company` tinyint(1) unsigned DEFAULT NULL COMMENT '上市公司.1是-境内/是   0-境外/否',
  `applicable_accounting_standards_or_accounting_systems` int(4) DEFAULT NULL COMMENT '采用一般企业财务报表格式',
  `tax_payer_number_vat` varchar(50) DEFAULT '' COMMENT '增值税纳税人识别号。仅国际化有',
  `tax_payer_number_cit` varchar(50) DEFAULT '' COMMENT '企业所得税纳税人识别号。仅国际化有',
  `tax_client_person_email_address` varchar(50) DEFAULT '' COMMENT '办税人邮箱。',
  `bank_account_name` varchar(200) DEFAULT '' COMMENT '三方协议开户银行名称.bank_account_name',
  `bank_account_number` varchar(128) DEFAULT '' COMMENT '银行账户号码',
  `legal_person_name` varchar(200) DEFAULT '' COMMENT '法定代表人/负责人姓名.',
  `legal_person_phone_number` varchar(100) DEFAULT '' COMMENT '法定代表人/负责人手机',
  `legal_person_landline_num` varchar(100) DEFAULT '' COMMENT '法定代表人/负责人座机',
  `legal_person_email_address` varchar(100) DEFAULT '' COMMENT '法定代表人/负责人邮箱',
  `reg_financial_officer_name` varchar(200) DEFAULT '' COMMENT '注册登记财务负责人姓名',
  `reg_financial_officer_phone_num` varchar(100) DEFAULT '' COMMENT '注册登记财务负责人电话',
  `reg_financial_officer_landline_num` varchar(100) DEFAULT '' COMMENT '注册登记财务负责人座机',
  `reg_financial_officer_email_address` varchar(100) DEFAULT '' COMMENT '注册登记财务负责人邮箱',
  `secondary_approval_amount` bigint(22) DEFAULT NULL COMMENT '二级审批金额',
  `business_registration_number` varchar(30) DEFAULT '' COMMENT '商业登记号码.Business registration number(国际化特有字段)',
  `par_value` float DEFAULT NULL COMMENT 'Par Value(国际化特有字段).票面价值。票面价值是企业发行的股票上面所标明的金额，有的企业发行的股票上有票面价值，也有的企业发行的股票不标明票面价值。',
  `issued_shares` bigint(22) DEFAULT NULL COMMENT 'Issued shares(国际化特有字段).发行股票',
  `directors` varchar(300) DEFAULT '' COMMENT 'Directors(国际化特有字段).董事。以;间隔',
  `actual_business_address` varchar(300) DEFAULT '' COMMENT '实际经营地址。例：杭州市余杭区九橙西溪创投中心',
  `tax_rule_introduction` varchar(500) DEFAULT '' COMMENT '税制简介',
  `audit_requirements` varchar(300) DEFAULT '' COMMENT '审计要求',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='机构-其他信息';

-- ----------------------------
-- Table structure for organization_invoice
-- ----------------------------
DROP TABLE IF EXISTS `organization_invoice`;
CREATE TABLE `organization_invoice` (
  `id` bigint(22) NOT NULL DEFAULT '0' COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL DEFAULT '' COMMENT '对应机构编号',
  `invoice_type_name` varchar(200) DEFAULT '' COMMENT '发票种类名称。增值税专用发票/增值税普通发票/机动车销售统一发票/其他票种',
  `unit` varchar(10) DEFAULT '' COMMENT '单位。份、本、其他',
  `single_invoice_max_invoice_amount` bigint(18) DEFAULT '0' COMMENT '单份发票最高开票额',
  `monthly_max_tickets_purchased` bigint(18) DEFAULT '0' COMMENT '每月最高购票数量',
  `single_invoicing_max_limit` bigint(18) DEFAULT '0' COMMENT '单份发票最高开票限额',
  `offline_billing_time_limit` varchar(200) DEFAULT '' COMMENT '离线开票时限',
  `create_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for organization_return_rate
-- ----------------------------
DROP TABLE IF EXISTS `organization_return_rate`;
CREATE TABLE `organization_return_rate` (
  `id` bigint(22) NOT NULL DEFAULT '0' COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL DEFAULT '' COMMENT '机构编号',
  `group_name` varchar(50) DEFAULT '' COMMENT '税种',
  `return_rate` float DEFAULT '0' COMMENT '返还率',
  `start_date` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '开始时间。2015-05-02',
  `create_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for organization_service_template_group
-- ----------------------------
DROP TABLE IF EXISTS `organization_service_template_group`;
CREATE TABLE `organization_service_template_group` (
  `id` bigint(19) NOT NULL,
  `organization_id` varchar(128) NOT NULL DEFAULT '',
  `service_type_id` varchar(128) NOT NULL DEFAULT '',
  `template_group_id` bigint(19) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `org_service_template_group_organization_id_IDX` (`organization_id`,`service_type_id`,`template_group_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for organization_structure
-- ----------------------------
DROP TABLE IF EXISTS `organization_structure`;
CREATE TABLE `organization_structure` (
  `id` varchar(128) NOT NULL,
  `name` varchar(100) NOT NULL DEFAULT '',
  `is_active` tinyint(1) NOT NULL DEFAULT '0',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `organization_structure_name_IDX` (`name`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for organization_tax_officer
-- ----------------------------
DROP TABLE IF EXISTS `organization_tax_officer`;
CREATE TABLE `organization_tax_officer` (
  `id` bigint(22) NOT NULL DEFAULT '0' COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL DEFAULT '' COMMENT '机构编号',
  `tax_officer_name` varchar(20) DEFAULT '' COMMENT '专管员姓名',
  `tax_officer_phone_num` varchar(20) DEFAULT '' COMMENT '专管员电话',
  `remark` varchar(500) DEFAULT '' COMMENT '备注.填写专管员特长等信息',
  `create_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for organization_tax_rule
-- ----------------------------
DROP TABLE IF EXISTS `organization_tax_rule`;
CREATE TABLE `organization_tax_rule` (
  `id` bigint(22) NOT NULL DEFAULT '0' COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL DEFAULT '' COMMENT '机构编号',
  `group_name` varchar(50) DEFAULT '' COMMENT '税种类型',
  `tax_dec_cycle` varchar(10) DEFAULT '' COMMENT '税种申报周期.月度/季度/半年度/年度',
  `tax_dec_type` varchar(50) DEFAULT '' COMMENT '税种申报方式.网报-CA、用户名密码；建议自己把各自负责的公司的网报账号、密码放到系统中，并更新',
  `create_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for organization_taxpayer_qualification
-- ----------------------------
DROP TABLE IF EXISTS `organization_taxpayer_qualification`;
CREATE TABLE `organization_taxpayer_qualification` (
  `id` bigint(22) DEFAULT '0' COMMENT '唯一编号',
  `organization_id` varchar(128) DEFAULT '' COMMENT '对应机构编号',
  `taxpayer_qualification_type` varchar(30) DEFAULT '' COMMENT '纳税人类型.  一般纳税人等',
  `determination_date` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '认定日期.到日',
  `validity_start` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '有效期起。到日',
  `validity_end` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '有效期止。到日',
  `create_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='机构信息-纳税人信息';

-- ----------------------------
-- Table structure for output_ar_invoice
-- ----------------------------
DROP TABLE IF EXISTS `output_ar_invoice`;
CREATE TABLE `output_ar_invoice` (
  `id` bigint(18) NOT NULL,
  `operation_unit_id` int(11) DEFAULT '0',
  `operation_name` varchar(240) DEFAULT '',
  `customer_trx_id` int(11) DEFAULT '0',
  `cust_trx_type_id` int(11) DEFAULT '0',
  `cust_trx_type_name` varchar(20) DEFAULT '',
  `ctt_class` varchar(20) DEFAULT '',
  `batch_source_id` int(11) DEFAULT '0',
  `batch_source_name` varchar(50) DEFAULT '',
  `trx_date` varchar(10) DEFAULT '',
  `gl_date` varchar(10) DEFAULT '',
  `trx_number` varchar(20) DEFAULT '',
  `invoice_currency_code` varchar(15) DEFAULT '',
  `invoice_amount` decimal(19,5) DEFAULT '0.00000',
  `invoice_tax_amount` decimal(19,5) DEFAULT '0.00000',
  `bill_to_customer_id` int(11) DEFAULT '0',
  `bill_to_customer_number` varchar(30) DEFAULT '',
  `bill_to_customer_name` varchar(360) DEFAULT '',
  `ct_reference` varchar(10) DEFAULT '',
  `status_trx` varchar(30) DEFAULT '',
  `description` varchar(240) DEFAULT '',
  `primary_salesrep_id` int(11) DEFAULT '0',
  `primary_salesrep_name` varchar(360) DEFAULT '',
  `terms_name` varchar(50) DEFAULT '',
  `attribute1` varchar(240) DEFAULT '',
  `attribute2` varchar(240) DEFAULT '',
  `attribute3` varchar(240) DEFAULT '',
  `attribute4` varchar(240) DEFAULT '',
  `attribute5` varchar(240) DEFAULT '',
  `attribute6` varchar(240) DEFAULT '',
  `attribute7` varchar(240) DEFAULT '',
  `attribute8` varchar(240) DEFAULT '',
  `attribute9` varchar(240) DEFAULT '',
  `attribute10` varchar(240) DEFAULT '',
  `attribute11` varchar(240) DEFAULT '',
  `attribute12` varchar(240) DEFAULT '',
  `attribute13` varchar(240) DEFAULT '',
  `attribute14` varchar(240) DEFAULT '',
  `attribute15` varchar(240) DEFAULT '',
  `attr1` varchar(240) DEFAULT '',
  `attr2` varchar(240) DEFAULT '',
  `attr3` varchar(240) DEFAULT '',
  `attr4` varchar(240) DEFAULT '',
  `attr5` varchar(240) DEFAULT '',
  `create_by` varchar(128) DEFAULT '',
  `update_by` varchar(128) DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `terms_date` varchar(10) DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for output_ar_receivables_trx
-- ----------------------------
DROP TABLE IF EXISTS `output_ar_receivables_trx`;
CREATE TABLE `output_ar_receivables_trx` (
  `id` bigint(18) NOT NULL,
  `org_id` int(11) NOT NULL DEFAULT '0' COMMENT '业务实体ID',
  `type_code` varchar(30) NOT NULL DEFAULT '' COMMENT '收款类别编码',
  `type_name` varchar(50) NOT NULL DEFAULT '' COMMENT '收款类别名称',
  `status` varchar(30) NOT NULL DEFAULT '' COMMENT '是否有效 有效（A）',
  `description` varchar(240) NOT NULL DEFAULT '' COMMENT '备注',
  `company_code` varchar(25) NOT NULL DEFAULT '' COMMENT '活动GL账户-公司段',
  `segment2` varchar(25) NOT NULL DEFAULT '' COMMENT '活动GL账户-成本中心段',
  `segment3` varchar(25) NOT NULL DEFAULT '' COMMENT '活动GL账户-科目段',
  `segment4` varchar(25) NOT NULL DEFAULT '' COMMENT '活动GL账户-区域段',
  `segment5` varchar(25) NOT NULL DEFAULT '' COMMENT '活动GL账户-往来段',
  `segment6` varchar(25) NOT NULL DEFAULT '' COMMENT '活动GL账户-产品段',
  `segment7` varchar(25) NOT NULL DEFAULT '' COMMENT '活动GL账户-备注段',
  `attr1` varchar(240) NOT NULL DEFAULT '' COMMENT '备用字段1',
  `attr2` varchar(240) NOT NULL DEFAULT '' COMMENT '备用字段2',
  `attr3` varchar(240) NOT NULL DEFAULT '' COMMENT '备用字段3',
  `attr4` varchar(240) NOT NULL DEFAULT '' COMMENT '备用字段4',
  `attr5` varchar(240) NOT NULL DEFAULT '' COMMENT '备用字段5',
  `receivables_trx_id` int(11) NOT NULL DEFAULT '0' COMMENT 'ID',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for output_ar_trx_type
-- ----------------------------
DROP TABLE IF EXISTS `output_ar_trx_type`;
CREATE TABLE `output_ar_trx_type` (
  `id` bigint(18) NOT NULL,
  `cust_trx_type_id` int(11) DEFAULT '0',
  `org_id` int(11) DEFAULT '0',
  `name` varchar(20) DEFAULT '',
  `description` varchar(240) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `creation_sign` varchar(30) DEFAULT '',
  `start_date` varchar(10) DEFAULT '',
  `end_date` varchar(10) DEFAULT '',
  `credit_memo_type_id` int(11) DEFAULT '0',
  `attr1` varchar(240) DEFAULT '',
  `attr2` varchar(240) DEFAULT '',
  `attr3` varchar(240) DEFAULT '',
  `attr4` varchar(240) DEFAULT '',
  `attr5` varchar(240) DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for output_customer
-- ----------------------------
DROP TABLE IF EXISTS `output_customer`;
CREATE TABLE `output_customer` (
  `id` bigint(18) NOT NULL,
  `party_id` int(11) NOT NULL DEFAULT '0',
  `party_name` varchar(360) NOT NULL DEFAULT '',
  `party_number` varchar(30) NOT NULL DEFAULT '',
  `known_as` varchar(240) NOT NULL DEFAULT '',
  `party_type` varchar(30) NOT NULL DEFAULT '',
  `status` varchar(1) NOT NULL DEFAULT '',
  `tax_reference` varchar(50) NOT NULL DEFAULT '',
  `duns_number` int(11) NOT NULL DEFAULT '0',
  `country` varchar(60) NOT NULL DEFAULT '',
  `province` varchar(60) NOT NULL DEFAULT '',
  `city` varchar(60) NOT NULL DEFAULT '',
  `county` varchar(60) NOT NULL DEFAULT '',
  `address1` varchar(240) NOT NULL DEFAULT '',
  `address2` varchar(240) NOT NULL DEFAULT '',
  `attr1` varchar(240) NOT NULL DEFAULT '',
  `attr2` varchar(240) NOT NULL DEFAULT '',
  `attr3` varchar(240) NOT NULL DEFAULT '',
  `attr4` varchar(240) NOT NULL DEFAULT '',
  `attr5` varchar(240) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for output_customer_account
-- ----------------------------
DROP TABLE IF EXISTS `output_customer_account`;
CREATE TABLE `output_customer_account` (
  `id` bigint(18) NOT NULL,
  `cust_account_id` int(11) NOT NULL DEFAULT '0',
  `party_id` int(11) NOT NULL DEFAULT '0',
  `account_number` varchar(30) NOT NULL DEFAULT '',
  `account_name` varchar(240) NOT NULL DEFAULT '',
  `customer_type` varchar(30) NOT NULL DEFAULT '',
  `status` varchar(1) NOT NULL DEFAULT '',
  `attribute_category` varchar(30) NOT NULL DEFAULT '',
  `attribute1` varchar(150) NOT NULL DEFAULT '',
  `attribute2` varchar(150) NOT NULL DEFAULT '',
  `attribute3` varchar(150) NOT NULL DEFAULT '',
  `attribute4` varchar(150) NOT NULL DEFAULT '',
  `attribute5` varchar(150) NOT NULL DEFAULT '',
  `attribute6` varchar(150) NOT NULL DEFAULT '',
  `attribute7` varchar(150) NOT NULL DEFAULT '',
  `attribute8` varchar(150) NOT NULL DEFAULT '',
  `attribute9` varchar(150) NOT NULL DEFAULT '',
  `attribute10` varchar(150) NOT NULL DEFAULT '',
  `attribute11` varchar(150) NOT NULL DEFAULT '',
  `attribute12` varchar(150) NOT NULL DEFAULT '',
  `attribute13` varchar(150) NOT NULL DEFAULT '',
  `attribute14` varchar(150) NOT NULL DEFAULT '',
  `attribute15` varchar(150) NOT NULL DEFAULT '',
  `attribute16` varchar(150) NOT NULL DEFAULT '',
  `attribute17` varchar(150) NOT NULL DEFAULT '',
  `attribute18` varchar(150) NOT NULL DEFAULT '',
  `attribute19` varchar(150) NOT NULL DEFAULT '',
  `attribute20` varchar(150) NOT NULL DEFAULT '',
  `attr1` varchar(240) NOT NULL DEFAULT '',
  `attr2` varchar(240) NOT NULL DEFAULT '',
  `attr3` varchar(240) NOT NULL DEFAULT '',
  `attr4` varchar(240) NOT NULL DEFAULT '',
  `attr5` varchar(240) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for output_customer_bank
-- ----------------------------
DROP TABLE IF EXISTS `output_customer_bank`;
CREATE TABLE `output_customer_bank` (
  `id` bigint(18) NOT NULL,
  `ext_payer_id` int(11) NOT NULL DEFAULT '0',
  `cust_account_id` int(11) NOT NULL DEFAULT '0',
  `operation_unit_id` int(11) NOT NULL DEFAULT '0',
  `site_use_id` int(11) NOT NULL DEFAULT '0',
  `country_code` varchar(2) NOT NULL DEFAULT '',
  `currency_code` varchar(15) NOT NULL DEFAULT '',
  `bank_name` varchar(360) NOT NULL DEFAULT '',
  `bank_number` varchar(30) NOT NULL DEFAULT '',
  `bank_branch_name` varchar(360) NOT NULL DEFAULT '',
  `branch_number` varchar(30) NOT NULL DEFAULT '',
  `bank_account_num_electronic` varchar(100) NOT NULL DEFAULT '',
  `attr1` varchar(240) NOT NULL DEFAULT '',
  `attr2` varchar(240) NOT NULL DEFAULT '',
  `attr3` varchar(240) NOT NULL DEFAULT '',
  `attr4` varchar(240) NOT NULL DEFAULT '',
  `attr5` varchar(240) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for output_customer_contactor
-- ----------------------------
DROP TABLE IF EXISTS `output_customer_contactor`;
CREATE TABLE `output_customer_contactor` (
  `id` bigint(18) NOT NULL,
  `contact_party_id` varchar(60) NOT NULL DEFAULT '',
  `contractor_name` varchar(100) NOT NULL DEFAULT '',
  `phon_number` varchar(30) NOT NULL DEFAULT '',
  `email_address` varchar(40) NOT NULL DEFAULT '',
  `attr1` varchar(240) NOT NULL DEFAULT '',
  `attr2` varchar(240) NOT NULL DEFAULT '',
  `attr3` varchar(240) NOT NULL DEFAULT '',
  `attr4` varchar(240) NOT NULL DEFAULT '',
  `attr5` varchar(240) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for output_customer_ex
-- ----------------------------
DROP TABLE IF EXISTS `output_customer_ex`;
CREATE TABLE `output_customer_ex` (
  `id` bigint(18) NOT NULL,
  `cust_account_id` int(11) DEFAULT '0',
  `party_number` varchar(30) DEFAULT '',
  `party_name` varchar(360) DEFAULT '',
  `party_class` varchar(150) DEFAULT '',
  `financial_class` varchar(150) DEFAULT '',
  `internal_comm_company` varchar(150) DEFAULT '',
  `payer_class` varchar(150) DEFAULT '',
  `payer_num` varchar(150) DEFAULT '',
  `party_address` varchar(240) DEFAULT '',
  `phone_num` varchar(30) DEFAULT '',
  `bank_name` varchar(360) DEFAULT '',
  `bank_num` varchar(50) DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for output_customer_party_site
-- ----------------------------
DROP TABLE IF EXISTS `output_customer_party_site`;
CREATE TABLE `output_customer_party_site` (
  `id` bigint(18) NOT NULL,
  `party_site_id` varchar(60) NOT NULL DEFAULT '',
  `cust_account_id` int(11) NOT NULL DEFAULT '0',
  `cust_acct_site_id` int(11) NOT NULL DEFAULT '0',
  `location_id` int(11) NOT NULL DEFAULT '0',
  `operation_unit_id` int(11) NOT NULL DEFAULT '0',
  `operation_name` varchar(240) NOT NULL DEFAULT '',
  `status` varchar(1) NOT NULL DEFAULT '',
  `party_site_number` varchar(30) NOT NULL DEFAULT '',
  `party_site_name` varchar(240) NOT NULL DEFAULT '',
  `party_site_status` varchar(1) NOT NULL DEFAULT '',
  `country` varchar(60) NOT NULL DEFAULT '',
  `province` varchar(60) NOT NULL DEFAULT '',
  `city` varchar(60) NOT NULL DEFAULT '',
  `county` varchar(60) NOT NULL DEFAULT '',
  `address1` varchar(240) NOT NULL DEFAULT '',
  `address2` varchar(240) NOT NULL DEFAULT '',
  `attr1` varchar(240) NOT NULL DEFAULT '',
  `attr2` varchar(240) NOT NULL DEFAULT '',
  `attr3` varchar(240) NOT NULL DEFAULT '',
  `attr4` varchar(240) NOT NULL DEFAULT '',
  `attr5` varchar(240) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for output_customer_site_use
-- ----------------------------
DROP TABLE IF EXISTS `output_customer_site_use`;
CREATE TABLE `output_customer_site_use` (
  `id` bigint(18) NOT NULL,
  `site_use_id` int(11) DEFAULT '0',
  `cust_acct_site_id` int(11) DEFAULT '0',
  `operation_unit_id` int(11) DEFAULT '0',
  `status` varchar(1) DEFAULT '',
  `site_use_code` varchar(30) DEFAULT '',
  `primary_flag` varchar(1) DEFAULT '',
  `location` varchar(40) DEFAULT '',
  `bill_to_site_use_id` int(11) DEFAULT '0',
  `primary_salesrep_id` int(11) DEFAULT '0',
  `primary_salesrep_emp_num` varchar(30) DEFAULT '',
  `territory_id` int(11) DEFAULT '0',
  `territory_name` varchar(51) DEFAULT '',
  `payment_term_id` int(11) DEFAULT '0',
  `payment_term_name_zhs` varchar(15) DEFAULT '',
  `payment_term_name_us` varchar(15) DEFAULT '',
  `attr1` varchar(240) DEFAULT '',
  `attr2` varchar(240) DEFAULT '',
  `attr3` varchar(240) DEFAULT '',
  `attr4` varchar(240) DEFAULT '',
  `attr5` varchar(240) DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for output_flex_value
-- ----------------------------
DROP TABLE IF EXISTS `output_flex_value`;
CREATE TABLE `output_flex_value` (
  `id` int(11) NOT NULL,
  `flex_value_set_id` int(11) NOT NULL DEFAULT '0',
  `flex_value_set_name` varchar(60) NOT NULL DEFAULT '',
  `flex_value_id` int(11) NOT NULL DEFAULT '0',
  `flex_value` varchar(150) NOT NULL DEFAULT '',
  `flex_value_meaning_zhs` varchar(150) NOT NULL DEFAULT '',
  `flex_value_meaning_us` varchar(150) NOT NULL DEFAULT '',
  `description_zhs` varchar(240) NOT NULL DEFAULT '',
  `description_us` varchar(240) NOT NULL DEFAULT '',
  `enabled_flag` varchar(1) NOT NULL DEFAULT '',
  `start_date` varchar(10) NOT NULL DEFAULT '',
  `end_date` varchar(10) NOT NULL DEFAULT '',
  `summary_flag` varchar(1) NOT NULL DEFAULT '',
  `structured_hierarchy_name_zhs` varchar(30) NOT NULL DEFAULT '',
  `structured_hierarchy_name_us` varchar(30) NOT NULL DEFAULT '',
  `hierarchy_level` varchar(30) NOT NULL DEFAULT '',
  `attribute1` varchar(240) NOT NULL DEFAULT '',
  `attribute2` varchar(240) NOT NULL DEFAULT '',
  `attribute3` varchar(240) NOT NULL DEFAULT '',
  `attribute4` varchar(240) NOT NULL DEFAULT '',
  `attribute5` varchar(240) NOT NULL DEFAULT '',
  `attribute6` varchar(240) NOT NULL DEFAULT '',
  `attribute7` varchar(240) NOT NULL DEFAULT '',
  `attribute8` varchar(240) NOT NULL DEFAULT '',
  `attribute9` varchar(240) NOT NULL DEFAULT '',
  `attribute10` varchar(240) NOT NULL DEFAULT '',
  `attribute11` varchar(240) NOT NULL DEFAULT '',
  `attribute12` varchar(240) NOT NULL DEFAULT '',
  `attribute13` varchar(240) NOT NULL DEFAULT '',
  `attribute14` varchar(240) NOT NULL DEFAULT '',
  `attribute15` varchar(240) NOT NULL DEFAULT '',
  `attr1` varchar(240) NOT NULL DEFAULT '',
  `attr2` varchar(240) NOT NULL DEFAULT '',
  `attr3` varchar(240) NOT NULL DEFAULT '',
  `attr4` varchar(240) NOT NULL DEFAULT '',
  `attr5` varchar(240) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for output_gl_daily_rate
-- ----------------------------
DROP TABLE IF EXISTS `output_gl_daily_rate`;
CREATE TABLE `output_gl_daily_rate` (
  `id` bigint(18) NOT NULL,
  `from_currency` varchar(15) NOT NULL DEFAULT '',
  `to_currency` varchar(15) NOT NULL DEFAULT '',
  `conversion_date` varchar(10) NOT NULL DEFAULT '',
  `conversion_type` varchar(30) NOT NULL DEFAULT '',
  `conversion_rate` int(11) NOT NULL DEFAULT '0',
  `creation_date` varchar(20) NOT NULL DEFAULT '',
  `created_by` varchar(30) NOT NULL DEFAULT '',
  `last_update_date` varchar(20) NOT NULL DEFAULT '',
  `last_updated_by` varchar(30) NOT NULL DEFAULT '',
  `attr1` varchar(240) NOT NULL DEFAULT '',
  `attr2` varchar(240) NOT NULL DEFAULT '',
  `attr3` varchar(240) NOT NULL DEFAULT '',
  `attr4` varchar(240) NOT NULL DEFAULT '',
  `attr5` varchar(240) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for output_invoice
-- ----------------------------
DROP TABLE IF EXISTS `output_invoice`;
CREATE TABLE `output_invoice` (
  `ID` varchar(255) NOT NULL,
  `BSC` varchar(255) DEFAULT NULL,
  `BSCDM` varchar(255) DEFAULT NULL,
  `BZ` varchar(255) DEFAULT NULL,
  `CJSJ` varchar(255) DEFAULT NULL,
  `DYZT` varchar(255) DEFAULT NULL,
  `EWM` varchar(255) DEFAULT NULL,
  `FHR` varchar(255) DEFAULT NULL,
  `FPDM` varchar(255) DEFAULT NULL,
  `FPHM` varchar(255) DEFAULT NULL,
  `FPLX` varchar(255) DEFAULT NULL,
  `FPLXDM` varchar(255) DEFAULT NULL,
  `FPQQLSH` varchar(255) DEFAULT NULL,
  `FPZT` varchar(255) DEFAULT NULL,
  `GDJLH` varchar(255) DEFAULT NULL,
  `GFDZDH` varchar(255) DEFAULT NULL,
  `GFGSBM` varchar(255) DEFAULT NULL,
  `GFMC` varchar(255) DEFAULT NULL,
  `GFSH` varchar(255) DEFAULT NULL,
  `GFYHZH` varchar(255) DEFAULT NULL,
  `HJJE` varchar(255) DEFAULT NULL,
  `HJSE` varchar(255) DEFAULT NULL,
  `HTBH` varchar(255) DEFAULT NULL,
  `JQBH` varchar(255) DEFAULT NULL,
  `JSFJ` varchar(255) DEFAULT NULL,
  `JSHJ` varchar(255) DEFAULT NULL,
  `JSZT` varchar(255) DEFAULT NULL,
  `JYM` varchar(255) DEFAULT NULL,
  `KDDH` varchar(255) DEFAULT NULL,
  `KDGS` varchar(255) DEFAULT NULL,
  `KDUUID` varchar(255) DEFAULT NULL,
  `KPR` varchar(255) DEFAULT NULL,
  `KPRQ` varchar(255) DEFAULT NULL,
  `KPZT` varchar(255) DEFAULT NULL,
  `QY` varchar(255) DEFAULT NULL,
  `QYDM` varchar(255) DEFAULT NULL,
  `SHZT` varchar(255) DEFAULT NULL,
  `SKR` varchar(255) DEFAULT NULL,
  `SLV` varchar(255) DEFAULT NULL,
  `SPBH` varchar(255) DEFAULT NULL,
  `SQBH` varchar(255) DEFAULT NULL,
  `SQR` varchar(255) DEFAULT NULL,
  `SQRQ` varchar(255) DEFAULT NULL,
  `THKPSQ` varchar(255) DEFAULT NULL,
  `XFDZDH` varchar(255) DEFAULT NULL,
  `XFGSBM` varchar(255) DEFAULT NULL,
  `XFMC` varchar(255) DEFAULT NULL,
  `XFSH` varchar(255) DEFAULT NULL,
  `XFYHZH` varchar(255) DEFAULT NULL,
  `XTLY` varchar(255) DEFAULT NULL,
  `XXBBH` varchar(255) DEFAULT NULL,
  `YFPDM` varchar(255) DEFAULT NULL,
  `YFPHM` varchar(255) DEFAULT NULL,
  `YZRQ` varchar(255) DEFAULT NULL,
  `ZKJE` varchar(255) DEFAULT NULL,
  `ZKJSHJ` varchar(255) DEFAULT NULL,
  `ZKSE` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for output_operation_unit
-- ----------------------------
DROP TABLE IF EXISTS `output_operation_unit`;
CREATE TABLE `output_operation_unit` (
  `id` bigint(18) NOT NULL,
  `operation_unit_id` int(11) NOT NULL DEFAULT '0',
  `operation_unit_code` varchar(30) NOT NULL DEFAULT '',
  `operation_unit_type_code` varchar(30) NOT NULL DEFAULT '',
  `operation_unit_type_name` varchar(80) NOT NULL DEFAULT '',
  `operation_name` varchar(240) NOT NULL DEFAULT '',
  `start_date` varchar(30) NOT NULL DEFAULT '',
  `end_date` varchar(30) NOT NULL DEFAULT '',
  `location_id` int(11) NOT NULL DEFAULT '0',
  `location_name` varchar(240) NOT NULL DEFAULT '',
  `internal_external` varchar(30) NOT NULL DEFAULT '',
  `company_name` varchar(240) NOT NULL DEFAULT '',
  `object_version_num` int(11) NOT NULL DEFAULT '0',
  `langue_code` varchar(30) NOT NULL DEFAULT '',
  `extend_attributes` varchar(4000) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for output_ra_interface
-- ----------------------------
DROP TABLE IF EXISTS `output_ra_interface`;
CREATE TABLE `output_ra_interface` (
  `id` int(11) NOT NULL,
  `interface_line_id` int(11) DEFAULT '0',
  `interface_line_context` varchar(30) DEFAULT '',
  `interface_line_attribute1` varchar(150) DEFAULT '',
  `interface_line_attribute2` varchar(150) DEFAULT '',
  `interface_line_attribute3` varchar(150) DEFAULT '',
  `interface_line_attribute4` varchar(150) DEFAULT '',
  `interface_line_attribute5` varchar(150) DEFAULT '',
  `interface_line_attribute6` varchar(150) DEFAULT '',
  `interface_line_attribute7` varchar(150) DEFAULT '',
  `interface_line_attribute8` varchar(150) DEFAULT '',
  `interface_line_attribute9` varchar(150) DEFAULT '',
  `interface_line_attribute10` varchar(150) DEFAULT '',
  `interface_line_attribute11` varchar(150) DEFAULT '',
  `interface_line_attribute12` varchar(150) DEFAULT '',
  `interface_line_attribute13` varchar(150) DEFAULT '',
  `interface_line_attribute14` varchar(150) DEFAULT '',
  `interface_line_attribute15` varchar(150) DEFAULT '',
  `link_to_line_context` varchar(30) DEFAULT '',
  `link_to_line_attribute1` varchar(150) DEFAULT '',
  `link_to_line_attribute2` varchar(150) DEFAULT '',
  `link_to_line_attribute3` varchar(150) DEFAULT '',
  `link_to_line_attribute4` varchar(150) DEFAULT '',
  `link_to_line_attribute5` varchar(150) DEFAULT '',
  `link_to_line_attribute6` varchar(150) DEFAULT '',
  `link_to_line_attribute7` varchar(150) DEFAULT '',
  `link_to_line_attribute8` varchar(150) DEFAULT '',
  `link_to_line_attribute9` varchar(150) DEFAULT '',
  `link_to_line_attribute10` varchar(150) DEFAULT '',
  `link_to_line_attribute11` varchar(150) DEFAULT '',
  `link_to_line_attribute12` varchar(150) DEFAULT '',
  `link_to_line_attribute13` varchar(150) DEFAULT '',
  `link_to_line_attribute14` varchar(150) DEFAULT '',
  `link_to_line_attribute15` varchar(150) DEFAULT '',
  `ship_date_actual` varchar(10) DEFAULT '',
  `amount` int(11) DEFAULT '0',
  `batch_source_name` varchar(50) DEFAULT '',
  `conversion_date` varchar(10) DEFAULT '',
  `conversion_rate` int(11) DEFAULT '0',
  `conversion_type` varchar(30) DEFAULT '',
  `currency_code` varchar(15) DEFAULT '',
  `cust_trx_type_id` int(11) DEFAULT '0',
  `description` varchar(240) DEFAULT '',
  `gl_date` varchar(10) DEFAULT '',
  `line_type` varchar(20) DEFAULT '',
  `orig_system_bill_address_id` int(11) DEFAULT '0',
  `orig_system_bill_customer_id` int(11) DEFAULT '0',
  `orig_system_ship_address_id` int(11) DEFAULT '0',
  `orig_system_ship_customer_id` int(11) DEFAULT '0',
  `orig_system_sold_customer_id` int(11) DEFAULT '0',
  `reason_code` varchar(30) DEFAULT '',
  `ship_via` varchar(25) DEFAULT '',
  `way_bill_number` varchar(50) DEFAULT '',
  `walehouse_id` int(11) DEFAULT '0',
  `quantity` int(11) DEFAULT '0',
  `quantity_ordered` int(11) DEFAULT '0',
  `unit_selling_price` int(11) DEFAULT '0',
  `term_id` int(11) DEFAULT '0',
  `taxable_flag` varchar(1) DEFAULT '',
  `amount_includes_tax_flag` varchar(1) DEFAULT '',
  `set_of_books_id` int(11) DEFAULT '0',
  `org_id` int(11) DEFAULT '0',
  `tax_regime_code` varchar(30) DEFAULT '',
  `tax` varchar(30) DEFAULT '',
  `tax_status_code` varchar(30) DEFAULT '',
  `tax_rate_code` varchar(30) DEFAULT '',
  `tax_jurisdiction_code` varchar(30) DEFAULT '',
  `tax_rate` int(11) DEFAULT '0',
  `primary_salesrep_id` int(11) DEFAULT '0',
  `inventory_item_id` int(11) DEFAULT '0',
  `sales_order` varchar(50) DEFAULT '',
  `sales_order_line` varchar(30) DEFAULT '',
  `sales_order_line_type` varchar(150) DEFAULT '',
  `sales_order_date` varchar(30) DEFAULT '',
  `sales_order_source` varchar(50) DEFAULT '',
  `purchase_order` varchar(50) DEFAULT '',
  `uom_code` varchar(30) DEFAULT '',
  `secondary_uom_code` varchar(30) DEFAULT '',
  `quantity_suc` int(11) DEFAULT '0',
  `unit_selling_price_suc` int(11) DEFAULT '0',
  `created_by` int(11) DEFAULT '0',
  `creation_date` varchar(30) DEFAULT '',
  `last_updated_by` int(11) DEFAULT '0',
  `last_update_date` varchar(30) DEFAULT '',
  `last_update_login` int(11) DEFAULT '0',
  `header_attribute_category` varchar(30) DEFAULT '',
  `header_attribute1` varchar(150) DEFAULT '',
  `header_attribute2` varchar(150) DEFAULT '',
  `header_attribute3` varchar(150) DEFAULT '',
  `header_attribute4` varchar(150) DEFAULT '',
  `header_attribute5` varchar(150) DEFAULT '',
  `header_attribute6` varchar(150) DEFAULT '',
  `header_attribute7` varchar(150) DEFAULT '',
  `header_attribute8` varchar(150) DEFAULT '',
  `header_attribute9` varchar(150) DEFAULT '',
  `header_attribute10` varchar(150) DEFAULT '',
  `header_attribute11` varchar(150) DEFAULT '',
  `header_attribute12` varchar(150) DEFAULT '',
  `header_attribute13` varchar(150) DEFAULT '',
  `header_attribute14` varchar(150) DEFAULT '',
  `header_attribute15` varchar(150) DEFAULT '',
  `line_gdf_attr_category` varchar(30) DEFAULT '',
  `line_gdf_attribute1` varchar(150) DEFAULT '',
  `line_gdf_attribute2` varchar(150) DEFAULT '',
  `line_gdf_attribute3` varchar(150) DEFAULT '',
  `line_gdf_attribute4` varchar(150) DEFAULT '',
  `line_gdf_attribute5` varchar(150) DEFAULT '',
  `line_gdf_attribute6` varchar(150) DEFAULT '',
  `line_gdf_attribute7` varchar(150) DEFAULT '',
  `line_gdf_attribute8` varchar(150) DEFAULT '',
  `line_gdf_attribute9` varchar(150) DEFAULT '',
  `line_gdf_attribute10` varchar(150) DEFAULT '',
  `line_gdf_attribute11` varchar(150) DEFAULT '',
  `line_gdf_attribute12` varchar(150) DEFAULT '',
  `line_gdf_attribute13` varchar(150) DEFAULT '',
  `line_gdf_attribute14` varchar(150) DEFAULT '',
  `line_gdf_attribute15` varchar(150) DEFAULT '',
  `line_gdf_attribute16` varchar(150) DEFAULT '',
  `line_gdf_attribute17` varchar(150) DEFAULT '',
  `line_gdf_attribute18` varchar(150) DEFAULT '',
  `line_gdf_attribute19` varchar(150) DEFAULT '',
  `line_gdf_attribute20` varchar(150) DEFAULT '',
  `attribute_category` varchar(30) DEFAULT '',
  `attribute1` varchar(240) DEFAULT '',
  `attribute2` varchar(240) DEFAULT '',
  `attribute3` varchar(240) DEFAULT '',
  `attribute4` varchar(240) DEFAULT '',
  `attribute5` varchar(240) DEFAULT '',
  `attribute6` varchar(240) DEFAULT '',
  `attribute7` varchar(240) DEFAULT '',
  `attribute8` varchar(240) DEFAULT '',
  `attribute9` varchar(240) DEFAULT '',
  `attribute10` varchar(240) DEFAULT '',
  `attribute11` varchar(240) DEFAULT '',
  `attribute12` varchar(240) DEFAULT '',
  `attribute13` varchar(240) DEFAULT '',
  `attribute14` varchar(240) DEFAULT '',
  `attribute15` varchar(240) DEFAULT '',
  `attr1` varchar(240) DEFAULT '',
  `attr2` varchar(240) DEFAULT '',
  `attr3` varchar(240) DEFAULT '',
  `attr4` varchar(240) DEFAULT '',
  `attr5` varchar(240) DEFAULT '',
  `sale_type` int(11) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for period_approve
-- ----------------------------
DROP TABLE IF EXISTS `period_approve`;
CREATE TABLE `period_approve` (
  `id` varchar(255) NOT NULL,
  `project_id` varchar(255) NOT NULL DEFAULT '',
  `period` int(10) NOT NULL DEFAULT '0',
  `report_ids` varchar(500) DEFAULT NULL,
  `report_paths` varchar(500) DEFAULT NULL,
  `status` varchar(255) DEFAULT NULL,
  `instance_id` varchar(255) DEFAULT NULL,
  `year` int(10) DEFAULT NULL,
  `template_ids` varchar(500) DEFAULT NULL,
  `create_by` varchar(255) DEFAULT NULL,
  `create_time` datetime DEFAULT NULL,
  `approval_by` varchar(255) DEFAULT NULL,
  `approval_time` datetime DEFAULT NULL,
  `approval_resualt` varchar(500) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `period_approve_project_id_IDX` (`project_id`,`period`,`year`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for period_cell_comment
-- ----------------------------
DROP TABLE IF EXISTS `period_cell_comment`;
CREATE TABLE `period_cell_comment` (
  `id` bigint(19) NOT NULL DEFAULT '0',
  `cell_data_id` bigint(19) NOT NULL DEFAULT '0',
  `user_id` varchar(128) NOT NULL DEFAULT '',
  `user_name` varchar(50) NOT NULL DEFAULT '',
  `comment` varchar(1000) NOT NULL DEFAULT '',
  `reply_to_user_name` varchar(50) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `update_by` varchar(128) NOT NULL DEFAULT '',
  `project_id` varchar(128) NOT NULL DEFAULT '',
  `period` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `period_cell_comment_user_id_IDX` (`user_id`,`create_by`,`project_id`,`period`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for period_cell_data
-- ----------------------------
DROP TABLE IF EXISTS `period_cell_data`;
CREATE TABLE `period_cell_data` (
  `id` bigint(19) NOT NULL DEFAULT '0',
  `report_id` bigint(19) NOT NULL DEFAULT '0',
  `cell_template_id` bigint(19) NOT NULL DEFAULT '0',
  `data` varchar(200) DEFAULT '',
  `formula_exp` varchar(1000) NOT NULL DEFAULT '',
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_by` varchar(128) NOT NULL DEFAULT '',
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `project_id` varchar(128) NOT NULL DEFAULT '',
  `period` int(10) NOT NULL DEFAULT '0',
  `keyin_data` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `CPR` (`cell_template_id`,`project_id`,`period`),
  KEY `period_cell_data_report_id_IDX` (`report_id`,`cell_template_id`,`project_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for period_cell_data_source
-- ----------------------------
DROP TABLE IF EXISTS `period_cell_data_source`;
CREATE TABLE `period_cell_data_source` (
  `id` bigint(19) NOT NULL DEFAULT '0',
  `cell_template_id` bigint(19) NOT NULL DEFAULT '0',
  `cell_data_id` bigint(19) NOT NULL DEFAULT '0',
  `data_source_id` bigint(19) NOT NULL DEFAULT '0',
  `operation_type` bigint(19) NOT NULL DEFAULT '0',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `project_id` varchar(128) NOT NULL DEFAULT '',
  `period` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `SYS_C0071279` (`cell_data_id`,`data_source_id`),
  KEY `period_cell_data_source_cell_template_id_IDX` (`cell_template_id`,`cell_data_id`,`project_id`,`period`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for period_cell_template
-- ----------------------------
DROP TABLE IF EXISTS `period_cell_template`;
CREATE TABLE `period_cell_template` (
  `id` bigint(19) NOT NULL DEFAULT '0',
  `period` int(10) NOT NULL DEFAULT '0',
  `report_template_id` bigint(19) NOT NULL DEFAULT '0',
  `row_index` int(10) NOT NULL DEFAULT '0',
  `row_name` varchar(200) DEFAULT '',
  `column_index` int(10) NOT NULL DEFAULT '0',
  `column_name` varchar(200) DEFAULT '',
  `comment` varchar(1000) DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `cell_template_id` bigint(19) NOT NULL DEFAULT '0',
  `data_type` int(10) NOT NULL DEFAULT '0',
  `is_read_only` int(10) NOT NULL DEFAULT '0',
  `copy_from_id` bigint(19) NOT NULL DEFAULT '0',
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `update_by` varchar(128) NOT NULL DEFAULT '',
  `project_id` varchar(128) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `PRCR` (`period`,`row_index`,`column_index`,`project_id`,`report_template_id`),
  KEY `period_cell_template_report_template_id_IDX` (`report_template_id`,`project_id`,`period`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for period_cell_template_config
-- ----------------------------
DROP TABLE IF EXISTS `period_cell_template_config`;
CREATE TABLE `period_cell_template_config` (
  `id` bigint(19) NOT NULL DEFAULT '0',
  `period` int(10) NOT NULL DEFAULT '0',
  `cell_template_id` bigint(19) NOT NULL DEFAULT '0',
  `report_template_id` bigint(19) NOT NULL DEFAULT '0',
  `data_source_type` int(10) NOT NULL DEFAULT '0',
  `formula` varchar(500) NOT NULL DEFAULT '',
  `parsed_formula` varchar(1000) NOT NULL DEFAULT '',
  `formula_description` varchar(1000) DEFAULT '',
  `account_codes` varchar(1000) DEFAULT '',
  `invoice_type` int(10) NOT NULL DEFAULT '0',
  `tax_rate` varchar(50) DEFAULT '',
  `invoice_amount_type` int(10) NOT NULL DEFAULT '0',
  `model_ids` varchar(1000) DEFAULT '',
  `create_by` varchar(128) DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_by` varchar(128) DEFAULT '',
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `invoice_category` varchar(50) DEFAULT '',
  `formula_data_source` varchar(1000) DEFAULT '',
  `validation` varchar(1000) DEFAULT '',
  `parsed_validation` varchar(1000) DEFAULT '',
  `validation_description` varchar(1000) DEFAULT '',
  `voucher_keyword` varchar(1000) DEFAULT '',
  `cell_template_config_id` bigint(19) DEFAULT '0',
  `key_value_parsed_formula` varchar(1000) DEFAULT '',
  `project_id` varchar(128) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `period_cell_template_config_project_id_IDX` (`project_id`,`report_template_id`,`period`,`cell_template_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for period_data_source
-- ----------------------------
DROP TABLE IF EXISTS `period_data_source`;
CREATE TABLE `period_data_source` (
  `id` bigint(19) NOT NULL DEFAULT '0',
  `type` int(10) NOT NULL DEFAULT '0',
  `name` varchar(1000) DEFAULT '',
  `amount` decimal(20,4) NOT NULL DEFAULT '0.0000',
  `description` varchar(1000) DEFAULT '',
  `key_value_data_id` varchar(128) DEFAULT '',
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_by` varchar(128) NOT NULL DEFAULT '',
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `row_name` varchar(1000) DEFAULT '',
  `column_name` varchar(1000) DEFAULT '',
  `row_index` int(10) NOT NULL DEFAULT '0',
  `remap_batch_id` varchar(128) DEFAULT '',
  `column_index` int(10) NOT NULL DEFAULT '0',
  `cell_template_id` bigint(19) NOT NULL DEFAULT '0',
  `period` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `project_id` varchar(128) DEFAULT '',
  `keyin_data` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `period_data_source_period_IDX` (`period`,`project_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for period_data_source_detail
-- ----------------------------
DROP TABLE IF EXISTS `period_data_source_detail`;
CREATE TABLE `period_data_source_detail` (
  `id` bigint(19) NOT NULL DEFAULT '0',
  `data_source_id` bigint(19) NOT NULL DEFAULT '0',
  `data_source_type` int(10) NOT NULL DEFAULT '0',
  `item_value` varchar(500) DEFAULT '',
  `project_id` varchar(128) NOT NULL DEFAULT '',
  `period` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `period_data_source_detail_project_id_IDX` (`project_id`,`period`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for period_enterprise_account
-- ----------------------------
DROP TABLE IF EXISTS `period_enterprise_account`;
CREATE TABLE `period_enterprise_account` (
  `id` varchar(128) NOT NULL DEFAULT '',
  `acct_code` varchar(50) NOT NULL DEFAULT '',
  `name` varchar(50) NOT NULL DEFAULT '',
  `parent_code` varchar(50) DEFAULT '',
  `full_name` varchar(200) DEFAULT '',
  `acct_prop` int(10) DEFAULT '0',
  `sub_prop` int(10) DEFAULT '0',
  `acct_level` int(10) DEFAULT '0',
  `direction` int(10) NOT NULL DEFAULT '0',
  `is_leaf` tinyint(1) DEFAULT '0',
  `is_active` tinyint(1) NOT NULL DEFAULT '0',
  `english_name` varchar(200) DEFAULT '',
  `std_code` varchar(50) DEFAULT '',
  `enterprise_account_set_id` varchar(128) NOT NULL DEFAULT '',
  `is_dummy` int(10) DEFAULT '0',
  `is_in_voucher` int(10) DEFAULT '0',
  `creator_id` varchar(128) NOT NULL DEFAULT '',
  `updator_id` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `project_id` varchar(128) NOT NULL DEFAULT '',
  `period` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `period_enterprise_account_acct_code_IDX` (`acct_code`,`parent_code`,`project_id`,`period`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for period_formula_block
-- ----------------------------
DROP TABLE IF EXISTS `period_formula_block`;
CREATE TABLE `period_formula_block` (
  `id` bigint(19) NOT NULL DEFAULT '0',
  `period` int(10) NOT NULL DEFAULT '0',
  `report_id` bigint(19) NOT NULL DEFAULT '0',
  `cell_template_id` bigint(19) NOT NULL DEFAULT '0',
  `formula_expression` varchar(1000) NOT NULL DEFAULT '',
  `data` varchar(200) NOT NULL DEFAULT '',
  `data_source_id` bigint(19) NOT NULL DEFAULT '0',
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_by` varchar(128) NOT NULL DEFAULT '',
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `project_id` varchar(128) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `period_formula_block_period_IDX` (`period`,`report_id`,`project_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for period_info
-- ----------------------------
DROP TABLE IF EXISTS `period_info`;
CREATE TABLE `period_info` (
  `id` varchar(128) NOT NULL,
  `project_id` varchar(128) NOT NULL DEFAULT '',
  `period` int(10) NOT NULL DEFAULT '0',
  `status` int(10) NOT NULL DEFAULT '0',
  `creator_id` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `project_info` varchar(500) DEFAULT '',
  `import_type` int(10) NOT NULL DEFAULT '0',
  `service_type` int(10) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for period_job
-- ----------------------------
DROP TABLE IF EXISTS `period_job`;
CREATE TABLE `period_job` (
  `id` varchar(64) NOT NULL,
  `name` varchar(64) DEFAULT NULL,
  `current_step` varchar(64) DEFAULT NULL,
  `project_id` varchar(64) DEFAULT NULL,
  `period` int(10) DEFAULT NULL,
  `steps_code` varchar(255) DEFAULT NULL,
  `create_time` datetime DEFAULT NULL,
  `status` varchar(4000) DEFAULT NULL,
  `error_msg` varchar(4000) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for period_modified_report_cell
-- ----------------------------
DROP TABLE IF EXISTS `period_modified_report_cell`;
CREATE TABLE `period_modified_report_cell` (
  `id` bigint(19) NOT NULL DEFAULT '0',
  `report_id` bigint(19) NOT NULL DEFAULT '0',
  `row` int(10) NOT NULL DEFAULT '0',
  `col` int(10) NOT NULL DEFAULT '0',
  `original_value` varchar(1000) NOT NULL DEFAULT '',
  `value` varchar(1000) NOT NULL DEFAULT '',
  `related_cell_data_id` bigint(19) NOT NULL DEFAULT '0',
  `comment` varchar(1000) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `update_by` varchar(128) NOT NULL DEFAULT '',
  `project_id` varchar(128) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for period_report
-- ----------------------------
DROP TABLE IF EXISTS `period_report`;
CREATE TABLE `period_report` (
  `id` bigint(19) NOT NULL DEFAULT '0',
  `template_id` bigint(19) NOT NULL DEFAULT '0',
  `period` int(10) NOT NULL DEFAULT '0',
  `project_id` varchar(128) NOT NULL DEFAULT '',
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_by` varchar(128) NOT NULL DEFAULT '',
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `period_report_template_id_IDX` (`template_id`,`period`,`project_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for period_standard_account
-- ----------------------------
DROP TABLE IF EXISTS `period_standard_account`;
CREATE TABLE `period_standard_account` (
  `id` varchar(128) NOT NULL DEFAULT '',
  `code` varchar(50) NOT NULL DEFAULT '',
  `name` varchar(50) NOT NULL DEFAULT '',
  `parent_code` varchar(50) DEFAULT '',
  `full_name` varchar(200) DEFAULT '',
  `acct_prop` int(10) DEFAULT '0',
  `sub_prop` int(10) DEFAULT '0',
  `acct_level` int(10) DEFAULT '0',
  `direction` int(10) NOT NULL DEFAULT '0',
  `is_leaf` tinyint(1) NOT NULL DEFAULT '0',
  `rule_type` int(10) NOT NULL DEFAULT '0',
  `is_active` tinyint(1) NOT NULL DEFAULT '0',
  `english_name` varchar(200) DEFAULT '',
  `industry_id` varchar(128) NOT NULL DEFAULT '',
  `project_id` varchar(128) NOT NULL DEFAULT '',
  `period` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for period_tax_payer_report_rule
-- ----------------------------
DROP TABLE IF EXISTS `period_tax_payer_report_rule`;
CREATE TABLE `period_tax_payer_report_rule` (
  `id` bigint(19) NOT NULL DEFAULT '0',
  `is_default` int(10) NOT NULL DEFAULT '0',
  `period` int(10) NOT NULL DEFAULT '0',
  `tax_payer_type` int(10) NOT NULL DEFAULT '0',
  `template_group_id` bigint(19) NOT NULL DEFAULT '0',
  `organization_id` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `tax_payer_report_rule_id` bigint(19) NOT NULL DEFAULT '0',
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `update_by` varchar(128) NOT NULL DEFAULT '',
  `project_id` varchar(128) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for period_tax_rule_setting
-- ----------------------------
DROP TABLE IF EXISTS `period_tax_rule_setting`;
CREATE TABLE `period_tax_rule_setting` (
  `id` bigint(19) NOT NULL DEFAULT '0',
  `name` varchar(50) NOT NULL DEFAULT '',
  `is_default` int(10) NOT NULL DEFAULT '0',
  `period` int(10) NOT NULL DEFAULT '0',
  `group_name` varchar(50) NOT NULL DEFAULT '',
  `tax_base` varchar(1000) NOT NULL DEFAULT '',
  `tax_rate` tinyint(4) NOT NULL DEFAULT '0',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `tax_rule_setting_id` bigint(19) NOT NULL DEFAULT '0',
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `update_by` varchar(128) NOT NULL DEFAULT '',
  `project_id` varchar(128) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for period_tax_rule_setting_org
-- ----------------------------
DROP TABLE IF EXISTS `period_tax_rule_setting_org`;
CREATE TABLE `period_tax_rule_setting_org` (
  `id` bigint(19) NOT NULL DEFAULT '0',
  `tax_setting_id` bigint(19) NOT NULL DEFAULT '0',
  `period` int(10) NOT NULL DEFAULT '0',
  `organization_id` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `setting_org_id` bigint(19) NOT NULL DEFAULT '0',
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `update_by` varchar(128) NOT NULL DEFAULT '',
  `project_id` varchar(128) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for period_template
-- ----------------------------
DROP TABLE IF EXISTS `period_template`;
CREATE TABLE `period_template` (
  `id` bigint(19) NOT NULL DEFAULT '0',
  `period` int(10) NOT NULL DEFAULT '0',
  `name` varchar(1000) NOT NULL DEFAULT '',
  `code` varchar(1000) NOT NULL DEFAULT '',
  `path` varchar(1000) NOT NULL DEFAULT '',
  `report_type` int(10) NOT NULL DEFAULT '0',
  `template_group_id` bigint(19) NOT NULL DEFAULT '0',
  `order_index` int(10) NOT NULL DEFAULT '0',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `is_system_type` tinyint(1) NOT NULL DEFAULT '0',
  `is_active_association` tinyint(1) NOT NULL DEFAULT '0',
  `parent_id` varchar(128) NOT NULL DEFAULT '',
  `template_id` bigint(19) NOT NULL DEFAULT '0',
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `update_by` varchar(128) NOT NULL DEFAULT '',
  `project_id` varchar(128) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `PT_PERIOD_TEMPLATE` (`period`,`template_id`,`project_id`),
  KEY `period_template_period_IDX` (`period`,`template_group_id`,`project_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for permission
-- ----------------------------
DROP TABLE IF EXISTS `permission`;
CREATE TABLE `permission` (
  `id` varchar(128) NOT NULL,
  `name` varchar(200) NOT NULL DEFAULT '',
  `code` varchar(128) DEFAULT '',
  `operation_perm_list` varchar(200) DEFAULT '',
  `parent_id` varchar(128) DEFAULT '',
  `is_active` tinyint(1) NOT NULL DEFAULT '0',
  `p_level` smallint(5) NOT NULL DEFAULT '0',
  `rely_on_codes` varchar(500) DEFAULT '',
  `menu_id` varchar(128) DEFAULT '',
  `service_type_id` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `permission_parent_id_IDX` (`parent_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for profit_loss_statement
-- ----------------------------
DROP TABLE IF EXISTS `profit_loss_statement`;
CREATE TABLE `profit_loss_statement` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL COMMENT '机构编号',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '项目ID',
  `date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '数据日期',
  `source` varchar(20) NOT NULL DEFAULT '' COMMENT '来源',
  `tms_period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '税务系统期间yyyymm',
  `period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '期间 yyyymm',
  `status` varchar(10) NOT NULL DEFAULT '' COMMENT '关账标识',
  `ledger_id` varchar(128) NOT NULL DEFAULT '' COMMENT '账套ID',
  `ledger_name` varchar(300) NOT NULL DEFAULT '' COMMENT '账套名称',
  `ledger_currency_code` varchar(20) NOT NULL DEFAULT '' COMMENT '账套币种',
  `entity_code` varchar(300) NOT NULL DEFAULT '' COMMENT '机构编码',
  `entity_name` varchar(300) NOT NULL DEFAULT '' COMMENT '机构名称',
  `category` varchar(300) NOT NULL DEFAULT '' COMMENT '主体性质',
  `frequency` varchar(300) NOT NULL DEFAULT '' COMMENT '频度',
  `item_name` varchar(300) NOT NULL DEFAULT '' COMMENT '项目名称',
  `period_amt` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本期发生额',
  `ytd_amt` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本年累计',
  `prc_flag` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否为国外',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='利润表。月度，次月传送上月，全部主体，只传送账套币种即折算后本位币币种金额';

-- ----------------------------
-- Table structure for profit_loss_statement_final
-- ----------------------------
DROP TABLE IF EXISTS `profit_loss_statement_final`;
CREATE TABLE `profit_loss_statement_final` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL COMMENT '机构编号',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '项目ID',
  `date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '数据日期',
  `source` varchar(20) NOT NULL DEFAULT '' COMMENT '来源',
  `tms_period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '税务系统期间yyyymm',
  `period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '期间 yyyymm',
  `status` varchar(10) NOT NULL DEFAULT '' COMMENT '关账标识',
  `ledger_id` varchar(128) NOT NULL DEFAULT '' COMMENT '账套ID',
  `ledger_name` varchar(300) NOT NULL DEFAULT '' COMMENT '账套名称',
  `ledger_currency_code` varchar(20) NOT NULL DEFAULT '' COMMENT '账套币种',
  `entity_code` varchar(300) NOT NULL DEFAULT '' COMMENT '机构编码',
  `entity_name` varchar(300) NOT NULL DEFAULT '' COMMENT '机构名称',
  `category` varchar(300) NOT NULL DEFAULT '' COMMENT '主体性质',
  `frequency` varchar(300) NOT NULL DEFAULT '' COMMENT '频度',
  `item_name` varchar(300) NOT NULL DEFAULT '' COMMENT '项目名称',
  `period_amt` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本期发生额',
  `ytd_amt` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本年累计',
  `prc_flag` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否为国外',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='利润表。最新版本，与接口导入、excel导入中最新版本一致';

-- ----------------------------
-- Table structure for profit_loss_statement_manual
-- ----------------------------
DROP TABLE IF EXISTS `profit_loss_statement_manual`;
CREATE TABLE `profit_loss_statement_manual` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL COMMENT '机构编号',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '项目ID',
  `date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '数据日期',
  `source` varchar(20) NOT NULL DEFAULT '' COMMENT '来源',
  `tms_period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '税务系统期间yyyymm',
  `period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '期间 yyyymm',
  `status` varchar(10) NOT NULL DEFAULT '' COMMENT '关账标识',
  `ledger_id` varchar(128) NOT NULL DEFAULT '' COMMENT '账套ID',
  `ledger_name` varchar(300) NOT NULL DEFAULT '' COMMENT '账套名称',
  `ledger_currency_code` varchar(20) NOT NULL DEFAULT '' COMMENT '账套币种',
  `entity_code` varchar(300) NOT NULL DEFAULT '' COMMENT '机构编码',
  `entity_name` varchar(300) NOT NULL DEFAULT '' COMMENT '机构名称',
  `category` varchar(300) NOT NULL DEFAULT '' COMMENT '主体性质',
  `frequency` varchar(300) NOT NULL DEFAULT '' COMMENT '频度',
  `item_name` varchar(300) NOT NULL DEFAULT '' COMMENT '项目名称',
  `period_amt` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本期发生额',
  `ytd_amt` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本年累计',
  `prc_flag` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否为国外',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='利润表。人工调整，excel导入';

-- ----------------------------
-- Table structure for project
-- ----------------------------
DROP TABLE IF EXISTS `project`;
CREATE TABLE `project` (
  `id` varchar(128) NOT NULL,
  `code` varchar(50) NOT NULL DEFAULT '',
  `organization_id` varchar(128) NOT NULL DEFAULT '',
  `name` varchar(100) NOT NULL DEFAULT '',
  `year` int(10) NOT NULL DEFAULT '0',
  `client_code` varchar(50) NOT NULL DEFAULT '',
  `is_active` tinyint(1) NOT NULL DEFAULT '0',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `region_id` varchar(128) NOT NULL DEFAULT '',
  `industry_id` varchar(128) NOT NULL DEFAULT '',
  `rule_type` int(10) NOT NULL DEFAULT '0',
  `db_name` varchar(64) DEFAULT '',
  `enterprise_account_set_id` varchar(128) DEFAULT '',
  `start_period` int(10) NOT NULL DEFAULT '0',
  `end_period` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for project_client
-- ----------------------------
DROP TABLE IF EXISTS `project_client`;
CREATE TABLE `project_client` (
  `id` varchar(128) NOT NULL,
  `code` varchar(50) NOT NULL DEFAULT '',
  `name` varchar(100) NOT NULL DEFAULT '',
  `industry_id` varchar(128) NOT NULL DEFAULT '',
  `is_active` tinyint(1) NOT NULL DEFAULT '0',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for project_service_type
-- ----------------------------
DROP TABLE IF EXISTS `project_service_type`;
CREATE TABLE `project_service_type` (
  `id` varchar(128) NOT NULL,
  `project_id` varchar(128) DEFAULT '',
  `service_type_id` varchar(128) DEFAULT '',
  `template_group_id` bigint(19) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for project_status_manage
-- ----------------------------
DROP TABLE IF EXISTS `project_status_manage`;
CREATE TABLE `project_status_manage` (
  `id` varchar(128) NOT NULL,
  `project_id` varchar(128) DEFAULT '',
  `period_id` int(10) DEFAULT '0',
  `status` int(10) DEFAULT '0',
  `creator_id` varchar(128) DEFAULT '',
  `create_time` datetime DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime DEFAULT CURRENT_TIMESTAMP,
  `db_name` varchar(64) DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `project_status_manage_project_id_IDX` (`project_id`,`period_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for pwc_report_attach
-- ----------------------------
DROP TABLE IF EXISTS `pwc_report_attach`;
CREATE TABLE `pwc_report_attach` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `template_id` varchar(64) DEFAULT NULL COMMENT '对应sheet模板ID',
  `col` bigint(20) DEFAULT NULL COMMENT '列',
  `row` bigint(20) DEFAULT NULL COMMENT '行',
  `del_flag` varchar(64) DEFAULT NULL,
  `file_name` varchar(64) DEFAULT NULL,
  `file_url` varchar(200) DEFAULT NULL,
  `upload_user` varchar(64) DEFAULT NULL,
  `size` varchar(64) DEFAULT NULL,
  `remarks` varchar(64) DEFAULT NULL,
  `create_time` datetime DEFAULT NULL,
  `update_time` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=29 DEFAULT CHARSET=utf8mb4 COMMENT='附件和report单元格关联表';

-- ----------------------------
-- Table structure for QRTZ_BLOB_TRIGGERS
-- ----------------------------
DROP TABLE IF EXISTS `QRTZ_BLOB_TRIGGERS`;
CREATE TABLE `QRTZ_BLOB_TRIGGERS` (
  `SCHED_NAME` varchar(120) NOT NULL,
  `TRIGGER_NAME` varchar(200) NOT NULL,
  `TRIGGER_GROUP` varchar(200) NOT NULL,
  `BLOB_DATA` blob,
  PRIMARY KEY (`SCHED_NAME`,`TRIGGER_NAME`,`TRIGGER_GROUP`),
  KEY `SCHED_NAME` (`SCHED_NAME`,`TRIGGER_NAME`,`TRIGGER_GROUP`),
  CONSTRAINT `QRTZ_BLOB_TRIGGERS_ibfk_1` FOREIGN KEY (`SCHED_NAME`, `TRIGGER_NAME`, `TRIGGER_GROUP`) REFERENCES `QRTZ_TRIGGERS` (`SCHED_NAME`, `TRIGGER_NAME`, `TRIGGER_GROUP`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for QRTZ_CALENDARS
-- ----------------------------
DROP TABLE IF EXISTS `QRTZ_CALENDARS`;
CREATE TABLE `QRTZ_CALENDARS` (
  `SCHED_NAME` varchar(120) NOT NULL,
  `CALENDAR_NAME` varchar(200) NOT NULL,
  `CALENDAR` blob NOT NULL,
  PRIMARY KEY (`SCHED_NAME`,`CALENDAR_NAME`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for QRTZ_CRON_TRIGGERS
-- ----------------------------
DROP TABLE IF EXISTS `QRTZ_CRON_TRIGGERS`;
CREATE TABLE `QRTZ_CRON_TRIGGERS` (
  `SCHED_NAME` varchar(120) NOT NULL,
  `TRIGGER_NAME` varchar(200) NOT NULL,
  `TRIGGER_GROUP` varchar(200) NOT NULL,
  `CRON_EXPRESSION` varchar(120) NOT NULL,
  `TIME_ZONE_ID` varchar(80) DEFAULT NULL,
  PRIMARY KEY (`SCHED_NAME`,`TRIGGER_NAME`,`TRIGGER_GROUP`),
  CONSTRAINT `QRTZ_CRON_TRIGGERS_ibfk_1` FOREIGN KEY (`SCHED_NAME`, `TRIGGER_NAME`, `TRIGGER_GROUP`) REFERENCES `QRTZ_TRIGGERS` (`SCHED_NAME`, `TRIGGER_NAME`, `TRIGGER_GROUP`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for QRTZ_FIRED_TRIGGERS
-- ----------------------------
DROP TABLE IF EXISTS `QRTZ_FIRED_TRIGGERS`;
CREATE TABLE `QRTZ_FIRED_TRIGGERS` (
  `SCHED_NAME` varchar(120) NOT NULL,
  `ENTRY_ID` varchar(95) NOT NULL,
  `TRIGGER_NAME` varchar(200) NOT NULL,
  `TRIGGER_GROUP` varchar(200) NOT NULL,
  `INSTANCE_NAME` varchar(200) NOT NULL,
  `FIRED_TIME` bigint(13) NOT NULL,
  `SCHED_TIME` bigint(13) NOT NULL,
  `PRIORITY` int(11) NOT NULL,
  `STATE` varchar(16) NOT NULL,
  `JOB_NAME` varchar(200) DEFAULT NULL,
  `JOB_GROUP` varchar(200) DEFAULT NULL,
  `IS_NONCONCURRENT` varchar(1) DEFAULT NULL,
  `REQUESTS_RECOVERY` varchar(1) DEFAULT NULL,
  PRIMARY KEY (`SCHED_NAME`,`ENTRY_ID`),
  KEY `IDX_QRTZ_FT_TRIG_INST_NAME` (`SCHED_NAME`,`INSTANCE_NAME`),
  KEY `IDX_QRTZ_FT_INST_JOB_REQ_RCVRY` (`SCHED_NAME`,`INSTANCE_NAME`,`REQUESTS_RECOVERY`),
  KEY `IDX_QRTZ_FT_J_G` (`SCHED_NAME`,`JOB_NAME`,`JOB_GROUP`),
  KEY `IDX_QRTZ_FT_JG` (`SCHED_NAME`,`JOB_GROUP`),
  KEY `IDX_QRTZ_FT_T_G` (`SCHED_NAME`,`TRIGGER_NAME`,`TRIGGER_GROUP`),
  KEY `IDX_QRTZ_FT_TG` (`SCHED_NAME`,`TRIGGER_GROUP`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for QRTZ_JOB_DETAILS
-- ----------------------------
DROP TABLE IF EXISTS `QRTZ_JOB_DETAILS`;
CREATE TABLE `QRTZ_JOB_DETAILS` (
  `SCHED_NAME` varchar(120) NOT NULL,
  `JOB_NAME` varchar(200) NOT NULL,
  `JOB_GROUP` varchar(200) NOT NULL,
  `DESCRIPTION` varchar(250) DEFAULT NULL,
  `JOB_CLASS_NAME` varchar(250) NOT NULL,
  `IS_DURABLE` varchar(1) NOT NULL,
  `IS_NONCONCURRENT` varchar(1) NOT NULL,
  `IS_UPDATE_DATA` varchar(1) NOT NULL,
  `REQUESTS_RECOVERY` varchar(1) NOT NULL,
  `JOB_DATA` blob,
  PRIMARY KEY (`SCHED_NAME`,`JOB_NAME`,`JOB_GROUP`),
  KEY `IDX_QRTZ_J_REQ_RECOVERY` (`SCHED_NAME`,`REQUESTS_RECOVERY`),
  KEY `IDX_QRTZ_J_GRP` (`SCHED_NAME`,`JOB_GROUP`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for QRTZ_LOCKS
-- ----------------------------
DROP TABLE IF EXISTS `QRTZ_LOCKS`;
CREATE TABLE `QRTZ_LOCKS` (
  `SCHED_NAME` varchar(120) NOT NULL,
  `LOCK_NAME` varchar(40) NOT NULL,
  PRIMARY KEY (`SCHED_NAME`,`LOCK_NAME`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for QRTZ_PAUSED_TRIGGER_GRPS
-- ----------------------------
DROP TABLE IF EXISTS `QRTZ_PAUSED_TRIGGER_GRPS`;
CREATE TABLE `QRTZ_PAUSED_TRIGGER_GRPS` (
  `SCHED_NAME` varchar(120) NOT NULL,
  `TRIGGER_GROUP` varchar(200) NOT NULL,
  PRIMARY KEY (`SCHED_NAME`,`TRIGGER_GROUP`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for QRTZ_SCHEDULER_STATE
-- ----------------------------
DROP TABLE IF EXISTS `QRTZ_SCHEDULER_STATE`;
CREATE TABLE `QRTZ_SCHEDULER_STATE` (
  `SCHED_NAME` varchar(120) NOT NULL,
  `INSTANCE_NAME` varchar(200) NOT NULL,
  `LAST_CHECKIN_TIME` bigint(13) NOT NULL,
  `CHECKIN_INTERVAL` bigint(13) NOT NULL,
  PRIMARY KEY (`SCHED_NAME`,`INSTANCE_NAME`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for QRTZ_SIMPLE_TRIGGERS
-- ----------------------------
DROP TABLE IF EXISTS `QRTZ_SIMPLE_TRIGGERS`;
CREATE TABLE `QRTZ_SIMPLE_TRIGGERS` (
  `SCHED_NAME` varchar(120) NOT NULL,
  `TRIGGER_NAME` varchar(200) NOT NULL,
  `TRIGGER_GROUP` varchar(200) NOT NULL,
  `REPEAT_COUNT` bigint(7) NOT NULL,
  `REPEAT_INTERVAL` bigint(12) NOT NULL,
  `TIMES_TRIGGERED` bigint(10) NOT NULL,
  PRIMARY KEY (`SCHED_NAME`,`TRIGGER_NAME`,`TRIGGER_GROUP`),
  CONSTRAINT `QRTZ_SIMPLE_TRIGGERS_ibfk_1` FOREIGN KEY (`SCHED_NAME`, `TRIGGER_NAME`, `TRIGGER_GROUP`) REFERENCES `QRTZ_TRIGGERS` (`SCHED_NAME`, `TRIGGER_NAME`, `TRIGGER_GROUP`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for QRTZ_SIMPROP_TRIGGERS
-- ----------------------------
DROP TABLE IF EXISTS `QRTZ_SIMPROP_TRIGGERS`;
CREATE TABLE `QRTZ_SIMPROP_TRIGGERS` (
  `SCHED_NAME` varchar(120) NOT NULL,
  `TRIGGER_NAME` varchar(200) NOT NULL,
  `TRIGGER_GROUP` varchar(200) NOT NULL,
  `STR_PROP_1` varchar(512) DEFAULT NULL,
  `STR_PROP_2` varchar(512) DEFAULT NULL,
  `STR_PROP_3` varchar(512) DEFAULT NULL,
  `INT_PROP_1` int(11) DEFAULT NULL,
  `INT_PROP_2` int(11) DEFAULT NULL,
  `LONG_PROP_1` bigint(20) DEFAULT NULL,
  `LONG_PROP_2` bigint(20) DEFAULT NULL,
  `DEC_PROP_1` decimal(13,4) DEFAULT NULL,
  `DEC_PROP_2` decimal(13,4) DEFAULT NULL,
  `BOOL_PROP_1` varchar(1) DEFAULT NULL,
  `BOOL_PROP_2` varchar(1) DEFAULT NULL,
  PRIMARY KEY (`SCHED_NAME`,`TRIGGER_NAME`,`TRIGGER_GROUP`),
  CONSTRAINT `QRTZ_SIMPROP_TRIGGERS_ibfk_1` FOREIGN KEY (`SCHED_NAME`, `TRIGGER_NAME`, `TRIGGER_GROUP`) REFERENCES `QRTZ_TRIGGERS` (`SCHED_NAME`, `TRIGGER_NAME`, `TRIGGER_GROUP`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for QRTZ_TRIGGERS
-- ----------------------------
DROP TABLE IF EXISTS `QRTZ_TRIGGERS`;
CREATE TABLE `QRTZ_TRIGGERS` (
  `SCHED_NAME` varchar(120) NOT NULL,
  `TRIGGER_NAME` varchar(200) NOT NULL,
  `TRIGGER_GROUP` varchar(200) NOT NULL,
  `JOB_NAME` varchar(200) NOT NULL,
  `JOB_GROUP` varchar(200) NOT NULL,
  `DESCRIPTION` varchar(250) DEFAULT NULL,
  `NEXT_FIRE_TIME` bigint(13) DEFAULT NULL,
  `PREV_FIRE_TIME` bigint(13) DEFAULT NULL,
  `PRIORITY` int(11) DEFAULT NULL,
  `TRIGGER_STATE` varchar(16) NOT NULL,
  `TRIGGER_TYPE` varchar(8) NOT NULL,
  `START_TIME` bigint(13) NOT NULL,
  `END_TIME` bigint(13) DEFAULT NULL,
  `CALENDAR_NAME` varchar(200) DEFAULT NULL,
  `MISFIRE_INSTR` smallint(2) DEFAULT NULL,
  `JOB_DATA` blob,
  PRIMARY KEY (`SCHED_NAME`,`TRIGGER_NAME`,`TRIGGER_GROUP`),
  KEY `IDX_QRTZ_T_J` (`SCHED_NAME`,`JOB_NAME`,`JOB_GROUP`),
  KEY `IDX_QRTZ_T_JG` (`SCHED_NAME`,`JOB_GROUP`),
  KEY `IDX_QRTZ_T_C` (`SCHED_NAME`,`CALENDAR_NAME`),
  KEY `IDX_QRTZ_T_G` (`SCHED_NAME`,`TRIGGER_GROUP`),
  KEY `IDX_QRTZ_T_STATE` (`SCHED_NAME`,`TRIGGER_STATE`),
  KEY `IDX_QRTZ_T_N_STATE` (`SCHED_NAME`,`TRIGGER_NAME`,`TRIGGER_GROUP`,`TRIGGER_STATE`),
  KEY `IDX_QRTZ_T_N_G_STATE` (`SCHED_NAME`,`TRIGGER_GROUP`,`TRIGGER_STATE`),
  KEY `IDX_QRTZ_T_NEXT_FIRE_TIME` (`SCHED_NAME`,`NEXT_FIRE_TIME`),
  KEY `IDX_QRTZ_T_NFT_ST` (`SCHED_NAME`,`TRIGGER_STATE`,`NEXT_FIRE_TIME`),
  KEY `IDX_QRTZ_T_NFT_MISFIRE` (`SCHED_NAME`,`MISFIRE_INSTR`,`NEXT_FIRE_TIME`),
  KEY `IDX_QRTZ_T_NFT_ST_MISFIRE` (`SCHED_NAME`,`MISFIRE_INSTR`,`NEXT_FIRE_TIME`,`TRIGGER_STATE`),
  KEY `IDX_QRTZ_T_NFT_ST_MISFIRE_GRP` (`SCHED_NAME`,`MISFIRE_INSTR`,`NEXT_FIRE_TIME`,`TRIGGER_GROUP`,`TRIGGER_STATE`),
  CONSTRAINT `QRTZ_TRIGGERS_ibfk_1` FOREIGN KEY (`SCHED_NAME`, `JOB_NAME`, `JOB_GROUP`) REFERENCES `QRTZ_JOB_DETAILS` (`SCHED_NAME`, `JOB_NAME`, `JOB_GROUP`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for red_letter_info_table
-- ----------------------------
DROP TABLE IF EXISTS `red_letter_info_table`;
CREATE TABLE `red_letter_info_table` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL COMMENT '机构编号',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '项目ID',
  `subject_num` varchar(128) NOT NULL DEFAULT '' COMMENT '主体编号',
  `subject_name` varchar(300) NOT NULL DEFAULT '' COMMENT '主体（购方）名称',
  `red_letter_invoice_info_table_num` varchar(128) NOT NULL DEFAULT '' COMMENT '红字发票信息表编号',
  `fill_in_date` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '填开日期 yyyyMM',
  `sales_tax_number` varchar(128) NOT NULL DEFAULT '' COMMENT '销方税号',
  `salesperson_name` varchar(300) NOT NULL DEFAULT '' COMMENT '销方名称',
  `total_amount` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '合计金额',
  `total_tax_amount` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '合计税额',
  `application_description` varchar(500) NOT NULL DEFAULT '' COMMENT '申请选择（说明）',
  `applicant_manager` varchar(20) NOT NULL DEFAULT '' COMMENT '申请方经办人',
  `invoice_code` varchar(128) NOT NULL DEFAULT '' COMMENT '发票代码',
  `invoice_number` varchar(128) NOT NULL DEFAULT '' COMMENT '发票号码',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='红字信息表';

-- ----------------------------
-- Table structure for region
-- ----------------------------
DROP TABLE IF EXISTS `region`;
CREATE TABLE `region` (
  `id` varchar(128) NOT NULL,
  `parent_id` varchar(128) DEFAULT '',
  `name` varchar(50) NOT NULL DEFAULT '',
  `short_name` varchar(10) NOT NULL DEFAULT '',
  `merger_name` varchar(200) NOT NULL DEFAULT '',
  `level_type` int(10) NOT NULL DEFAULT '0',
  `tel_code` varchar(10) DEFAULT '',
  `zip_code` varchar(11) DEFAULT '',
  `pin_yin` varchar(50) NOT NULL DEFAULT '',
  `longitude` float NOT NULL DEFAULT '0',
  `latitude` float NOT NULL DEFAULT '0',
  `is_active` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `parent_id_IDX` (`parent_id`),
  KEY `region_parent_id_IDX` (`parent_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for revenue_config
-- ----------------------------
DROP TABLE IF EXISTS `revenue_config`;
CREATE TABLE `revenue_config` (
  `id` bigint(18) NOT NULL,
  `serial_no` varchar(50) NOT NULL DEFAULT '' COMMENT '序号',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '收入类型名称',
  `org_id` varchar(128) NOT NULL DEFAULT '' COMMENT '机构ID',
  `account_type` tinyint(4) NOT NULL DEFAULT '0' COMMENT '账载收入类型   0.0值 1.科目 2.手工输入',
  `account_name` varchar(255) NOT NULL DEFAULT '' COMMENT '账载收入名称',
  `tax_rate` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '税率',
  `tax_base` tinyint(4) NOT NULL DEFAULT '0' COMMENT '计税基础  1.账载 2.开票收入 3.手工录入 4.借方发生额 5.贷方发生额',
  `revenue_type` tinyint(4) NOT NULL DEFAULT '0' COMMENT '收入类别 0.货物及加工修理修配劳务 1.服务、不动产和无形资产',
  `tax_type` tinyint(4) NOT NULL DEFAULT '0' COMMENT '计税方法 0.一般计税 1.简易计税 2.免抵退税 3.免税',
  `status` tinyint(4) NOT NULL DEFAULT '0' COMMENT '状态 0：启用 1：停用',
  `start_date` varchar(10) NOT NULL DEFAULT '' COMMENT '启用日期',
  `end_date` varchar(10) NOT NULL DEFAULT '' COMMENT '终止日期',
  `tb_segment3` varchar(255) NOT NULL DEFAULT '' COMMENT '账载科目代码',
  `tb_segment5` varchar(255) NOT NULL DEFAULT '' COMMENT '账载利润中心代码',
  `tb_segment6` varchar(255) NOT NULL DEFAULT '' COMMENT '账载产品代码',
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_by` varchar(128) NOT NULL DEFAULT '',
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `base_cr_code` varchar(255) NOT NULL DEFAULT '' COMMENT '计税基础贷方发生额Code',
  `base_dr_code` varchar(255) NOT NULL DEFAULT '' COMMENT '计税基础借方发生额Code',
  PRIMARY KEY (`id`),
  UNIQUE KEY `uniq_org_name` (`org_id`,`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='收入类型配置表';

-- ----------------------------
-- Table structure for revenue_type_mapping
-- ----------------------------
DROP TABLE IF EXISTS `revenue_type_mapping`;
CREATE TABLE `revenue_type_mapping` (
  `id` bigint(18) NOT NULL,
  `org_id` varchar(128) NOT NULL DEFAULT '' COMMENT '机构ID',
  `ou_name` varchar(255) NOT NULL DEFAULT '' COMMENT '申请部门',
  `content` varchar(255) NOT NULL DEFAULT '' COMMENT '开票内容',
  `tax_rate` decimal(6,4) NOT NULL DEFAULT '0.0000' COMMENT '税率',
  `revenue_type_name` varchar(255) NOT NULL DEFAULT '' COMMENT '收入类型名',
  `start_date` varchar(10) NOT NULL DEFAULT '' COMMENT '启用日期',
  `end_date` varchar(10) NOT NULL DEFAULT '' COMMENT '终止日期',
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `update_by` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='开票与收入类型映射';

-- ----------------------------
-- Table structure for role
-- ----------------------------
DROP TABLE IF EXISTS `role`;
CREATE TABLE `role` (
  `id` varchar(128) NOT NULL,
  `name` varchar(200) NOT NULL DEFAULT '',
  `description` varchar(500) DEFAULT '',
  `role_category_id` varchar(128) NOT NULL DEFAULT '',
  `service_type_id` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `role_role_category_id_IDX` (`role_category_id`,`service_type_id`) USING BTREE,
  KEY `role_name_IDX` (`name`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for role_category
-- ----------------------------
DROP TABLE IF EXISTS `role_category`;
CREATE TABLE `role_category` (
  `id` varchar(128) NOT NULL,
  `name` varchar(200) NOT NULL DEFAULT '',
  `is_active` tinyint(1) NOT NULL DEFAULT '0',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `role_category_name_IDX` (`name`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for role_permission
-- ----------------------------
DROP TABLE IF EXISTS `role_permission`;
CREATE TABLE `role_permission` (
  `id` varchar(128) NOT NULL,
  `role_id` varchar(128) NOT NULL DEFAULT '',
  `permission_id` varchar(128) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for service_type
-- ----------------------------
DROP TABLE IF EXISTS `service_type`;
CREATE TABLE `service_type` (
  `id` varchar(128) NOT NULL,
  `name` varchar(200) NOT NULL DEFAULT '',
  `prefix` varchar(50) NOT NULL DEFAULT '',
  `is_active` tinyint(1) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for standard_account
-- ----------------------------
DROP TABLE IF EXISTS `standard_account`;
CREATE TABLE `standard_account` (
  `id` varchar(128) NOT NULL,
  `code` varchar(50) NOT NULL DEFAULT '',
  `name` varchar(50) NOT NULL DEFAULT '',
  `parent_code` varchar(50) DEFAULT '',
  `full_name` varchar(200) NOT NULL DEFAULT '',
  `acct_prop` int(10) DEFAULT '0',
  `sub_prop` int(10) DEFAULT '0',
  `acct_level` int(10) DEFAULT '0',
  `direction` int(10) DEFAULT '0',
  `is_leaf` tinyint(1) DEFAULT '0',
  `rule_type` int(10) DEFAULT '0',
  `is_active` tinyint(1) DEFAULT '0',
  `english_name` varchar(200) DEFAULT '',
  `industry_id` varchar(128) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `standard_account_parent_code_IDX` (`parent_code`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for statistic_attribute
-- ----------------------------
DROP TABLE IF EXISTS `statistic_attribute`;
CREATE TABLE `statistic_attribute` (
  `id` varchar(128) NOT NULL,
  `name` varchar(200) NOT NULL DEFAULT '',
  `is_active` tinyint(1) NOT NULL DEFAULT '0',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for statistic_attribute_dimension
-- ----------------------------
DROP TABLE IF EXISTS `statistic_attribute_dimension`;
CREATE TABLE `statistic_attribute_dimension` (
  `id` varchar(128) NOT NULL,
  `dimension_id` varchar(128) NOT NULL DEFAULT '',
  `statistics_attribute_id` varchar(128) NOT NULL DEFAULT '',
  `order_index` tinyint(1) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for stock
-- ----------------------------
DROP TABLE IF EXISTS `stock`;
CREATE TABLE `stock` (
  `id` varchar(128) NOT NULL,
  `name` varchar(500) NOT NULL DEFAULT '',
  `code` varchar(200) DEFAULT '',
  `stock_amount` tinyint(3) NOT NULL DEFAULT '0',
  `capital_amount` tinyint(3) NOT NULL DEFAULT '0',
  `capital_percent` tinyint(3) NOT NULL DEFAULT '0',
  `effective_date` datetime DEFAULT CURRENT_TIMESTAMP,
  `expired_date` datetime DEFAULT CURRENT_TIMESTAMP,
  `parent_id` varchar(128) DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for table_menu
-- ----------------------------
DROP TABLE IF EXISTS `table_menu`;
CREATE TABLE `table_menu` (
  `id` bigint(18) NOT NULL DEFAULT '0' COMMENT '系统唯一标识',
  `menu_name_cn` varchar(100) NOT NULL DEFAULT ' ' COMMENT '菜单中文',
  `menu_name_en` varchar(100) NOT NULL DEFAULT ' ' COMMENT '菜单英文',
  `menu_index` int(1) NOT NULL DEFAULT '0' COMMENT '菜单排序',
  `order_index` int(1) NOT NULL DEFAULT '0',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='一级菜单表';

-- ----------------------------
-- Table structure for table_test
-- ----------------------------
DROP TABLE IF EXISTS `table_test`;
CREATE TABLE `table_test` (
  `id` bigint(18) NOT NULL,
  `stat_period` int(11) NOT NULL DEFAULT '0',
  `test` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`,`stat_period`),
  KEY `table_test_test_index` (`test`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4
/*!50100 PARTITION BY RANGE (stat_period)
(PARTITION p_01 VALUES LESS THAN (201902) ENGINE = InnoDB,
 PARTITION p_02 VALUES LESS THAN (201903) ENGINE = InnoDB,
 PARTITION p_03 VALUES LESS THAN (201904) ENGINE = InnoDB,
 PARTITION p_04 VALUES LESS THAN (201905) ENGINE = InnoDB) */;

-- ----------------------------
-- Table structure for tax_payer_report_rule
-- ----------------------------
DROP TABLE IF EXISTS `tax_payer_report_rule`;
CREATE TABLE `tax_payer_report_rule` (
  `id` bigint(19) NOT NULL,
  `is_default` tinyint(1) NOT NULL DEFAULT '0',
  `tax_payer_type` int(10) NOT NULL DEFAULT '0',
  `template_group_id` bigint(19) NOT NULL DEFAULT '0',
  `organization_id` varchar(128) DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `create_by` varchar(128) DEFAULT '',
  `update_by` varchar(128) DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `tax_payer_report_rule_template_group_id_IDX` (`template_group_id`,`organization_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for tax_rule_setting
-- ----------------------------
DROP TABLE IF EXISTS `tax_rule_setting`;
CREATE TABLE `tax_rule_setting` (
  `id` bigint(19) NOT NULL,
  `name` varchar(50) NOT NULL DEFAULT '',
  `is_default` tinyint(1) NOT NULL DEFAULT '0',
  `group_name` varchar(50) NOT NULL DEFAULT '',
  `tax_base` varchar(1000) NOT NULL DEFAULT '',
  `tax_rate` float NOT NULL DEFAULT '0',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `create_by` varchar(128) DEFAULT '',
  `update_by` varchar(128) DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for tax_rule_setting_organization
-- ----------------------------
DROP TABLE IF EXISTS `tax_rule_setting_organization`;
CREATE TABLE `tax_rule_setting_organization` (
  `id` bigint(19) NOT NULL,
  `tax_setting_id` bigint(19) NOT NULL DEFAULT '0',
  `organization_id` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `create_by` varchar(128) NOT NULL DEFAULT '',
  `update_by` varchar(128) DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `tax_rule_setting_organization_tax_setting_id_IDX` (`tax_setting_id`,`organization_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for template
-- ----------------------------
DROP TABLE IF EXISTS `template`;
CREATE TABLE `template` (
  `id` bigint(19) NOT NULL,
  `name` varchar(200) NOT NULL DEFAULT '',
  `code` varchar(200) NOT NULL DEFAULT '',
  `path` varchar(500) NOT NULL DEFAULT '',
  `report_type` int(10) NOT NULL DEFAULT '0',
  `template_group_id` bigint(19) NOT NULL DEFAULT '0',
  `order_index` int(10) NOT NULL DEFAULT '0',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `is_system_type` tinyint(1) NOT NULL DEFAULT '0',
  `is_active_association` tinyint(1) NOT NULL DEFAULT '0',
  `parent_id` varchar(128) DEFAULT '',
  `create_by` varchar(128) DEFAULT '',
  `update_by` varchar(128) DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `template_template_group_id_IDX` (`template_group_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for template_formula
-- ----------------------------
DROP TABLE IF EXISTS `template_formula`;
CREATE TABLE `template_formula` (
  `id` varchar(128) NOT NULL,
  `row_index` int(10) NOT NULL DEFAULT '0',
  `column_index` int(10) NOT NULL DEFAULT '0',
  `column_end_index` int(10) DEFAULT '0',
  `formula` varchar(500) NOT NULL DEFAULT '',
  `template_id` varchar(128) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `is_manual_change` tinyint(1) NOT NULL DEFAULT '0',
  `instructions` varchar(500) DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for template_group
-- ----------------------------
DROP TABLE IF EXISTS `template_group`;
CREATE TABLE `template_group` (
  `id` bigint(19) NOT NULL,
  `name` varchar(255) NOT NULL DEFAULT '',
  `service_type_id` varchar(128) NOT NULL DEFAULT '',
  `industry_ids` varchar(1000) NOT NULL DEFAULT '',
  `pay_tax_type` int(10) NOT NULL DEFAULT '0',
  `group_type` int(10) NOT NULL DEFAULT '0',
  `copy_from` bigint(19) NOT NULL DEFAULT '0',
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `is_system_type` tinyint(1) NOT NULL DEFAULT '0',
  `create_by` varchar(128) DEFAULT '',
  `update_by` varchar(128) DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for trial_balance
-- ----------------------------
DROP TABLE IF EXISTS `trial_balance`;
CREATE TABLE `trial_balance` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL COMMENT '机构编号',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '项目ID',
  `date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '数据日期',
  `source` varchar(20) NOT NULL DEFAULT '' COMMENT '来源',
  `period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '期间 yyyymm',
  `ledger_id` varchar(128) NOT NULL DEFAULT '' COMMENT '账套ID',
  `ledger_name` varchar(300) NOT NULL DEFAULT '' COMMENT '账套名称',
  `currency_code` varchar(20) NOT NULL DEFAULT '' COMMENT '账套币种',
  `status` varchar(20) NOT NULL DEFAULT '' COMMENT '关账标识',
  `category` varchar(10) NOT NULL DEFAULT '' COMMENT '主体性质',
  `account_category` varchar(20) NOT NULL DEFAULT '' COMMENT '科目性质',
  `acct_code1` varchar(300) NOT NULL DEFAULT '' COMMENT '一级科目代码',
  `acct_name1` varchar(300) NOT NULL DEFAULT '' COMMENT '一级科目说明',
  `acct_name2` varchar(300) NOT NULL DEFAULT '' COMMENT '二级科目说明',
  `acct_name3` varchar(300) NOT NULL DEFAULT '' COMMENT '三级科目说明',
  `segment1` varchar(300) NOT NULL DEFAULT '' COMMENT '主体代码',
  `segment2` varchar(300) NOT NULL DEFAULT '' COMMENT '成本中心代码',
  `segment3` varchar(300) NOT NULL DEFAULT '' COMMENT '科目代码',
  `segment4` varchar(300) NOT NULL DEFAULT '' COMMENT '辅助科目代码',
  `segment5` varchar(300) NOT NULL DEFAULT '' COMMENT '利润中心代码',
  `segment6` varchar(300) NOT NULL DEFAULT '' COMMENT '产品代码',
  `segment7` varchar(300) NOT NULL DEFAULT '' COMMENT '项目代码',
  `segment8` varchar(300) NOT NULL DEFAULT '' COMMENT '公司间代码',
  `segment9` varchar(300) NOT NULL DEFAULT '' COMMENT '备用1代码',
  `segment10` varchar(300) NOT NULL DEFAULT '' COMMENT '备用2代码',
  `segment1_name` varchar(300) NOT NULL DEFAULT '' COMMENT '主体说明',
  `segment2_name` varchar(300) NOT NULL DEFAULT '' COMMENT '成本中心说明',
  `segment3_name` varchar(300) NOT NULL DEFAULT '' COMMENT '科目说明',
  `segment4_name` varchar(300) NOT NULL DEFAULT '' COMMENT '辅助科目说明',
  `segment5_name` varchar(300) NOT NULL DEFAULT '' COMMENT '利润中心说明',
  `segment6_name` varchar(300) NOT NULL DEFAULT '' COMMENT '产品说明',
  `segment7_name` varchar(300) NOT NULL DEFAULT '' COMMENT '项目说明',
  `segment8_name` varchar(300) NOT NULL DEFAULT '' COMMENT '公司间说明',
  `segment9_name` varchar(300) NOT NULL DEFAULT '' COMMENT '备用1说明',
  `segment10_name` varchar(300) NOT NULL DEFAULT '' COMMENT '备用2说明',
  `beg_bal` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '原币本期期初余额',
  `period_dr` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '原币本期借方发生额',
  `period_cr` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '原币本期贷方发生额',
  `end_bal` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '原币本期期末余额',
  `qtd_dr` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '原币本季借方发生额',
  `qtd_cr` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '原币本季贷方发生额',
  `ytd_dr` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '原币本年借方发生额',
  `ytd_cr` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '原币本年贷方发生额',
  `beg_bal_beq` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本位币本期期初余额',
  `period_dr_beq` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本位币本期借方发生额',
  `period_cr_beq` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本位币本期贷方发生额',
  `end_bal_beq` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本位币本期期末余额',
  `qtd_dr_beq` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本位币本季借方发生额',
  `qtd_cr_beq` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本位币本季贷方发生额',
  `ytd_dr_beq` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本位币本年借方发生额',
  `ytd_cr_beq` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本位币本年贷方发生额',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='月度科目余额表。月度，次月传送上月，全部主体';

-- ----------------------------
-- Table structure for trial_balance_final
-- ----------------------------
DROP TABLE IF EXISTS `trial_balance_final`;
CREATE TABLE `trial_balance_final` (
  `id` bigint(22) NOT NULL COMMENT '唯一编号',
  `organization_id` varchar(128) NOT NULL COMMENT '机构编号',
  `project_id` varchar(128) NOT NULL DEFAULT '' COMMENT '项目ID',
  `date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '数据日期',
  `source` varchar(20) NOT NULL DEFAULT '' COMMENT '来源',
  `period` int(6) unsigned NOT NULL DEFAULT '0' COMMENT '期间 yyyymm',
  `ledger_id` varchar(128) NOT NULL DEFAULT '' COMMENT '账套ID',
  `ledger_name` varchar(300) NOT NULL DEFAULT '' COMMENT '账套名称',
  `currency_code` varchar(20) NOT NULL DEFAULT '' COMMENT '账套币种',
  `status` varchar(20) NOT NULL DEFAULT '' COMMENT '关账标识',
  `category` varchar(10) NOT NULL DEFAULT '' COMMENT '主体性质',
  `account_category` varchar(20) NOT NULL DEFAULT '' COMMENT '科目性质',
  `acct_code1` varchar(300) NOT NULL DEFAULT '' COMMENT '一级科目代码',
  `acct_name1` varchar(300) NOT NULL DEFAULT '' COMMENT '一级科目说明',
  `acct_name2` varchar(300) NOT NULL DEFAULT '' COMMENT '二级科目说明',
  `acct_name3` varchar(300) NOT NULL DEFAULT '' COMMENT '三级科目说明',
  `segment1` varchar(300) NOT NULL DEFAULT '' COMMENT '主体代码',
  `segment2` varchar(300) NOT NULL DEFAULT '' COMMENT '成本中心代码',
  `segment3` varchar(300) NOT NULL DEFAULT '' COMMENT '科目代码',
  `segment4` varchar(300) NOT NULL DEFAULT '' COMMENT '辅助科目代码',
  `segment5` varchar(300) NOT NULL DEFAULT '' COMMENT '利润中心代码',
  `segment6` varchar(300) NOT NULL DEFAULT '' COMMENT '产品代码',
  `segment7` varchar(300) NOT NULL DEFAULT '' COMMENT '项目代码',
  `segment8` varchar(300) NOT NULL DEFAULT '' COMMENT '公司间代码',
  `segment9` varchar(300) NOT NULL DEFAULT '' COMMENT '备用1代码',
  `segment10` varchar(300) NOT NULL DEFAULT '' COMMENT '备用2代码',
  `segment1_name` varchar(300) NOT NULL DEFAULT '' COMMENT '主体说明',
  `segment2_name` varchar(300) NOT NULL DEFAULT '' COMMENT '成本中心说明',
  `segment3_name` varchar(300) NOT NULL DEFAULT '' COMMENT '科目说明',
  `segment4_name` varchar(300) NOT NULL DEFAULT '' COMMENT '辅助科目说明',
  `segment5_name` varchar(300) NOT NULL DEFAULT '' COMMENT '利润中心说明',
  `segment6_name` varchar(300) NOT NULL DEFAULT '' COMMENT '产品说明',
  `segment7_name` varchar(300) NOT NULL DEFAULT '' COMMENT '项目说明',
  `segment8_name` varchar(300) NOT NULL DEFAULT '' COMMENT '公司间说明',
  `segment9_name` varchar(300) NOT NULL DEFAULT '' COMMENT '备用1说明',
  `segment10_name` varchar(300) NOT NULL DEFAULT '' COMMENT '备用2说明',
  `beg_bal` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '原币本期期初余额',
  `period_dr` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '原币本期借方发生额',
  `period_cr` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '原币本期贷方发生额',
  `end_bal` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '原币本期期末余额',
  `qtd_dr` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '原币本季借方发生额',
  `qtd_cr` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '原币本季贷方发生额',
  `ytd_dr` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '原币本年借方发生额',
  `ytd_cr` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '原币本年贷方发生额',
  `beg_bal_beq` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本位币本期期初余额',
  `period_dr_beq` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本位币本期借方发生额',
  `period_cr_beq` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本位币本期贷方发生额',
  `end_bal_beq` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本位币本期期末余额',
  `qtd_dr_beq` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本位币本季借方发生额',
  `qtd_cr_beq` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本位币本季贷方发生额',
  `ytd_dr_beq` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本位币本年借方发生额',
  `ytd_cr_beq` decimal(18,4) NOT NULL DEFAULT '0.0000' COMMENT '本位币本年贷方发生额',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='月度科目余额表（汇总）。月度，次月传送上月，全部主体';

-- ----------------------------
-- Table structure for user
-- ----------------------------
DROP TABLE IF EXISTS `user`;
CREATE TABLE `user` (
  `id` varchar(128) NOT NULL DEFAULT '',
  `user_name` varchar(50) NOT NULL DEFAULT '',
  `email` varchar(200) DEFAULT '',
  `password` varchar(200) DEFAULT '',
  `login_type` int(10) NOT NULL DEFAULT '0',
  `status` int(10) NOT NULL DEFAULT '0',
  `expiration_date` datetime DEFAULT CURRENT_TIMESTAMP,
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `is_admin` tinyint(1) NOT NULL DEFAULT '0',
  `password_update_time` datetime DEFAULT CURRENT_TIMESTAMP,
  `attempt_times` int(10) NOT NULL DEFAULT '0',
  `locked_time` datetime DEFAULT CURRENT_TIMESTAMP,
  `organization_id` varchar(128) NOT NULL DEFAULT '',
  `is_super_admin` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `user_user_name_IDX` (`user_name`) USING HASH
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for user_dimension_value
-- ----------------------------
DROP TABLE IF EXISTS `user_dimension_value`;
CREATE TABLE `user_dimension_value` (
  `id` varchar(128) NOT NULL,
  `user_id` varchar(128) NOT NULL DEFAULT ' ',
  `dimension_id` varchar(128) NOT NULL DEFAULT ' ',
  `dimension_value_id` varchar(128) NOT NULL DEFAULT ' ',
  `is_accessible` tinyint(1) NOT NULL DEFAULT '0',
  `has_original_role` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `user_dimension_value_user_id_IDX` (`user_id`,`dimension_id`) USING HASH
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for user_dimension_value_org
-- ----------------------------
DROP TABLE IF EXISTS `user_dimension_value_org`;
CREATE TABLE `user_dimension_value_org` (
  `id` varchar(128) NOT NULL,
  `user_dimension_value_id` varchar(128) NOT NULL DEFAULT '',
  `organization_id` varchar(128) NOT NULL DEFAULT '',
  `is_heritable` tinyint(1) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for user_dimension_value_role
-- ----------------------------
DROP TABLE IF EXISTS `user_dimension_value_role`;
CREATE TABLE `user_dimension_value_role` (
  `id` varchar(128) NOT NULL,
  `user_dimension_value_id` varchar(128) NOT NULL DEFAULT '',
  `role_id` varchar(128) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for user_historical_password
-- ----------------------------
DROP TABLE IF EXISTS `user_historical_password`;
CREATE TABLE `user_historical_password` (
  `id` varchar(128) NOT NULL,
  `user_id` varchar(128) NOT NULL DEFAULT '',
  `password` varchar(200) NOT NULL DEFAULT '',
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for user_organization
-- ----------------------------
DROP TABLE IF EXISTS `user_organization`;
CREATE TABLE `user_organization` (
  `id` varchar(128) NOT NULL,
  `user_id` varchar(128) NOT NULL DEFAULT '',
  `organization_id` varchar(128) NOT NULL DEFAULT '',
  `is_accessible` tinyint(1) DEFAULT '0',
  `has_original_role` tinyint(1) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `index_uid` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for user_organization_role
-- ----------------------------
DROP TABLE IF EXISTS `user_organization_role`;
CREATE TABLE `user_organization_role` (
  `id` varchar(128) NOT NULL,
  `user_organization_id` varchar(128) NOT NULL DEFAULT '',
  `role_id` varchar(128) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Table structure for user_role
-- ----------------------------
DROP TABLE IF EXISTS `user_role`;
CREATE TABLE `user_role` (
  `id` varchar(128) NOT NULL,
  `user_id` varchar(128) NOT NULL DEFAULT '',
  `role_id` varchar(128) NOT NULL DEFAULT '',
  `project_id` varchar(128) DEFAULT '',
  `service_type_id` varchar(128) DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
